#include "header.hpp"

#include "ppllll04.amplitude.set.hpp"

void ppllll24_computeE(double s, double t, double ma2, double mb2, int type, vector<double_complex> &E) {
  // tree level form factors (for debugging purposes)
  double u = ma2+mb2-s-t;

  if (type==0) {
    E[0] = 0;
    E[1] = -2.0/s/t;
    E[2] = 2.0/s/t;
    E[3] = 0;
    E[4] = 2.0/t;
    E[5] = -2.0*(s-t+mb2)/s/t;
    E[6] = 2.0*(t-ma2)/s/t;
    E[7] = -2.0*(t-mb2)/s/t;
    E[8] = 2.0*(s-t+ma2)/s/t;
  } else if (type==1) {
    E[0] = 0;
    E[1] = -2.0/s/u;
    E[2] = 2.0/s/u;
    E[3] = 0;
    E[4] = -2.0/u;
    E[5] = -2.0*(u-ma2)/s/u;
    E[6] = 2.0*(s-u+mb2)/s/u;
    E[7] = -2.0*(s-u+ma2)/s/u;
    E[8] = 2.0*(u-mb2)/s/u;
  } else if (type==2) {
    E[0] = 0;
    E[1] = 0;
    E[2] = 0;
    E[3] = 0;
    E[4] = 0;
    E[5] = 0;
    E[6] = 0;
    E[7] = 0;
    E[8] = 0;
  } else if (type==3) {
    E[0] = 0;
    E[1] = 0;
    E[2] = 0;
    E[3] = 0;
    E[4] = -4;
    E[5] = 4;
    E[6] = 4;
    E[7] = -4;
    E[8] = -4;
  }
}

void add_hel_amps(vector<vector<vector<vector<double_complex> > > > &M1, vector<vector<vector<vector<double_complex> > > > &M2) {
  for (int h1=0; h1<2; h1++) {
    for (int h2=0; h2<2; h2++) {
      for (int h3=0; h3<2; h3++) {
        for (int loop=0; loop<3; loop++) {
          M1[h1][h2][h3][loop] += M2[h1][h2][h3][loop];
        }
      }
    }
  }
}

