#ifndef ppllll04_AMPLITUDE_SET_HPP
#define ppllll04_AMPLITUDE_SET_HPP
/*
#ifndef TYPEDEF_ENUM
#define TYPEDEF_ENUM

typedef enum {
    V_PHOT = 0,
    V_ZLL,
    V_WMIN,
    V_WPLU,
    V_ZNN
} TypeV;

#endif
*/
#include "ppllll04.qqVVamp.hpp"
#include "ppllll04.decay.set.hpp"

void ppllll04_amplitude_initialization(munich * MUC);
void ppllll24_computeE(double s, double t, double ma2, double mb2, int type, vector<double_complex> &E);

using namespace std;

class ppllll04_amplitude_set : virtual public amplitude_set {
private:

public:
  ppllll04_amplitude_set();
  ~ppllll04_amplitude_set();
  
  void calculate_H2_QCD_2loop();
  //  void calculate_H2_QCD_2loop_initialization_ingredients();
  void initialization_H2_QCD_2loop();
  void add_hel_amplitudes_H2_QCD_2loop(int i_x);
  void reset_hel_amplitudes_H2_QCD_2loop(int i_x);
  //  void calculate_H2_QCD_2loop_helicity_amplitude();
  void calculate_H2_QCD_2loop_computeVVprimeHelAmplitudesDR(int i_x, int i_a);
  double_complex compute_M(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop, int type);
  void calculate_H2_QCD_2loop_computeVVprimeHelAmplitudesSR(int i_x, int i_a);
  double_complex compute_M_FSR_7(int i1, int i2, int i5, int i6, int i7, int i8, int hel, int loop);

  int q1;
  double sym_factor;

  vector<fourvector> p_VVamp;
  double s;
  double t;
  double ma2;
  double mb2;
  vector<vector<double_complex > > za, zb;
  vector<vector<double> > s_inv;
  
  vector<vector<vector<double_complex> > > E;
  vector<double_complex> F;

  vector<vector<int> > permutation;
  vector<vector<ppllll04_decay_DR> > DR;
  vector<vector<ppllll04_decay_SR> > SR;

  vector<vector<vector<vector<double_complex> > > > M_dressed;
  vector<vector<vector<vector<double_complex> > > > M_dressed2;
  vector<vector<vector<vector<double_complex> > > > M_dressed_tmp;

};


#ifdef OPENLOOPS
class ppllll04_amplitude_OpenLoops_set : public amplitude_OpenLoops_set, public ppllll04_amplitude_set {
private:

public:
  ppllll04_amplitude_OpenLoops_set();
  ~ppllll04_amplitude_OpenLoops_set();
  
  virtual void initialization_process();
};
#endif


#ifdef RECOLA
class ppllll04_amplitude_Recola_set : public amplitude_Recola_set, public ppllll04_amplitude_set {
private:

public:
  ppllll04_amplitude_Recola_set();
  ~ppllll04_amplitude_Recola_set();
  
  virtual void initialization_process();
};
#endif

#endif
