#ifndef ppemexmx04_PHASESPACE_SET_HPP
#define ppemexmx04_PHASESPACE_SET_HPP

using namespace std;

class ppemexmx04_phasespace_set : public phasespace_set {
private:

public:
  ppemexmx04_phasespace_set(){}
  ~ppemexmx04_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_040_ddx_emmumepmup(int x_a);
  void ac_psp_040_ddx_emmumepmup(int x_a, int channel);
  void ag_psp_040_ddx_emmumepmup(int x_a, int zero);
  void ax_psp_040_uux_emmumepmup(int x_a);
  void ac_psp_040_uux_emmumepmup(int x_a, int channel);
  void ag_psp_040_uux_emmumepmup(int x_a, int zero);
  void ax_psp_040_bbx_emmumepmup(int x_a);
  void ac_psp_040_bbx_emmumepmup(int x_a, int channel);
  void ag_psp_040_bbx_emmumepmup(int x_a, int zero);
  void ax_psp_040_aa_emmumepmup(int x_a);
  void ac_psp_040_aa_emmumepmup(int x_a, int channel);
  void ag_psp_040_aa_emmumepmup(int x_a, int zero);
  void ax_psp_240_gg_emmumepmup(int x_a);
  void ac_psp_240_gg_emmumepmup(int x_a, int channel);
  void ag_psp_240_gg_emmumepmup(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_140_gd_emmumepmupd(int x_a);
  void ac_psp_140_gd_emmumepmupd(int x_a, int channel);
  void ag_psp_140_gd_emmumepmupd(int x_a, int zero);
  void ax_psp_140_gu_emmumepmupu(int x_a);
  void ac_psp_140_gu_emmumepmupu(int x_a, int channel);
  void ag_psp_140_gu_emmumepmupu(int x_a, int zero);
  void ax_psp_140_gb_emmumepmupb(int x_a);
  void ac_psp_140_gb_emmumepmupb(int x_a, int channel);
  void ag_psp_140_gb_emmumepmupb(int x_a, int zero);
  void ax_psp_140_gdx_emmumepmupdx(int x_a);
  void ac_psp_140_gdx_emmumepmupdx(int x_a, int channel);
  void ag_psp_140_gdx_emmumepmupdx(int x_a, int zero);
  void ax_psp_140_gux_emmumepmupux(int x_a);
  void ac_psp_140_gux_emmumepmupux(int x_a, int channel);
  void ag_psp_140_gux_emmumepmupux(int x_a, int zero);
  void ax_psp_140_gbx_emmumepmupbx(int x_a);
  void ac_psp_140_gbx_emmumepmupbx(int x_a, int channel);
  void ag_psp_140_gbx_emmumepmupbx(int x_a, int zero);
  void ax_psp_140_ddx_emmumepmupg(int x_a);
  void ac_psp_140_ddx_emmumepmupg(int x_a, int channel);
  void ag_psp_140_ddx_emmumepmupg(int x_a, int zero);
  void ax_psp_050_da_emmumepmupd(int x_a);
  void ac_psp_050_da_emmumepmupd(int x_a, int channel);
  void ag_psp_050_da_emmumepmupd(int x_a, int zero);
  void ax_psp_140_uux_emmumepmupg(int x_a);
  void ac_psp_140_uux_emmumepmupg(int x_a, int channel);
  void ag_psp_140_uux_emmumepmupg(int x_a, int zero);
  void ax_psp_050_ua_emmumepmupu(int x_a);
  void ac_psp_050_ua_emmumepmupu(int x_a, int channel);
  void ag_psp_050_ua_emmumepmupu(int x_a, int zero);
  void ax_psp_140_bbx_emmumepmupg(int x_a);
  void ac_psp_140_bbx_emmumepmupg(int x_a, int channel);
  void ag_psp_140_bbx_emmumepmupg(int x_a, int zero);
  void ax_psp_050_ba_emmumepmupb(int x_a);
  void ac_psp_050_ba_emmumepmupb(int x_a, int channel);
  void ag_psp_050_ba_emmumepmupb(int x_a, int zero);
  void ax_psp_050_dxa_emmumepmupdx(int x_a);
  void ac_psp_050_dxa_emmumepmupdx(int x_a, int channel);
  void ag_psp_050_dxa_emmumepmupdx(int x_a, int zero);
  void ax_psp_050_uxa_emmumepmupux(int x_a);
  void ac_psp_050_uxa_emmumepmupux(int x_a, int channel);
  void ag_psp_050_uxa_emmumepmupux(int x_a, int zero);
  void ax_psp_050_bxa_emmumepmupbx(int x_a);
  void ac_psp_050_bxa_emmumepmupbx(int x_a, int channel);
  void ag_psp_050_bxa_emmumepmupbx(int x_a, int zero);
  void ax_psp_050_ddx_emmumepmupa(int x_a);
  void ac_psp_050_ddx_emmumepmupa(int x_a, int channel);
  void ag_psp_050_ddx_emmumepmupa(int x_a, int zero);
  void ax_psp_050_uux_emmumepmupa(int x_a);
  void ac_psp_050_uux_emmumepmupa(int x_a, int channel);
  void ag_psp_050_uux_emmumepmupa(int x_a, int zero);
  void ax_psp_050_bbx_emmumepmupa(int x_a);
  void ac_psp_050_bbx_emmumepmupa(int x_a, int channel);
  void ag_psp_050_bbx_emmumepmupa(int x_a, int zero);
  void ax_psp_050_aa_emmumepmupa(int x_a);
  void ac_psp_050_aa_emmumepmupa(int x_a, int channel);
  void ag_psp_050_aa_emmumepmupa(int x_a, int zero);
  void ax_psp_340_gg_emmumepmupg(int x_a);
  void ac_psp_340_gg_emmumepmupg(int x_a, int channel);
  void ag_psp_340_gg_emmumepmupg(int x_a, int zero);
  void ax_psp_340_gd_emmumepmupd(int x_a);
  void ac_psp_340_gd_emmumepmupd(int x_a, int channel);
  void ag_psp_340_gd_emmumepmupd(int x_a, int zero);
  void ax_psp_340_gu_emmumepmupu(int x_a);
  void ac_psp_340_gu_emmumepmupu(int x_a, int channel);
  void ag_psp_340_gu_emmumepmupu(int x_a, int zero);
  void ax_psp_340_gb_emmumepmupb(int x_a);
  void ac_psp_340_gb_emmumepmupb(int x_a, int channel);
  void ag_psp_340_gb_emmumepmupb(int x_a, int zero);
  void ax_psp_340_gdx_emmumepmupdx(int x_a);
  void ac_psp_340_gdx_emmumepmupdx(int x_a, int channel);
  void ag_psp_340_gdx_emmumepmupdx(int x_a, int zero);
  void ax_psp_340_gux_emmumepmupux(int x_a);
  void ac_psp_340_gux_emmumepmupux(int x_a, int channel);
  void ag_psp_340_gux_emmumepmupux(int x_a, int zero);
  void ax_psp_340_gbx_emmumepmupbx(int x_a);
  void ac_psp_340_gbx_emmumepmupbx(int x_a, int channel);
  void ag_psp_340_gbx_emmumepmupbx(int x_a, int zero);
  void ax_psp_340_ddx_emmumepmupg(int x_a);
  void ac_psp_340_ddx_emmumepmupg(int x_a, int channel);
  void ag_psp_340_ddx_emmumepmupg(int x_a, int zero);
  void ax_psp_340_uux_emmumepmupg(int x_a);
  void ac_psp_340_uux_emmumepmupg(int x_a, int channel);
  void ag_psp_340_uux_emmumepmupg(int x_a, int zero);
  void ax_psp_340_bbx_emmumepmupg(int x_a);
  void ac_psp_340_bbx_emmumepmupg(int x_a, int channel);
  void ag_psp_340_bbx_emmumepmupg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_240_gg_emmumepmupddx(int x_a);
  void ac_psp_240_gg_emmumepmupddx(int x_a, int channel);
  void ag_psp_240_gg_emmumepmupddx(int x_a, int zero);
  void ax_psp_240_gg_emmumepmupuux(int x_a);
  void ac_psp_240_gg_emmumepmupuux(int x_a, int channel);
  void ag_psp_240_gg_emmumepmupuux(int x_a, int zero);
  void ax_psp_240_gg_emmumepmupbbx(int x_a);
  void ac_psp_240_gg_emmumepmupbbx(int x_a, int channel);
  void ag_psp_240_gg_emmumepmupbbx(int x_a, int zero);
  void ax_psp_240_gd_emmumepmupgd(int x_a);
  void ac_psp_240_gd_emmumepmupgd(int x_a, int channel);
  void ag_psp_240_gd_emmumepmupgd(int x_a, int zero);
  void ax_psp_240_gu_emmumepmupgu(int x_a);
  void ac_psp_240_gu_emmumepmupgu(int x_a, int channel);
  void ag_psp_240_gu_emmumepmupgu(int x_a, int zero);
  void ax_psp_240_gb_emmumepmupgb(int x_a);
  void ac_psp_240_gb_emmumepmupgb(int x_a, int channel);
  void ag_psp_240_gb_emmumepmupgb(int x_a, int zero);
  void ax_psp_240_gdx_emmumepmupgdx(int x_a);
  void ac_psp_240_gdx_emmumepmupgdx(int x_a, int channel);
  void ag_psp_240_gdx_emmumepmupgdx(int x_a, int zero);
  void ax_psp_240_gux_emmumepmupgux(int x_a);
  void ac_psp_240_gux_emmumepmupgux(int x_a, int channel);
  void ag_psp_240_gux_emmumepmupgux(int x_a, int zero);
  void ax_psp_240_gbx_emmumepmupgbx(int x_a);
  void ac_psp_240_gbx_emmumepmupgbx(int x_a, int channel);
  void ag_psp_240_gbx_emmumepmupgbx(int x_a, int zero);
  void ax_psp_240_dd_emmumepmupdd(int x_a);
  void ac_psp_240_dd_emmumepmupdd(int x_a, int channel);
  void ag_psp_240_dd_emmumepmupdd(int x_a, int zero);
  void ax_psp_240_du_emmumepmupdu(int x_a);
  void ac_psp_240_du_emmumepmupdu(int x_a, int channel);
  void ag_psp_240_du_emmumepmupdu(int x_a, int zero);
  void ax_psp_240_ds_emmumepmupds(int x_a);
  void ac_psp_240_ds_emmumepmupds(int x_a, int channel);
  void ag_psp_240_ds_emmumepmupds(int x_a, int zero);
  void ax_psp_240_dc_emmumepmupdc(int x_a);
  void ac_psp_240_dc_emmumepmupdc(int x_a, int channel);
  void ag_psp_240_dc_emmumepmupdc(int x_a, int zero);
  void ax_psp_240_db_emmumepmupdb(int x_a);
  void ac_psp_240_db_emmumepmupdb(int x_a, int channel);
  void ag_psp_240_db_emmumepmupdb(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupgg(int x_a);
  void ac_psp_240_ddx_emmumepmupgg(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupgg(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupddx(int x_a);
  void ac_psp_240_ddx_emmumepmupddx(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupddx(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupuux(int x_a);
  void ac_psp_240_ddx_emmumepmupuux(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupuux(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupssx(int x_a);
  void ac_psp_240_ddx_emmumepmupssx(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupssx(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupccx(int x_a);
  void ac_psp_240_ddx_emmumepmupccx(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupccx(int x_a, int zero);
  void ax_psp_240_ddx_emmumepmupbbx(int x_a);
  void ac_psp_240_ddx_emmumepmupbbx(int x_a, int channel);
  void ag_psp_240_ddx_emmumepmupbbx(int x_a, int zero);
  void ax_psp_240_dux_emmumepmupdux(int x_a);
  void ac_psp_240_dux_emmumepmupdux(int x_a, int channel);
  void ag_psp_240_dux_emmumepmupdux(int x_a, int zero);
  void ax_psp_240_dsx_emmumepmupdsx(int x_a);
  void ac_psp_240_dsx_emmumepmupdsx(int x_a, int channel);
  void ag_psp_240_dsx_emmumepmupdsx(int x_a, int zero);
  void ax_psp_240_dcx_emmumepmupdcx(int x_a);
  void ac_psp_240_dcx_emmumepmupdcx(int x_a, int channel);
  void ag_psp_240_dcx_emmumepmupdcx(int x_a, int zero);
  void ax_psp_240_dbx_emmumepmupdbx(int x_a);
  void ac_psp_240_dbx_emmumepmupdbx(int x_a, int channel);
  void ag_psp_240_dbx_emmumepmupdbx(int x_a, int zero);
  void ax_psp_240_uu_emmumepmupuu(int x_a);
  void ac_psp_240_uu_emmumepmupuu(int x_a, int channel);
  void ag_psp_240_uu_emmumepmupuu(int x_a, int zero);
  void ax_psp_240_uc_emmumepmupuc(int x_a);
  void ac_psp_240_uc_emmumepmupuc(int x_a, int channel);
  void ag_psp_240_uc_emmumepmupuc(int x_a, int zero);
  void ax_psp_240_ub_emmumepmupub(int x_a);
  void ac_psp_240_ub_emmumepmupub(int x_a, int channel);
  void ag_psp_240_ub_emmumepmupub(int x_a, int zero);
  void ax_psp_240_udx_emmumepmupudx(int x_a);
  void ac_psp_240_udx_emmumepmupudx(int x_a, int channel);
  void ag_psp_240_udx_emmumepmupudx(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupgg(int x_a);
  void ac_psp_240_uux_emmumepmupgg(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupgg(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupddx(int x_a);
  void ac_psp_240_uux_emmumepmupddx(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupddx(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupuux(int x_a);
  void ac_psp_240_uux_emmumepmupuux(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupuux(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupssx(int x_a);
  void ac_psp_240_uux_emmumepmupssx(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupssx(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupccx(int x_a);
  void ac_psp_240_uux_emmumepmupccx(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupccx(int x_a, int zero);
  void ax_psp_240_uux_emmumepmupbbx(int x_a);
  void ac_psp_240_uux_emmumepmupbbx(int x_a, int channel);
  void ag_psp_240_uux_emmumepmupbbx(int x_a, int zero);
  void ax_psp_240_usx_emmumepmupusx(int x_a);
  void ac_psp_240_usx_emmumepmupusx(int x_a, int channel);
  void ag_psp_240_usx_emmumepmupusx(int x_a, int zero);
  void ax_psp_240_ucx_emmumepmupucx(int x_a);
  void ac_psp_240_ucx_emmumepmupucx(int x_a, int channel);
  void ag_psp_240_ucx_emmumepmupucx(int x_a, int zero);
  void ax_psp_240_ubx_emmumepmupubx(int x_a);
  void ac_psp_240_ubx_emmumepmupubx(int x_a, int channel);
  void ag_psp_240_ubx_emmumepmupubx(int x_a, int zero);
  void ax_psp_240_bb_emmumepmupbb(int x_a);
  void ac_psp_240_bb_emmumepmupbb(int x_a, int channel);
  void ag_psp_240_bb_emmumepmupbb(int x_a, int zero);
  void ax_psp_240_bdx_emmumepmupbdx(int x_a);
  void ac_psp_240_bdx_emmumepmupbdx(int x_a, int channel);
  void ag_psp_240_bdx_emmumepmupbdx(int x_a, int zero);
  void ax_psp_240_bux_emmumepmupbux(int x_a);
  void ac_psp_240_bux_emmumepmupbux(int x_a, int channel);
  void ag_psp_240_bux_emmumepmupbux(int x_a, int zero);
  void ax_psp_240_bbx_emmumepmupgg(int x_a);
  void ac_psp_240_bbx_emmumepmupgg(int x_a, int channel);
  void ag_psp_240_bbx_emmumepmupgg(int x_a, int zero);
  void ax_psp_240_bbx_emmumepmupddx(int x_a);
  void ac_psp_240_bbx_emmumepmupddx(int x_a, int channel);
  void ag_psp_240_bbx_emmumepmupddx(int x_a, int zero);
  void ax_psp_240_bbx_emmumepmupuux(int x_a);
  void ac_psp_240_bbx_emmumepmupuux(int x_a, int channel);
  void ag_psp_240_bbx_emmumepmupuux(int x_a, int zero);
  void ax_psp_240_bbx_emmumepmupbbx(int x_a);
  void ac_psp_240_bbx_emmumepmupbbx(int x_a, int channel);
  void ag_psp_240_bbx_emmumepmupbbx(int x_a, int zero);
  void ax_psp_240_dxdx_emmumepmupdxdx(int x_a);
  void ac_psp_240_dxdx_emmumepmupdxdx(int x_a, int channel);
  void ag_psp_240_dxdx_emmumepmupdxdx(int x_a, int zero);
  void ax_psp_240_dxux_emmumepmupdxux(int x_a);
  void ac_psp_240_dxux_emmumepmupdxux(int x_a, int channel);
  void ag_psp_240_dxux_emmumepmupdxux(int x_a, int zero);
  void ax_psp_240_dxsx_emmumepmupdxsx(int x_a);
  void ac_psp_240_dxsx_emmumepmupdxsx(int x_a, int channel);
  void ag_psp_240_dxsx_emmumepmupdxsx(int x_a, int zero);
  void ax_psp_240_dxcx_emmumepmupdxcx(int x_a);
  void ac_psp_240_dxcx_emmumepmupdxcx(int x_a, int channel);
  void ag_psp_240_dxcx_emmumepmupdxcx(int x_a, int zero);
  void ax_psp_240_dxbx_emmumepmupdxbx(int x_a);
  void ac_psp_240_dxbx_emmumepmupdxbx(int x_a, int channel);
  void ag_psp_240_dxbx_emmumepmupdxbx(int x_a, int zero);
  void ax_psp_240_uxux_emmumepmupuxux(int x_a);
  void ac_psp_240_uxux_emmumepmupuxux(int x_a, int channel);
  void ag_psp_240_uxux_emmumepmupuxux(int x_a, int zero);
  void ax_psp_240_uxcx_emmumepmupuxcx(int x_a);
  void ac_psp_240_uxcx_emmumepmupuxcx(int x_a, int channel);
  void ag_psp_240_uxcx_emmumepmupuxcx(int x_a, int zero);
  void ax_psp_240_uxbx_emmumepmupuxbx(int x_a);
  void ac_psp_240_uxbx_emmumepmupuxbx(int x_a, int channel);
  void ag_psp_240_uxbx_emmumepmupuxbx(int x_a, int zero);
  void ax_psp_240_bxbx_emmumepmupbxbx(int x_a);
  void ac_psp_240_bxbx_emmumepmupbxbx(int x_a, int channel);
  void ag_psp_240_bxbx_emmumepmupbxbx(int x_a, int zero);

};
#endif
