#ifndef AMPLITUDE_RECOLASET_H
#define AMPLITUDE_RECOLASET_H
#ifdef RECOLA

using namespace std;

class phasespace_set;

class amplitude_Recola_set : virtual public amplitude_set {
 private:

 public:
  amplitude_Recola_set();
  amplitude_Recola_set(observable_set * _osi, contribution_set * _csi, model_set * _msi, event_set * _esi);
  
  virtual ~amplitude_Recola_set() {}

  virtual void initialization(observable_set * _osi, contribution_set * _csi, model_set * _msi, event_set * _esi, inputparameter_set * isi);
  virtual void initialization(inputparameter_set * isi);
  virtual void initialization_set_default();
  virtual void initialization_input(inputparameter_set * isi);
  virtual void initialization_parameter();
  virtual void initialization_process();
  virtual void output_parameter(string label);
 // not available yet !!!
  virtual void generate_testpoint();
  virtual void set_phasespacepoint(double P_Recola [][4]);
  virtual void set_phasespacepoint_dipole(double P_Recola [][4], const int x_a);
  virtual void set_phasespacepoint_OLformat();

  // amplitude/Recola/amplitude.Recola.ME2.born.cpp
  virtual void calculate_ME2_born();
  virtual void check_vanishing_ME2_born();

  
  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.CA.QCD.cpp
  virtual void calculate_ME2_CA_QCD();

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.VA.QCD.cpp
  virtual void set_mu_and_delta_VA();
  virtual void set_testpoint_alpha_S(const double alpha_S);
  virtual void set_testpoint_rescale_I_ME2();
  virtual void calculate_ME2_ioperator_VA_QCD();
  virtual void calculate_ME2_VA_QCD();

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.RA.QCD.cpp
  virtual void calculate_ME2_RA_QCD();
  virtual void calculate_dipole_Acc_QCD(int x_a);
  virtual void calculate_dipole_Asc_QCD(int x_a, fourvector & Vtensor);


  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.CA.QEW.cpp
  virtual void calculate_ME2_CA_QEW();

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.VA.QEW.cpp
  virtual void calculate_ME2_ioperator_VA_QEW();
  virtual void calculate_ME2_VA_QEW();

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.RA.QEW.cpp
  virtual void calculate_ME2_RA_QEW();
  virtual void calculate_dipole_Acc_QEW(int x_a);
  virtual void calculate_dipole_Asc_QEW(int x_a, fourvector & Vtensor);

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.VA.MIX.cpp
  virtual void calculate_ME2_ioperator_VA_MIX();
  virtual void calculate_ME2_VA_MIX();

  // amplitude/Recola/amplitude.Recola.dipolesubtraction.ME2.RA.MIX.cpp
  virtual void calculate_ME2_RA_MIX();

  
  // amplitude/Recola/amplitude.Recola.qTsubtraction.ME2.CT.QCD.cpp
  virtual void calculate_ME2_CT_QCD();

  // amplitude/Recola/amplitude.Recola.qTsubtraction.ME2.VT.QCD.cpp
  virtual void calculate_ME2_VT_QCD();


  // amplitude/Recola/amplitude.Recola.qTsubtraction.ME2.CT2.QCD.cpp
  virtual void calculate_ME2_CT2_QCD();

  // amplitude/Recola/amplitude.Recola.qTsubtraction.ME2.VT2.QCD.cpp
  virtual void calculate_ME2_VT2_QCD();


  // external 2-loop components:
  //  virtual void calculate_H2_QCD_2loop(){}
  //  virtual void calculate_H1gg_2loop(){}


  virtual void register_RCL_subprocess(int i_a, int amptype, int & process_id_rcl);

  vector<string> RCL_parameter;
  vector<string> RCL_value;

  int n_momentum;
  double * P_OLformat;

};
#endif
#endif
