#ifndef FIDUCIALCUT_H
#define FIDUCIALCUT_H

#include <map>
#include <string>
#include <vector>

#include "logger.hpp"
#include "user.defined.hpp"

using namespace std;

class event_set;
class observable_set;

typedef enum {
    UPPER = 0,
    LOWER,
    WINDOW,
    GAP,
} cut_type;

class fiducialcut{
private:

public:
  fiducialcut();
  fiducialcut(string & _name, event_set & _esi);

  void apply_fiducialcut(int i_a);
  string output_fiducialcut(size_t indent);

  friend std::ostream & operator << ( std::ostream &, const fiducialcut &);

  event_set *esi;

  string name;

  string observable;
  
  cut_type type;

  vector<string> type_particle;
  vector<vector<int> > no_particles;

  vector<int> order_min;
  vector<int> order_max;

  double cut_value_lower;
  double cut_value_upper;

  int n_combination;
  vector<int> cut_combination;
  int cut;
};
#endif
