logger << LOG_DEBUG_VERBOSE << "user/specify.cuts.cxx started" << endl;
{
  static int switch_cut_R_gamjet = USERSWITCH("R_gamjet");
  static double cut_min_R_gamjet = USERCUT("min_R_gamjet");
  static double cut_min_R2_gamjet = pow(cut_min_R_gamjet, 2);
  
  for (int i_j = 0; i_j < NUMBER("jet"); i_j++){
    // photon--jet isolation cuts
    if (switch_cut_R_gamjet == 1){
      if (R2_eta(PARTICLE("photon")[0], PARTICLE("jet")[i_j]) < cut_min_R2_gamjet){cut_ps[i_a] = -1; logger << LOG_DEBUG_VERBOSE << "switch_cut_R_gamjet cut applied" << endl; return;}
    }
  }

  // dynamical jet-veto cut
  static int switch_cut_rel_HTjet_HTlep = USERSWITCH("rel_HTjet_HTlep");
  static double cut_min_rel_HTjet_HTlep = USERCUT("min_rel_HTjet_HTlep");
  

  // cut on relative HTjet/HTlep fraction
  if (switch_cut_rel_HTjet_HTlep){
    double HTjet = 0.;
    for (int i_j = 0; i_j < PARTICLE("jet").size(); i_j++){HTjet += PARTICLE("jet")[i_j].pT;}
    if (HTjet > 0.){
      double HTlep = 0.;
      for (int i_l = 0; i_l < PARTICLE("lep").size(); i_l++){HTlep += PARTICLE("lep")[i_l].pT;}
      for (int m_l = 0; m_l < PARTICLE("missing").size(); m_l++){if(m_l==0){HTlep += PARTICLE("missing")[m_l].pT;}}
      for (int p_l = 0; p_l < PARTICLE("photon").size(); p_l++){if(p_l==0){HTlep += PARTICLE("photon")[p_l].pT;}}

      if (HTjet > cut_min_rel_HTjet_HTlep * HTlep){
	cut_ps[i_a] = -1;
	logger << LOG_DEBUG_VERBOSE << "switch_cut_rel_HTjet_HTlep cut applied" << endl; 
	return;
      }
    }
  }

  
  if (switch_output_cutinfo){info_cut << "individual cuts passed" << endl;}

}
logger << LOG_DEBUG_VERBOSE << "user/specify.cuts.cxx ended" << endl;


