#include "header.hpp"

void model_set::fill_charge_pdg(){
  Logger logger("model_set::fill_charge_pdg");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  charge_pdg[1] = -1. / 3.;
  charge_pdg[2] = 2. / 3.;
  charge_pdg[3] = -1. / 3.;
  charge_pdg[4] = 2. / 3.;
  charge_pdg[5] = -1. / 3.;
  charge_pdg[6] = 2. / 3.;

  charge_pdg[-1] = 1. / 3.;
  charge_pdg[-2] = -2. / 3.;
  charge_pdg[-3] = 1. / 3.;
  charge_pdg[-4] = -2. / 3.;
  charge_pdg[-5] = 1. / 3.;
  charge_pdg[-6] = -2. / 3.;

  charge_pdg[11] = -1.;
  charge_pdg[12] = 0.;
  charge_pdg[13] = -1.;
  charge_pdg[14] = 0.;
  charge_pdg[15] = -1.;
  charge_pdg[16] = 0.;

  charge_pdg[-11] = 1.;
  charge_pdg[-12] = 0.;
  charge_pdg[-13] = 1.;
  charge_pdg[-14] = 0.;
  charge_pdg[-15] = 1.;
  charge_pdg[-16] = 0.;

  charge_pdg[0] = 0.;
  charge_pdg[21] = 0.;
  charge_pdg[22] = 0.;
  charge_pdg[-22] = 0.; // ???
  charge_pdg[23] = 0.;
  charge_pdg[25] = 0.;

  charge_pdg[24] = -1.;
  charge_pdg[-24] = 1.;

  for (int i_pdg = -25; i_pdg < 26; i_pdg++){charge2_pdg[i_pdg] = pow(charge_pdg[i_pdg], 2);}
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void model_set::fill_casimir_pdg(){
  Logger logger("model_set::fill_casimir_pdg");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  casimir_pdg[1] = C_F;
  casimir_pdg[2] = C_F;
  casimir_pdg[3] = C_F;
  casimir_pdg[4] = C_F;
  casimir_pdg[5] = C_F;
  casimir_pdg[6] = C_F;

  casimir_pdg[-1] = C_F;
  casimir_pdg[-2] = C_F;
  casimir_pdg[-3] = C_F;
  casimir_pdg[-4] = C_F;
  casimir_pdg[-5] = C_F;
  casimir_pdg[-6] = C_F;

  casimir_pdg[11] = 0.;
  casimir_pdg[12] = 0.;
  casimir_pdg[13] = 0.;
  casimir_pdg[14] = 0.;
  casimir_pdg[15] = 0.;
  casimir_pdg[16] = 0.;

  casimir_pdg[-11] = 0.;
  casimir_pdg[-12] = 0.;
  casimir_pdg[-13] = 0.;
  casimir_pdg[-14] = 0.;
  casimir_pdg[-15] = 0.;
  casimir_pdg[-16] = 0.;

  casimir_pdg[0] = C_A;
  casimir_pdg[21] = C_A;
  casimir_pdg[22] = 0.;
  casimir_pdg[-22] = 0.; // ???
  casimir_pdg[23] = 0.;
  casimir_pdg[25] = 0.;

  casimir_pdg[24] = 0.;
  casimir_pdg[-24] = 0.;
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void model_set::fill_mass_pdg(){
  Logger logger("model_set::fill_mass_pdg");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  M_pdg[1] = M_d;
  M_pdg[2] = M_u;
  M_pdg[3] = M_s;
  M_pdg[4] = M_c;
  M_pdg[5] = M_b;
  M_pdg[6] = M_t;

  M_pdg[-1] = M_d;
  M_pdg[-2] = M_u;
  M_pdg[-3] = M_s;
  M_pdg[-4] = M_c;
  M_pdg[-5] = M_b;
  M_pdg[-6] = M_t;

  M_pdg[11] = M_e;
  M_pdg[12] = M_ve;
  M_pdg[13] = M_mu;
  M_pdg[14] = M_vm;
  M_pdg[15] = M_tau;
  M_pdg[16] = M_vt;

  M_pdg[-11] = M_e;
  M_pdg[-12] = M_ve;
  M_pdg[-13] = M_mu;
  M_pdg[-14] = M_vm;
  M_pdg[-15] = M_tau;
  M_pdg[-16] = M_vt;

  M_pdg[0] = 0.;
  M_pdg[21] = 0.;
  M_pdg[22] = 0.;
  M_pdg[-22] = 0.; // ???
  M_pdg[23] = M_Z;
  M_pdg[25] = M_H;

  M_pdg[24] = M_W;
  M_pdg[-24] = M_W;

  
  M2_pdg[1] = M2_d;
  M2_pdg[2] = M2_u;
  M2_pdg[3] = M2_s;
  M2_pdg[4] = M2_c;
  M2_pdg[5] = M2_b;
  M2_pdg[6] = M2_t;

  M2_pdg[-1] = M2_d;
  M2_pdg[-2] = M2_u;
  M2_pdg[-3] = M2_s;
  M2_pdg[-4] = M2_c;
  M2_pdg[-5] = M2_b;
  M2_pdg[-6] = M2_t;

  M2_pdg[11] = M2_e;
  M2_pdg[12] = M2_ve;
  M2_pdg[13] = M2_mu;
  M2_pdg[14] = M2_vm;
  M2_pdg[15] = M2_tau;
  M2_pdg[16] = M2_vt;

  M2_pdg[-11] = M2_e;
  M2_pdg[-12] = M2_ve;
  M2_pdg[-13] = M2_mu;
  M2_pdg[-14] = M2_vm;
  M2_pdg[-15] = M2_tau;
  M2_pdg[-16] = M2_vt;

  M2_pdg[0] = 0.;
  M2_pdg[21] = 0.;
  M2_pdg[22] = 0.;
  M2_pdg[-22] = 0.; // ???
  M2_pdg[23] = M2_Z;
  M2_pdg[25] = M2_H;

  M2_pdg[24] = M2_W;
  M2_pdg[-24] = M2_W;

  
  Gamma_pdg[1] = 0.;//Gamma_d;
  Gamma_pdg[2] = 0.;//Gamma_u;
  Gamma_pdg[3] = 0.;//Gamma_s;
  Gamma_pdg[4] = Gamma_c;
  Gamma_pdg[5] = Gamma_b;
  Gamma_pdg[6] = Gamma_t;

  Gamma_pdg[-1] = 0.;//Gamma_d;
  Gamma_pdg[-2] = 0.;//Gamma_u;
  Gamma_pdg[-3] = 0.;//Gamma_s;
  Gamma_pdg[-4] = Gamma_c;
  Gamma_pdg[-5] = Gamma_b;
  Gamma_pdg[-6] = Gamma_t;

  Gamma_pdg[11] = 0.;//Gamma_e;
  Gamma_pdg[12] = 0.;//Gamma_ve;
  Gamma_pdg[13] = 0.;//Gamma_mu;
  Gamma_pdg[14] = 0.;//Gamma_vm;
  Gamma_pdg[15] = 0.;//Gamma_tau;
  Gamma_pdg[16] = 0.;//Gamma_vt;

  Gamma_pdg[-11] = 0.;//Gamma_e;
  Gamma_pdg[-12] = 0.;//Gamma_ve;
  Gamma_pdg[-13] = 0.;//Gamma_mu;
  Gamma_pdg[-14] = 0.;//Gamma_vm;
  Gamma_pdg[-15] = 0.;//Gamma_tau;
  Gamma_pdg[-16] = 0.;//Gamma_vt;

  Gamma_pdg[0] = 0.;
  Gamma_pdg[21] = 0.;
  Gamma_pdg[22] = 0.;
  Gamma_pdg[-22] = 0.; // ???
  Gamma_pdg[23] = Gamma_Z;
  Gamma_pdg[25] = Gamma_H;

  Gamma_pdg[24] = Gamma_W;
  Gamma_pdg[-24] = Gamma_W;
  

  cM_pdg[1] = 0.;//cM_d;
  cM_pdg[2] = 0.;//cM_u;
  cM_pdg[3] = 0.;//cM_s;
  cM_pdg[4] = cM_c;
  cM_pdg[5] = cM_b;
  cM_pdg[6] = cM_t;

  cM_pdg[-1] = 0.;//cM_d;
  cM_pdg[-2] = 0.;//cM_u;
  cM_pdg[-3] = 0.;//cM_s;
  cM_pdg[-4] = cM_c;
  cM_pdg[-5] = cM_b;
  cM_pdg[-6] = cM_t;

  cM_pdg[11] = M_e;//c;
  cM_pdg[12] = 0.;//cM_ve;
  cM_pdg[13] = M_mu;//cM_mu;
  cM_pdg[14] = 0.;//cM_vm;
  cM_pdg[15] = M_tau;//cM_tau;
  cM_pdg[16] = 0.;//cM_vt;

  cM_pdg[-11] = M_e;//cM_e;
  cM_pdg[-12] = 0.;//cM_ve;
  cM_pdg[-13] = M_mu;//cM_mu;
  cM_pdg[-14] = 0.;//cM_vm;
  cM_pdg[-15] = M_tau;//cM_tau;
  cM_pdg[-16] = 0.;//cM_vt;

  cM_pdg[0] = 0.;
  cM_pdg[21] = 0.;
  cM_pdg[22] = 0.;
  cM_pdg[-22] = 0.; // ???
  cM_pdg[23] = cM_Z;
  cM_pdg[25] = cM_H;

  cM_pdg[24] = cM_W;
  cM_pdg[-24] = cM_W;
  

  cM2_pdg[1] = 0.;//cM2_d;
  cM2_pdg[2] = 0.;//cM2_u;
  cM2_pdg[3] = 0.;//cM2_s;
  cM2_pdg[4] = cM2_c;
  cM2_pdg[5] = cM2_b;
  cM2_pdg[6] = cM2_t;

  cM2_pdg[-1] = 0.;//cM2_d;
  cM2_pdg[-2] = 0.;//cM2_u;
  cM2_pdg[-3] = 0.;//cM2_s;
  cM2_pdg[-4] = cM2_c;
  cM2_pdg[-5] = cM2_b;
  cM2_pdg[-6] = cM2_t;

  cM2_pdg[11] = M2_e;//cM2_e;
  cM2_pdg[12] = 0.;//cM2_ve;
  cM2_pdg[13] = M2_mu;//cM2_mu;
  cM2_pdg[14] = 0.;//cM2_vm;
  cM2_pdg[15] = M2_tau;//cM2_tau;
  cM2_pdg[16] = 0.;//cM2_vt;

  cM2_pdg[-11] = M2_e;//cM2_e;
  cM2_pdg[-12] = 0.;//cM2_ve;
  cM2_pdg[-13] = M2_mu;//cM2_mu;
  cM2_pdg[-14] = 0.;//cM2_vm;
  cM2_pdg[-15] = M2_tau;//cM2_tau;
  cM2_pdg[-16] = 0.;//cM2_vt;

  cM2_pdg[0] = 0.;
  cM2_pdg[21] = 0.;
  cM2_pdg[22] = 0.;
  cM2_pdg[-22] = 0.; // ???
  cM2_pdg[23] = cM2_Z;
  cM2_pdg[25] = cM2_H;

  cM2_pdg[24] = cM2_W;
  cM2_pdg[-24] = cM2_W;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


