#include "header.hpp"

void munich::integration_born(){
  static Logger logger("munich::integration_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization_integration();
  asi->calculate_ME2check_born();
  initialization_integration_check();
  
  while (osi->int_end == 0){
    rsi.perform_iteration_step();
    if (osi->int_end == 1){break;}
    psi->calculate_IS();
    psi->ac_psp(0, psi->MC_phasespace.channel);
    esi->determine_p_parton();
    //    if (esi->p_parton != esi->p_parton){errorhandling_c_psp(); continue;}
    if (munich_isnan(esi->p_parton)){errorhandling_c_psp(); continue;}
    esi->cut_ps[0] = 0;
    esi->perform_event_selection();
    if (esi->cut_ps[0] == -1){psi->handling_cut_psp(); continue;}
    if (osi->switch_console_output_tau_0){psi->output_check_tau_0();}
    if (osi->switch_output_testpoint){osi->output_testpoint_input();}
    psi->ag_psp(0, 0);
    psi->calculate_g_tot();
    //    if (munich_isnan(psi->g_tot) || munich_isinf(psi->g_tot)){errorhandling_gtot(); continue;} // isinf case ???
    if (munich_isinfnan(psi->g_tot)){errorhandling_gtot(); continue;}
    asi->calculate_ME2_born();
    if (munich_isnan(osi->ME2)){errorhandling_me2(); continue;}
    if (csi->class_contribution_qTcut_explicit){
      esi->qT_basic->counter_acc_qTcut[esi->cut_ps[0]]++;
      if (osi->ME2 == 0.){
	esi->qT_basic->counter_killed_qTcut[esi->cut_ps[0]]++;
	psi->i_tec++;
	psi->handling_techcut_psp();
	continue;
      }
    }
    if (!(osi->check_vanishing_ME2_end) && !(csi->class_contribution_loopinduced)){handling_vanishing_me2(); if (osi->flag_vanishing_ME2){continue;}}
    osi->calculate_dynamic_scale(0);
    osi->calculate_dynamic_scale_TSV(0);
    osi->determine_scale();
    if (osi->switch_moment){osi->moments();}
    osi->calculate_pdf_LHAPDF_CV();
    //    osi->calculate_pdf_LHAPDF_TSV();
    osi->calculate_pdf_LHAPDF_list_TSV();
    if (munich_isnan(osi->pdf_factor[0])){errorhandling_pdf(); continue;}
    if (munich_isnan(osi->var_rel_alpha_S)){errorhandling_alpha_S(); continue;}
    osi->determine_integrand();
    osi->determine_psp_weight_TSV();
    osi->determine_psp_weight();
    if (osi->switch_output_maxevent){osi->output_integrand_maximum();}
    if (osi->switch_distribution){osi->determine_distribution_complete();}
    if (osi->switch_optimization_modifier){osi->calculate_optimization_modifier();}
    psi->psp_optimization_complete(osi->integrand, osi->this_psp_weight, osi->this_psp_weight2, osi->optimization_modifier);
    psi->i_acc++; psi->i_acc_step++;
    
    // Introduce switch !!!
    //    asi->output_phasespacepoints();
   
    osi->determine_runtime();
  }
  osi->output_finalization_integration();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
