#include "header.hpp"

void observable_set::calculate_pdf_LHAPDF_list_TSV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_list_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // Location should be checked - could be done here if only this function is used !!!
  for (int i_x = 0; i_x < 3; i_x++){psi->xz_pdf[i_x][0] = psi->x_pdf[i_x];}
  if (csi->class_contribution_collinear){for (int i_x = 1; i_x < 3; i_x++){psi->xz_pdf[i_x][1] = psi->x_pdf[i_x] / psi->z_coll[i_x];}}
  // xz_pdf: 0 - 0 : tau = x1 * x2
  //         1 - 0 : x1 -> no collinear emission from 1st parton
  //         2 - 0 : x2 -> no collinear emission from 2nd parton
  //        (x - 1 is only filled for contributions with collinear emission)
  //         0 - 1 : empty
  //         1 - 1 : x1 / z1 -> collinear emission from 1st parton
  //         2 - 1 : x2 / z2 -> collinear emission from 2nd parton

  if (!switch_TSV){return;}
  for (int i_a = 0; i_a < n_ps; i_a++){
    for (int i_v = 0; i_v < max_dyn_fact + 1; i_v++){
      for (int i_m = 0; i_m < n_scale_dyn_fact[i_v]; i_m++){
	calculate_pdf_LHAPDF_scale_list_TSV(i_a, i_v, i_m);
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_scale_list_TSV(int i_a, int i_v, int i_m){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_scale_list_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // Shift to separate initialization function !!!

  static int initialization = 1;
  static vector<vector<vector<double> > > lhapdf_result;
  static int hasPhoton = LHAPDF::hasPhoton();
  ///  static vector<int> max_emission(3, 0);
  if (initialization == 1){
    if (hasPhoton == 0){lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (13)));}
    else {lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (14)));}
    /*
    if (csi->class_contribution_QT_collinear || csi->class_contribution_QT_virtual){
      for (int i_x = 1; i_x < 3; i_x++){
	for (int i_c = 0; i_c < ncollinear.size(); i_c++){
	  if (ncollinear[i_c].n_emission_leg_type[i_x][0] > 0){max_emission[i_x] = 1;}
	}
      }
    }
    if (csi->class_contribution_CS_collinear){
      for (int i_x = 1; i_x < 3; i_x++){
	for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
	  if ((*CA_collinear)[i_c].size() == 0){continue;}
	  if ((*CA_collinear)[i_c][0].in_collinear()[i_x] > 0){max_emission[i_x] = 1;}
	}
      }
    }
    */
    logger << LOG_DEBUG_VERBOSE << "initialization done" << endline_flush;
    initialization = 0;
  }

  for (int i_x = 1; i_x < 3; i_x++){
    for (int i_z = 0; i_z < 2; i_z++){
      if (active_pdf[i_x][i_z]){
	if (hasPhoton == 0){lhapdf_result[i_x][i_z] = LHAPDF::xfx(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
	else {lhapdf_result[i_x][i_z] = LHAPDF::xfxphoton(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
      }
      /*
      for (int i_z = 0; i_z <= max_emission[i_x]; i_z++){
      if (hasPhoton == 0){lhapdf_result[i_x][i_z] = LHAPDF::xfx(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
      else {lhapdf_result[i_x][i_z] = LHAPDF::xfxphoton(psi->xz_pdf[i_x][i_z], value_scale_fact[i_a][i_v][i_m]);}
      */
    }
  }
  logger << LOG_DEBUG_VERBOSE << "lhapdf_result calculation done" << endline_flush;

  for (int i_l = 0; i_l < list_combination_pdf.size(); i_l++){
    for (int i_y = 1; i_y < 3; i_y++){value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][i_y] = 0.;}
    if (list_combination_pdf[i_l].size() == 0){continue;}
    int i_z1 = list_combination_pdf_emission[i_l][1];
    int i_z2 = list_combination_pdf_emission[i_l][2];
    logger << LOG_DEBUG_VERBOSE << "i_z1 = " << i_z1 << endline_flush;
    logger << LOG_DEBUG_VERBOSE << "i_z2 = " << i_z2 << endline_flush;

    for (int i_i = 0; i_i < list_combination_pdf[i_l].size(); i_i++){
      for (int i_x = 0; i_x < list_combination_pdf[i_l][i_i].size(); i_x++){
	double factor1 = 0.;
	double factor2 = 0.;
	int direction = 1;
	if (list_combination_pdf[i_l][i_i][i_x][0] == -1){direction = 2;}

	if (list_combination_pdf[i_l][i_i][i_x][1] == 7){factor1 = lhapdf_result[1][i_z1][13];}
	else if (csi->coll_choice == 1){factor1 = lhapdf_result[1][i_z1][6 + list_combination_pdf[i_l][i_i][i_x][1]];}
	else if (csi->coll_choice == 2){
	  if      (list_combination_pdf[i_l][i_i][i_x][0] ==  1){factor1 = lhapdf_result[1][i_z1][6 + list_combination_pdf[i_l][i_i][i_x][1]];}
	  else if (list_combination_pdf[i_l][i_i][i_x][0] == -1){factor1 = lhapdf_result[1][i_z1][6 - list_combination_pdf[i_l][i_i][i_x][1]];}
	}
	else if (csi->coll_choice == 3){factor1 = lhapdf_result[1][i_z1][6 - list_combination_pdf[i_l][i_i][i_x][1]];}

	if (list_combination_pdf[i_l][i_i][i_x][2] == 7){factor2 = lhapdf_result[2][i_z2][13];}
	else if (csi->coll_choice == 1){factor2 = lhapdf_result[2][i_z2][6 + list_combination_pdf[i_l][i_i][i_x][2]];}
	else if (csi->coll_choice == 2){
	  if      (list_combination_pdf[i_l][i_i][i_x][0] ==  1){factor2 = lhapdf_result[2][i_z2][6 - list_combination_pdf[i_l][i_i][i_x][2]];}
	  else if (list_combination_pdf[i_l][i_i][i_x][0] == -1){factor2 = lhapdf_result[2][i_z2][6 + list_combination_pdf[i_l][i_i][i_x][2]];}
	}
	else if (csi->coll_choice == 3){factor2 = lhapdf_result[2][i_z2][6 - list_combination_pdf[i_l][i_i][i_x][2]];}

	// new !!! to have a and b components available later !!!
	if (csi->class_contribution_CS_collinear){
	  int i_z = 0;
	  if (i_z1 == 1){i_z = 1;}
	  if (i_z2 == 1){i_z = 2;}
	  // Each list_combination_pdf should contain only a single xz1/xz2 combination now, so filling only i_z = 0 should be sufficient (index can be removed later) !!!
	  i_z = 0;

	  // i_z is treated differently for QT and CS collinear:  Use  value_pdf_factor for CA for now !!!
	  value_pdf_factor_a[i_l][i_i][i_x][i_z][i_v][i_m][direction] = factor1 / psi->x_pdf[1];
	  if (i_z1 == 1){value_pdf_factor_a[i_l][i_i][i_x][i_z][i_v][i_m][direction] *= psi->z_coll[1];}
	  value_pdf_factor_b[i_l][i_i][i_x][i_z][i_v][i_m][direction] = factor2 / psi->x_pdf[2];
	  if (i_z2 == 1){value_pdf_factor_b[i_l][i_i][i_x][i_z][i_v][i_m][direction] *= psi->z_coll[2];}

	  // Use  value_list_pdf_factor_TSV  here ???
	  value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][direction] += value_pdf_factor_a[i_l][i_i][i_x][i_z][i_v][i_m][direction] * value_pdf_factor_b[i_l][i_i][i_x][i_z][i_v][i_m][direction] * QT_Q2f[i_l][i_i][i_x];  // Charge factors added for QED (should always be 1 for QCD) !!!
	}
	else {
	  double factor = factor1 * factor2;
	  // Might require some modification for more than one emission !!!
	  if (csi->class_contribution_collinear){
	    factor *= QT_Q2f[i_l][i_i][i_x];  // Charge factors added for QED (should always be 1 for QCD) !!!
	    logger << LOG_DEBUG_POINT << "QT_Q2f[" << i_l << "][" << i_i << "][" << i_x << "] = " << QT_Q2f[i_l][i_i][i_x] << endline_flush;
	  }
	  value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][direction] += factor;

	  logger << LOG_DEBUG_POINT << "factor = " << factor << endline_flush;
	  logger << LOG_DEBUG_POINT << "value_list_pdf_factor_TSV[" << i_a << "][" << i_v << "][" << i_m << "][" << i_l << "][" << direction << "] = " << value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][direction] << endline_flush;
	}
      }
    }

    if (!csi->class_contribution_CS_collinear){
      for (int i_y = 1; i_y < 3; i_y++){
	value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][i_y] = value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][i_y] / (psi->xz_pdf[1][i_z1] * psi->xz_pdf[2][i_z2]);
      }
    }
    value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][0] = value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][1] + value_list_pdf_factor_TSV[i_a][i_v][i_m][i_l][2];
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}





void observable_set::calculate_pdf_LHAPDF_list_CV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_list_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int sd = 0; sd < value_mu_fact.size(); sd++){
    if (value_mu_fact[sd].size() == 0){continue;}
    for (int ss = 0; ss < value_mu_fact[sd].size(); ss++){
      calculate_pdf_LHAPDF_scale_list_CV(sd, ss);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_scale_list_CV(int sd, int ss){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_scale_list_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  static int initialization = 1;
  static vector<vector<vector<double> > > lhapdf_result;
  static int hasPhoton = LHAPDF::hasPhoton();
  static vector<int> max_emission(3, 0);
  if (initialization == 1){
    if (hasPhoton == 0){lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (13)));}
    else {lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (14)));}
    for (int i_x = 1; i_x < 3; i_x++){
      for (int i_c = 0; i_c < ncollinear.size(); i_c++){
	if (ncollinear[i_c].n_emission_leg_type[i_x][0] > 0){max_emission[i_x] = 1;}
      }
    }
    initialization = 0;
  }

  // new meaning for multicollinear !!!
  // xz_pdf: 0 - 0 : empty - could be filled with tau = x1 * x2
  //         1 - 0 : x1 -> no collinear emission from 1st parton
  //         2 - 0 : x2 -> no collinear emission from 2nd parton
  //         0 - 1 : empty
  //         1 - 1 : x1 / z1 -> collinear emission from 1st parton
  //         2 - 1 : x2 / z2 -> collinear emission from 2nd parton

  for (int i_x = 1; i_x < 3; i_x++){
    for (int i_z = 0; i_z <= max_emission[i_x]; i_z++){
      if (hasPhoton == 0){lhapdf_result[i_x][i_z] = LHAPDF::xfx(psi->xz_pdf[i_x][i_z], value_mu_fact[sd][ss]);}
      else {lhapdf_result[i_x][i_z] = LHAPDF::xfxphoton(psi->xz_pdf[i_x][i_z], value_mu_fact[sd][ss]);}
      //      modify_pdf_content(lhapdf_result[i_x][i_z], *this);
      for (int i_p = 0; i_p < lhapdf_result[i_x][i_z].size(); i_p++){logger << LOG_DEBUG_VERBOSE << "psi->xz_pdf[" << i_x << "][" << i_z << "] = " << setw(23) << setprecision(15) << psi->xz_pdf[i_x][i_z] << "   lhapdf_result[" << i_x << "][" << i_z << "][" << i_p << "] = " << lhapdf_result[i_x][i_z][i_p] << endline_flush;}
    }
  }

  for (int i_l = 0; i_l < list_combination_pdf.size(); i_l++){
    value_list_pdf_factor[sd][ss][i_l] = vector<double> (3, 0.);
    //    for (int i_y = 0; i_y < 3; i_y++){value_list_pdf_factor[sd][ss][i_l][i_y] = 0.;}
    if (list_combination_pdf[i_l].size() == 0){continue;}
    int i_z1 = list_combination_pdf_emission[i_l][1];
    int i_z2 = list_combination_pdf_emission[i_l][2];
    for (int i_i = 0; i_i < list_combination_pdf[i_l].size(); i_i++){
      for (int i_x = 0; i_x < list_combination_pdf[i_l][i_i].size(); i_x++){
	double factor1 = 0.;
	double factor2 = 0.;
	int direction = 1;
	if (list_combination_pdf[i_l][i_i][i_x][0] == -1){direction = 2;}

	if (list_combination_pdf[i_l][i_i][i_x][1] == 7){factor1 = lhapdf_result[1][i_z1][13];}
	else if (csi->coll_choice == 1){factor1 = lhapdf_result[1][i_z1][6 + list_combination_pdf[i_l][i_i][i_x][1]];}
	else if (csi->coll_choice == 2){
	  if      (list_combination_pdf[i_l][i_i][i_x][0] ==  1){factor1 = lhapdf_result[1][i_z1][6 + list_combination_pdf[i_l][i_i][i_x][1]];}
	  else if (list_combination_pdf[i_l][i_i][i_x][0] == -1){factor1 = lhapdf_result[1][i_z1][6 - list_combination_pdf[i_l][i_i][i_x][1]];}
	}
	else if (csi->coll_choice == 3){factor1 = lhapdf_result[1][i_z1][6 - list_combination_pdf[i_l][i_i][i_x][1]];}

	if (list_combination_pdf[i_l][i_i][i_x][2] == 7){factor2 = lhapdf_result[2][i_z2][13];}
	else if (csi->coll_choice == 1){factor2 = lhapdf_result[2][i_z2][6 + list_combination_pdf[i_l][i_i][i_x][2]];}
	else if (csi->coll_choice == 2){
	  if      (list_combination_pdf[i_l][i_i][i_x][0] ==  1){factor2 = lhapdf_result[2][i_z2][6 - list_combination_pdf[i_l][i_i][i_x][2]];}
	  else if (list_combination_pdf[i_l][i_i][i_x][0] == -1){factor2 = lhapdf_result[2][i_z2][6 + list_combination_pdf[i_l][i_i][i_x][2]];}
	}
	else if (csi->coll_choice == 3){factor2 = lhapdf_result[2][i_z2][6 - list_combination_pdf[i_l][i_i][i_x][2]];}
	double factor = factor1 * factor2;
	factor *= QT_Q2f[i_l][i_i][i_x];  // Charge factors added for QED (should always be 1 for QCD) !!!
	value_list_pdf_factor[sd][ss][i_l][direction] += factor;
	/*
	// Might require some modification for more than one emission !!!
	for (int i_e = 0; i_e < list_combination_pdf[i_l][i_i].size(); i_e++){
	  if (ncollinear[i_l].type_correction[i_e] == 2){factor *= QT_Q2f[i_l][i_i][i_x];}// charge factors !!!
	  logger << LOG_DEBUG_POINT << "QT_Q2f[" << i_l << "][" << i_i << "][" << i_x << "] = " << QT_Q2f[i_l][i_i][i_x] << endline_flush;
	  value_list_pdf_factor[sd][ss][i_l][direction] += factor1 * factor2;
	}
	*/
	//	value_list_pdf_factor[sd][ss][i_l][direction] += factor1 * factor2;
      }
    }

    for (int i_y = 1; i_y < 3; i_y++){value_list_pdf_factor[sd][ss][i_l][i_y] = value_list_pdf_factor[sd][ss][i_l][i_y] / (psi->xz_pdf[1][i_z1] * psi->xz_pdf[2][i_z2]);}
    value_list_pdf_factor[sd][ss][i_l][0] = value_list_pdf_factor[sd][ss][i_l][1] + value_list_pdf_factor[sd][ss][i_l][2];
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_CA_collinear_CV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_CA_collinear_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int sd = 0; sd < value_mu_fact.size(); sd++){
    if (value_mu_fact[sd].size() == 0){continue;}
    for (int ss = 0; ss < value_mu_fact[sd].size(); ss++){
      if (csi->coll_choice == 0){logger << LOG_FATAL << "parton--parton scattering CA contribution doesn't make sense!" << endline_flush; exit(1);}
      else {calculate_pdf_LHAPDF_scale_CA_collinear_CV(value_mu_fact[sd][ss], CA_value_pdf_factor[sd][ss]);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_scale_CA_collinear_CV(double & mu_fact, vector<vector<vector<double> > > & all_pdf_factor){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_scale_CA_collinear_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  static int initialization = 1;
  static vector<vector<vector<double> > > lhapdf_result;
  static vector<vector<int> > in_collinear((*CA_collinear).size());
  static vector<vector<vector<int> > > all_pdf((*CA_collinear).size());
  static int hasPhoton = LHAPDF::hasPhoton();
  if (initialization == 1){
    if (hasPhoton == 0){lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (13)));}
    else {lhapdf_result.resize(3, vector<vector<double> > (3, vector<double> (14)));}
    for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
      in_collinear[i_a] = (*CA_collinear)[i_a][0].in_collinear();
      all_pdf[i_a] = (*CA_collinear)[i_a][0].all_pdf();
    }
    initialization = 0;
  }

  for (int i_x = 1; i_x < 3; i_x++){
    //    for (int i_z = 0; i_z < i_x + 1; i_z += i_x){
    for (int i_z = 0; i_z < 2; i_z++){
      if (hasPhoton == 0){lhapdf_result[i_x][i_z] = LHAPDF::xfx(psi->xz_pdf[i_x][i_z], mu_fact);}
      else {lhapdf_result[i_x][i_z] = LHAPDF::xfxphoton(psi->xz_pdf[i_x][i_z], mu_fact);}
      /*
      if (hasPhoton == 0){lhapdf_result[i_x][i_z] = LHAPDF::xfx(all_xz_coll_pdf[i_x][i_z], mu_fact);}
      else {lhapdf_result[i_x][i_z] = LHAPDF::xfxphoton(all_xz_coll_pdf[i_x][i_z], mu_fact);}
      */
      //      for (int i_p = 0; i_p < lhapdf_result[i_x][i_z].size(); i_p++){logger << LOG_DEBUG_POINT << "lhapdf_result[" << i_x << "][" << i_z << "][" << i_p << "] = " << lhapdf_result[i_x][i_z][i_p] << endline_flush;}
    }
  }
  static vector<vector<vector<double> > > empty_all_pdf_factor(all_pdf_factor.size(), vector<vector<double> > (3, vector<double> (3, 0.))); // ???
  all_pdf_factor = empty_all_pdf_factor;
  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int i_i = 0; i_i < all_pdf[i_c].size(); i_i++){
      for (int i_z = 0; i_z < 3; i_z++){
	if (in_collinear[i_c][i_z] == 1){
	  /*
	  int i_z1;
	  int i_z2;
	  if      (i_z == 0){i_z1 = 0; i_z2 = 0;}
	  else if (i_z == 1){i_z1 = 1; i_z2 = 0;}
	  else if (i_z == 2){i_z1 = 0; i_z2 = 2;}
	  */
	  int i_z1 = 0;
	  int i_z2 = 0;
	  if (i_z == 1){i_z1 = 1;}
	  if (i_z == 2){i_z2 = 1;}
	  double factor1 = 0.;
	  double factor2 = 0.;
	  for (int i_x = 0; i_x < CA_combination_pdf[i_c][i_i].size(); i_x++){
	    int direction = 1;
	    if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){direction = 2;}

	    if (CA_combination_pdf[i_c][i_i][i_x][1] == 7){factor1 = lhapdf_result[1][i_z1][13];}
	    else if (csi->coll_choice == 1){factor1 = lhapdf_result[1][i_z1][6 + CA_combination_pdf[i_c][i_i][i_x][1]];}
	    else if (csi->coll_choice == 2){
	      if      (CA_combination_pdf[i_c][i_i][i_x][0] ==  1){factor1 = lhapdf_result[1][i_z1][6 + CA_combination_pdf[i_c][i_i][i_x][1]];}
	      else if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){factor1 = lhapdf_result[1][i_z1][6 - CA_combination_pdf[i_c][i_i][i_x][1]];}
	    }
	    else if (csi->coll_choice == 3){factor1 = lhapdf_result[1][i_z1][6 - CA_combination_pdf[i_c][i_i][i_x][1]];}

	    if (CA_combination_pdf[i_c][i_i][i_x][2] == 7){factor2 = lhapdf_result[2][i_z2][13];}
	    else if (csi->coll_choice == 1){factor2 = lhapdf_result[2][i_z2][6 + CA_combination_pdf[i_c][i_i][i_x][2]];}
	    else if (csi->coll_choice == 2){
	      if      (CA_combination_pdf[i_c][i_i][i_x][0] ==  1){factor2 = lhapdf_result[2][i_z2][6 - CA_combination_pdf[i_c][i_i][i_x][2]];}
	      else if (CA_combination_pdf[i_c][i_i][i_x][0] == -1){factor2 = lhapdf_result[2][i_z2][6 + CA_combination_pdf[i_c][i_i][i_x][2]];}
	    }
	    else if (csi->coll_choice == 3){factor2 = lhapdf_result[2][i_z2][6 - CA_combination_pdf[i_c][i_i][i_x][2]];}

	    double factor = factor1 * factor2;
	    if ((*CA_collinear)[i_c][0].type_correction() == 2){factor *= CA_Q2f[i_c][i_i][i_x];}  // Charge factors added for QED !!!
	    all_pdf_factor[i_c][i_z][direction] += factor;
	  }
	}
      }
    }
  }

  for (int i_c = 0; i_c < (*CA_collinear).size(); i_c++){
    for (int i_z = 0; i_z < 3; i_z++){
      if (in_collinear[i_c][i_z] == 0){continue;}
      for (int i_y = 1; i_y < 3; i_y++){
	all_pdf_factor[i_c][i_z][i_y] = all_pdf_factor[i_c][i_z][i_y] / psi->x_pdf[0];
	if (i_z > 0){all_pdf_factor[i_c][i_z][i_y] *= psi->z_coll[i_z];}
	/*
	if (i_z == 0){all_pdf_factor[i_c][i_z][i_y] = all_pdf_factor[i_c][i_z][i_y] / all_xz_coll_pdf[0][0];}
	else {all_pdf_factor[i_c][i_z][i_y] = all_pdf_factor[i_c][i_z][i_y] / all_xz_coll_pdf[i_z % 2 + 1][i_z];}
	*/
      }
      all_pdf_factor[i_c][i_z][0] = all_pdf_factor[i_c][i_z][1] + all_pdf_factor[i_c][i_z][2];
    }
  }

  // all_xz_coll_pdf: 0 - 0 : tau = x1 * x2
  //                  1 - 0 : x1 -> enters 1st pdf if ()_+ or delta distributions are present
  //                  2 - 0 : x2 -> enters 2nd pdf if ()_+ or delta distributions are present
  //                  0 - 1 : z1 -> collinear emission from a
  //                  1 - 1 : x1 / z1 -> enters 1st pdf for regular and ()_+ distributions
  //                  2 - 1 : empty - could be filled with (x1 / z1) * x2
  //                  0 - 2 : z2 -> collinear emission from b
  //                  1 - 2 : empty - could be filled with (x2 / z2) * x1
  //                  2 - 2 : x2 / z2 -> enters 1st pdf for regular and ()_+ distributions
  // should maybe replace psi->x_pdf, z_coll, and xz_coll_pdf later...

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_CV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<vector<vector<double> > > value_pdf_factor(value_mu_fact.size());
  for (int sd = 0; sd < value_mu_fact.size(); sd++){
    value_pdf_factor[sd].resize(value_mu_fact[sd].size(), vector<double> (3));
    for (int ss = 0; ss < value_mu_fact[sd].size(); ss++){
      if (csi->coll_choice == 0){value_pdf_factor[sd][ss][1] = 1.; value_pdf_factor[sd][ss][2] = 0.; value_pdf_factor[sd][ss][0] = value_pdf_factor[sd][ss][1];}
      else {calculate_pdf_LHAPDF_scale_CV(value_mu_fact[sd][ss], value_pdf_factor[sd][ss]);}
    }
  }
  pdf_factor = value_pdf_factor[dynamic_scale][map_value_scale_fact];
  if (switch_CV){for (int s = 0; s < n_scales_CV; s++){pdf_factor_CV[s] = value_pdf_factor[dynamic_scale_CV][map_value_scale_fact_CV[s]];}}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_RA_CV(){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_RA_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<vector<vector<vector<double> > > > RA_value_pdf_factor(RA_value_mu_fact.size());
  for (int ia = 0; ia < RA_value_pdf_factor.size(); ia++){
    RA_value_pdf_factor[ia].resize(RA_value_mu_fact[ia].size());
    for (int sd = 0; sd < RA_value_mu_fact[ia].size(); sd++){
      if (sd == 0 && ia > 0){
	RA_value_pdf_factor[ia][0] = RA_value_pdf_factor[0][0];
      }
      else {
	RA_value_pdf_factor[ia][sd].resize(RA_value_mu_fact[ia][sd].size(), vector<double> (3));
	for (int ss = 0; ss < RA_value_mu_fact[ia][sd].size(); ss++){
	  if (csi->coll_choice == 0){RA_value_pdf_factor[ia][sd][ss][1] = 1.; RA_value_pdf_factor[ia][sd][ss][2] = 0.; RA_value_pdf_factor[ia][sd][ss][0] = RA_value_pdf_factor[ia][sd][ss][1];}
	  else {calculate_pdf_LHAPDF_scale_CV(RA_value_mu_fact[ia][sd][ss], RA_value_pdf_factor[ia][sd][ss]);}
	}
      }
    }
    RA_pdf_factor[ia] = RA_value_pdf_factor[ia][dynamic_scale][map_value_scale_fact];
    if (switch_CV){for (int s = 0; s < n_scales_CV; s++){RA_pdf_factor_CV[ia][s] = RA_value_pdf_factor[ia][dynamic_scale_CV][map_value_scale_fact_CV[s]];}}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::calculate_pdf_LHAPDF_scale_CV(double & mu_fact, vector<double> & pdf_factor){
  static Logger logger("observable_set::calculate_pdf_LHAPDF_scale_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  static int initialization = 1;
  static int hasPhoton = LHAPDF::hasPhoton();
  static vector<vector<double> > lhapdf_result;
  if (initialization == 1){
    if (hasPhoton == 0){lhapdf_result.resize(3, vector<double> (13));}
    else {lhapdf_result.resize(3, vector<double> (14));}
    initialization = 0;
  }
  for (int i_h = 1; i_h < 3; i_h++){
    if (hasPhoton == 0){lhapdf_result[i_h] = LHAPDF::xfx(psi->x_pdf[i_h], mu_fact);}
    else {lhapdf_result[i_h] = LHAPDF::xfxphoton(psi->x_pdf[i_h], mu_fact);}
    //    if (pdf_content_modify != -1){modify_pdf_content(lhapdf_result[i_h], *this);}
  }
  
  for (int i_y = 1; i_y < 3; i_y++){pdf_factor[i_y] = 0.;}
  for (int i = 0; i < csi->combination_pdf.size(); i++){
    double factor1 = 0.;
    double factor2 = 0.;
    int direction = 1;
    if (csi->combination_pdf[i][0] == -1){direction = 2;}

    if (csi->combination_pdf[i][1] == 7){factor1 = lhapdf_result[1][13];}
    else if (csi->coll_choice == 1){factor1 = lhapdf_result[1][6 + csi->combination_pdf[i][1]];}
    else if (csi->coll_choice == 2){
      if      (csi->combination_pdf[i][0] ==  1){factor1 = lhapdf_result[1][6 + csi->combination_pdf[i][1]];}
      else if (csi->combination_pdf[i][0] == -1){factor1 = lhapdf_result[1][6 - csi->combination_pdf[i][1]];}
    }
    else if (csi->coll_choice == 3){factor1 = lhapdf_result[1][6 - csi->combination_pdf[i][1]];}

    if (csi->combination_pdf[i][2] == 7){factor2 = lhapdf_result[2][13];}
    else if (csi->coll_choice == 1){factor2 = lhapdf_result[2][6 + csi->combination_pdf[i][2]];}
    else if (csi->coll_choice == 2){
      if      (csi->combination_pdf[i][0] ==  1){factor2 = lhapdf_result[2][6 - csi->combination_pdf[i][2]];}
      else if (csi->combination_pdf[i][0] == -1){factor2 = lhapdf_result[2][6 + csi->combination_pdf[i][2]];}
    }
    else if (csi->coll_choice == 3){factor2 = lhapdf_result[2][6 - csi->combination_pdf[i][2]];}

    double factor = factor1 * factor2;
    pdf_factor[direction] += factor;
  }
  pdf_factor[0] = pdf_factor[1] + pdf_factor[2];
  for (int i_x = 0; i_x < 3; i_x++){
    pdf_factor[i_x] = pdf_factor[i_x] / psi->x_pdf[0];
  }

  /*  
  pdf_factor.resize(3, 0.);
  for (int i = 0; i < csi->combination_pdf.size(); i++){
    if (csi->coll_choice == 1){
      if      (csi->combination_pdf[i][0] ==  1){pdf_factor[1] += lhapdf_result[1][6 + csi->combination_pdf[i][1]] * lhapdf_result[2][6 + csi->combination_pdf[i][2]];}
      else if (csi->combination_pdf[i][0] == -1){pdf_factor[2] += lhapdf_result[1][6 + csi->combination_pdf[i][1]] * lhapdf_result[2][6 + csi->combination_pdf[i][2]];}
      else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
    }
    else if (csi->coll_choice == 2){
      if      (csi->combination_pdf[i][0] ==  1){pdf_factor[1] += lhapdf_result[1][6 + csi->combination_pdf[i][1]] * lhapdf_result[2][6 - csi->combination_pdf[i][2]];}
      else if (csi->combination_pdf[i][0] == -1){pdf_factor[2] += lhapdf_result[1][6 - csi->combination_pdf[i][1]] * lhapdf_result[2][6 + csi->combination_pdf[i][2]];}
      else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
    }
    else if (csi->coll_choice == 3){
      if      (csi->combination_pdf[i][0] ==  1){pdf_factor[1] += lhapdf_result[1][6 - csi->combination_pdf[i][1]] * lhapdf_result[2][6 - csi->combination_pdf[i][2]];}
      else if (csi->combination_pdf[i][0] == -1){pdf_factor[2] += lhapdf_result[1][6 - csi->combination_pdf[i][1]] * lhapdf_result[2][6 - csi->combination_pdf[i][2]];}
      else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
    }
    else {logger << LOG_FATAL << "No valid pdf selection!" << endline_flush; exit(1);}
  }
  pdf_factor[0] = pdf_factor[1] + pdf_factor[2];
  for (int i_x = 0; i_x < 3; i_x++){
    pdf_factor[i_x] = pdf_factor[i_x] / psi->x_pdf[0];
  }
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
