#include "header.hpp"

void summary_contribution::readin_result_contribution_CV(string result_moment, int x_m){
  Logger logger("summary_contribution::readin_result_contribution_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "readin_result_contribution_CV started:" << endline_flush;
  logger << LOG_DEBUG << "ylist->resultdirectory = " << ylist->resultdirectory << endline_flush;
  logger << LOG_DEBUG << "type_perturbative_order = " << type_perturbative_order << endline_flush;
  logger << LOG_DEBUG << "type_subtraction_method = " << type_subtraction_method << endline_flush;
  logger << LOG_DEBUG << "in_contribution_order_alpha_s = " << in_contribution_order_alpha_s << endline_flush;
  logger << LOG_DEBUG << "in_contribution_order_alpha_e = " << in_contribution_order_alpha_e << endline_flush;
  logger << LOG_DEBUG << "type_contribution = " << type_contribution << endline_flush;
  logger << LOG_DEBUG << "type_correction = " << type_correction << endline_flush;
  logger << LOG_DEBUG << "interference = " << interference << endline_flush;
  logger << LOG_DEBUG << "photon_induced = " << photon_induced << endline_flush;
  logger << LOG_DEBUG << "infix_contribution = " << infix_contribution << endline_flush;
  logger << LOG_DEBUG << "infix_order_contribution = " << infix_order_contribution << endline_flush;
  for (int i_d = 0; i_d < directory.size(); i_d++){logger << LOG_DEBUG << "directory[" << setw(3) << "] = " << directory[i_d] << endline_flush;}
  logger << LOG_DEBUG << "xsubprocess.size() = " << xsubprocess.size() << endline_flush;
  for (int i_p = 1; i_p < xsubprocess.size(); i_p++){logger << LOG_DEBUG << "xsubprocess[" << setw(3) << "] = " << xsubprocess[i_p]->name << endline_flush;}
  logger << LOG_DEBUG << "ygeneric->subgroup.size() = " << ygeneric->subgroup.size() << endline_flush;
  for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){logger << LOG_DEBUG << "ygeneric->subgroup[" << setw(3) << "] = " << ygeneric->subgroup[i_g] << endline_flush;}
  logger << LOG_DEBUG << "subgroup_no_member = " << subgroup_no_member.size() << endline_flush;
  logger << LOG_DEBUG << "ygeneric->subgroup.size() = " << ygeneric->subgroup.size() << endline_flush;
  logger << LOG_DEBUG << "result_moment = " << result_moment << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "osi->n_qTcut        = " << osi->n_qTcut << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "osi->min_qTcut     = " << osi->min_qTcut << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "osi->value_qTcut.size()     = " << osi->value_qTcut.size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "osi->n_scales_CV    = " << osi->n_scales_CV << endline_flush;

  int default_size_CV =  1 + 2;
  if (active_qTcut){default_size_CV += 2 * osi->n_qTcut * osi->n_scales_CV;}
  else {default_size_CV += 2 * osi->n_scales_CV;}

  result_CV.resize(osi->n_moments, vector<vector<vector<double> > > (ygeneric->subgroup.size(), vector<vector<double> > (osi->n_qTcut, vector<double> (osi->n_scales_CV, 0.))));
  deviation_CV.resize(osi->n_moments, vector<vector<vector<double> > > (ygeneric->subgroup.size(), vector<vector<double> > (osi->n_qTcut, vector<double> (osi->n_scales_CV, 0.))));

  for (int i_p = 1; i_p < xsubprocess.size(); i_p++){xsubprocess[i_p]->readin_result_CV(result_moment);}

  ///////////////////////////////////////////////////////////////
  //  combination of different-seed runs for all subprocesses  //
  ///////////////////////////////////////////////////////////////

  for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
    logger << LOG_DEBUG_VERBOSE << left << xsubprocess[i_p]->name << ":" << endline_flush;
    // ???
    xsubprocess[i_p]->combine_result_alternative();
    //    xsubprocess[i_p]->combine_result_original(oset);
  }

  /////////////////////////////////////////////////////////////////////////////////
  //  combination of different-seed runs for all subprocesses with CV variation  //
  /////////////////////////////////////////////////////////////////////////////////

  for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
    logger << LOG_DEBUG_VERBOSE << left << xsubprocess[i_p]->name << ":" << endline_flush;
    xsubprocess[i_p]->combination_result_CV(result_moment);
  }

  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      xsubprocess[0]->result_CV[i_q][i_s] = 0.;
      double dev = 0.;
      for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
	xsubprocess[0]->result_CV[i_q][i_s] += xsubprocess[i_p]->result_CV[i_q][i_s];
	dev += pow(xsubprocess[i_p]->deviation_CV[i_q][i_s], 2);
      }
      xsubprocess[0]->deviation_CV[i_q][i_s] = sqrt(dev);
    }
  }

  ///////////////////////////////////////////////////////
  //  calculation of subgroup results in CV variation  //
  ///////////////////////////////////////////////////////

  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	double dev = 0.;
	for (int i_m = 0; i_m < subgroup_no_member[i_g].size(); i_m++){
	  result_CV[x_m][i_g][i_q][i_s] += xsubprocess[subgroup_no_member[i_g][i_m]]->result_CV[i_q][i_s];
	  dev += pow(xsubprocess[subgroup_no_member[i_g][i_m]]->deviation_CV[i_q][i_s], 2);
	}
	deviation_CV[x_m][i_g][i_q][i_s] = sqrt(dev);
      }
    }
  }

  ////////////////////
  //  output begin  // ???
  ////////////////////

  if ((x_m == 0 || x_m == osi->n_moments)){// || (infix_order_contribution == "LO")){
    if (ygeneric->switch_output_subprocess > 1){
      string filename;
      ofstream outfile_moment;

      if (x_m == osi->n_moments){filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_order_contribution + "/group/plot.qTcut." + infix_order_contribution + ".dat";}
      else {filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/" + ylist->resultdirectory + "/" + infix_order_contribution + "/group/plot." + result_moment + ".qTcut." + infix_order_contribution + ".dat";}
      logger << LOG_DEBUG << "Output : xfilename = " << filename << endline_flush;
      outfile_moment.open(filename.c_str(), ofstream::out | ofstream::trunc);
      outfile_moment << showpoint;
      for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
	outfile_moment << noshowpoint << setw(10) << setprecision(4) << osi->value_qTcut[i_q];
	for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	    outfile_moment << setw(15) << setprecision(8) << osi->unit_factor_result * result_CV[x_m][i_g][i_q][i_s] << setw(15) << setprecision(8) << osi->unit_factor_result * deviation_CV[x_m][i_g][i_q][i_s];
	  }
	}
	outfile_moment << endline;
      }
      outfile_moment.close();
      logger << LOG_DEBUG << filename << " finished." << endline_flush;
    }
  }

  logger << LOG_DEBUG << "output osi->min_qTcut variation finished" << endline_flush;

  //  if ((x_m == 0 || x_m == osi->n_moments)){
  if (ygeneric->switch_output_overview > 2){output_result_overview_qTcut_CV();}
  if (ygeneric->switch_output_result > 2){output_result_qTcut_CV();}
  if (ygeneric->switch_output_plot > 2){output_result_plot_qTcut_CV();}
  if (ygeneric->switch_output_plot > 2){output_result_plot_CV();}

  if (ygeneric->switch_output_plot > 3){output_subprocesses_result_plot_qTcut_CV();}
  if (ygeneric->switch_output_plot > 3){output_subprocesses_result_plot_CV();}
  //  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_contribution::readin_result_contribution_TSV(string result_moment, int x_m){
  Logger logger("summary_contribution::readin_result_contribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "infix_order_contribution = " << infix_order_contribution << endline_flush;

  // only debug output -> temporary !!!
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "readin_result_contribution_TSV started:" << endline_flush;
  logger << LOG_DEBUG << "type_perturbative_order = " << type_perturbative_order << endline_flush;
  logger << LOG_DEBUG << "type_subtraction_method = " << type_subtraction_method << endline_flush;
  logger << LOG_DEBUG << "in_contribution_order_alpha_s = " << in_contribution_order_alpha_s << endline_flush;
  logger << LOG_DEBUG << "in_contribution_order_alpha_e = " << in_contribution_order_alpha_e << endline_flush;
  logger << LOG_DEBUG << "type_contribution = " << type_contribution << endline_flush;
  logger << LOG_DEBUG << "type_correction = " << type_correction << endline_flush;
  logger << LOG_DEBUG << "interference = " << interference << endline_flush;
  logger << LOG_DEBUG << "photon_induced = " << photon_induced << endline_flush;
  for (int i_d = 0; i_d < directory.size(); i_d++){logger << LOG_DEBUG << "directory[" << setw(3) << "] = " << directory[i_d] << endline_flush;}
  logger << LOG_DEBUG << "subprocess.size() = " << subprocess.size() << endline_flush;
  for (int i_p = 1; i_p < subprocess.size(); i_p++){logger << LOG_DEBUG << "subprocess[" << setw(3) << "] = " << subprocess[i_p] << endline_flush;}
  logger << LOG_DEBUG << "ygeneric->subgroup.size() = " << ygeneric->subgroup.size() << endline_flush;
  for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){logger << LOG_DEBUG << "ygeneric->subgroup[" << setw(3) << "] = " << ygeneric->subgroup[i_g] << endline_flush;}
  logger << LOG_DEBUG << "subgroup_no_member = " << subgroup_no_member.size() << endline_flush;
  logger << LOG_DEBUG << "ygeneric->subgroup.size() = " << ygeneric->subgroup.size() << endline_flush;
  logger << LOG_DEBUG << "result_moment = " << result_moment << endline_flush;

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    for (int i_v = 0; i_v < ygeneric->name_scale_variation_TSV.size(); i_v++){
      // only if filled ???
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + ygeneric->name_scale_variation_TSV[i_v] + "/" + ylist->resultdirectory);
      // only if filled ???
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + ygeneric->name_scale_variation_TSV[i_v] + "/" + ylist->resultdirectory + "/" + infix_contribution);
    }
  }

  result_TSV.resize(osi->n_moments, vector<vector<vector<vector<vector<double> > > > > (ygeneric->subgroup.size(), vector<vector<vector<vector<double> > > > (osi->n_qTcut, vector<vector<vector<double> > > (osi->n_extended_set_TSV))));
  deviation_TSV.resize(osi->n_moments, vector<vector<vector<vector<vector<double> > > > > (ygeneric->subgroup.size(), vector<vector<vector<vector<double> > > > (osi->n_qTcut, vector<vector<vector<double> > > (osi->n_extended_set_TSV))));

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
      /////      for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
	for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	  if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	  if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	  result_TSV[i_m][i_g][i_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
	  deviation_TSV[i_m][i_g][i_q][i_s].resize(osi->n_scale_ren_TSV[i_s], vector<double> (osi->n_scale_fact_TSV[i_s], 0.));
	}
      }
    }
  }

  ///////////////////////////////////////////////////////////
  //  read and calculate results of individual subprocess  //
  ///////////////////////////////////////////////////////////

  for (int i_p = 1; i_p < xsubprocess.size(); i_p++){
    xsubprocess[i_p]->readin_result_TSV(result_moment);
    xsubprocess[i_p]->combination_result_TSV(result_moment);
    vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(xsubprocess[i_p]->result_group_run_TSV);
    vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(xsubprocess[i_p]->deviation_group_run_TSV);
  }

  ////////////////////////////////////////////////////////////
  //  calculate result summed over individual subprocesses  //
  ////////////////////////////////////////////////////////////

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    xsubprocess[0]->result_TSV[i_m][i_q][i_s][i_r][i_f] = 0.;
	    double dev = 0.;
	    for (int i_p = 1; i_p < subprocess.size(); i_p++){
	      xsubprocess[0]->result_TSV[i_m][i_q][i_s][i_r][i_f] += xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f];
	      dev += pow(xsubprocess[i_p]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] , 2);
	    }
	    xsubprocess[0]->deviation_TSV[i_m][i_q][i_s][i_r][i_f] = sqrt(dev);
	  }
	}
      }
    }
  }

  /////////////////////////////////////////////////////////////////////////////////////////
  //  calculation of cross sections for subprocess groups (i_g = 0 -> all subprocesses)  //
  /////////////////////////////////////////////////////////////////////////////////////////

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
      int x_q = 0;
      if (osi->n_qTcut == output_n_qTcut){x_q = i_q;}
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	      double dev = 0.;
	      logger << LOG_DEBUG_VERBOSE << "subgroup_no_member[" << i_g << "].size() = " << subgroup_no_member[i_g].size() << endline_flush;
	      for (int i_gm = 0; i_gm < subgroup_no_member[i_g].size(); i_gm++){
		result_TSV[i_m][i_g][i_q][i_s][i_r][i_f] += xsubprocess[subgroup_no_member[i_g][i_gm]]->result_TSV[i_m][x_q][i_s][i_r][i_f];
		dev += pow(xsubprocess[subgroup_no_member[i_g][i_gm]]->deviation_TSV[i_m][x_q][i_s][i_r][i_f], 2);
	      }
	      deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f] = sqrt(dev);
	    }
	  }
	}
      }
    }
  }

  
  logger << LOG_INFO << "Cross section results for reference scales and rcut values in contribution  " << infix_order_contribution << endline << endline << output_result_contribution_TSV() << endline_flush;

    
  if (ygeneric->switch_output_overview > 2){output_result_overview_qTcut_TSV();}
  if (ygeneric->switch_output_result > 2){output_result_qTcut_TSV();}
  if (ygeneric->switch_output_plot > 2){output_result_plot_qTcut_TSV();}
  if (ygeneric->switch_output_plot > 3){output_subprocesses_result_plot_qTcut_TSV();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


string summary_contribution::output_result_contribution_TSV(){
  Logger logger("summary_contribution::output_result_contribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp_ss;
  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
      int x_q = 0;
      if (osi->n_qTcut == output_n_qTcut){x_q = i_q;}
      for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
	if (!ygeneric->switch_output_scaleset[i_s]){continue;}
	if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    for (int i_g = 0; i_g < ygeneric->subgroup.size(); i_g++){
	      logger << LOG_DEBUG_VERBOSE << "subgroup_no_member[" << i_g << "].size() = " << subgroup_no_member[i_g].size() << endline_flush;
	      if (i_g == 0 && i_m == 0 && i_q == 0 && i_s == osi->no_reference_TSV && i_r == osi->no_scale_ren_reference_TSV && i_f == osi->no_scale_fact_reference_TSV){
		temp_ss << left << setw(20) << infix_contribution;
		temp_ss << "   " << "result_TSV = " << setw(23) << setprecision(15) << result_TSV[i_m][i_g][i_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << deviation_TSV[i_m][i_g][i_q][i_s][i_r][i_f] << endline;
		for (int i_s = 0; i_s < 87; i_s++){temp_ss << "-";} temp_ss << endline;
		for (int i_gm = 0; i_gm < subgroup_no_member[i_g].size(); i_gm++){
		  //		  for (int i_p = 0; i_p < subprocess.size(); i_p++){
		  temp_ss << left << setw(20) << xsubprocess[subgroup_no_member[i_g][i_gm]]->name << "   " << "result_TSV = " << setw(23) << setprecision(15) << xsubprocess[subgroup_no_member[i_g][i_gm]]->result_TSV[i_m][x_q][i_s][i_r][i_f] << " +- " << setw(23) << setprecision(15) << xsubprocess[subgroup_no_member[i_g][i_gm]]->deviation_TSV[i_m][x_q][i_s][i_r][i_f] << endline;
		  //		    xsubprocess[0]->result_TSV[i_m][i_q][i_s][i_r][i_f] += xsubprocess[i_p]->result_TSV[i_m][i_q][i_s][i_r][i_f];
		  //[" << i_m << "][" << subgroup_no_member[i_g][i_gm] << "][" << i_q << "][" << i_s << "][" << i_r << "][" << i_f << "]
		}
	      }
	    }
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished - return" << endline_flush;
  return temp_ss.str();
}
