#include "header.hpp"

void summary_generic::determine_scaleband(){
  Logger logger("summary_generic::determine_scaleband");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  vector<string> subgroup;
  //  int plotmode = 0;

  logger << LOG_DEBUG << "final_resultdirectory = " << final_resultdirectory << endline_flush;

  readin_infile_scaleband();

  logger << LOG_DEBUG_VERBOSE << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;

  scaleband_variable.resize(outpath_scaleband.size(), vector<vector<vector<double> > > (osi->extended_distribution.size(), vector<vector<double> > ()));
  scaleband_central_result.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));
  scaleband_central_deviation.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));
  scaleband_minimum_result.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));
  scaleband_minimum_deviation.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));
  scaleband_maximum_result.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));
  scaleband_maximum_deviation.resize(outpath_scaleband.size(), vector<vector<vector<vector<double> > > > (osi->extended_distribution.size(), vector<vector<vector<double> > > (yorder.size(), vector<vector<double> > ())));

  for (int i_sb = 0; i_sb < outpath_scaleband.size(); i_sb++){
    logger << LOG_INFO << "Determination of scaleband for " << outpath_scaleband[i_sb] << endline_flush;
    int x_v = -1;
    for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
      if (inpath_scalecentral[i_sb] == inpath_scalevariation[i_sb][i_v]){x_v = i_v; break;}
    }
    if (x_v == -1){
      x_v = inpath_scalevariation[i_sb].size();
      inpath_scalevariation[i_sb].push_back(inpath_scalecentral[i_sb]);
    }

    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scaleband[i_sb]);
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalegeneva[i_sb]);
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalecentral[i_sb]);
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalemax[i_sb]);
    system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalemin[i_sb]);

    for (int x_q = 0; x_q < osi->value_qTcut_distribution.size() + 1; x_q++){
      string directory_qTcut;
      string in_directory_qTcut;
      string out_directory_qTcut;
      if (x_q == osi->value_qTcut_distribution.size()){
	directory_qTcut = "";
	in_directory_qTcut = "";
	out_directory_qTcut = "";
      }
      else {
	stringstream qTcut_ss;
	qTcut_ss << "qTcut-" << osi->value_qTcut_distribution[x_q];
	directory_qTcut = "/" + qTcut_ss.str();
	in_directory_qTcut = "";
	out_directory_qTcut = directory_qTcut;
      }

      logger << LOG_DEBUG << "x_q = " << x_q << "   directory_qTcut = " << directory_qTcut << endline_flush;

      if (x_q != osi->value_qTcut_distribution.size()){
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut);
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalegeneva[i_sb] + directory_qTcut);
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalecentral[i_sb] + directory_qTcut);
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalemax[i_sb] + directory_qTcut);
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + outpath_scalemin[i_sb] + directory_qTcut);
      }



      string infilename;

      char LineBuffer[1024];
      string s0;
      vector<string> vs0, vs1(1);
      logger << LOG_DEBUG << "osi->extended_distribution.size() = " << osi->extended_distribution.size() << endline_flush;
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	logger << LOG_INFO << "Determination of scaleband for " << outpath_scaleband[i_sb] << " : " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	logger << LOG_DEBUG << "switch_output_distribution[" << i_d << "] = " << switch_output_distribution[i_d] << endline_flush;
	if (!switch_output_distribution[i_d]){continue;}
	logger << LOG_DEBUG << "osi->extended_distribution[" << i_d << "].xdistribution_name = " << osi->extended_distribution[i_d].xdistribution_name << endline_flush;

	for (int i_o = 0; i_o < yorder.size(); i_o++){
	  logger << LOG_DEBUG << "(!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()) = " << (!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()) << endline_flush;
	  logger << LOG_DEBUG << "osi->value_qTcut_distribution.size() = " << osi->value_qTcut_distribution.size() << endline_flush;
	  logger << LOG_DEBUG << "yorder[" << i_o << "].active_qTcut = " << yorder[i_o]->active_qTcut << endline_flush;

	  if (!yorder[i_o]->active_qTcut && x_q < osi->value_qTcut_distribution.size()){continue;}

	  vector<string> format_plot;
	  vector<string> name_plot;

	  string temp_sdd = osi->extended_distribution[i_d].xdistribution_name + ".." + yorder[i_o]->resultdirectory;

	  format_plot.push_back("plot");
	  name_plot.push_back(temp_sdd + ".dat");

	  format_plot.push_back("norm");
	  name_plot.push_back(temp_sdd + ".dat");

	  if (i_d >= osi->dat.size()){
	    int i_ddd = i_d - osi->dat.size();

	    // recombined distributions (essentially for validation)
	    stringstream name_rec;
	    name_rec << osi->dddat[i_ddd].distribution_2.xdistribution_name << ".from." << osi->dddat[i_ddd].name << ".." << yorder[i_o]->resultdirectory;

	    format_plot.push_back("plot.rec");
	    name_plot.push_back(name_rec.str() + ".dat");

	    format_plot.push_back("norm.rec");
	    name_plot.push_back(name_rec.str() + ".dat");

	    for (int i_b1 = 0; i_b1 < osi->dddat[i_ddd].distribution_1.n_bins; i_b1++){
	      stringstream name_split_bin;
	      name_split_bin << "_" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1] << "-" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1 + 1];
	      stringstream name_split_lt;
	      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];
	      stringstream name_split_ge;
	      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_1.bin_edge[i_b1];

	      format_plot.push_back("norm.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.norm.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_first");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	    }
	    for (int i_b2 = 0; i_b2 < osi->dddat[i_ddd].distribution_2.n_bins; i_b2++){
	      stringstream name_split_bin;
	      name_split_bin << "_" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2] << "-" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2 + 1];
	      stringstream name_split_lt;
	      name_split_lt << "_lt" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];
	      stringstream name_split_ge;
	      name_split_ge << "_ge" << osi->dddat[i_ddd].distribution_2.bin_edge[i_b2];

	      format_plot.push_back("norm.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.norm.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.plot.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.norm.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.plot.split_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_bin.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.two");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	      format_plot.push_back("norm.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("norm.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_lt.str() + ".." + yorder[i_o]->resultdirectory + ".dat");

	      format_plot.push_back("plot.ge_lt_in_second");
	      name_plot.push_back(osi->dddat[i_ddd].name + name_split_ge.str() + ".." + yorder[i_o]->resultdirectory + ".dat");


	    }
	  }

	  int n_max_output_version = name_plot.size();
	  logger << LOG_DEBUG << "n_max_output_version = " << n_max_output_version << endline_flush;

	  vector<string> selection_format_plot;
	  vector<string> selection_name_plot;

	  for (size_t i_x = 0; i_x < format_plot.size(); i_x++){
	    for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	      if (format_plot[i_x] == output_distribution_format[i_d][i_f]){
		if      (format_plot[i_x] == "plot.plot.split_in_first" || format_plot[i_x] == "plot.plot.split_in_second"){selection_format_plot.push_back("plot.plot.split");}
		else if (format_plot[i_x] == "plot.norm.split_in_first" || format_plot[i_x] == "plot.norm.split_in_second"){selection_format_plot.push_back("plot.norm.split");}
		else if (format_plot[i_x] == "norm.plot.split_in_first" || format_plot[i_x] == "norm.plot.split_in_second"){selection_format_plot.push_back("norm.plot.split");}
		else if (format_plot[i_x] == "norm.norm.split_in_first" || format_plot[i_x] == "norm.norm.split_in_second"){selection_format_plot.push_back("norm.norm.split");}
		else if (format_plot[i_x] == "plot.ge_lt_in_first" || format_plot[i_x] == "plot.ge_lt_in_second"){selection_format_plot.push_back("plot.two");}
		else if (format_plot[i_x] == "norm.ge_lt_in_first" || format_plot[i_x] == "norm.ge_lt_in_second"){selection_format_plot.push_back("norm.two");}
		else {selection_format_plot.push_back(format_plot[i_x]);}
		selection_name_plot.push_back(name_plot[i_x]);
	      }
	    }
	  }


	  for (size_t i_f = 0; i_f < output_distribution_format[i_d].size(); i_f++){
	    logger << LOG_INFO << "output_distribution_format[" << setw(3) << i_d << "][" << setw(3) << i_f << "] = " << setw(20) << output_distribution_format[i_d][i_f] << "   " << "selection_format_plot[" << setw(3) << i_f << "] = " << setw(20) << selection_format_plot[i_f] << "   " << "selection_name_plot[" << setw(3) << i_f << "] = " << setw(20) << selection_name_plot[i_f] << endline_flush;
	  }


	  stringstream temp;
	  temp << "Output selection: " << osi->extended_distribution[i_d].xdistribution_name  << " : ";
	  for (size_t i_x = 0; i_x < selection_format_plot.size(); i_x++){
	    temp << selection_format_plot[i_x] << "." << selection_name_plot[i_x] << endline;
	  }
	  logger << LOG_INFO << temp.str() << endline_flush;
	  int n_output_version = selection_format_plot.size();


	  scaleband_variable[i_sb][i_d].resize(n_output_version);

	  logger << LOG_DEBUG << "scaleband_variable[" << i_sb << "].size() = " << scaleband_variable[i_sb].size() << endline_flush;
	  logger << LOG_DEBUG << "scaleband_variable[" << i_sb << "][" << i_d << "].size() = " << scaleband_variable[i_sb][i_d].size() << endline_flush;

	  scaleband_central_result[i_sb][i_d][i_o].resize(n_output_version);
	  scaleband_central_deviation[i_sb][i_d][i_o].resize(n_output_version);
	  scaleband_minimum_result[i_sb][i_d][i_o].resize(n_output_version);
	  scaleband_minimum_deviation[i_sb][i_d][i_o].resize(n_output_version);
	  scaleband_maximum_result[i_sb][i_d][i_o].resize(n_output_version);
	  scaleband_maximum_deviation[i_sb][i_d][i_o].resize(n_output_version);

	  for (int i_x = 0; i_x < n_output_version; i_x++){

	    logger << LOG_INFO << "selection_format_plot[" << setw(3) << i_x << "] = " << setw(20) << selection_format_plot[i_x] << "   selection_name_plot[" << setw(3) << i_x << "] = " << setw(20) << selection_name_plot[i_x] << endline_flush;

	    int switch_exist = 0;

	    vector<vector<vector<double> > > xresult, xdeviation, xdeviation2;
	    vector<double> variable;
	    vector<double> centralresult;
	    vector<double> centraldeviation;
	    for (int i_v = 0; i_v < inpath_scalevariation[i_sb].size(); i_v++){
	      vector<string> readin;
	      vector<vector<string> > readin2;
	      infilename = final_resultdirectory + "/" + inpath_scalevariation[i_sb][i_v] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];

	      logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << endline_flush;

	      ifstream inf(infilename.c_str());
	      readin = vs0;
	      while (inf.getline(LineBuffer, 1024)){readin.push_back(LineBuffer);}
	      logger << LOG_DEBUG << infilename << "   readin.size() = " << readin.size() << endline_flush;
	      if (readin.size() == 0){continue;}
	      else {switch_exist = 1;}
	      for (int i_b = 0; i_b < readin.size(); i_b++){
		if (readin[i_b][0] == char(35)){}
		else {
		  readin2.push_back(vs0);
		  int start = 0;
		  for (int j = 0; j < readin[i_b].size(); j++){
		    if (readin[i_b][j] != ' '){
		      if (start == 0){start = 1; readin2[readin2.size() - 1].push_back(s0); readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin[i_b][j];}
		       else {readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] = readin2[readin2.size() - 1][readin2[readin2.size() - 1].size() - 1] + readin[i_b][j];}
		    }
		    else if ((readin[i_b][j] == ' ') && (start == 1)){start = 0;}
		  }
		}
		if (i_b == 0 || i_b == readin.size() - 1){logger << LOG_DEBUG_VERBOSE << "i_b = " << setw(2) << i_b << "   (" << readin.size() << " - " << readin2.size() << ")" << endline_flush;}
	      }

	      if (i_v == 0){variable.resize(readin2.size());}
	      vector<vector<double> > data(readin2.size());
	      vector<vector<double> > result(readin2.size()), deviation(readin2.size()), deviation2(readin2.size());


	      logger << LOG_DEBUG << "i_v = " << i_v << "   readin2.size() = " << readin2.size() << endline_flush;

	      for (int i_b = 0; i_b < readin2.size(); i_b++){
		data[i_b].resize(readin2[i_b].size());
		result[i_b].resize((readin2[i_b].size() - 1) / 2);
		deviation[i_b].resize((readin2[i_b].size() - 1) / 2);
		deviation2[i_b].resize((readin2[i_b].size() - 1) / 2);
	      }

	      for (int i_b = 0; i_b < readin2.size(); i_b++){
		for (int j = 0; j < readin2[i_b].size(); j++){
		  data[i_b][j] = atof(readin2[i_b][j].c_str());
		}
	      }
	      for (int i_b = 0; i_b < result.size(); i_b++){
		if (i_v == 0){variable[i_b] = data[i_b][0];}
		for (int j = 0; j < result[i_b].size(); j++){
		  result[i_b][j] = data[i_b][j * 2 + 1];
		  deviation[i_b][j] = data[i_b][j * 2 + 2];
		  deviation2[i_b][j] = pow(deviation[i_b][j], 2);
		}
	      }

	      if (x_v == i_v){
		centralresult.resize(result.size());
		centraldeviation.resize(deviation.size());
		for (int i_b = 0; i_b < result.size(); i_b++){
		  centralresult[i_b] = result[i_b][0];
		  centraldeviation[i_b] = deviation[i_b][0];
		}
	      }
	      xresult.push_back(result);
	      xdeviation.push_back(deviation);
	      xdeviation2.push_back(deviation2);

	      logger << LOG_DEBUG << "i_d = " << setw(2) << i_d << "   i_v = " << setw(2) << i_v << "   i_o = " << setw(2) << i_o << "   infilename = " << infilename << "   " << readin.size() << " " << readin2.size() << endline_flush;

	    }

	    if (!switch_exist){continue;}





	    vector<double> minresult(xresult[0].size(), 0.);
	    vector<double> maxresult(xresult[0].size(), 0.);
	    vector<double> mindeviation(xdeviation[0].size(), 0.);
	    vector<double> maxdeviation(xdeviation[0].size(), 0.);
	    for (int i_v = 0; i_v < xresult[0].size(); i_v++){
	      logger << LOG_DEBUG_VERBOSE << "i_v = " << i_v << "   xresult.size() = " << xresult.size() << endline_flush;

	      minresult[i_v] = 1.e99;
	      maxresult[i_v] = -1.e99;
	      for (int i_c = 0; i_c < xresult.size(); i_c++){
		if (xresult[i_c][i_v][0] < minresult[i_v]){
		  minresult[i_v] = xresult[i_c][i_v][0];
		  mindeviation[i_v] = xdeviation[i_c][i_v][0];
		}
		if (xresult[i_c][i_v][0] > maxresult[i_v]){
		  maxresult[i_v] = xresult[i_c][i_v][0];
		  maxdeviation[i_v] = xdeviation[i_c][i_v][0];
		}
	      }
	      //	if (plotmode == 1){if (minresult[i_b] < 0.){minresult[i_b] = 0.;}}
	      logger << LOG_DEBUG_VERBOSE << "i_v = " << i_v << "   xresult.size() = " << xresult.size() << " done." << endline_flush;
	    }


	    scaleband_variable[i_sb][i_d][i_x] = variable;
	    scaleband_central_result[i_sb][i_d][i_o][i_x] = centralresult;
	    scaleband_central_deviation[i_sb][i_d][i_o][i_x] = centraldeviation;
	    scaleband_minimum_result[i_sb][i_d][i_o][i_x] = minresult;
	    scaleband_minimum_deviation[i_sb][i_d][i_o][i_x] = mindeviation;
	    scaleband_maximum_result[i_sb][i_d][i_o][i_x] = maxresult;
	    scaleband_maximum_deviation[i_sb][i_d][i_o][i_x] = maxdeviation;

	    logger << LOG_DEBUG << "scaleband_variable[" << i_sb << "][" << i_d << "][" << i_x << "].size() = " <<  scaleband_variable[i_sb][i_d][i_x].size() << endline_flush;

	    ofstream outf;

	    string outfilename_scaleband_matrix = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scaleband = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/fill" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scaleband_ref = final_resultdirectory + "/" + outpath_scaleband[i_sb] + directory_qTcut + "/reffill" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scaleband_geneva = final_resultdirectory + "/" + outpath_scalegeneva[i_sb] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scalecentral = final_resultdirectory + "/" + outpath_scalecentral[i_sb] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scalemax = final_resultdirectory + "/" + outpath_scalemax[i_sb] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];
	    string outfilename_scalemin = final_resultdirectory + "/" + outpath_scalemin[i_sb] + directory_qTcut + "/" + selection_format_plot[i_x] + "." + selection_name_plot[i_x];

	    logger << LOG_DEBUG << "outfilename_scaleband_matrix = " << outfilename_scaleband_matrix << endline_flush;
	    logger << LOG_DEBUG << "outfilename_scaleband = " << outfilename_scaleband << endline_flush;
	    logger << LOG_DEBUG << "outfilename_scaleband_geneva = " << outfilename_scaleband_geneva << endline_flush;
	    logger << LOG_DEBUG << "outfilename_scalecentral = " << outfilename_scalecentral << endline_flush;
	    logger << LOG_DEBUG << "outfilename_scalemax = " << outfilename_scalemax << endline_flush;
	    logger << LOG_DEBUG << "outfilename_scalemin = " << outfilename_scalemin << endline_flush;

	    /////////////////
	    //  scaleband  //
	    /////////////////
	    outf.open(outfilename_scaleband_matrix.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < centralresult.size(); i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << "   "
		   << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b]
		   << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b]
		   << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b]
		   << endline;
	    }
	    outf.close();

	    // outfilename_scaleband_matrix contains all the output needed for using matrix plot scripts !!!

	    outf.open(outfilename_scaleband.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < minresult.size(); i_b++){
	      /*
	      if (centralresult[i_b] < 0.){centralresult[i_b] = 0.;}
	      if (minresult[i_b] < 0.){minresult[i_b] = 0.;}
	      if (maxresult[i_b] < 0.){maxresult[i_b] = 0.;}
	      */
	      outf << setw(16) << setprecision(8) << variable[i_b] << "   "
		   << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b]
		   << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b]
		   << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b]
		   << endline;
	      //	       outf << setw(16) << setprecision(8) << variable[i_b] << "   " << setw(16) << minresult[i_b] << setw(16) << maxresult[i_b] << endline;

	      if (i_b < minresult.size() - 1){
		outf << setw(16) << setprecision(8) << variable[i_b + 1] << "   "
		     << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b]
		     << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b]
		     << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b]
		     << endline;
		//		 outf << setw(16) << setprecision(8) << variable[i_b + 1] << "   " << setw(16) << minresult[i_b] << setw(16) << maxresult[i_b] << endline;
	      }
	    }
	    outf.close();

	    /////////////////////
	    //  scaleband-ref  //
	    /////////////////////
	    outf.open(outfilename_scaleband_ref.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < centralresult.size(); i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << setw(16) << setprecision(8) << centralresult[i_b] << endline;
	      if (i_b < centralresult.size() - 1){
		outf << setw(16) << setprecision(8) << variable[i_b + 1] << setw(16) << setprecision(8) << centralresult[i_b] << endline;
	      }
	    }
	    outf.close();

	    ///////////////////
	    //  scalegeneva  //
	    ///////////////////
	    if (xresult.size() == 3){
	      outf.open(outfilename_scaleband_geneva.c_str(), ofstream::out | ofstream::trunc);
	      if (osi->extended_distribution[i_d].type_binning == "logarithmic"){
		for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		  double factor = osi->extended_distribution[i_d].bin_width[i_b] / (log10(osi->extended_distribution[i_d].bin_edge[i_b + 1]) - log10(osi->extended_distribution[i_d].bin_edge[i_b]));
		  outf << setw(16) << setprecision(8) << log10(variable[i_b]) << "   "
		       << setw(16) << setprecision(8) << log10(variable[i_b + 1]) << "   "
		       << setw(16) << setprecision(8) << xresult[1][i_b][0] * factor << "   " << setw(16) << setprecision(8) << xdeviation[1][i_b][0] * factor
		       << setw(16) << setprecision(8) << xresult[2][i_b][0] * factor << "   " << setw(16) << setprecision(8) << xdeviation[2][i_b][0] * factor
		       << setw(16) << setprecision(8) << xresult[0][i_b][0] * factor << "   " << setw(16) << setprecision(8) << xdeviation[0][i_b][0] * factor
		       << endline;
		}
	      }
	      else {
		for (int i_b = 0; i_b < variable.size() - 1; i_b++){
		  outf << setw(16) << setprecision(8) << variable[i_b] << "   "
		       << setw(16) << setprecision(8) << variable[i_b + 1] << "   "
		       << setw(16) << setprecision(8) << xresult[1][i_b][0] << "   " << setw(16) << setprecision(8) << xdeviation[1][i_b][0]
		       << setw(16) << setprecision(8) << xresult[2][i_b][0] << "   " << setw(16) << setprecision(8) << xdeviation[2][i_b][0]
		       << setw(16) << setprecision(8) << xresult[0][i_b][0] << "   " << setw(16) << setprecision(8) << xdeviation[0][i_b][0]
		       << endline;
		}
	      }
	      outf.close();
	    }
	    
	    ////////////////////
	    //  scalecentral  //
	    ////////////////////
	    /*
	    outf.open(outfilename_scalecentral.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < centralresult.size(); i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b] << endline;
	      //  if (i < centralresult.size() - 1){outf << setw(16) << setprecision(8) << variable[i + 1] << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b] << endline;}
	    }
	    outf.close();
	    */
	    outf.open(outfilename_scalecentral.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < centralresult.size() - 1; i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << "   "
		   << setw(16) << setprecision(8) << variable[i_b + 1] << "   "
		   << setw(16) << setprecision(8) << centralresult[i_b] << "   " << setw(16) << setprecision(8) << centraldeviation[i_b]
		   << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b]
		   << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b]
		   << endline;
	    }
	    outf.close();

	    ////////////////
	    //  scalemax  //
	    ////////////////
	    outf.open(outfilename_scalemax.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < maxresult.size(); i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b] << endline;
	      //  if (i < maxresult.size() - 1){outf << setw(16) << setprecision(8) << variable[i + 1] << setw(16) << setprecision(8) << maxresult[i_b] << "   " << setw(16) << setprecision(8) << maxdeviation[i_b] << endline;}
	    }
	    outf.close();

	    ////////////////
	    //  scalemin  //
	    ////////////////
	    outf.open(outfilename_scalemin.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < minresult.size(); i_b++){
	      outf << setw(16) << setprecision(8) << variable[i_b] << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b] << endline;
	      //  if (i < minresult.size() - 1){outf << setw(16) << setprecision(8) << variable[i + 1] << setw(16) << setprecision(8) << minresult[i_b] << "   " << setw(16) << setprecision(8) << mindeviation[i_b] << endline;}
	    }
	    outf.close();
	  }
	}
      }
    }
  }

  //  if (switch_output_table_order){output_distribution_table_order();}
  if (switch_output_table_order){output_distribution_table_order_nNNLOQCDxEW();}
  if (switch_output_table_Kfactor){output_distribution_table_Kfactor();}
  if (switch_output_table_crosssection_Kfactor){output_distribution_table_crosssection_Kfactor();}
  if (switch_output_table_IS_splitting){output_distribution_table_IS_splitting();}
  if (switch_output_table_crosssection_Kfactor_combination_NNLOQCD_NLOEW){output_distribution_table_crosssection_Kfactor_combination_NNLOQCD_NLOEW();}
  if (switch_output_table_order_cumulative_ggNLO){output_distribution_table_order_cumulative_ggNLO();}
  logger << LOG_DEBUG << "switch_output_table_order_cumulative_ggLO = " << switch_output_table_order_cumulative_ggLO << endline_flush;
  if (switch_output_table_order_cumulative_ggLO){output_distribution_table_order_cumulative_ggLO();}
  if (switch_output_table_crosssection_Kfactor_ggNLO){output_distribution_table_crosssection_Kfactor_ggNLO();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

