#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ac_psp_220_uxcx_aauxcx(int x_a, int channel){
  static Logger logger("ppaa02_phasespace_set::ac_psp_220_uxcx_aauxcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = smin_opt[x_a][24];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  24, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = smin_opt[x_a][36];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  4], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = smin_opt[x_a][40];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  0], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  1] = smin_opt[x_a][24];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,   0,  24, v_smin[x_a][  1], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 9));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  1] = smin_opt[x_a][24];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][56]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  8], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][  9] = smin_opt[x_a][48];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][  9], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][  4] = smin_opt[x_a][36];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][  4], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][  0] = smin_opt[x_a][20];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  20, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 11], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 12], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][  5] = smin_opt[x_a][40];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a,  40, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  6], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 13], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 14], v_smax[x_a][ 10], random_manager.get_random(x_a, 1, 12));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  60,   1,   2,   4,  56, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  32,  24, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  24,   5,  34,   8,  16, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0,  56,   2,   5,   8,  48, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel(x_a,   0,  48,   5,  10,  16,  32, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  16,  44, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0,  44,   2,  17,   8,  36, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel(x_a,   0,  36,  17,  10,  32,   4, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,   0,  60,   1,   2,   8,  52, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  32,  20, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel(x_a,   0,  20,   9,  34,   4,  16, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,   0,  52,   2,   9,   4,  48, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel(x_a,   0,  48,   9,   6,  16,  32, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0,  44,   2,  17,   4,  40, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel(x_a,   0,  40,  17,   6,  32,   8, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   8,  52, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,   0,  52,   1,  10,  20,  32, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   4,  56, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0,  56,   1,   6,  24,  32, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  40,  16, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  36,  16, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  24,  36, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  24,   8,  16, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  28,   4,  24, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
