#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_gd_aagd(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_gd_aagd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   8,    9,   16,   17,   24,   25,   26,   29,    2}; //   9
  needed_v_smin[x_a][  1] = {  10,   13,   15,   18,   20,   23}; //   6
  needed_v_smin[x_a][  2] = {  11,   12,   14,   19,   21,   22,   27,   28,    6}; //   9
  needed_v_smin[x_a][  3] = {  14,   22,   28,    6,   11,   27}; //   6
  needed_v_smin[x_a][  4] = {  15,   23,   10}; //   3
  needed_v_smin[x_a][  5] = {  16,   24,    9}; //   3
  needed_v_smin[x_a][  6] = {  17,   25,   29,    2,    8,   26}; //   6
  needed_v_smin[x_a][  7] = {  18,   20,   13}; //   3
  needed_v_smin[x_a][  8] = {  19,   21,   12}; //   3
  needed_v_smin[x_a][  9] = {   0,    4}; //   2
  needed_v_smin[x_a][ 10] = {   0,    4}; //   2
  needed_v_smin[x_a][ 11] = {   1,    3}; //   2
  needed_v_smin[x_a][ 12] = {   1,    3}; //   2
  needed_v_smin[x_a][ 13] = {   5,    7}; //   2
  needed_v_smin[x_a][ 14] = {   5,    7}; //   2

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   8,    9,   16,   17,   24,   25,   26,   29,    2}; //   9
  needed_v_smax[x_a][  1] = {  10,   13,   15,   18,   20,   23}; //   6
  needed_v_smax[x_a][  2] = {  11,   12,   14,   19,   21,   22,   27,   28,    6}; //   9
  needed_v_smax[x_a][  3] = {  14,   17,   22,   25,   28,   29,    2,    6,    8,   11,   26,   27}; //  12
  needed_v_smax[x_a][  4] = {  15,   16,   23,   24,    9,   10}; //   6
  needed_v_smax[x_a][  5] = {  18,   19,   20,   21,   12,   13}; //   6
  needed_v_smax[x_a][  6] = {   0,    4}; //   2
  needed_v_smax[x_a][  7] = {   0,    1,    3,    4,    5,    7}; //   6
  needed_v_smax[x_a][  8] = {   1,    3}; //   2
  needed_v_smax[x_a][  9] = {   5,    7}; //   2

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   8,    9,   16,   17,   24,   25,   26,   29}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  10,   13,   15,   18,   20,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  11,   12,   14,   19,   21,   22,   27,   28}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  14,   22,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  15,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  16,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  17,   25,   29}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][7] = {  18,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  19,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   2,    8,   26}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][6] = {   5,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][7] = {   5,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax7");
  needed_g_f[x_a][8] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][9] = {   6,   11,   27}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][11] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][12] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][13] = {  13}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    3,    4,    5,    7}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][5] = {   2,    6,   26,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][10] = {   5,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][12] = {   6,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][15] = {   8,   11,   14,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][16] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__36_8");
  needed_g_t[x_a][17] = {   9,   10,   15,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][18] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][19] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][20] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_4");
  needed_g_t[x_a][21] = {  12,   13,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][22] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_16");
  needed_g_t[x_a][23] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {   8,    9,   16,   17,   24,   25,   26,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {  10,   13,   15,   18,   20,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {  11,   12,   14,   19,   21,   22,   27,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {  14,   22,   28}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {  15,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][5] = {  16,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  17,   25,   29}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][7] = {  18,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][8] = {  19,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][9] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][10] = {  22,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  23,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  0,   3,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   1}; //   2
  c_t[x_a][4] = {  0,   1,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  6,   7}; //   2
  c_t[x_a][5] = {  0,  10,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  8,   9}; //   2
  c_t[x_a][6] = {  5,  12,  13}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  6,   7}; //   2
  c_t[x_a][7] = {  0,  10,  14}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  5}; //   1
  c_t[x_a][8] = { 15,  16}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = { 10}; //   1
  c_t[x_a][9] = { 17,  18}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = { 11}; //   1
  c_t[x_a][10] = { 17,  19}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2}; //   1
  c_f[x_a][11] = {  9}; //   1
  c_t[x_a][11] = { 15,  20}; //   2
  c_d[x_a][11] = {  2}; //   1

  c_p[x_a][12] = {  2}; //   1
  c_f[x_a][12] = { 12}; //   1
  c_t[x_a][12] = { 21,  22}; //   2
  c_d[x_a][12] = {  2}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = { 13}; //   1
  c_t[x_a][13] = { 21,  23}; //   2
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  2,   3}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 15}; //   1
  c_d[x_a][14] = {  3,   2}; //   2

  c_p[x_a][15] = {  1,   4}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 17}; //   1
  c_d[x_a][15] = {  4,   1}; //   2

  c_p[x_a][16] = {  0,   5}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 17}; //   1
  c_d[x_a][16] = {  5,   0}; //   2

  c_p[x_a][17] = {  0,   6}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 15}; //   1
  c_d[x_a][17] = {  6,   0}; //   2

  c_p[x_a][18] = {  1,   7}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 21}; //   1
  c_d[x_a][18] = {  7,   1}; //   2

  c_p[x_a][19] = {  2,   8}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 21}; //   1
  c_d[x_a][19] = {  8,   2}; //   2

  c_p[x_a][20] = {  1,   7}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  9,   7,   1}; //   3

  c_p[x_a][21] = {  2,   8}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  9,   8,   2}; //   3

  c_p[x_a][22] = {  2,   3}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 10,   3,   2}; //   3

  c_p[x_a][23] = {  1,   4}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 11,   4,   1}; //   3

  c_p[x_a][24] = {  0,   5}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 11,   5,   0}; //   3

  c_p[x_a][25] = {  0,   6}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 10,   6,   0}; //   3

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  5}; //   1
  c_t[x_a][26] = {  5,   6}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  2}; //   1
  c_f[x_a][27] = {  9}; //   1
  c_t[x_a][27] = {  5,  12}; //   2
  c_d[x_a][27] = {  2}; //   1

  c_p[x_a][28] = {  2,   3}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  5}; //   1
  c_d[x_a][28] = {  3,   2}; //   2

  c_p[x_a][29] = {  0,   6}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  5}; //   1
  c_d[x_a][29] = {  6,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    1: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    4: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel    5: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel    6: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel    7: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
// channel    8: 2v11(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel    9: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel   10: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   11: 2v11(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   12: 2v11(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel   13: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel   14: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   15: 3yv1(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel   16: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   17: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel   18: 3yv1(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel   19: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   20: 4yyv(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   21: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   22: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   23: 4yyv(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   24: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   25: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   26: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   27: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   28: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   29: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
