#include "header.hpp"

#include "ppeeexex04.phasespace.set.hpp"

void ppeeexex04_phasespace_set::ax_psp_040_ddx_ememepep(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_040_ddx_ememepep");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47}; //  16
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  2] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  3] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  needed_v_smin[x_a][  4] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  5] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  needed_v_smin[x_a][  7] = {  16,   17,   18,   19}; //   4
  needed_v_smin[x_a][  8] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][  9] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47}; //  16
  needed_v_smin[x_a][ 10] = {  24,   25,   26,   27}; //   4
  needed_v_smin[x_a][ 11] = {  28,   29,   30,   31}; //   4

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35}; //  12
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smax[x_a][  2] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smax[x_a][  3] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39}; //  12
  needed_v_smax[x_a][  4] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smax[x_a][  5] = {  16,   17,   18,   19,   20,   21,   22,   23,   40,   41,   42,   43}; //  12
  needed_v_smax[x_a][  6] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  7] = {  24,   25,   26,   27,   28,   29,   30,   31,   44,   45,   46,   47}; //  12
  needed_v_smax[x_a][  8] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][  9] = {  36,   37,   38,   39}; //   4
  needed_v_smax[x_a][ 10] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 11] = {  44,   45,   46,   47}; //   4

  g_p[x_a].resize(24);
  needed_g_p[x_a].resize(24);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    6,    7,   34,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   8,    9,   12,   13,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {  10,   11,   14,   15,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][7] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][8] = {  16,   17,   20,   21,   40,   41}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][9] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][10] = {  18,   19,   22,   23,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax5");
  needed_g_p[x_a][11] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][12] = {  24,   25,   28,   29,   44,   45}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][14] = {  26,   27,   30,   31,   46,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax7");
  needed_g_p[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][16] = {  32,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][17] = {  33,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax8");
  needed_g_p[x_a][18] = {  36,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax9");
  needed_g_p[x_a][19] = {  37,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax9");
  needed_g_p[x_a][20] = {  40,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][21] = {  41,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax10");
  needed_g_p[x_a][22] = {  44,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][23] = {  45,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][1] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][2] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][3] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   44,   45,   46,   47}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   12,   13,   14,   15,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][9] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  16,   17,   18,   19,   20,   21,   22,   23,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  2,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  2,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   5,   6}; //   3

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   5,   6}; //   3

  c_p[x_a][10] = {  6,   5}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   5,   6}; //   3

  c_p[x_a][11] = {  6,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   5,   6}; //   3

  c_p[x_a][12] = {  4,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  7,   8,   6}; //   3

  c_p[x_a][13] = {  4,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  7,   8,   6}; //   3

  c_p[x_a][14] = {  6,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  7,   8,   6}; //   3

  c_p[x_a][15] = {  6,   7}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = {  8,   9}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  9,  10,  11}; //   3

  c_p[x_a][17] = {  8,   9}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,  10,  11}; //   3

  c_p[x_a][18] = { 10,   9}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  9,  10,  11}; //   3

  c_p[x_a][19] = { 10,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  9,  10,  11}; //   3

  c_p[x_a][20] = {  8,  11}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  3,  12,  11}; //   3

  c_p[x_a][21] = {  8,  11}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  3,  12,  11}; //   3

  c_p[x_a][22] = { 10,  11}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  3,  12,  11}; //   3

  c_p[x_a][23] = { 10,  11}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  3,  12,  11}; //   3

  c_p[x_a][24] = { 12,  13}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  9,  13,  14}; //   3

  c_p[x_a][25] = { 12,  13}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  9,  13,  14}; //   3

  c_p[x_a][26] = { 14,  13}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  9,  13,  14}; //   3

  c_p[x_a][27] = { 14,  13}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  9,  13,  14}; //   3

  c_p[x_a][28] = { 12,  15}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  7,  15,  14}; //   3

  c_p[x_a][29] = { 12,  15}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  7,  15,  14}; //   3

  c_p[x_a][30] = { 14,  15}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  7,  15,  14}; //   3

  c_p[x_a][31] = { 14,  15}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  7,  15,  14}; //   3

  c_p[x_a][32] = {  0,  16}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 14,   2}; //   2

  c_p[x_a][33] = {  0,  17}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 14,   2}; //   2

  c_p[x_a][34] = {  2,  16}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = { 14,   2}; //   2

  c_p[x_a][35] = {  2,  17}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  0}; //   1
  c_d[x_a][35] = { 14,   2}; //   2

  c_p[x_a][36] = {  4,  18}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = { 11,   6}; //   2

  c_p[x_a][37] = {  4,  19}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = { 11,   6}; //   2

  c_p[x_a][38] = {  6,  18}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = { 11,   6}; //   2

  c_p[x_a][39] = {  6,  19}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = { 11,   6}; //   2

  c_p[x_a][40] = {  8,  20}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = {  6,  11}; //   2

  c_p[x_a][41] = {  8,  21}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = {  6,  11}; //   2

  c_p[x_a][42] = { 10,  20}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = {  6,  11}; //   2

  c_p[x_a][43] = { 10,  21}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = {  6,  11}; //   2

  c_p[x_a][44] = { 12,  22}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = {  2,  14}; //   2

  c_p[x_a][45] = { 12,  23}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  3}; //   1
  c_d[x_a][45] = {  2,  14}; //   2

  c_p[x_a][46] = { 14,  22}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  3}; //   1
  c_d[x_a][46] = {  2,  14}; //   2

  c_p[x_a][47] = { 14,  23}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  3}; //   1
  c_d[x_a][47] = {  2,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel    1: 4yyv(1, 2, 4, 32, 8, 16;   0,   0,  23)
// channel    2: 4yyv(1, 2, 4, 32, 8, 16;  23,   0,   0)
// channel    3: 4yyv(1, 2, 4, 32, 8, 16;  23,   0,  23)
// channel    4: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    5: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,  23)
// channel    6: 4yyv(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel    7: 4yyv(1, 2, 32, 4, 8, 16;  23,   0,  23)
// channel    8: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel    9: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,  23)
// channel   10: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,   0)
// channel   11: 4yyv(1, 2, 4, 16, 8, 32;  23,   0,  23)
// channel   12: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   13: 4yyv(1, 2, 16, 4, 8, 32;   0,   0,  23)
// channel   14: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel   15: 4yyv(1, 2, 16, 4, 8, 32;  23,   0,  23)
// channel   16: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   17: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  23)
// channel   18: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,   0)
// channel   19: 4yyv(1, 2, 8, 32, 4, 16;  23,   0,  23)
// channel   20: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
// channel   21: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  23)
// channel   22: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,   0)
// channel   23: 4yyv(1, 2, 32, 8, 4, 16;  23,   0,  23)
// channel   24: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   25: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,  23)
// channel   26: 4yyv(1, 2, 8, 16, 4, 32;  23,   0,   0)
// channel   27: 4yyv(1, 2, 8, 16, 4, 32;  23,   0,  23)
// channel   28: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   29: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,  23)
// channel   30: 4yyv(1, 2, 16, 8, 4, 32;  23,   0,   0)
// channel   31: 4yyv(1, 2, 16, 8, 4, 32;  23,   0,  23)
// channel   32: 2v2v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   33: 2v2v(1, 2, 4, 32, 8, 16;   0,  23,   0)
// channel   34: 2v2v(1, 2, 4, 32, 8, 16;  23,   0,   0)
// channel   35: 2v2v(1, 2, 4, 32, 8, 16;  23,  23,   0)
// channel   36: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   37: 2v2v(1, 2, 4, 16, 8, 32;   0,  23,   0)
// channel   38: 2v2v(1, 2, 4, 16, 8, 32;  23,   0,   0)
// channel   39: 2v2v(1, 2, 4, 16, 8, 32;  23,  23,   0)
// channel   40: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   41: 2v2v(1, 2, 8, 32, 4, 16;   0,  23,   0)
// channel   42: 2v2v(1, 2, 8, 32, 4, 16;  23,   0,   0)
// channel   43: 2v2v(1, 2, 8, 32, 4, 16;  23,  23,   0)
// channel   44: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   45: 2v2v(1, 2, 8, 16, 4, 32;   0,  23,   0)
// channel   46: 2v2v(1, 2, 8, 16, 4, 32;  23,   0,   0)
// channel   47: 2v2v(1, 2, 8, 16, 4, 32;  23,  23,   0)
