#include "header.hpp"

#include "ppeeexex04.phasespace.set.hpp"

void ppeeexex04_phasespace_set::ax_psp_140_uux_ememepepg(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_140_uux_ememepepg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  5] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  needed_v_smin[x_a][  6] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  needed_v_smin[x_a][  7] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  needed_v_smin[x_a][  8] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  needed_v_smin[x_a][  9] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  needed_v_smin[x_a][ 10] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  needed_v_smin[x_a][ 11] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  needed_v_smin[x_a][ 12] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  needed_v_smin[x_a][ 13] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  needed_v_smin[x_a][ 14] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  needed_v_smin[x_a][ 15] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  needed_v_smin[x_a][ 16] = {  64,   65,   66,   67,   76,   77,   78,   79,   96,   97,   98,   99,  108,  109,  110,  111}; //  16
  needed_v_smin[x_a][ 17] = {  68,   69,   70,   71,   72,   73,   74,   75,  100,  101,  102,  103,  104,  105,  106,  107}; //  16
  needed_v_smin[x_a][ 18] = {  80,   81,   82,   83}; //   4
  needed_v_smin[x_a][ 19] = {  84,   85,   86,   87}; //   4
  needed_v_smin[x_a][ 20] = {  88,   89,   90,   91}; //   4
  needed_v_smin[x_a][ 21] = {  92,   93,   94,   95}; //   4

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   80,   81,   82,   83,   96,   97,   98,   99}; //  28
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  96
  needed_v_smax[x_a][  3] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   84,   85,   86,   87,  100,  101,  102,  103}; //  28
  needed_v_smax[x_a][  5] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  needed_v_smax[x_a][  6] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   72,   73,   74,   75,   88,   89,   90,   91,  104,  105,  106,  107}; //  28
  needed_v_smax[x_a][  7] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  needed_v_smax[x_a][  8] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  28
  needed_v_smax[x_a][  9] = {  64,   65,   66,   67,   80,   81,   82,   83,   96,   97,   98,   99}; //  12
  needed_v_smax[x_a][ 10] = {  68,   69,   70,   71,   84,   85,   86,   87,  100,  101,  102,  103}; //  12
  needed_v_smax[x_a][ 11] = {  72,   73,   74,   75,   88,   89,   90,   91,  104,  105,  106,  107}; //  12
  needed_v_smax[x_a][ 12] = {  76,   77,   78,   79,   92,   93,   94,   95,  108,  109,  110,  111}; //  12
  needed_v_smax[x_a][ 13] = {  80,   81,   82,   83}; //   4
  needed_v_smax[x_a][ 14] = {  84,   85,   86,   87}; //   4
  needed_v_smax[x_a][ 15] = {  88,   89,   90,   91}; //   4
  needed_v_smax[x_a][ 16] = {  92,   93,   94,   95}; //   4

  g_p[x_a].resize(32);
  needed_g_p[x_a].resize(32);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33,   36,   37,   64,   65,   80,   81,   96,   97}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    8,   10,   32,   34,   40,   42}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    9,   11,   33,   35,   41,   43}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   34,   35,   38,   39,   66,   67,   82,   83,   98,   99}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6,   20,   22,   36,   38,   52,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7,   21,   23,   37,   39,   53,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   40,   41,   44,   45,   68,   69,   84,   85,  100,  101}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][10] = {  10,   11,   14,   15,   42,   43,   46,   47,   70,   71,   86,   87,  102,  103}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][11] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {  12,   14,   28,   30,   44,   46,   60,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][13] = {  13,   15,   29,   31,   45,   47,   61,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][14] = {  16,   17,   20,   21,   48,   49,   52,   53,   72,   73,   88,   89,  104,  105}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][15] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][16] = {  16,   18,   24,   26,   48,   50,   56,   58}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][17] = {  17,   19,   25,   27,   49,   51,   57,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][18] = {  18,   19,   22,   23,   50,   51,   54,   55,   74,   75,   90,   91,  106,  107}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][19] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax3");
  needed_g_p[x_a][20] = {  24,   25,   28,   29,   56,   57,   60,   61,   76,   77,   92,   93,  108,  109}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][21] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][22] = {  26,   27,   30,   31,   58,   59,   62,   63,   78,   79,   94,   95,  110,  111}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax8");
  needed_g_p[x_a][23] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][24] = {  64,   66,   80,   82,   96,   98}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][25] = {  65,   67,   81,   83,   97,   99}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax9");
  needed_g_p[x_a][26] = {  68,   70,   84,   86,  100,  102}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax10");
  needed_g_p[x_a][27] = {  69,   71,   85,   87,  101,  103}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax10");
  needed_g_p[x_a][28] = {  72,   74,   88,   90,  104,  106}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax11");
  needed_g_p[x_a][29] = {  73,   75,   89,   91,  105,  107}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax11");
  needed_g_p[x_a][30] = {  76,   78,   92,   94,  108,  110}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][31] = {  77,   79,   93,   95,  109,  111}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {  64,   65,   66,   67,   76,   77,   78,   79,   96,   97,   98,   99,  108,  109,  110,  111}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][1] = {  68,   69,   70,   71,   72,   73,   74,   75,  100,  101,  102,  103,  104,  105,  106,  107}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][2] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax13");
  needed_g_f[x_a][3] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax14");
  needed_g_f[x_a][4] = {  88,   89,   90,   91}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax15");
  needed_g_f[x_a][5] = {  92,   93,   94,   95}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax16");

  g_t[x_a].resize(18);
  needed_g_t[x_a].resize(18);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  64,   65,   66,   67}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_24");
  needed_g_t[x_a][3] = {  68,   69,   70,   71}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_40");
  needed_g_t[x_a][4] = {  72,   73,   74,   75}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_20");
  needed_g_t[x_a][5] = {  76,   77,   78,   79}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][6] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][7] = {  80,   81,   82,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_64");
  needed_g_t[x_a][8] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][9] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_64");
  needed_g_t[x_a][10] = {  88,   89,   90,   91}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][11] = {  88,   89,   90,   91}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_64");
  needed_g_t[x_a][12] = {  92,   93,   94,   95}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][13] = {  92,   93,   94,   95}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");
  needed_g_t[x_a][14] = {  96,   97,   98,   99}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_36");
  needed_g_t[x_a][15] = { 100,  101,  102,  103}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][16] = { 104,  105,  106,  107}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");
  needed_g_t[x_a][17] = { 108,  109,  110,  111}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11,   32,   33,   34,   35,   40,   41,   42,   43}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   32,   33,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,    6,    7,   20,   21,   22,   23,   36,   37,   38,   39,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,    6,    7,   36,   37,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   8,    9,   10,   11,   40,   41,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   8,    9,   10,   11,   12,   13,   14,   15,   40,   41,   42,   43,   44,   45,   46,   47,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   60,   61,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  12,   13,   14,   15,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][9] = {  16,   17,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51,   56,   57,   58,   59}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   18,   19,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {  16,   17,   18,   19,   20,   21,   22,   23,   48,   49,   50,   51,   52,   53,   54,   55,   68,   69,   70,   71,   72,   73,   74,   75,   84,   85,   86,   87,   88,   89,   90,   91,  100,  101,  102,  103,  104,  105,  106,  107}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {  24,   25,   26,   27,   56,   57,   58,   59}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {  24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   76,   77,   78,   79,   80,   81,   82,   83,   92,   93,   94,   95,   96,   97,   98,   99,  108,  109,  110,  111}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  28,   29,   30,   31,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(112);
  c_f[x_a].resize(112);
  c_t[x_a].resize(112);
  c_d[x_a].resize(112);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,   4,   2}; //   3

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  3,   4,   2}; //   3

  c_p[x_a][8] = {  8,   9,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,   5,   6}; //   3

  c_p[x_a][9] = {  8,   9,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,   5,   6}; //   3

  c_p[x_a][10] = { 10,   9,   2}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  0,   5,   6}; //   3

  c_p[x_a][11] = { 10,   9,   3}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  0,   5,   6}; //   3

  c_p[x_a][12] = {  8,  11,  12}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  7,   8,   6}; //   3

  c_p[x_a][13] = {  8,  11,  13}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  7,   8,   6}; //   3

  c_p[x_a][14] = { 10,  11,  12}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  7,   8,   6}; //   3

  c_p[x_a][15] = { 10,  11,  13}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = { 14,  15,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  9,  10,  11}; //   3

  c_p[x_a][17] = { 14,  15,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = {  9,  10,  11}; //   3

  c_p[x_a][18] = { 18,  15,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  9,  10,  11}; //   3

  c_p[x_a][19] = { 18,  15,  17}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  9,  10,  11}; //   3

  c_p[x_a][20] = { 14,  19,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  3,  12,  11}; //   3

  c_p[x_a][21] = { 14,  19,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  3,  12,  11}; //   3

  c_p[x_a][22] = { 18,  19,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  3,  12,  11}; //   3

  c_p[x_a][23] = { 18,  19,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  3,  12,  11}; //   3

  c_p[x_a][24] = { 20,  21,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  9,  13,  14}; //   3

  c_p[x_a][25] = { 20,  21,  17}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  9,  13,  14}; //   3

  c_p[x_a][26] = { 22,  21,  16}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  9,  13,  14}; //   3

  c_p[x_a][27] = { 22,  21,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  9,  13,  14}; //   3

  c_p[x_a][28] = { 20,  23,  12}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  7,  15,  14}; //   3

  c_p[x_a][29] = { 20,  23,  13}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = {  7,  15,  14}; //   3

  c_p[x_a][30] = { 22,  23,  12}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  7,  15,  14}; //   3

  c_p[x_a][31] = { 22,  23,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = {  7,  15,  14}; //   3

  c_p[x_a][32] = {  0,   1,   2}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  1}; //   1
  c_d[x_a][32] = {  0,   1,   2}; //   3

  c_p[x_a][33] = {  0,   1,   3}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  1}; //   1
  c_d[x_a][33] = {  0,   1,   2}; //   3

  c_p[x_a][34] = {  4,   1,   2}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  1}; //   1
  c_d[x_a][34] = {  0,   1,   2}; //   3

  c_p[x_a][35] = {  4,   1,   3}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  1}; //   1
  c_d[x_a][35] = {  0,   1,   2}; //   3

  c_p[x_a][36] = {  0,   5,   6}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = {  3,   4,   2}; //   3

  c_p[x_a][37] = {  0,   5,   7}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = {  3,   4,   2}; //   3

  c_p[x_a][38] = {  4,   5,   6}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = {  3,   4,   2}; //   3

  c_p[x_a][39] = {  4,   5,   7}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = {  3,   4,   2}; //   3

  c_p[x_a][40] = {  8,   9,   2}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  1}; //   1
  c_d[x_a][40] = {  0,   5,   6}; //   3

  c_p[x_a][41] = {  8,   9,   3}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  1}; //   1
  c_d[x_a][41] = {  0,   5,   6}; //   3

  c_p[x_a][42] = { 10,   9,   2}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  1}; //   1
  c_d[x_a][42] = {  0,   5,   6}; //   3

  c_p[x_a][43] = { 10,   9,   3}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  1}; //   1
  c_d[x_a][43] = {  0,   5,   6}; //   3

  c_p[x_a][44] = {  8,  11,  12}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  1}; //   1
  c_d[x_a][44] = {  7,   8,   6}; //   3

  c_p[x_a][45] = {  8,  11,  13}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  1}; //   1
  c_d[x_a][45] = {  7,   8,   6}; //   3

  c_p[x_a][46] = { 10,  11,  12}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  1}; //   1
  c_d[x_a][46] = {  7,   8,   6}; //   3

  c_p[x_a][47] = { 10,  11,  13}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  1}; //   1
  c_d[x_a][47] = {  7,   8,   6}; //   3

  c_p[x_a][48] = { 14,  15,  16}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  1}; //   1
  c_d[x_a][48] = {  9,  10,  11}; //   3

  c_p[x_a][49] = { 14,  15,  17}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  1}; //   1
  c_d[x_a][49] = {  9,  10,  11}; //   3

  c_p[x_a][50] = { 18,  15,  16}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  1}; //   1
  c_d[x_a][50] = {  9,  10,  11}; //   3

  c_p[x_a][51] = { 18,  15,  17}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  1}; //   1
  c_d[x_a][51] = {  9,  10,  11}; //   3

  c_p[x_a][52] = { 14,  19,   6}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  1}; //   1
  c_d[x_a][52] = {  3,  12,  11}; //   3

  c_p[x_a][53] = { 14,  19,   7}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  1}; //   1
  c_d[x_a][53] = {  3,  12,  11}; //   3

  c_p[x_a][54] = { 18,  19,   6}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  1}; //   1
  c_d[x_a][54] = {  3,  12,  11}; //   3

  c_p[x_a][55] = { 18,  19,   7}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  1}; //   1
  c_d[x_a][55] = {  3,  12,  11}; //   3

  c_p[x_a][56] = { 20,  21,  16}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  1}; //   1
  c_d[x_a][56] = {  9,  13,  14}; //   3

  c_p[x_a][57] = { 20,  21,  17}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  1}; //   1
  c_d[x_a][57] = {  9,  13,  14}; //   3

  c_p[x_a][58] = { 22,  21,  16}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  1}; //   1
  c_d[x_a][58] = {  9,  13,  14}; //   3

  c_p[x_a][59] = { 22,  21,  17}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  1}; //   1
  c_d[x_a][59] = {  9,  13,  14}; //   3

  c_p[x_a][60] = { 20,  23,  12}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  1}; //   1
  c_d[x_a][60] = {  7,  15,  14}; //   3

  c_p[x_a][61] = { 20,  23,  13}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  1}; //   1
  c_d[x_a][61] = {  7,  15,  14}; //   3

  c_p[x_a][62] = { 22,  23,  12}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  1}; //   1
  c_d[x_a][62] = {  7,  15,  14}; //   3

  c_p[x_a][63] = { 22,  23,  13}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  1}; //   1
  c_d[x_a][63] = {  7,  15,  14}; //   3

  c_p[x_a][64] = {  0,  24}; //   2
  c_f[x_a][64] = {  0}; //   1
  c_t[x_a][64] = {  0,   2}; //   2
  c_d[x_a][64] = { 14,   2}; //   2

  c_p[x_a][65] = {  0,  25}; //   2
  c_f[x_a][65] = {  0}; //   1
  c_t[x_a][65] = {  0,   2}; //   2
  c_d[x_a][65] = { 14,   2}; //   2

  c_p[x_a][66] = {  4,  24}; //   2
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  0,   2}; //   2
  c_d[x_a][66] = { 14,   2}; //   2

  c_p[x_a][67] = {  4,  25}; //   2
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  0,   2}; //   2
  c_d[x_a][67] = { 14,   2}; //   2

  c_p[x_a][68] = {  8,  26}; //   2
  c_f[x_a][68] = {  1}; //   1
  c_t[x_a][68] = {  0,   3}; //   2
  c_d[x_a][68] = { 11,   6}; //   2

  c_p[x_a][69] = {  8,  27}; //   2
  c_f[x_a][69] = {  1}; //   1
  c_t[x_a][69] = {  0,   3}; //   2
  c_d[x_a][69] = { 11,   6}; //   2

  c_p[x_a][70] = { 10,  26}; //   2
  c_f[x_a][70] = {  1}; //   1
  c_t[x_a][70] = {  0,   3}; //   2
  c_d[x_a][70] = { 11,   6}; //   2

  c_p[x_a][71] = { 10,  27}; //   2
  c_f[x_a][71] = {  1}; //   1
  c_t[x_a][71] = {  0,   3}; //   2
  c_d[x_a][71] = { 11,   6}; //   2

  c_p[x_a][72] = { 14,  28}; //   2
  c_f[x_a][72] = {  1}; //   1
  c_t[x_a][72] = {  0,   4}; //   2
  c_d[x_a][72] = {  6,  11}; //   2

  c_p[x_a][73] = { 14,  29}; //   2
  c_f[x_a][73] = {  1}; //   1
  c_t[x_a][73] = {  0,   4}; //   2
  c_d[x_a][73] = {  6,  11}; //   2

  c_p[x_a][74] = { 18,  28}; //   2
  c_f[x_a][74] = {  1}; //   1
  c_t[x_a][74] = {  0,   4}; //   2
  c_d[x_a][74] = {  6,  11}; //   2

  c_p[x_a][75] = { 18,  29}; //   2
  c_f[x_a][75] = {  1}; //   1
  c_t[x_a][75] = {  0,   4}; //   2
  c_d[x_a][75] = {  6,  11}; //   2

  c_p[x_a][76] = { 20,  30}; //   2
  c_f[x_a][76] = {  0}; //   1
  c_t[x_a][76] = {  0,   5}; //   2
  c_d[x_a][76] = {  2,  14}; //   2

  c_p[x_a][77] = { 20,  31}; //   2
  c_f[x_a][77] = {  0}; //   1
  c_t[x_a][77] = {  0,   5}; //   2
  c_d[x_a][77] = {  2,  14}; //   2

  c_p[x_a][78] = { 22,  30}; //   2
  c_f[x_a][78] = {  0}; //   1
  c_t[x_a][78] = {  0,   5}; //   2
  c_d[x_a][78] = {  2,  14}; //   2

  c_p[x_a][79] = { 22,  31}; //   2
  c_f[x_a][79] = {  0}; //   1
  c_t[x_a][79] = {  0,   5}; //   2
  c_d[x_a][79] = {  2,  14}; //   2

  c_p[x_a][80] = {  0,  24}; //   2
  c_f[x_a][80] = {  2}; //   1
  c_t[x_a][80] = {  6,   7}; //   2
  c_d[x_a][80] = { 14,   2}; //   2

  c_p[x_a][81] = {  0,  25}; //   2
  c_f[x_a][81] = {  2}; //   1
  c_t[x_a][81] = {  6,   7}; //   2
  c_d[x_a][81] = { 14,   2}; //   2

  c_p[x_a][82] = {  4,  24}; //   2
  c_f[x_a][82] = {  2}; //   1
  c_t[x_a][82] = {  6,   7}; //   2
  c_d[x_a][82] = { 14,   2}; //   2

  c_p[x_a][83] = {  4,  25}; //   2
  c_f[x_a][83] = {  2}; //   1
  c_t[x_a][83] = {  6,   7}; //   2
  c_d[x_a][83] = { 14,   2}; //   2

  c_p[x_a][84] = {  8,  26}; //   2
  c_f[x_a][84] = {  3}; //   1
  c_t[x_a][84] = {  8,   9}; //   2
  c_d[x_a][84] = { 11,   6}; //   2

  c_p[x_a][85] = {  8,  27}; //   2
  c_f[x_a][85] = {  3}; //   1
  c_t[x_a][85] = {  8,   9}; //   2
  c_d[x_a][85] = { 11,   6}; //   2

  c_p[x_a][86] = { 10,  26}; //   2
  c_f[x_a][86] = {  3}; //   1
  c_t[x_a][86] = {  8,   9}; //   2
  c_d[x_a][86] = { 11,   6}; //   2

  c_p[x_a][87] = { 10,  27}; //   2
  c_f[x_a][87] = {  3}; //   1
  c_t[x_a][87] = {  8,   9}; //   2
  c_d[x_a][87] = { 11,   6}; //   2

  c_p[x_a][88] = { 14,  28}; //   2
  c_f[x_a][88] = {  4}; //   1
  c_t[x_a][88] = { 10,  11}; //   2
  c_d[x_a][88] = {  6,  11}; //   2

  c_p[x_a][89] = { 14,  29}; //   2
  c_f[x_a][89] = {  4}; //   1
  c_t[x_a][89] = { 10,  11}; //   2
  c_d[x_a][89] = {  6,  11}; //   2

  c_p[x_a][90] = { 18,  28}; //   2
  c_f[x_a][90] = {  4}; //   1
  c_t[x_a][90] = { 10,  11}; //   2
  c_d[x_a][90] = {  6,  11}; //   2

  c_p[x_a][91] = { 18,  29}; //   2
  c_f[x_a][91] = {  4}; //   1
  c_t[x_a][91] = { 10,  11}; //   2
  c_d[x_a][91] = {  6,  11}; //   2

  c_p[x_a][92] = { 20,  30}; //   2
  c_f[x_a][92] = {  5}; //   1
  c_t[x_a][92] = { 12,  13}; //   2
  c_d[x_a][92] = {  2,  14}; //   2

  c_p[x_a][93] = { 20,  31}; //   2
  c_f[x_a][93] = {  5}; //   1
  c_t[x_a][93] = { 12,  13}; //   2
  c_d[x_a][93] = {  2,  14}; //   2

  c_p[x_a][94] = { 22,  30}; //   2
  c_f[x_a][94] = {  5}; //   1
  c_t[x_a][94] = { 12,  13}; //   2
  c_d[x_a][94] = {  2,  14}; //   2

  c_p[x_a][95] = { 22,  31}; //   2
  c_f[x_a][95] = {  5}; //   1
  c_t[x_a][95] = { 12,  13}; //   2
  c_d[x_a][95] = {  2,  14}; //   2

  c_p[x_a][96] = {  0,  24}; //   2
  c_f[x_a][96] = {  0}; //   1
  c_t[x_a][96] = {  1,  14}; //   2
  c_d[x_a][96] = { 14,   2}; //   2

  c_p[x_a][97] = {  0,  25}; //   2
  c_f[x_a][97] = {  0}; //   1
  c_t[x_a][97] = {  1,  14}; //   2
  c_d[x_a][97] = { 14,   2}; //   2

  c_p[x_a][98] = {  4,  24}; //   2
  c_f[x_a][98] = {  0}; //   1
  c_t[x_a][98] = {  1,  14}; //   2
  c_d[x_a][98] = { 14,   2}; //   2

  c_p[x_a][99] = {  4,  25}; //   2
  c_f[x_a][99] = {  0}; //   1
  c_t[x_a][99] = {  1,  14}; //   2
  c_d[x_a][99] = { 14,   2}; //   2

  c_p[x_a][100] = {  8,  26}; //   2
  c_f[x_a][100] = {  1}; //   1
  c_t[x_a][100] = {  1,  15}; //   2
  c_d[x_a][100] = { 11,   6}; //   2

  c_p[x_a][101] = {  8,  27}; //   2
  c_f[x_a][101] = {  1}; //   1
  c_t[x_a][101] = {  1,  15}; //   2
  c_d[x_a][101] = { 11,   6}; //   2

  c_p[x_a][102] = { 10,  26}; //   2
  c_f[x_a][102] = {  1}; //   1
  c_t[x_a][102] = {  1,  15}; //   2
  c_d[x_a][102] = { 11,   6}; //   2

  c_p[x_a][103] = { 10,  27}; //   2
  c_f[x_a][103] = {  1}; //   1
  c_t[x_a][103] = {  1,  15}; //   2
  c_d[x_a][103] = { 11,   6}; //   2

  c_p[x_a][104] = { 14,  28}; //   2
  c_f[x_a][104] = {  1}; //   1
  c_t[x_a][104] = {  1,  16}; //   2
  c_d[x_a][104] = {  6,  11}; //   2

  c_p[x_a][105] = { 14,  29}; //   2
  c_f[x_a][105] = {  1}; //   1
  c_t[x_a][105] = {  1,  16}; //   2
  c_d[x_a][105] = {  6,  11}; //   2

  c_p[x_a][106] = { 18,  28}; //   2
  c_f[x_a][106] = {  1}; //   1
  c_t[x_a][106] = {  1,  16}; //   2
  c_d[x_a][106] = {  6,  11}; //   2

  c_p[x_a][107] = { 18,  29}; //   2
  c_f[x_a][107] = {  1}; //   1
  c_t[x_a][107] = {  1,  16}; //   2
  c_d[x_a][107] = {  6,  11}; //   2

  c_p[x_a][108] = { 20,  30}; //   2
  c_f[x_a][108] = {  0}; //   1
  c_t[x_a][108] = {  1,  17}; //   2
  c_d[x_a][108] = {  2,  14}; //   2

  c_p[x_a][109] = { 20,  31}; //   2
  c_f[x_a][109] = {  0}; //   1
  c_t[x_a][109] = {  1,  17}; //   2
  c_d[x_a][109] = {  2,  14}; //   2

  c_p[x_a][110] = { 22,  30}; //   2
  c_f[x_a][110] = {  0}; //   1
  c_t[x_a][110] = {  1,  17}; //   2
  c_d[x_a][110] = {  2,  14}; //   2

  c_p[x_a][111] = { 22,  31}; //   2
  c_f[x_a][111] = {  0}; //   1
  c_t[x_a][111] = {  1,  17}; //   2
  c_d[x_a][111] = {  2,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel    1: 4yyv1(1, 2, 4, 32, 8, 16, 64;   0,   0,  23,   0)
// channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  23,   0,  23,   0)
// channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,  23,   0)
// channel    6: 4yyv1(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 4, 8, 16, 64;  23,   0,  23,   0)
// channel    8: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel    9: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,  23,   0)
// channel   10: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
// channel   11: 4yyv1(1, 2, 4, 16, 8, 32, 64;  23,   0,  23,   0)
// channel   12: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   13: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,  23,   0)
// channel   14: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
// channel   15: 4yyv1(1, 2, 16, 4, 8, 32, 64;  23,   0,  23,   0)
// channel   16: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   17: 4yyv1(1, 2, 8, 32, 4, 16, 64;   0,   0,  23,   0)
// channel   18: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
// channel   19: 4yyv1(1, 2, 8, 32, 4, 16, 64;  23,   0,  23,   0)
// channel   20: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   21: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,  23,   0)
// channel   22: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,   0,   0)
// channel   23: 4yyv1(1, 2, 32, 8, 4, 16, 64;  23,   0,  23,   0)
// channel   24: 4yyv1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   25: 4yyv1(1, 2, 8, 16, 4, 32, 64;   0,   0,  23,   0)
// channel   26: 4yyv1(1, 2, 8, 16, 4, 32, 64;  23,   0,   0,   0)
// channel   27: 4yyv1(1, 2, 8, 16, 4, 32, 64;  23,   0,  23,   0)
// channel   28: 4yyv1(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel   29: 4yyv1(1, 2, 16, 8, 4, 32, 64;   0,   0,  23,   0)
// channel   30: 4yyv1(1, 2, 16, 8, 4, 32, 64;  23,   0,   0,   0)
// channel   31: 4yyv1(1, 2, 16, 8, 4, 32, 64;  23,   0,  23,   0)
// channel   32: 14yyv(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
// channel   33: 14yyv(1, 2, 64, 4, 32, 8, 16;   0,   0,  23,   0)
// channel   34: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
// channel   35: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  23,   0)
// channel   36: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   37: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  23,   0)
// channel   38: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
// channel   39: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  23,   0)
// channel   40: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
// channel   41: 14yyv(1, 2, 64, 4, 16, 8, 32;   0,   0,  23,   0)
// channel   42: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
// channel   43: 14yyv(1, 2, 64, 4, 16, 8, 32;  23,   0,  23,   0)
// channel   44: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   45: 14yyv(1, 2, 64, 16, 4, 8, 32;   0,   0,  23,   0)
// channel   46: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
// channel   47: 14yyv(1, 2, 64, 16, 4, 8, 32;  23,   0,  23,   0)
// channel   48: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
// channel   49: 14yyv(1, 2, 64, 8, 32, 4, 16;   0,   0,  23,   0)
// channel   50: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
// channel   51: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  23,   0)
// channel   52: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   53: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  23,   0)
// channel   54: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,   0,   0)
// channel   55: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  23,   0)
// channel   56: 14yyv(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
// channel   57: 14yyv(1, 2, 64, 8, 16, 4, 32;   0,   0,  23,   0)
// channel   58: 14yyv(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
// channel   59: 14yyv(1, 2, 64, 8, 16, 4, 32;  23,   0,  23,   0)
// channel   60: 14yyv(1, 2, 64, 16, 8, 4, 32;   0,   0,   0,   0)
// channel   61: 14yyv(1, 2, 64, 16, 8, 4, 32;   0,   0,  23,   0)
// channel   62: 14yyv(1, 2, 64, 16, 8, 4, 32;  23,   0,   0,   0)
// channel   63: 14yyv(1, 2, 64, 16, 8, 4, 32;  23,   0,  23,   0)
// channel   64: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel   65: 2v2v1(1, 2, 4, 32, 8, 16, 64;   0,  23,   0,   0)
// channel   66: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,   0,   0,   0)
// channel   67: 2v2v1(1, 2, 4, 32, 8, 16, 64;  23,  23,   0,   0)
// channel   68: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel   69: 2v2v1(1, 2, 4, 16, 8, 32, 64;   0,  23,   0,   0)
// channel   70: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,   0,   0,   0)
// channel   71: 2v2v1(1, 2, 4, 16, 8, 32, 64;  23,  23,   0,   0)
// channel   72: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   73: 2v2v1(1, 2, 8, 32, 4, 16, 64;   0,  23,   0,   0)
// channel   74: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,   0,   0,   0)
// channel   75: 2v2v1(1, 2, 8, 32, 4, 16, 64;  23,  23,   0,   0)
// channel   76: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   77: 2v2v1(1, 2, 8, 16, 4, 32, 64;   0,  23,   0,   0)
// channel   78: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,   0,   0,   0)
// channel   79: 2v2v1(1, 2, 8, 16, 4, 32, 64;  23,  23,   0,   0)
// channel   80: 2v12v(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel   81: 2v12v(1, 2, 4, 32, 64, 8, 16;   0,  23,   0,   0)
// channel   82: 2v12v(1, 2, 4, 32, 64, 8, 16;  23,   0,   0,   0)
// channel   83: 2v12v(1, 2, 4, 32, 64, 8, 16;  23,  23,   0,   0)
// channel   84: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,   0,   0,   0)
// channel   85: 2v12v(1, 2, 4, 16, 64, 8, 32;   0,  23,   0,   0)
// channel   86: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,   0,   0,   0)
// channel   87: 2v12v(1, 2, 4, 16, 64, 8, 32;  23,  23,   0,   0)
// channel   88: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   89: 2v12v(1, 2, 8, 32, 64, 4, 16;   0,  23,   0,   0)
// channel   90: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,   0,   0,   0)
// channel   91: 2v12v(1, 2, 8, 32, 64, 4, 16;  23,  23,   0,   0)
// channel   92: 2v12v(1, 2, 8, 16, 64, 4, 32;   0,   0,   0,   0)
// channel   93: 2v12v(1, 2, 8, 16, 64, 4, 32;   0,  23,   0,   0)
// channel   94: 2v12v(1, 2, 8, 16, 64, 4, 32;  23,   0,   0,   0)
// channel   95: 2v12v(1, 2, 8, 16, 64, 4, 32;  23,  23,   0,   0)
// channel   96: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,   0,   0,   0)
// channel   97: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,  23,   0,   0)
// channel   98: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,   0,   0,   0)
// channel   99: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,  23,   0,   0)
// channel  100: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,   0,   0,   0)
// channel  101: 12v2v(1, 2, 64, 4, 16, 8, 32;   0,  23,   0,   0)
// channel  102: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,   0,   0,   0)
// channel  103: 12v2v(1, 2, 64, 4, 16, 8, 32;  23,  23,   0,   0)
// channel  104: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,   0,   0,   0)
// channel  105: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  23,   0,   0)
// channel  106: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,   0,   0,   0)
// channel  107: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  23,   0,   0)
// channel  108: 12v2v(1, 2, 64, 8, 16, 4, 32;   0,   0,   0,   0)
// channel  109: 12v2v(1, 2, 64, 8, 16, 4, 32;   0,  23,   0,   0)
// channel  110: 12v2v(1, 2, 64, 8, 16, 4, 32;  23,   0,   0,   0)
// channel  111: 12v2v(1, 2, 64, 8, 16, 4, 32;  23,  23,   0,   0)
void ppeeexex04_phasespace_set::ax_psp_340_uux_ememepepg(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_340_uux_ememepepg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 49);
  int needed_v_smin_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   4,    5,    6,    7}; //   4
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 4);
  int needed_v_smin_4[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 49);
  int needed_v_smin_6[] = {   8,    9,   10,   11}; //   4
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 4);
  int needed_v_smin_7[] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 8);
  int needed_v_smin_9[] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 49);
  int needed_v_smin_10[] = {  16,   17,   18,   19}; //   4
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 4);
  int needed_v_smin_11[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 8);
  int needed_v_smin_12[] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  needed_v_smin[x_a][ 13] = get_vector_from_array_int(needed_v_smin_13, 49);
  int needed_v_smin_14[] = {  24,   25,   26,   27}; //   4
  needed_v_smin[x_a][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {  28,   29,   30,   31}; //   4
  needed_v_smin[x_a][ 15] = get_vector_from_array_int(needed_v_smin_15, 4);
  int needed_v_smin_16[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40}; //   9
  needed_v_smin[x_a][ 16] = get_vector_from_array_int(needed_v_smin_16, 9);
  int needed_v_smin_17[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49}; //   9
  needed_v_smin[x_a][ 17] = get_vector_from_array_int(needed_v_smin_17, 9);
  int needed_v_smin_18[] = {  50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85,  110,  111,  112,  113}; //  16
  needed_v_smin[x_a][ 18] = get_vector_from_array_int(needed_v_smin_18, 16);
  int needed_v_smin_19[] = {  58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89,  106,  107,  108,  109}; //  16
  needed_v_smin[x_a][ 19] = get_vector_from_array_int(needed_v_smin_19, 16);
  int needed_v_smin_20[] = {  66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93,  102,  103,  104,  105}; //  16
  needed_v_smin[x_a][ 20] = get_vector_from_array_int(needed_v_smin_20, 16);
  int needed_v_smin_21[] = {  74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97,   98,   99,  100,  101}; //  16
  needed_v_smin[x_a][ 21] = get_vector_from_array_int(needed_v_smin_21, 16);

  v_smax[x_a].resize(25);
  needed_v_smax[x_a].resize(25);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85,   98,   99,  100,  101}; //  33
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 33);
  int needed_v_smax_1[] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 8);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49}; //  50
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 50);
  int needed_v_smax_3[] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 8);
  int needed_v_smax_4[] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89,  102,  103,  104,  105}; //  33
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 33);
  int needed_v_smax_5[] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 8);
  int needed_v_smax_6[] = {  16,   17,   18,   19,   20,   21,   22,   23,   66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93,  106,  107,  108,  109}; //  24
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 24);
  int needed_v_smax_7[] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 8);
  int needed_v_smax_8[] = {  24,   25,   26,   27,   28,   29,   30,   31,   74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97,  110,  111,  112,  113}; //  24
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 24);
  int needed_v_smax_9[] = {  32,   33,   34,   35,   36,   37,   38,   39,   40,   98,   99,  100,  101}; //  13
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 13);
  int needed_v_smax_10[] = {  41,   42,   43,   44,   45,   46,   47,   48,   49,  102,  103,  104,  105}; //  13
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 13);
  int needed_v_smax_11[] = {  50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85}; //  12
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 12);
  int needed_v_smax_12[] = {  50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85}; //  12
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 12);
  int needed_v_smax_13[] = {  58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89}; //  12
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 12);
  int needed_v_smax_14[] = {  58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89}; //  12
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 12);
  int needed_v_smax_15[] = {  66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93}; //  12
  needed_v_smax[x_a][ 15] = get_vector_from_array_int(needed_v_smax_15, 12);
  int needed_v_smax_16[] = {  66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93}; //  12
  needed_v_smax[x_a][ 16] = get_vector_from_array_int(needed_v_smax_16, 12);
  int needed_v_smax_17[] = {  74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97}; //  12
  needed_v_smax[x_a][ 17] = get_vector_from_array_int(needed_v_smax_17, 12);
  int needed_v_smax_18[] = {  74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97}; //  12
  needed_v_smax[x_a][ 18] = get_vector_from_array_int(needed_v_smax_18, 12);
  int needed_v_smax_19[] = {  98,   99,  100,  101}; //   4
  needed_v_smax[x_a][ 19] = get_vector_from_array_int(needed_v_smax_19, 4);
  int needed_v_smax_20[] = { 102,  103,  104,  105}; //   4
  needed_v_smax[x_a][ 20] = get_vector_from_array_int(needed_v_smax_20, 4);
  int needed_v_smax_21[] = { 106,  107,  108,  109}; //   4
  needed_v_smax[x_a][ 21] = get_vector_from_array_int(needed_v_smax_21, 4);
  int needed_v_smax_22[] = { 106,  107,  108,  109}; //   4
  needed_v_smax[x_a][ 22] = get_vector_from_array_int(needed_v_smax_22, 4);
  int needed_v_smax_23[] = { 110,  111,  112,  113}; //   4
  needed_v_smax[x_a][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = { 110,  111,  112,  113}; //   4
  needed_v_smax[x_a][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);

  g_p[x_a].resize(58);
  needed_g_p[x_a].resize(58);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,   32,   33,   34,   35,   50,   51,   52,   53,   82,   83,   98,   99}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    8,   10}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    9,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    6,    7,   36,   37,   38,   39,   40,   54,   55,   56,   57,   84,   85,  100,  101}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   4,    6,   20,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {   5,    7,   21,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {   8,    9,   12,   13,   41,   42,   43,   44,   58,   59,   60,   61,   86,   87,  102,  103}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][10] = {  10,   11,   14,   15,   45,   46,   47,   48,   49,   62,   63,   64,   65,   88,   89,  104,  105}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][11] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {  12,   14,   28,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][13] = {  13,   15,   29,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][14] = {  16,   17,   20,   21,   66,   67,   68,   69,   90,   91,  106,  107}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][15] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][16] = {  16,   18,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][17] = {  17,   19,   25,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][18] = {  18,   19,   22,   23,   70,   71,   72,   73,   92,   93,  108,  109}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax6");
  needed_g_p[x_a][19] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax3");
  needed_g_p[x_a][20] = {  24,   25,   28,   29,   74,   75,   76,   77,   94,   95,  110,  111}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][21] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][22] = {  26,   27,   30,   31,   78,   79,   80,   81,   96,   97,  112,  113}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax8");
  needed_g_p[x_a][23] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax5");
  needed_g_p[x_a][24] = {  32,   33,   36,   37,   98,  100}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][25] = {  32,   34,   36,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][26] = {  33,   35,   37,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin16_smax2");
  needed_g_p[x_a][27] = {  34,   35,   38,   39,   40,   99,  101}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax9");
  needed_g_p[x_a][28] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][29] = {  41,   42,   45,   46,  102,  104}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax10");
  needed_g_p[x_a][30] = {  41,   43,   45,   48}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax2");
  needed_g_p[x_a][31] = {  42,   44,   46,   49}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin17_smax2");
  needed_g_p[x_a][32] = {  43,   44,   47,   48,   49,  103,  105}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax10");
  needed_g_p[x_a][33] = {  47}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin17_smax2");
  needed_g_p[x_a][34] = {  50,   51,   54,   55,   82,   83,   84,   85}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax11");
  needed_g_p[x_a][35] = {  50,   52,   54,   56,   82,   84}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax12");
  needed_g_p[x_a][36] = {  51,   53,   55,   57,   83,   85}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax12");
  needed_g_p[x_a][37] = {  52,   53,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin18_smax11");
  needed_g_p[x_a][38] = {  58,   59,   62,   63,   86,   87,   88,   89}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax13");
  needed_g_p[x_a][39] = {  58,   60,   62,   64,   86,   88}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax14");
  needed_g_p[x_a][40] = {  59,   61,   63,   65,   87,   89}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax14");
  needed_g_p[x_a][41] = {  60,   61,   64,   65}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin19_smax13");
  needed_g_p[x_a][42] = {  66,   67,   70,   71,   90,   91,   92,   93}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][43] = {  66,   68,   70,   72,   90,   92}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax16");
  needed_g_p[x_a][44] = {  67,   69,   71,   73,   91,   93}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax16");
  needed_g_p[x_a][45] = {  68,   69,   72,   73}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin20_smax15");
  needed_g_p[x_a][46] = {  74,   75,   78,   79,   94,   95,   96,   97}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax17");
  needed_g_p[x_a][47] = {  74,   76,   78,   80,   94,   96}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax18");
  needed_g_p[x_a][48] = {  75,   77,   79,   81,   95,   97}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][49] = {  76,   77,   80,   81}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin21_smax17");
  needed_g_p[x_a][50] = {  98,   99,  100,  101}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax19");
  needed_g_p[x_a][51] = { 102,  103,  104,  105}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax20");
  needed_g_p[x_a][52] = { 106,  108}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax21");
  needed_g_p[x_a][53] = { 106,  107,  108,  109}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax22");
  needed_g_p[x_a][54] = { 107,  109}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax21");
  needed_g_p[x_a][55] = { 110,  112}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax23");
  needed_g_p[x_a][56] = { 110,  111,  112,  113}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax24");
  needed_g_p[x_a][57] = { 111,  113}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax23");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(8);
  needed_g_t[x_a].resize(8);
  needed_g_t[x_a][0] = {  82,   83,   84,   85}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][1] = {  86,   87,   88,   89}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_104");
  needed_g_t[x_a][2] = {  90,   91,   92,   93}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][3] = {  94,   95,   96,   97}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][4] = {  98,   99,  100,  101}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__24_100");
  needed_g_t[x_a][5] = { 102,  103,  104,  105}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][6] = { 106,  107,  108,  109}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][7] = { 110,  111,  112,  113}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");

  g_d[x_a].resize(27);
  needed_g_d[x_a].resize(27);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49}; //  50
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    8,    9,   10,   11}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   4,    5,    6,    7,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   4,    5,    6,    7}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   8,    9,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][7] = {   8,    9,   10,   11,   12,   13,   14,   15,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][8] = {  12,   13,   14,   15,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][10] = {  16,   17,   18,   19,   24,   25,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][11] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][12] = {  16,   17,   18,   19,   20,   21,   22,   23,   41,   42,   43,   44,   45,   46,   47,   48,   49,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   86,   87,   88,   89,   90,   91,   92,   93,  102,  103,  104,  105,  106,  107,  108,  109}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][13] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {  24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   50,   51,   52,   53,   54,   55,   56,   57,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   94,   95,   96,   97,   98,   99,  100,  101,  110,  111,  112,  113}; //  49
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][16] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][17] = {  32,   33,   34,   35,   36,   37,   38,   39,   40}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][18] = {  41,   42,   43,   44,   45,   46,   47,   48,   49}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][19] = {  50,   51,   52,   53,   54,   55,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][20] = {  50,   51,   52,   53,   54,   55,   56,   57,   82,   83,   84,   85,  110,  111,  112,  113}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][21] = {  58,   59,   60,   61,   62,   63,   64,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][22] = {  58,   59,   60,   61,   62,   63,   64,   65,   86,   87,   88,   89,  106,  107,  108,  109}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][23] = {  66,   67,   68,   69,   70,   71,   72,   73}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][24] = {  66,   67,   68,   69,   70,   71,   72,   73,   90,   91,   92,   93,  102,  103,  104,  105}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][25] = {  74,   75,   76,   77,   78,   79,   80,   81}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][26] = {  74,   75,   76,   77,   78,   79,   80,   81,   94,   95,   96,   97,   98,   99,  100,  101}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(114);
  c_f[x_a].resize(114);
  c_t[x_a].resize(114);
  c_d[x_a].resize(114);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   2,   3}; //   4

  c_p[x_a][3] = {  4,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   2,   3}; //   4

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   4,   5,   3}; //   4

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   4,   5,   3}; //   4

  c_p[x_a][6] = {  4,   5,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   4,   5,   3}; //   4

  c_p[x_a][7] = {  4,   5,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   4,   5,   3}; //   4

  c_p[x_a][8] = {  8,   9,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,   6,   7}; //   4

  c_p[x_a][9] = {  8,   9,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,   6,   7}; //   4

  c_p[x_a][10] = { 10,   9,   2}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,   6,   7}; //   4

  c_p[x_a][11] = { 10,   9,   3}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   1,   6,   7}; //   4

  c_p[x_a][12] = {  8,  11,  12}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   8,   9,   7}; //   4

  c_p[x_a][13] = {  8,  11,  13}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,   8,   9,   7}; //   4

  c_p[x_a][14] = { 10,  11,  12}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,   8,   9,   7}; //   4

  c_p[x_a][15] = { 10,  11,  13}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,   8,   9,   7}; //   4

  c_p[x_a][16] = { 14,  15,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  0,  10,  11,  12}; //   4

  c_p[x_a][17] = { 14,  15,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  0,  10,  11,  12}; //   4

  c_p[x_a][18] = { 18,  15,  16}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  10,  11,  12}; //   4

  c_p[x_a][19] = { 18,  15,  17}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  10,  11,  12}; //   4

  c_p[x_a][20] = { 14,  19,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  0,   4,  13,  12}; //   4

  c_p[x_a][21] = { 14,  19,   7}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  0,   4,  13,  12}; //   4

  c_p[x_a][22] = { 18,  19,   6}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  0,   4,  13,  12}; //   4

  c_p[x_a][23] = { 18,  19,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  0,   4,  13,  12}; //   4

  c_p[x_a][24] = { 20,  21,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  0,  10,  14,  15}; //   4

  c_p[x_a][25] = { 20,  21,  17}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  0,  10,  14,  15}; //   4

  c_p[x_a][26] = { 22,  21,  16}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  0,  10,  14,  15}; //   4

  c_p[x_a][27] = { 22,  21,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  0,  10,  14,  15}; //   4

  c_p[x_a][28] = { 20,  23,  12}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  0,   8,  16,  15}; //   4

  c_p[x_a][29] = { 20,  23,  13}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  0,   8,  16,  15}; //   4

  c_p[x_a][30] = { 22,  23,  12}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  0,   8,  16,  15}; //   4

  c_p[x_a][31] = { 22,  23,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  0,   8,  16,  15}; //   4

  c_p[x_a][32] = {  0,  24,  25}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = {  0,  17,  15,   3}; //   4

  c_p[x_a][33] = {  0,  24,  26}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = {  0,  17,  15,   3}; //   4

  c_p[x_a][34] = {  0,  27,  25}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = {  0,  17,  15,   3}; //   4

  c_p[x_a][35] = {  0,  27,  26}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = {  0,  17,  15,   3}; //   4

  c_p[x_a][36] = {  4,  24,  25}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  0,  17,  15,   3}; //   4

  c_p[x_a][37] = {  4,  24,  26}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  0,  17,  15,   3}; //   4

  c_p[x_a][38] = {  4,  27,  28}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = {  0,  17,  15,   3}; //   4

  c_p[x_a][39] = {  4,  27,  25}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = {  0,  17,  15,   3}; //   4

  c_p[x_a][40] = {  4,  27,  26}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = {  0,  17,  15,   3}; //   4

  c_p[x_a][41] = {  8,  29,  30}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = {  0,  18,  12,   7}; //   4

  c_p[x_a][42] = {  8,  29,  31}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = {  0,  18,  12,   7}; //   4

  c_p[x_a][43] = {  8,  32,  30}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = {  0,  18,  12,   7}; //   4

  c_p[x_a][44] = {  8,  32,  31}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = {  0,  18,  12,   7}; //   4

  c_p[x_a][45] = { 10,  29,  30}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = {  0,  18,  12,   7}; //   4

  c_p[x_a][46] = { 10,  29,  31}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = {  0,  18,  12,   7}; //   4

  c_p[x_a][47] = { 10,  32,  33}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = {  0,  18,  12,   7}; //   4

  c_p[x_a][48] = { 10,  32,  30}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = {  0,  18,  12,   7}; //   4

  c_p[x_a][49] = { 10,  32,  31}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = {  0,  18,  12,   7}; //   4

  c_p[x_a][50] = {  0,  34,  35}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = { 19,  15,  20,   3}; //   4

  c_p[x_a][51] = {  0,  34,  36}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = { 19,  15,  20,   3}; //   4

  c_p[x_a][52] = {  0,  37,  35}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = { 19,  15,  20,   3}; //   4

  c_p[x_a][53] = {  0,  37,  36}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = { 19,  15,  20,   3}; //   4

  c_p[x_a][54] = {  4,  34,  35}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = { 19,  15,  20,   3}; //   4

  c_p[x_a][55] = {  4,  34,  36}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = { 19,  15,  20,   3}; //   4

  c_p[x_a][56] = {  4,  37,  35}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = { 19,  15,  20,   3}; //   4

  c_p[x_a][57] = {  4,  37,  36}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = { 19,  15,  20,   3}; //   4

  c_p[x_a][58] = {  8,  38,  39}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = { 21,  12,  22,   7}; //   4

  c_p[x_a][59] = {  8,  38,  40}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = { 21,  12,  22,   7}; //   4

  c_p[x_a][60] = {  8,  41,  39}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {}; //   0
  c_d[x_a][60] = { 21,  12,  22,   7}; //   4

  c_p[x_a][61] = {  8,  41,  40}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {}; //   0
  c_d[x_a][61] = { 21,  12,  22,   7}; //   4

  c_p[x_a][62] = { 10,  38,  39}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {}; //   0
  c_d[x_a][62] = { 21,  12,  22,   7}; //   4

  c_p[x_a][63] = { 10,  38,  40}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {}; //   0
  c_d[x_a][63] = { 21,  12,  22,   7}; //   4

  c_p[x_a][64] = { 10,  41,  39}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {}; //   0
  c_d[x_a][64] = { 21,  12,  22,   7}; //   4

  c_p[x_a][65] = { 10,  41,  40}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {}; //   0
  c_d[x_a][65] = { 21,  12,  22,   7}; //   4

  c_p[x_a][66] = { 14,  42,  43}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {}; //   0
  c_d[x_a][66] = { 23,   7,  24,  12}; //   4

  c_p[x_a][67] = { 14,  42,  44}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {}; //   0
  c_d[x_a][67] = { 23,   7,  24,  12}; //   4

  c_p[x_a][68] = { 14,  45,  43}; //   3
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {}; //   0
  c_d[x_a][68] = { 23,   7,  24,  12}; //   4

  c_p[x_a][69] = { 14,  45,  44}; //   3
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {}; //   0
  c_d[x_a][69] = { 23,   7,  24,  12}; //   4

  c_p[x_a][70] = { 18,  42,  43}; //   3
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {}; //   0
  c_d[x_a][70] = { 23,   7,  24,  12}; //   4

  c_p[x_a][71] = { 18,  42,  44}; //   3
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {}; //   0
  c_d[x_a][71] = { 23,   7,  24,  12}; //   4

  c_p[x_a][72] = { 18,  45,  43}; //   3
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {}; //   0
  c_d[x_a][72] = { 23,   7,  24,  12}; //   4

  c_p[x_a][73] = { 18,  45,  44}; //   3
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {}; //   0
  c_d[x_a][73] = { 23,   7,  24,  12}; //   4

  c_p[x_a][74] = { 20,  46,  47}; //   3
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {}; //   0
  c_d[x_a][74] = { 25,   3,  26,  15}; //   4

  c_p[x_a][75] = { 20,  46,  48}; //   3
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {}; //   0
  c_d[x_a][75] = { 25,   3,  26,  15}; //   4

  c_p[x_a][76] = { 20,  49,  47}; //   3
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {}; //   0
  c_d[x_a][76] = { 25,   3,  26,  15}; //   4

  c_p[x_a][77] = { 20,  49,  48}; //   3
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {}; //   0
  c_d[x_a][77] = { 25,   3,  26,  15}; //   4

  c_p[x_a][78] = { 22,  46,  47}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {}; //   0
  c_d[x_a][78] = { 25,   3,  26,  15}; //   4

  c_p[x_a][79] = { 22,  46,  48}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {}; //   0
  c_d[x_a][79] = { 25,   3,  26,  15}; //   4

  c_p[x_a][80] = { 22,  49,  47}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {}; //   0
  c_d[x_a][80] = { 25,   3,  26,  15}; //   4

  c_p[x_a][81] = { 22,  49,  48}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {}; //   0
  c_d[x_a][81] = { 25,   3,  26,  15}; //   4

  c_p[x_a][82] = {  0,  34,  35}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  0}; //   1
  c_d[x_a][82] = { 15,  20,   3}; //   3

  c_p[x_a][83] = {  0,  34,  36}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  0}; //   1
  c_d[x_a][83] = { 15,  20,   3}; //   3

  c_p[x_a][84] = {  4,  34,  35}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  0}; //   1
  c_d[x_a][84] = { 15,  20,   3}; //   3

  c_p[x_a][85] = {  4,  34,  36}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  0}; //   1
  c_d[x_a][85] = { 15,  20,   3}; //   3

  c_p[x_a][86] = {  8,  38,  39}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = {  1}; //   1
  c_d[x_a][86] = { 12,  22,   7}; //   3

  c_p[x_a][87] = {  8,  38,  40}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = {  1}; //   1
  c_d[x_a][87] = { 12,  22,   7}; //   3

  c_p[x_a][88] = { 10,  38,  39}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = {  1}; //   1
  c_d[x_a][88] = { 12,  22,   7}; //   3

  c_p[x_a][89] = { 10,  38,  40}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  1}; //   1
  c_d[x_a][89] = { 12,  22,   7}; //   3

  c_p[x_a][90] = { 14,  42,  43}; //   3
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = {  2}; //   1
  c_d[x_a][90] = {  7,  24,  12}; //   3

  c_p[x_a][91] = { 14,  42,  44}; //   3
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = {  2}; //   1
  c_d[x_a][91] = {  7,  24,  12}; //   3

  c_p[x_a][92] = { 18,  42,  43}; //   3
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = {  2}; //   1
  c_d[x_a][92] = {  7,  24,  12}; //   3

  c_p[x_a][93] = { 18,  42,  44}; //   3
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = {  2}; //   1
  c_d[x_a][93] = {  7,  24,  12}; //   3

  c_p[x_a][94] = { 20,  46,  47}; //   3
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = {  3}; //   1
  c_d[x_a][94] = {  3,  26,  15}; //   3

  c_p[x_a][95] = { 20,  46,  48}; //   3
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = {  3}; //   1
  c_d[x_a][95] = {  3,  26,  15}; //   3

  c_p[x_a][96] = { 22,  46,  47}; //   3
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = {  3}; //   1
  c_d[x_a][96] = {  3,  26,  15}; //   3

  c_p[x_a][97] = { 22,  46,  48}; //   3
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = {  3}; //   1
  c_d[x_a][97] = {  3,  26,  15}; //   3

  c_p[x_a][98] = {  0,  24,  50}; //   3
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = {  4}; //   1
  c_d[x_a][98] = { 26,  15,   3}; //   3

  c_p[x_a][99] = {  0,  27,  50}; //   3
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = {  4}; //   1
  c_d[x_a][99] = { 26,  15,   3}; //   3

  c_p[x_a][100] = {  4,  24,  50}; //   3
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = {  4}; //   1
  c_d[x_a][100] = { 26,  15,   3}; //   3

  c_p[x_a][101] = {  4,  27,  50}; //   3
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = {  4}; //   1
  c_d[x_a][101] = { 26,  15,   3}; //   3

  c_p[x_a][102] = {  8,  29,  51}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = {  5}; //   1
  c_d[x_a][102] = { 24,  12,   7}; //   3

  c_p[x_a][103] = {  8,  32,  51}; //   3
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = {  5}; //   1
  c_d[x_a][103] = { 24,  12,   7}; //   3

  c_p[x_a][104] = { 10,  29,  51}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = {  5}; //   1
  c_d[x_a][104] = { 24,  12,   7}; //   3

  c_p[x_a][105] = { 10,  32,  51}; //   3
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = {  5}; //   1
  c_d[x_a][105] = { 24,  12,   7}; //   3

  c_p[x_a][106] = { 14,  52,  53}; //   3
  c_f[x_a][106] = {}; //   0
  c_t[x_a][106] = {  6}; //   1
  c_d[x_a][106] = { 22,   7,  12}; //   3

  c_p[x_a][107] = { 14,  54,  53}; //   3
  c_f[x_a][107] = {}; //   0
  c_t[x_a][107] = {  6}; //   1
  c_d[x_a][107] = { 22,   7,  12}; //   3

  c_p[x_a][108] = { 18,  52,  53}; //   3
  c_f[x_a][108] = {}; //   0
  c_t[x_a][108] = {  6}; //   1
  c_d[x_a][108] = { 22,   7,  12}; //   3

  c_p[x_a][109] = { 18,  54,  53}; //   3
  c_f[x_a][109] = {}; //   0
  c_t[x_a][109] = {  6}; //   1
  c_d[x_a][109] = { 22,   7,  12}; //   3

  c_p[x_a][110] = { 20,  55,  56}; //   3
  c_f[x_a][110] = {}; //   0
  c_t[x_a][110] = {  7}; //   1
  c_d[x_a][110] = { 20,   3,  15}; //   3

  c_p[x_a][111] = { 20,  57,  56}; //   3
  c_f[x_a][111] = {}; //   0
  c_t[x_a][111] = {  7}; //   1
  c_d[x_a][111] = { 20,   3,  15}; //   3

  c_p[x_a][112] = { 22,  55,  56}; //   3
  c_f[x_a][112] = {}; //   0
  c_t[x_a][112] = {  7}; //   1
  c_d[x_a][112] = { 20,   3,  15}; //   3

  c_p[x_a][113] = { 22,  57,  56}; //   3
  c_f[x_a][113] = {}; //   0
  c_t[x_a][113] = {  7}; //   1
  c_d[x_a][113] = { 20,   3,  15}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
