#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_140_gd_ememepvexu(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_140_gd_ememepvexu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   18,   19,   20,   21,   22,   28,   29,   32,   33,   38,   39,   40,   41,   46,   47}; //  22
  needed_v_smin[x_a][  1] = {   0,   20}; //   2
  needed_v_smin[x_a][  2] = {   0,    3,   20,   23}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,   21,   22}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  needed_v_smin[x_a][  5] = {   3,   10,   11,   14,   15,   16,   17,   23,   30,   31,   34,   35,   36,   37,   42,   43,   44,   45}; //  18
  needed_v_smin[x_a][  6] = {   3,   23}; //   2
  needed_v_smin[x_a][  7] = {   4,    5,    6,   10,   11,   14,   15,   16,   17,   24,   25,   26,   30,   31,   34,   35,   36,   37,   42,   43,   44,   45}; //  22
  needed_v_smin[x_a][  8] = {   4,   24}; //   2
  needed_v_smin[x_a][  9] = {   4,    7,   24,   27}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,   25,   26}; //   4
  needed_v_smin[x_a][ 11] = {   7,    8,    9,   12,   13,   18,   19,   27,   28,   29,   32,   33,   38,   39,   40,   41,   46,   47}; //  18
  needed_v_smin[x_a][ 12] = {   7,   27}; //   2
  needed_v_smin[x_a][ 13] = {   8,    9,   28,   29,   40,   41,   46,   47}; //   8
  needed_v_smin[x_a][ 14] = {  10,   11,   30,   31,   42,   43,   44,   45}; //   8
  needed_v_smin[x_a][ 15] = {  12,   13,   38,   39}; //   4
  needed_v_smin[x_a][ 16] = {  14,   15,   36,   37}; //   4
  needed_v_smin[x_a][ 17] = {  16,   17,   34,   35}; //   4
  needed_v_smin[x_a][ 18] = {  18,   19,   32,   33}; //   4

  v_smax[x_a].resize(24);
  needed_v_smax[x_a].resize(24);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   20,   21,   22,   28,   29,   32,   33,   40,   41}; //  16
  needed_v_smax[x_a][  1] = {   0,    3,   20,   23}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47}; //  32
  needed_v_smax[x_a][  3] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  needed_v_smax[x_a][  4] = {   3,   10,   11,   14,   15,   23,   30,   31,   34,   35,   42,   43}; //  12
  needed_v_smax[x_a][  5] = {   4,    5,    6,   16,   17,   24,   25,   26,   36,   37,   44,   45}; //  12
  needed_v_smax[x_a][  6] = {   4,    7,   24,   27}; //   4
  needed_v_smax[x_a][  7] = {   7,   18,   19,   27,   38,   39,   46,   47}; //   8
  needed_v_smax[x_a][  8] = {   8,    9,   28,   29,   32,   33,   40,   41}; //   8
  needed_v_smax[x_a][  9] = {  10,   11,   30,   31,   34,   35,   42,   43}; //   8
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2
  needed_v_smax[x_a][ 11] = {  12,   13}; //   2
  needed_v_smax[x_a][ 12] = {  14,   15}; //   2
  needed_v_smax[x_a][ 13] = {  14,   15}; //   2
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  16,   17}; //   2
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  18,   19}; //   2
  needed_v_smax[x_a][ 18] = {  32,   33}; //   2
  needed_v_smax[x_a][ 19] = {  34,   35}; //   2
  needed_v_smax[x_a][ 20] = {  36,   37,   44,   45}; //   4
  needed_v_smax[x_a][ 21] = {  36,   37}; //   2
  needed_v_smax[x_a][ 22] = {  38,   39,   46,   47}; //   4
  needed_v_smax[x_a][ 23] = {  38,   39}; //   2

  g_p[x_a].resize(37);
  needed_g_p[x_a].resize(37);
  needed_g_p[x_a][0] = {   0,    2,    9,   13,   20,   22,   29,   33,   41}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    8,   12,   21,   28,   32,   40}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,   10,   11,   14,   15,   23,   30,   31,   34,   35,   42,   43}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][8] = {   4,    6,   17,   24,   26,   37,   45}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,    7,   24,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   16,   25,   36,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {   5,    6,   25,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax3");
  needed_g_p[x_a][13] = {   7,   18,   19,   27,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax7");
  needed_g_p[x_a][14] = {   7,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][15] = {   8,    9,   28,   29,   32,   33,   40,   41}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax8");
  needed_g_p[x_a][16] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {  10,   30,   34,   42}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][18] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][19] = {  11,   31,   35,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][20] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][21] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax11");
  needed_g_p[x_a][22] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax12");
  needed_g_p[x_a][23] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax13");
  needed_g_p[x_a][24] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax13");
  needed_g_p[x_a][25] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax14");
  needed_g_p[x_a][26] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax15");
  needed_g_p[x_a][27] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax16");
  needed_g_p[x_a][28] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax17");
  needed_g_p[x_a][29] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax17");
  needed_g_p[x_a][30] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax18");
  needed_g_p[x_a][31] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax19");
  needed_g_p[x_a][32] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax20");
  needed_g_p[x_a][33] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax21");
  needed_g_p[x_a][34] = {  38,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax22");
  needed_g_p[x_a][35] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax23");
  needed_g_p[x_a][36] = {  39,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax22");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  40,   41,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][1] = {  42,   43,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax2");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__24_100");
  needed_g_t[x_a][2] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][3] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][4] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");
  needed_g_t[x_a][5] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_36");
  needed_g_t[x_a][6] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][7] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");
  needed_g_t[x_a][8] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    3,   20,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    8,    9,   12,   13,   18,   19,   20,   21,   22,   28,   29,   32,   33,   38,   39,   40,   41,   46,   47}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   1,    2,    5,    6,   21,   22,   25,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   3,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][7] = {   3,   10,   11,   14,   15,   16,   17,   23,   30,   31,   34,   35,   36,   37,   42,   43,   44,   45}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][8] = {   4,    7,   24,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][10] = {   4,    5,    6,   10,   11,   14,   15,   16,   17,   24,   25,   26,   30,   31,   34,   35,   36,   37,   42,   43,   44,   45}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][11] = {   5,    6,   25,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][12] = {   7,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][13] = {   7,    8,    9,   12,   13,   18,   19,   27,   28,   29,   32,   33,   38,   39,   40,   41,   46,   47}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][14] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][15] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][17] = {  12,   13,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][19] = {  14,   15,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][21] = {  16,   17,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][23] = {  18,   19,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  6,   7,   2}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   6,   7}; //   4

  c_p[x_a][4] = {  8,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   8,   9,  10}; //   4

  c_p[x_a][5] = { 11,  12,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   4,  11,  10}; //   4

  c_p[x_a][6] = {  8,  12,   5}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   4,  11,  10}; //   4

  c_p[x_a][7] = { 13,  14,  10}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   8,  12,  13}; //   4

  c_p[x_a][8] = {  3,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  14,  13,   3}; //   4

  c_p[x_a][9] = {  0,  15,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  14,  13,   3}; //   4

  c_p[x_a][10] = {  6,  17,  18}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  15,  10,   7}; //   4

  c_p[x_a][11] = {  6,  19,  18}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,  15,  10,   7}; //   4

  c_p[x_a][12] = {  3,  20,  21}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 16,  13,  17,   3}; //   4

  c_p[x_a][13] = {  0,  20,  21}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 16,  13,  17,   3}; //   4

  c_p[x_a][14] = {  6,  22,  23}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 18,  10,  19,   7}; //   4

  c_p[x_a][15] = {  6,  22,  24}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 18,  10,  19,   7}; //   4

  c_p[x_a][16] = { 11,  25,  26}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 20,   7,  21,  10}; //   4

  c_p[x_a][17] = {  8,  25,  26}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 20,   7,  21,  10}; //   4

  c_p[x_a][18] = { 13,  27,  28}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 22,   3,  23,  13}; //   4

  c_p[x_a][19] = { 13,  27,  29}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 22,   3,  23,  13}; //   4

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  3,   4,   5}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  4,   5,   3}; //   3

  c_p[x_a][22] = {  0,   4,   5}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  4,   5,   3}; //   3

  c_p[x_a][23] = {  6,   7,   2}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  1,   6,   7}; //   3

  c_p[x_a][24] = {  8,   9,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  8,   9,  10}; //   3

  c_p[x_a][25] = { 11,  12,   5}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  4,  11,  10}; //   3

  c_p[x_a][26] = {  8,  12,   5}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  4,  11,  10}; //   3

  c_p[x_a][27] = { 13,  14,  10}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  8,  12,  13}; //   3

  c_p[x_a][28] = {  3,  15,  16}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 14,  13,   3}; //   3

  c_p[x_a][29] = {  0,  15,  16}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 14,  13,   3}; //   3

  c_p[x_a][30] = {  6,  17,  18}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 15,  10,   7}; //   3

  c_p[x_a][31] = {  6,  19,  18}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 15,  10,   7}; //   3

  c_p[x_a][32] = {  3,  15,  30}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  1}; //   1
  c_d[x_a][32] = { 23,  13,   3}; //   3

  c_p[x_a][33] = {  0,  15,  30}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  1}; //   1
  c_d[x_a][33] = { 23,  13,   3}; //   3

  c_p[x_a][34] = {  6,  17,  31}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  2}; //   1
  c_d[x_a][34] = { 21,  10,   7}; //   3

  c_p[x_a][35] = {  6,  19,  31}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = { 21,  10,   7}; //   3

  c_p[x_a][36] = { 11,  32,  33}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  3}; //   1
  c_d[x_a][36] = { 19,   7,  10}; //   3

  c_p[x_a][37] = {  8,  32,  33}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  3}; //   1
  c_d[x_a][37] = { 19,   7,  10}; //   3

  c_p[x_a][38] = { 13,  34,  35}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  4}; //   1
  c_d[x_a][38] = { 17,   3,  13}; //   3

  c_p[x_a][39] = { 13,  36,  35}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  4}; //   1
  c_d[x_a][39] = { 17,   3,  13}; //   3

  c_p[x_a][40] = {  3,  15}; //   2
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  0,   5}; //   2
  c_d[x_a][40] = { 13,   3}; //   2

  c_p[x_a][41] = {  0,  15}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   5}; //   2
  c_d[x_a][41] = { 13,   3}; //   2

  c_p[x_a][42] = {  6,  17}; //   2
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  0,   6}; //   2
  c_d[x_a][42] = { 10,   7}; //   2

  c_p[x_a][43] = {  6,  19}; //   2
  c_f[x_a][43] = {  1}; //   1
  c_t[x_a][43] = {  0,   6}; //   2
  c_d[x_a][43] = { 10,   7}; //   2

  c_p[x_a][44] = { 11,  32}; //   2
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  0,   7}; //   2
  c_d[x_a][44] = {  7,  10}; //   2

  c_p[x_a][45] = {  8,  32}; //   2
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  0,   7}; //   2
  c_d[x_a][45] = {  7,  10}; //   2

  c_p[x_a][46] = { 13,  34}; //   2
  c_f[x_a][46] = {  0}; //   1
  c_t[x_a][46] = {  0,   8}; //   2
  c_d[x_a][46] = {  3,  13}; //   2

  c_p[x_a][47] = { 13,  36}; //   2
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  0,   8}; //   2
  c_d[x_a][47] = {  3,  13}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 5yyyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  24,   0)
// channel    1: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  24,   0)
// channel    2: 5yyyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  24,   0)
// channel    3: 5yyyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel    4: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel    5: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel    6: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel    7: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
// channel    8: 5y2vv(1, 2, 64, 4, 32, 8, 16;   0,  24,  24,   0)
// channel    9: 5y2vv(1, 2, 64, 4, 32, 8, 16;  23,  24,  24,   0)
// channel   10: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   11: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   12: 52vyv(1, 2, 4, 32, 64, 8, 16;   0,   0,  24,   0)
// channel   13: 52vyv(1, 2, 4, 32, 64, 8, 16;  23,   0,  24,   0)
// channel   14: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   15: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,  23,   0)
// channel   16: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,  24,   0)
// channel   17: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,  24,   0)
// channel   18: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,   0,   0,   0)
// channel   19: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,   0,  23,   0)
// channel   20: 14yyv(1, 2, 64, 4, 32, 8, 16;  23,   0,  24,   0)
// channel   21: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,  24,   0)
// channel   22: 14yyv(1, 2, 64, 32, 4, 8, 16;  23,   0,  24,   0)
// channel   23: 14yyv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   24: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel   25: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel   26: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel   27: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
// channel   28: 142vv(1, 2, 64, 4, 32, 8, 16;   0,  24,  24,   0)
// channel   29: 142vv(1, 2, 64, 4, 32, 8, 16;  23,  24,  24,   0)
// channel   30: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   31: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   32: 3yv2v(1, 2, 64, 4, 32, 8, 16;   0,  24,   0,   0)
// channel   33: 3yv2v(1, 2, 64, 4, 32, 8, 16;  23,  24,   0,   0)
// channel   34: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
// channel   35: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
// channel   36: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
// channel   37: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
// channel   38: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   39: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  23,   0,   0)
// channel   40: 12v2v(1, 2, 64, 4, 32, 8, 16;   0,  24,   0,   0)
// channel   41: 12v2v(1, 2, 64, 4, 32, 8, 16;  23,  24,   0,   0)
// channel   42: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
// channel   43: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
// channel   44: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
// channel   45: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
// channel   46: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   47: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  23,   0,   0)
