#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_gg_emepa(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_gg_emepa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15}; //  12
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 12);
  int needed_v_smin_1[] = {   4,    5}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {  10,   11}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15}; //  12
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 12);
  int needed_v_smax_1[] = {   4,    5}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {  10,   11}; //   2
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 2);

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    1,    6,    7,   12,   13}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    3,    8,    9,   14,   15}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][1] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][2] = {  12,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][3] = {  13,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][4] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(16);
  c_f[x_a].resize(16);
  c_t[x_a].resize(16);
  c_d[x_a].resize(16);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  1,   2}; //   2

  c_p[x_a][5] = {  2}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  1,   2}; //   2

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  3,   0}; //   2

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  3,   0}; //   2

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  3,   0}; //   2

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  3,   0}; //   2

  c_p[x_a][10] = {  3}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  4,   5}; //   2

  c_p[x_a][11] = {  3}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  4,   5}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  2}; //   1
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  1}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  3}; //   1
  c_d[x_a][15] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
