#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_gdx_emepagdx(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_gdx_emepagdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15,   18,   19,   20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49,   54,   55}; //  18
  needed_v_smin[x_a][  2] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  needed_v_smin[x_a][  4] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51,   60,   61,   64,   65}; //  16
  needed_v_smin[x_a][  5] = {   6,    7,   18,   19,    2,    3}; //   6
  needed_v_smin[x_a][  6] = {   8,    9,   20,   21,   48,   49,    0,    1,   42,   43,   54,   55}; //  12
  needed_v_smin[x_a][  7] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  needed_v_smin[x_a][  8] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  needed_v_smin[x_a][  9] = {  12,   13,   24,   25,   30,   31,   52,   53,   76,   77,   82,   83,   88,   89,   90,   91,   70,   71}; //  18
  needed_v_smin[x_a][ 10] = {  12,   13,   24,   25,   52,   53,   70,   71,   76,   77,   90,   91}; //  12
  needed_v_smin[x_a][ 11] = {  14,   15,   26,   27,   28,   29,   32,   33,   34,   35,   74,   75,   78,   79,   80,   81,   84,   85,   86,   87}; //  20
  needed_v_smin[x_a][ 12] = {  14,   15,   26,   27,   74,   75}; //   6
  needed_v_smin[x_a][ 13] = {  28,   29,   86,   87}; //   4
  needed_v_smin[x_a][ 14] = {  30,   31,   88,   89}; //   4
  needed_v_smin[x_a][ 15] = {  36,   37,   58,   59,   84,   85}; //   6
  needed_v_smin[x_a][ 16] = {  36,   37,   40,   41,   44,   45,   58,   59,   62,   63,   66,   67}; //  12
  needed_v_smin[x_a][ 17] = {  38,   39,   56,   57,   82,   83}; //   6
  needed_v_smin[x_a][ 18] = {  38,   39,   56,   57}; //   4
  needed_v_smin[x_a][ 19] = {  68,   69,   72,   73}; //   4
  needed_v_smin[x_a][ 20] = {  68,   69,   72,   73}; //   4

  v_smax[x_a].resize(22);
  needed_v_smax[x_a].resize(22);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   36,   37,   38,   39,   42,   43,   48,   49,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  46
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49,   54,   55}; //  18
  needed_v_smax[x_a][  2] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  needed_v_smax[x_a][  3] = {   4,    5,   10,   11,   16,   17,   22,   23,   32,   33,   34,   35,   40,   41,   44,   45,   46,   47,   50,   51,   60,   61,   62,   63,   64,   65,   66,   67,   78,   79,   80,   81,   36,   37,   58,   59}; //  36
  needed_v_smax[x_a][  4] = {   4,    5,    8,    9,   10,   11,   12,   13,   16,   17,   20,   21,   22,   23,   24,   25,   46,   47,   48,   49,   50,   51,   52,   53,    0,    1,   42,   43,   54,   55,   60,   61,   64,   65,   70,   71,   76,   77,   90,   91}; //  40
  needed_v_smax[x_a][  5] = {   6,    7,   14,   15,   18,   19,   26,   27,    2,    3,   74,   75}; //  12
  needed_v_smax[x_a][  6] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  needed_v_smax[x_a][  7] = {  12,   13,   24,   25,   30,   31,   52,   53}; //   8
  needed_v_smax[x_a][  8] = {  12,   13,   24,   25,   52,   53}; //   6
  needed_v_smax[x_a][  9] = {  14,   15,   26,   27,   28,   29}; //   6
  needed_v_smax[x_a][ 10] = {  14,   15,   26,   27}; //   4
  needed_v_smax[x_a][ 11] = {  28,   29,   30,   31}; //   4
  needed_v_smax[x_a][ 12] = {  28,   29,   30,   31}; //   4
  needed_v_smax[x_a][ 13] = {  32,   33,   34,   35,   78,   79,   80,   81}; //   8
  needed_v_smax[x_a][ 14] = {  74,   75,   84,   85,   86,   87}; //   6
  needed_v_smax[x_a][ 15] = {  76,   77,   82,   83,   88,   89,   90,   91,   70,   71}; //  10
  needed_v_smax[x_a][ 16] = {  86,   87,   88,   89}; //   4
  needed_v_smax[x_a][ 17] = {  36,   37,   38,   39,   40,   41,   44,   45,   56,   57,   58,   59,   62,   63,   66,   67,   68,   69,   72,   73}; //  20
  needed_v_smax[x_a][ 18] = {  38,   39,   56,   57}; //   4
  needed_v_smax[x_a][ 19] = {  68,   69,   72,   73}; //   4
  needed_v_smax[x_a][ 20] = {  82,   83}; //   2
  needed_v_smax[x_a][ 21] = {  84,   85}; //   2

  g_p[x_a].resize(29);
  needed_g_p[x_a].resize(29);
  needed_g_p[x_a][0] = {   0,    2,    6,    8,   18,   20,   36,   38,   42,   48,   54,   56,   58,   68,   70,   72,   74,   76,   82,   84,   86,   88,   90}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    7,    9,   19,   21,   37,   39,   43,   49,   55,   57,   59,   69,   71,   73,   75,   77,   83,   85,   87,   89,   91}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   4,   16,   32,   40,   46,   60,   62,   78}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   5,   17,   33,   41,   47,   61,   63,   79}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][7] = {   6,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][8] = {   8,    9,   20,   21,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][9] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][10] = {  10,   22,   34,   44,   50,   64,   66,   80}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax3");
  needed_g_p[x_a][11] = {  11,   23,   35,   45,   51,   65,   67,   81}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax3");
  needed_g_p[x_a][12] = {  12,   13,   24,   25,   30,   31,   52,   53}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  12,   24,   52}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][14] = {  12,   13,   24,   25,   52,   53}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][15] = {  13,   25,   53}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][16] = {  14,   15,   26,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][17] = {  14,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][18] = {  14,   15,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax5");
  needed_g_p[x_a][19] = {  15,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][20] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][21] = {  28,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][22] = {  29,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");
  needed_g_p[x_a][23] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][24] = {  32,   33,   34,   35,   78,   79,   80,   81}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax13");
  needed_g_p[x_a][25] = {  74,   75,   84,   85,   86,   87}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");
  needed_g_p[x_a][26] = {  76,   77,   82,   83,   88,   89,   90,   91}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax15");
  needed_g_p[x_a][27] = {  86,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax16");
  needed_g_p[x_a][28] = {  88,   89}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax16");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,    1,   42,   43,   54,   55}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][2] = {  36,   37,   58,   59}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax3");
  needed_g_f[x_a][3] = {  36,   37,   40,   41,   44,   45,   58,   59,   62,   63,   66,   67}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax17");
  needed_g_f[x_a][4] = {  38,   39,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax18");
  needed_g_f[x_a][5] = {  38,   39,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax17");
  needed_g_f[x_a][6] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  60,   61,   64,   65}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][8] = {  68,   69,   72,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax19");
  needed_g_f[x_a][9] = {  68,   69,   72,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax17");
  needed_g_f[x_a][10] = {  70,   71}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax15");
  needed_g_f[x_a][11] = {  70,   71,   76,   77,   90,   91}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax4");
  needed_g_f[x_a][12] = {  74,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax5");
  needed_g_f[x_a][13] = {  82,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax20");
  needed_g_f[x_a][14] = {  84,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax21");

  g_t[x_a].resize(28);
  needed_g_t[x_a].resize(28);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    8,    9,   10,   11,   12,   13,   76,   77}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   2,    3,    6,    7,   14,   15,   74,   75}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][4] = {  36,   37,   38,   39,   40,   41,   44,   45,   56,   57,   58,   59,   62,   63,   66,   67,   68,   69,   72,   73}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  36,   37,   40,   41,   44,   45,   58,   59}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  38,   39,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][8] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][9] = {  42,   43,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   60,   61,   64,   65,   70,   71,   90,   91}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][10] = {  42,   43,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][11] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][12] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][13] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][14] = {  60,   61,   64,   65}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][15] = {  62,   63,   66,   67}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][16] = {  68,   69,   72,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][17] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][18] = {  70,   71,   90,   91}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][19] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][20] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][21] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][22] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][23] = {  78,   79,   80,   81,   84,   85}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][24] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][25] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");
  needed_g_t[x_a][26] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][27] = {  86,   87,   88,   89}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    6,    7,    8,    9,   18,   19,   20,   21,   42,   43,   48,   49}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    6,    7,    8,    9,   12,   13,   14,   15,   18,   19,   20,   21,   24,   25,   26,   27,   28,   29,   30,   31,   36,   37,   38,   39,   42,   43,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   4,    5,   10,   11,   16,   17,   22,   23,   46,   47,   50,   51}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][3] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {   4,    5,   16,   17,   32,   33,   40,   41,   46,   47,   60,   61,   62,   63,   78,   79}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   6,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][6] = {   8,    9,   20,   21,   48,   49}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][7] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {  10,   11,   22,   23,   34,   35,   44,   45,   50,   51,   64,   65,   66,   67,   80,   81}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][9] = {  12,   13,   24,   25,   52,   53}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][10] = {  12,   13,   24,   25,   30,   31,   52,   53,   76,   77,   82,   83,   88,   89,   90,   91}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][11] = {  14,   15,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__12_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__12_96");
  needed_g_d[x_a][12] = {  14,   15,   26,   27,   28,   29,   32,   33,   34,   35,   74,   75,   78,   79,   80,   81,   84,   85,   86,   87}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][13] = {  16,   17,   20,   21,   22,   23,   24,   25}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][14] = {  18,   19,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][15] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][16] = {  28,   29,   86,   87}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__16_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__16_96");
  needed_g_d[x_a][17] = {  30,   31,   88,   89}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][18] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__96_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__96_28");

  c_p[x_a].resize(92);
  c_f[x_a].resize(92);
  c_t[x_a].resize(92);
  c_d[x_a].resize(92);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0,   1}; //   2

  c_p[x_a][3] = {  2,   1}; //   2
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0,   1}; //   2

  c_p[x_a][4] = {  3,   4,   5}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  2,   3,   4}; //   3

  c_p[x_a][5] = {  3,   6,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  2,   3,   4}; //   3

  c_p[x_a][6] = {  0,   1,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  2}; //   1
  c_d[x_a][6] = {  5,   0,   1}; //   3

  c_p[x_a][7] = {  2,   1,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  5,   0,   1}; //   3

  c_p[x_a][8] = {  0,   1,   8}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  6,   0,   1}; //   3

  c_p[x_a][9] = {  2,   1,   8}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  6,   0,   1}; //   3

  c_p[x_a][10] = {  9,  10,   5}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  2,   7,   8}; //   3

  c_p[x_a][11] = {  9,  11,   5}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  2,   7,   8}; //   3

  c_p[x_a][12] = { 12,  13,  14}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  9,   1,  10}; //   3

  c_p[x_a][13] = { 12,  15,  14}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  9,   1,  10}; //   3

  c_p[x_a][14] = { 16,  17,  18}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = { 11,   1,  12}; //   3

  c_p[x_a][15] = { 16,  19,  18}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = { 11,   1,  12}; //   3

  c_p[x_a][16] = {  3,   4,   5}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 13,   2,   3,   4}; //   4

  c_p[x_a][17] = {  3,   6,   5}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 13,   2,   3,   4}; //   4

  c_p[x_a][18] = {  0,   1,   7}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,   5,   0,   1}; //   4

  c_p[x_a][19] = {  2,   1,   7}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,   5,   0,   1}; //   4

  c_p[x_a][20] = {  0,   1,   8}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 13,   6,   0,   1}; //   4

  c_p[x_a][21] = {  2,   1,   8}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 13,   6,   0,   1}; //   4

  c_p[x_a][22] = {  9,  10,   5}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 13,   2,   7,   8}; //   4

  c_p[x_a][23] = {  9,  11,   5}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 13,   2,   7,   8}; //   4

  c_p[x_a][24] = { 12,  13,  14}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 13,   9,   1,  10}; //   4

  c_p[x_a][25] = { 12,  15,  14}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 13,   9,   1,  10}; //   4

  c_p[x_a][26] = { 16,  17,  18}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 14,  11,   1,  12}; //   4

  c_p[x_a][27] = { 16,  19,  18}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 14,  11,   1,  12}; //   4

  c_p[x_a][28] = { 16,  20,  21}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 15,   1,  16,  12}; //   4

  c_p[x_a][29] = { 16,  20,  22}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 15,   1,  16,  12}; //   4

  c_p[x_a][30] = { 12,  23,  21}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 15,   1,  17,  10}; //   4

  c_p[x_a][31] = { 12,  23,  22}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 15,   1,  17,  10}; //   4

  c_p[x_a][32] = {  3,   4,  24}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 18,  12,   3,   4}; //   4

  c_p[x_a][33] = {  3,   6,  24}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 18,  12,   3,   4}; //   4

  c_p[x_a][34] = {  9,  10,  24}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 18,  12,   7,   8}; //   4

  c_p[x_a][35] = {  9,  11,  24}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 18,  12,   7,   8}; //   4

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = {  2,   3}; //   2
  c_t[x_a][36] = {  4,   5,   6}; //   3
  c_d[x_a][36] = {  1}; //   1

  c_p[x_a][37] = {  2}; //   1
  c_f[x_a][37] = {  2,   3}; //   2
  c_t[x_a][37] = {  4,   5,   6}; //   3
  c_d[x_a][37] = {  1}; //   1

  c_p[x_a][38] = {  0}; //   1
  c_f[x_a][38] = {  4,   5}; //   2
  c_t[x_a][38] = {  4,   7,   8}; //   3
  c_d[x_a][38] = {  1}; //   1

  c_p[x_a][39] = {  2}; //   1
  c_f[x_a][39] = {  4,   5}; //   2
  c_t[x_a][39] = {  4,   7,   8}; //   3
  c_d[x_a][39] = {  1}; //   1

  c_p[x_a][40] = {  3,   4}; //   2
  c_f[x_a][40] = {  3}; //   1
  c_t[x_a][40] = {  4,   5}; //   2
  c_d[x_a][40] = {  3,   4}; //   2

  c_p[x_a][41] = {  3,   6}; //   2
  c_f[x_a][41] = {  3}; //   1
  c_t[x_a][41] = {  4,   5}; //   2
  c_d[x_a][41] = {  3,   4}; //   2

  c_p[x_a][42] = {  0,   1}; //   2
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  9,  10}; //   2
  c_d[x_a][42] = {  0,   1}; //   2

  c_p[x_a][43] = {  2,   1}; //   2
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  9,  10}; //   2
  c_d[x_a][43] = {  0,   1}; //   2

  c_p[x_a][44] = {  9,  10}; //   2
  c_f[x_a][44] = {  3}; //   1
  c_t[x_a][44] = {  4,   5}; //   2
  c_d[x_a][44] = {  7,   8}; //   2

  c_p[x_a][45] = {  9,  11}; //   2
  c_f[x_a][45] = {  3}; //   1
  c_t[x_a][45] = {  4,   5}; //   2
  c_d[x_a][45] = {  7,   8}; //   2

  c_p[x_a][46] = {  3,   4,   5}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  9}; //   1
  c_d[x_a][46] = {  2,   3,   4}; //   3

  c_p[x_a][47] = {  3,   6,   5}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  9}; //   1
  c_d[x_a][47] = {  2,   3,   4}; //   3

  c_p[x_a][48] = {  0,   1,   8}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  9}; //   1
  c_d[x_a][48] = {  6,   0,   1}; //   3

  c_p[x_a][49] = {  2,   1,   8}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  9}; //   1
  c_d[x_a][49] = {  6,   0,   1}; //   3

  c_p[x_a][50] = {  9,  10,   5}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  9}; //   1
  c_d[x_a][50] = {  2,   7,   8}; //   3

  c_p[x_a][51] = {  9,  11,   5}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  9}; //   1
  c_d[x_a][51] = {  2,   7,   8}; //   3

  c_p[x_a][52] = { 12,  13,  14}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  9}; //   1
  c_d[x_a][52] = {  9,   1,  10}; //   3

  c_p[x_a][53] = { 12,  15,  14}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  9}; //   1
  c_d[x_a][53] = {  9,   1,  10}; //   3

  c_p[x_a][54] = {  0}; //   1
  c_f[x_a][54] = {  6,   0}; //   2
  c_t[x_a][54] = {  9,  10,  11}; //   3
  c_d[x_a][54] = {  1}; //   1

  c_p[x_a][55] = {  2}; //   1
  c_f[x_a][55] = {  6,   0}; //   2
  c_t[x_a][55] = {  9,  10,  11}; //   3
  c_d[x_a][55] = {  1}; //   1

  c_p[x_a][56] = {  0}; //   1
  c_f[x_a][56] = {  4,   5}; //   2
  c_t[x_a][56] = {  4,   7,  12}; //   3
  c_d[x_a][56] = {  1}; //   1

  c_p[x_a][57] = {  2}; //   1
  c_f[x_a][57] = {  4,   5}; //   2
  c_t[x_a][57] = {  4,   7,  12}; //   3
  c_d[x_a][57] = {  1}; //   1

  c_p[x_a][58] = {  0}; //   1
  c_f[x_a][58] = {  2,   3}; //   2
  c_t[x_a][58] = {  4,   5,  13}; //   3
  c_d[x_a][58] = {  1}; //   1

  c_p[x_a][59] = {  2}; //   1
  c_f[x_a][59] = {  2,   3}; //   2
  c_t[x_a][59] = {  4,   5,  13}; //   3
  c_d[x_a][59] = {  1}; //   1

  c_p[x_a][60] = {  3,   4}; //   2
  c_f[x_a][60] = {  7}; //   1
  c_t[x_a][60] = {  9,  14}; //   2
  c_d[x_a][60] = {  3,   4}; //   2

  c_p[x_a][61] = {  3,   6}; //   2
  c_f[x_a][61] = {  7}; //   1
  c_t[x_a][61] = {  9,  14}; //   2
  c_d[x_a][61] = {  3,   4}; //   2

  c_p[x_a][62] = {  3,   4}; //   2
  c_f[x_a][62] = {  3}; //   1
  c_t[x_a][62] = {  4,  15}; //   2
  c_d[x_a][62] = {  3,   4}; //   2

  c_p[x_a][63] = {  3,   6}; //   2
  c_f[x_a][63] = {  3}; //   1
  c_t[x_a][63] = {  4,  15}; //   2
  c_d[x_a][63] = {  3,   4}; //   2

  c_p[x_a][64] = {  9,  10}; //   2
  c_f[x_a][64] = {  7}; //   1
  c_t[x_a][64] = {  9,  14}; //   2
  c_d[x_a][64] = {  7,   8}; //   2

  c_p[x_a][65] = {  9,  11}; //   2
  c_f[x_a][65] = {  7}; //   1
  c_t[x_a][65] = {  9,  14}; //   2
  c_d[x_a][65] = {  7,   8}; //   2

  c_p[x_a][66] = {  9,  10}; //   2
  c_f[x_a][66] = {  3}; //   1
  c_t[x_a][66] = {  4,  15}; //   2
  c_d[x_a][66] = {  7,   8}; //   2

  c_p[x_a][67] = {  9,  11}; //   2
  c_f[x_a][67] = {  3}; //   1
  c_t[x_a][67] = {  4,  15}; //   2
  c_d[x_a][67] = {  7,   8}; //   2

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = {  8,   9}; //   2
  c_t[x_a][68] = {  4,  16,  17}; //   3
  c_d[x_a][68] = {  1}; //   1

  c_p[x_a][69] = {  2}; //   1
  c_f[x_a][69] = {  8,   9}; //   2
  c_t[x_a][69] = {  4,  16,  17}; //   3
  c_d[x_a][69] = {  1}; //   1

  c_p[x_a][70] = {  0}; //   1
  c_f[x_a][70] = { 10,  11}; //   2
  c_t[x_a][70] = {  9,  18,  19}; //   3
  c_d[x_a][70] = {  1}; //   1

  c_p[x_a][71] = {  2}; //   1
  c_f[x_a][71] = { 10,  11}; //   2
  c_t[x_a][71] = {  9,  18,  19}; //   3
  c_d[x_a][71] = {  1}; //   1

  c_p[x_a][72] = {  0}; //   1
  c_f[x_a][72] = {  8,   9}; //   2
  c_t[x_a][72] = {  4,  16,  20}; //   3
  c_d[x_a][72] = {  1}; //   1

  c_p[x_a][73] = {  2}; //   1
  c_f[x_a][73] = {  8,   9}; //   2
  c_t[x_a][73] = {  4,  16,  20}; //   3
  c_d[x_a][73] = {  1}; //   1

  c_p[x_a][74] = {  0,  25}; //   2
  c_f[x_a][74] = { 12}; //   1
  c_t[x_a][74] = {  2,  21}; //   2
  c_d[x_a][74] = { 12,   1}; //   2

  c_p[x_a][75] = {  2,  25}; //   2
  c_f[x_a][75] = { 12}; //   1
  c_t[x_a][75] = {  2,  21}; //   2
  c_d[x_a][75] = { 12,   1}; //   2

  c_p[x_a][76] = {  0,  26}; //   2
  c_f[x_a][76] = { 11}; //   1
  c_t[x_a][76] = {  0,  22}; //   2
  c_d[x_a][76] = { 10,   1}; //   2

  c_p[x_a][77] = {  2,  26}; //   2
  c_f[x_a][77] = { 11}; //   1
  c_t[x_a][77] = {  0,  22}; //   2
  c_d[x_a][77] = { 10,   1}; //   2

  c_p[x_a][78] = {  3,   4,  24}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 23}; //   1
  c_d[x_a][78] = { 12,   3,   4}; //   3

  c_p[x_a][79] = {  3,   6,  24}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 23}; //   1
  c_d[x_a][79] = { 12,   3,   4}; //   3

  c_p[x_a][80] = {  9,  10,  24}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 23}; //   1
  c_d[x_a][80] = { 12,   7,   8}; //   3

  c_p[x_a][81] = {  9,  11,  24}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 23}; //   1
  c_d[x_a][81] = { 12,   7,   8}; //   3

  c_p[x_a][82] = {  0,  26}; //   2
  c_f[x_a][82] = { 13}; //   1
  c_t[x_a][82] = { 24,  25}; //   2
  c_d[x_a][82] = { 10,   1}; //   2

  c_p[x_a][83] = {  2,  26}; //   2
  c_f[x_a][83] = { 13}; //   1
  c_t[x_a][83] = { 24,  25}; //   2
  c_d[x_a][83] = { 10,   1}; //   2

  c_p[x_a][84] = {  0,  25}; //   2
  c_f[x_a][84] = { 14}; //   1
  c_t[x_a][84] = { 23,  26}; //   2
  c_d[x_a][84] = { 12,   1}; //   2

  c_p[x_a][85] = {  2,  25}; //   2
  c_f[x_a][85] = { 14}; //   1
  c_t[x_a][85] = { 23,  26}; //   2
  c_d[x_a][85] = { 12,   1}; //   2

  c_p[x_a][86] = {  0,  25,  27}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 27}; //   1
  c_d[x_a][86] = { 16,  12,   1}; //   3

  c_p[x_a][87] = {  2,  25,  27}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 27}; //   1
  c_d[x_a][87] = { 16,  12,   1}; //   3

  c_p[x_a][88] = {  0,  26,  28}; //   3
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = { 27}; //   1
  c_d[x_a][88] = { 17,  10,   1}; //   3

  c_p[x_a][89] = {  2,  26,  28}; //   3
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = { 27}; //   1
  c_d[x_a][89] = { 17,  10,   1}; //   3

  c_p[x_a][90] = {  0,  26}; //   2
  c_f[x_a][90] = { 11}; //   1
  c_t[x_a][90] = {  9,  18}; //   2
  c_d[x_a][90] = { 10,   1}; //   2

  c_p[x_a][91] = {  2,  26}; //   2
  c_f[x_a][91] = { 11}; //   1
  c_t[x_a][91] = {  9,  18}; //   2
  c_d[x_a][91] = { 10,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    1: 3yv11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel    2: 3yv11(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel    3: 3yv11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
// channel    4: 4yyv1(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel    6: 4yyv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel    8: 4yyv1(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel    9: 4yyv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   10: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   11: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,  23,   0,   0)
// channel   12: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel   13: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
// channel   14: 42vv1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   15: 42vv1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
// channel   16: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   17: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   18: 5yyyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   19: 5yyyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   20: 5yyyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   21: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   22: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   23: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   24: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   25: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   26: 5y2vv(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   27: 5y2vv(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
// channel   28: 52vyv(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   29: 52vyv(1, 2, 4, 8, 16, 32, 64;   0,   0,  23,   0)
// channel   30: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel   31: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
// channel   32: 52vyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   33: 52vyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   34: 52vyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   35: 52vyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   36: 12v11(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   37: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   38: 12v11(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel   39: 12v11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
// channel   40: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   41: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   42: 13yv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   43: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   44: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   45: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  23,   0,   0)
// channel   46: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   47: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   48: 14yyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   49: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   50: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   51: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   52: 142vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   53: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   54: 112v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   55: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   56: 112v1(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   57: 112v1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
// channel   58: 112v1(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   59: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
// channel   60: 113yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   61: 113yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   62: 113yv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   63: 113yv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
// channel   64: 113yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   65: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   66: 113yv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   67: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
// channel   68: 1112v(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   69: 1112v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   70: 1112v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   71: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   72: 1112v(1, 2, 64, 32, 16, 4, 8;   0,   0,   0,   0)
// channel   73: 1112v(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,   0)
// channel   74: 2v2v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   75: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   76: 2v2v1(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   77: 2v2v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   78: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   79: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   80: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   81: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   82: 2v12v(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   83: 2v12v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   84: 2v12v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   85: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   86: 3yv2v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   87: 3yv2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   88: 3yv2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   89: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   90: 12v2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   91: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
