#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_gg_emepauux(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_gg_emepauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  needed_v_smin[x_a][  1] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81,   84,   85}; //  16
  needed_v_smin[x_a][  2] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83,   86,   87}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  4] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  5] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61,   42,   43,   46,   47,   50,   51,   70,   71}; //  20
  needed_v_smin[x_a][  6] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63,   40,   41,   44,   45,   48,   49,   68,   69}; //  20
  needed_v_smin[x_a][  7] = {   8,    9,   26,   27,   58,   59,    0,    1,   74,   75}; //  10
  needed_v_smin[x_a][  8] = {  10,   11,   24,   25,   56,   57,    2,    3,   72,   73}; //  10
  needed_v_smin[x_a][  9] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  needed_v_smin[x_a][ 11] = {  16,   17,   32,   33,   36,   37,   64,   65,   78,   79,   80,   81,   84,   85,   88,   89}; //  16
  needed_v_smin[x_a][ 12] = {  16,   17,   32,   33,   64,   65,   78,   79,   88,   89}; //  10
  needed_v_smin[x_a][ 13] = {  18,   19,   34,   35,   38,   39,   66,   67,   76,   77,   82,   83,   86,   87,   90,   91}; //  16
  needed_v_smin[x_a][ 14] = {  18,   19,   34,   35,   66,   67,   76,   77,   90,   91}; //  10
  needed_v_smin[x_a][ 15] = {  40,   41,   42,   43,   68,   69,   70,   71}; //   8

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   24,   25,   26,   27,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  40
  needed_v_smax[x_a][  1] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81}; //  14
  needed_v_smax[x_a][  2] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83}; //  14
  needed_v_smax[x_a][  3] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  4] = {   4,    5,    6,    7,   12,   13,   14,   15,   20,   21,   22,   23,   28,   29,   30,   31,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   60,   61,   62,   63,   40,   41,   42,   43,   68,   69,   70,   71}; //  40
  needed_v_smax[x_a][  5] = {   4,    5,    8,    9,   12,   13,   18,   19,   20,   21,   26,   27,   28,   29,   34,   35,   52,   53,   58,   59,   60,   61,   66,   67,    0,    1,   42,   43,   46,   47,   50,   51,   70,   71,   74,   75,   76,   77,   90,   91}; //  40
  needed_v_smax[x_a][  6] = {   6,    7,   10,   11,   14,   15,   16,   17,   22,   23,   24,   25,   30,   31,   32,   33,   54,   55,   56,   57,   62,   63,   64,   65,    2,    3,   40,   41,   44,   45,   48,   49,   68,   69,   72,   73,   78,   79,   88,   89}; //  40
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  needed_v_smax[x_a][  8] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  needed_v_smax[x_a][  9] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  needed_v_smax[x_a][ 10] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  needed_v_smax[x_a][ 11] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  needed_v_smax[x_a][ 12] = {  36,   37,   80,   81}; //   4
  needed_v_smax[x_a][ 13] = {  38,   39,   82,   83}; //   4
  needed_v_smax[x_a][ 14] = {  76,   77}; //   2
  needed_v_smax[x_a][ 15] = {  78,   79}; //   2
  needed_v_smax[x_a][ 16] = {  84,   85}; //   2
  needed_v_smax[x_a][ 17] = {  86,   87}; //   2

  g_p[x_a].resize(28);
  needed_g_p[x_a].resize(28);
  needed_g_p[x_a][0] = {   0,    2,    8,   10,   24,   26,   36,   38,   40,   42,   56,   58,   68,   70,   72,   74,   76,   78,   80,   82}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    9,   11,   25,   27,   37,   39,   41,   43,   57,   59,   69,   71,   73,   75,   77,   79,   81,   83}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    6,   20,   22,   44,   46,   52,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   5,    7,   21,   23,   45,   47,   53,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][8] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][9] = {   8,    9,   26,   27,   58,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][10] = {  10,   11,   24,   25,   56,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {  12,   14,   28,   30,   48,   50,   60,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][13] = {  13,   15,   29,   31,   49,   51,   61,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax4");
  needed_g_p[x_a][14] = {  16,   17,   32,   33,   64,   65,   84,   85,   88,   89}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][15] = {  16,   32,   64,   84,   88}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][16] = {  16,   17,   32,   33,   64,   65}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][17] = {  17,   33,   65,   85,   89}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][18] = {  18,   19,   34,   35,   66,   67,   86,   87,   90,   91}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][19] = {  18,   34,   66,   86,   90}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax11");
  needed_g_p[x_a][20] = {  18,   19,   34,   35,   66,   67}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax5");
  needed_g_p[x_a][21] = {  19,   35,   67,   87,   91}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][22] = {  36,   37,   80,   81}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax12");
  needed_g_p[x_a][23] = {  38,   39,   82,   83}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax13");
  needed_g_p[x_a][24] = {  76,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax14");
  needed_g_p[x_a][25] = {  78,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax15");
  needed_g_p[x_a][26] = {  84,   85}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax16");
  needed_g_p[x_a][27] = {  86,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax17");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,    1,   74,   75}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][1] = {   2,    3,   72,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][2] = {  40,   41,   42,   43,   68,   69,   70,   71}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax4");
  needed_g_f[x_a][3] = {  40,   41,   44,   45,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][4] = {  42,   43,   46,   47,   50,   51,   70,   71}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][5] = {  76,   77,   90,   91}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax5");
  needed_g_f[x_a][6] = {  78,   79,   88,   89}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax6");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    8,    9,   12,   13,   18,   19,   76,   77}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   2,    3,    6,    7,   10,   11,   14,   15,   16,   17,   78,   79}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__16_44");
  needed_g_t[x_a][4] = {  40,   41,   44,   45,   48,   49,   54,   55,   56,   57,   62,   63,   64,   65,   68,   69,   72,   73,   88,   89}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  40,   41,   44,   45,   48,   49,   68,   69}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  42,   43,   46,   47,   50,   51,   52,   53,   58,   59,   60,   61,   66,   67,   70,   71,   74,   75,   90,   91}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][8] = {  42,   43,   46,   47,   50,   51,   70,   71}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][9] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][10] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][11] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][12] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__16_44");
  needed_g_t[x_a][13] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__16_76");
  needed_g_t[x_a][14] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][15] = {  78,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][16] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][17] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][18] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][19] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][20] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][21] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__80_12");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   0,    1,    8,    9,   26,   27,   36,   37,   58,   59,   74,   75,   80,   81,   84,   85}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   24,   25,   26,   27,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   56,   57,   58,   59,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    3,   10,   11,   24,   25,   38,   39,   56,   57,   72,   73,   82,   83,   86,   87}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   4,    5,   12,   13,   20,   21,   28,   29,   52,   53,   60,   61}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][4] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   4,    5,    6,    7,   20,   21,   22,   23,   44,   45,   46,   47,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][6] = {   6,    7,   14,   15,   22,   23,   30,   31,   54,   55,   62,   63}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   8,    9,   26,   27,   58,   59}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][8] = {  10,   11,   24,   25,   56,   57}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   28,   29,   30,   31,   48,   49,   50,   51,   60,   61,   62,   63}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][11] = {  16,   17,   32,   33,   64,   65}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][12] = {  16,   17,   32,   33,   36,   37,   64,   65,   78,   79,   80,   81,   84,   85,   88,   89}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][13] = {  18,   19,   34,   35,   66,   67}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][14] = {  18,   19,   34,   35,   38,   39,   66,   67,   76,   77,   82,   83,   86,   87,   90,   91}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][15] = {  20,   21,   26,   27,   28,   29,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][16] = {  22,   23,   24,   25,   30,   31,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][17] = {  36,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][18] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(92);
  c_f[x_a].resize(92);
  c_t[x_a].resize(92);
  c_d[x_a].resize(92);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   1}; //   2
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  0,   3}; //   2
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  2,   1}; //   2

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  2,   1}; //   2

  c_p[x_a][4] = {  4,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   4,   5}; //   3

  c_p[x_a][5] = {  4,   7,   6}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3,   4,   5}; //   3

  c_p[x_a][6] = {  4,   5,   8}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  2}; //   1
  c_d[x_a][6] = {  6,   4,   5}; //   3

  c_p[x_a][7] = {  4,   7,   8}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  6,   4,   5}; //   3

  c_p[x_a][8] = {  0,   1,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  7,   0,   1}; //   3

  c_p[x_a][9] = {  2,   1,   9}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  7,   0,   1}; //   3

  c_p[x_a][10] = {  0,   3,  10}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = {  8,   2,   1}; //   3

  c_p[x_a][11] = {  2,   3,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  2}; //   1
  c_d[x_a][11] = {  8,   2,   1}; //   3

  c_p[x_a][12] = { 11,  12,   6}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  3,   9,  10}; //   3

  c_p[x_a][13] = { 11,  13,   6}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  3,   9,  10}; //   3

  c_p[x_a][14] = { 11,  12,   8}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = {  6,   9,  10}; //   3

  c_p[x_a][15] = { 11,  13,   8}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = {  6,   9,  10}; //   3

  c_p[x_a][16] = { 14,  15,  16}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = { 11,   1,  12}; //   3

  c_p[x_a][17] = { 14,  17,  16}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = { 11,   1,  12}; //   3

  c_p[x_a][18] = { 18,  19,  20}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 13,   1,  14}; //   3

  c_p[x_a][19] = { 18,  21,  20}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 13,   1,  14}; //   3

  c_p[x_a][20] = {  4,   5,   6}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,   3,   4,   5}; //   4

  c_p[x_a][21] = {  4,   7,   6}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 15,   3,   4,   5}; //   4

  c_p[x_a][22] = {  4,   5,   8}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 16,   6,   4,   5}; //   4

  c_p[x_a][23] = {  4,   7,   8}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 16,   6,   4,   5}; //   4

  c_p[x_a][24] = {  0,   3,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 16,   8,   2,   1}; //   4

  c_p[x_a][25] = {  2,   3,  10}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 16,   8,   2,   1}; //   4

  c_p[x_a][26] = {  0,   1,   9}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 15,   7,   0,   1}; //   4

  c_p[x_a][27] = {  2,   1,   9}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 15,   7,   0,   1}; //   4

  c_p[x_a][28] = { 11,  12,   6}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 15,   3,   9,  10}; //   4

  c_p[x_a][29] = { 11,  13,   6}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 15,   3,   9,  10}; //   4

  c_p[x_a][30] = { 11,  12,   8}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 16,   6,   9,  10}; //   4

  c_p[x_a][31] = { 11,  13,   8}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 16,   6,   9,  10}; //   4

  c_p[x_a][32] = { 14,  15,  16}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 16,  11,   1,  12}; //   4

  c_p[x_a][33] = { 14,  17,  16}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 16,  11,   1,  12}; //   4

  c_p[x_a][34] = { 18,  19,  20}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 15,  13,   1,  14}; //   4

  c_p[x_a][35] = { 18,  21,  20}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 15,  13,   1,  14}; //   4

  c_p[x_a][36] = {  0,   1,  22}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 17,  12,   0,   1}; //   4

  c_p[x_a][37] = {  2,   1,  22}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 17,  12,   0,   1}; //   4

  c_p[x_a][38] = {  0,   3,  23}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 18,  14,   2,   1}; //   4

  c_p[x_a][39] = {  2,   3,  23}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 18,  14,   2,   1}; //   4

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = {  2,   3}; //   2
  c_t[x_a][40] = {  4,   5,   6}; //   3
  c_d[x_a][40] = {  1}; //   1

  c_p[x_a][41] = {  2}; //   1
  c_f[x_a][41] = {  2,   3}; //   2
  c_t[x_a][41] = {  4,   5,   6}; //   3
  c_d[x_a][41] = {  1}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {  2,   4}; //   2
  c_t[x_a][42] = {  7,   8,   9}; //   3
  c_d[x_a][42] = {  1}; //   1

  c_p[x_a][43] = {  2}; //   1
  c_f[x_a][43] = {  2,   4}; //   2
  c_t[x_a][43] = {  7,   8,   9}; //   3
  c_d[x_a][43] = {  1}; //   1

  c_p[x_a][44] = {  4,   5}; //   2
  c_f[x_a][44] = {  3}; //   1
  c_t[x_a][44] = {  4,   5}; //   2
  c_d[x_a][44] = {  4,   5}; //   2

  c_p[x_a][45] = {  4,   7}; //   2
  c_f[x_a][45] = {  3}; //   1
  c_t[x_a][45] = {  4,   5}; //   2
  c_d[x_a][45] = {  4,   5}; //   2

  c_p[x_a][46] = {  4,   5}; //   2
  c_f[x_a][46] = {  4}; //   1
  c_t[x_a][46] = {  7,   8}; //   2
  c_d[x_a][46] = {  4,   5}; //   2

  c_p[x_a][47] = {  4,   7}; //   2
  c_f[x_a][47] = {  4}; //   1
  c_t[x_a][47] = {  7,   8}; //   2
  c_d[x_a][47] = {  4,   5}; //   2

  c_p[x_a][48] = { 11,  12}; //   2
  c_f[x_a][48] = {  3}; //   1
  c_t[x_a][48] = {  4,   5}; //   2
  c_d[x_a][48] = {  9,  10}; //   2

  c_p[x_a][49] = { 11,  13}; //   2
  c_f[x_a][49] = {  3}; //   1
  c_t[x_a][49] = {  4,   5}; //   2
  c_d[x_a][49] = {  9,  10}; //   2

  c_p[x_a][50] = { 11,  12}; //   2
  c_f[x_a][50] = {  4}; //   1
  c_t[x_a][50] = {  7,   8}; //   2
  c_d[x_a][50] = {  9,  10}; //   2

  c_p[x_a][51] = { 11,  13}; //   2
  c_f[x_a][51] = {  4}; //   1
  c_t[x_a][51] = {  7,   8}; //   2
  c_d[x_a][51] = {  9,  10}; //   2

  c_p[x_a][52] = {  4,   5,   6}; //   3
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  7}; //   1
  c_d[x_a][52] = {  3,   4,   5}; //   3

  c_p[x_a][53] = {  4,   7,   6}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  7}; //   1
  c_d[x_a][53] = {  3,   4,   5}; //   3

  c_p[x_a][54] = {  4,   5,   8}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  4}; //   1
  c_d[x_a][54] = {  6,   4,   5}; //   3

  c_p[x_a][55] = {  4,   7,   8}; //   3
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  4}; //   1
  c_d[x_a][55] = {  6,   4,   5}; //   3

  c_p[x_a][56] = {  0,   3,  10}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  4}; //   1
  c_d[x_a][56] = {  8,   2,   1}; //   3

  c_p[x_a][57] = {  2,   3,  10}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  4}; //   1
  c_d[x_a][57] = {  8,   2,   1}; //   3

  c_p[x_a][58] = {  0,   1,   9}; //   3
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  7}; //   1
  c_d[x_a][58] = {  7,   0,   1}; //   3

  c_p[x_a][59] = {  2,   1,   9}; //   3
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  7}; //   1
  c_d[x_a][59] = {  7,   0,   1}; //   3

  c_p[x_a][60] = { 11,  12,   6}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  7}; //   1
  c_d[x_a][60] = {  3,   9,  10}; //   3

  c_p[x_a][61] = { 11,  13,   6}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  7}; //   1
  c_d[x_a][61] = {  3,   9,  10}; //   3

  c_p[x_a][62] = { 11,  12,   8}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  4}; //   1
  c_d[x_a][62] = {  6,   9,  10}; //   3

  c_p[x_a][63] = { 11,  13,   8}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  4}; //   1
  c_d[x_a][63] = {  6,   9,  10}; //   3

  c_p[x_a][64] = { 14,  15,  16}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  4}; //   1
  c_d[x_a][64] = { 11,   1,  12}; //   3

  c_p[x_a][65] = { 14,  17,  16}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  4}; //   1
  c_d[x_a][65] = { 11,   1,  12}; //   3

  c_p[x_a][66] = { 18,  19,  20}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  7}; //   1
  c_d[x_a][66] = { 13,   1,  14}; //   3

  c_p[x_a][67] = { 18,  21,  20}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  7}; //   1
  c_d[x_a][67] = { 13,   1,  14}; //   3

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = {  2,   3}; //   2
  c_t[x_a][68] = {  4,   5,  10}; //   3
  c_d[x_a][68] = {  1}; //   1

  c_p[x_a][69] = {  2}; //   1
  c_f[x_a][69] = {  2,   3}; //   2
  c_t[x_a][69] = {  4,   5,  10}; //   3
  c_d[x_a][69] = {  1}; //   1

  c_p[x_a][70] = {  0}; //   1
  c_f[x_a][70] = {  2,   4}; //   2
  c_t[x_a][70] = {  7,   8,  11}; //   3
  c_d[x_a][70] = {  1}; //   1

  c_p[x_a][71] = {  2}; //   1
  c_f[x_a][71] = {  2,   4}; //   2
  c_t[x_a][71] = {  7,   8,  11}; //   3
  c_d[x_a][71] = {  1}; //   1

  c_p[x_a][72] = {  0,   3}; //   2
  c_f[x_a][72] = {  1}; //   1
  c_t[x_a][72] = {  4,  12}; //   2
  c_d[x_a][72] = {  2,   1}; //   2

  c_p[x_a][73] = {  2,   3}; //   2
  c_f[x_a][73] = {  1}; //   1
  c_t[x_a][73] = {  4,  12}; //   2
  c_d[x_a][73] = {  2,   1}; //   2

  c_p[x_a][74] = {  0,   1}; //   2
  c_f[x_a][74] = {  0}; //   1
  c_t[x_a][74] = {  7,  13}; //   2
  c_d[x_a][74] = {  0,   1}; //   2

  c_p[x_a][75] = {  2,   1}; //   2
  c_f[x_a][75] = {  0}; //   1
  c_t[x_a][75] = {  7,  13}; //   2
  c_d[x_a][75] = {  0,   1}; //   2

  c_p[x_a][76] = {  0,  24}; //   2
  c_f[x_a][76] = {  5}; //   1
  c_t[x_a][76] = {  0,  14}; //   2
  c_d[x_a][76] = { 14,   1}; //   2

  c_p[x_a][77] = {  2,  24}; //   2
  c_f[x_a][77] = {  5}; //   1
  c_t[x_a][77] = {  0,  14}; //   2
  c_d[x_a][77] = { 14,   1}; //   2

  c_p[x_a][78] = {  0,  25}; //   2
  c_f[x_a][78] = {  6}; //   1
  c_t[x_a][78] = {  2,  15}; //   2
  c_d[x_a][78] = { 12,   1}; //   2

  c_p[x_a][79] = {  2,  25}; //   2
  c_f[x_a][79] = {  6}; //   1
  c_t[x_a][79] = {  2,  15}; //   2
  c_d[x_a][79] = { 12,   1}; //   2

  c_p[x_a][80] = {  0,   1,  22}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 16}; //   1
  c_d[x_a][80] = { 12,   0,   1}; //   3

  c_p[x_a][81] = {  2,   1,  22}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 16}; //   1
  c_d[x_a][81] = { 12,   0,   1}; //   3

  c_p[x_a][82] = {  0,   3,  23}; //   3
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = { 17}; //   1
  c_d[x_a][82] = { 14,   2,   1}; //   3

  c_p[x_a][83] = {  2,   3,  23}; //   3
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = { 17}; //   1
  c_d[x_a][83] = { 14,   2,   1}; //   3

  c_p[x_a][84] = { 14,  15,  26}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 18}; //   1
  c_d[x_a][84] = {  0,   1,  12}; //   3

  c_p[x_a][85] = { 14,  17,  26}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 18}; //   1
  c_d[x_a][85] = {  0,   1,  12}; //   3

  c_p[x_a][86] = { 18,  19,  27}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 19}; //   1
  c_d[x_a][86] = {  2,   1,  14}; //   3

  c_p[x_a][87] = { 18,  21,  27}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 19}; //   1
  c_d[x_a][87] = {  2,   1,  14}; //   3

  c_p[x_a][88] = { 14,  15}; //   2
  c_f[x_a][88] = {  6}; //   1
  c_t[x_a][88] = {  4,  20}; //   2
  c_d[x_a][88] = {  1,  12}; //   2

  c_p[x_a][89] = { 14,  17}; //   2
  c_f[x_a][89] = {  6}; //   1
  c_t[x_a][89] = {  4,  20}; //   2
  c_d[x_a][89] = {  1,  12}; //   2

  c_p[x_a][90] = { 18,  19}; //   2
  c_f[x_a][90] = {  5}; //   1
  c_t[x_a][90] = {  7,  21}; //   2
  c_d[x_a][90] = {  1,  14}; //   2

  c_p[x_a][91] = { 18,  21}; //   2
  c_f[x_a][91] = {  5}; //   1
  c_t[x_a][91] = {  7,  21}; //   2
  c_d[x_a][91] = {  1,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    1: 3yv11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel    3: 3yv11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
// channel    4: 4yyv1(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel    5: 4yyv1(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel    6: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel    8: 4yyv1(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel    9: 4yyv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   10: 4yyv1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   11: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel   12: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   13: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,  23,   0,   0)
// channel   14: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   15: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,   0)
// channel   16: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   17: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   18: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel   19: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
// channel   20: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   21: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   22: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   23: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
// channel   24: 5yyyv(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   25: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   26: 5yyyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   27: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   28: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   29: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   30: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   31: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
// channel   32: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   33: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   34: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   35: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   36: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   37: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   38: 52vyv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   39: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   40: 12v11(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   41: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   42: 12v11(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   43: 12v11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
// channel   44: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   45: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   46: 13yv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   47: 13yv1(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   48: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   49: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  23,   0,   0)
// channel   50: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   51: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,   0)
// channel   52: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   53: 14yyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   54: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   55: 14yyv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
// channel   56: 14yyv(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   57: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   58: 14yyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   59: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   60: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   61: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   62: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   63: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
// channel   64: 142vv(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   65: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   66: 142vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   67: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   68: 112v1(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   69: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
// channel   70: 112v1(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel   71: 112v1(1, 2, 32, 16, 4, 8, 64;  23,   0,   0,   0)
// channel   72: 113yv(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   73: 113yv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   74: 113yv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   75: 113yv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   76: 2v2v1(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   77: 2v2v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   78: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   79: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel   80: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   81: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   82: 2v3yv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   83: 2v3yv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   84: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   85: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   86: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   87: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   88: 12v2v(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   89: 12v2v(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   90: 12v2v(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   91: 12v2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
