#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_uux_emepagg(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_uux_emepagg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91}; //  60
  needed_v_smin[x_a][  1] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77,   84,   85}; //  16
  needed_v_smin[x_a][  2] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77,   84,   85}; //  16
  needed_v_smin[x_a][  3] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79,   86,   87}; //  16
  needed_v_smin[x_a][  4] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79,   86,   87}; //  16
  needed_v_smin[x_a][  5] = {  72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,    8,    9,   10,   11,   60,   61,   62,   63}; //  28
  needed_v_smin[x_a][  6] = {   0,    1,    6,    7,   64,   65,   70,   71}; //   8
  needed_v_smin[x_a][  7] = {   0,    1,    6,    7,   64,   65,   70,   71}; //   8
  needed_v_smin[x_a][  8] = {   2,    3,    4,    5,   66,   67,   68,   69}; //   8
  needed_v_smin[x_a][  9] = {   2,    3,    4,    5,   66,   67,   68,   69}; //   8
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11,   60,   61,   62,   63,   72,   73,   74,   75,   88,   89,   90,   91}; //  16
  needed_v_smin[x_a][ 11] = {  12,   13,   16,   17,   20,   21,   32,   33,   36,   37,   46,   47,   54,   55,   58,   59}; //  16
  needed_v_smin[x_a][ 12] = {  14,   15,   18,   19,   24,   25,   34,   35,   38,   39,   50,   51,   52,   53,   56,   57}; //  16
  needed_v_smin[x_a][ 13] = {  20,   21,   24,   25,   46,   47,   50,   51,   82,   83}; //  10
  needed_v_smin[x_a][ 14] = {  22,   23,   28,   29,   42,   43,   48,   49}; //   8
  needed_v_smin[x_a][ 15] = {  22,   23,   42,   43}; //   4
  needed_v_smin[x_a][ 16] = {  26,   27,   30,   31,   40,   41,   44,   45}; //   8
  needed_v_smin[x_a][ 17] = {  26,   27,   40,   41}; //   4
  needed_v_smin[x_a][ 18] = {  28,   29,   48,   49}; //   4
  needed_v_smin[x_a][ 19] = {  30,   31,   44,   45}; //   4
  needed_v_smin[x_a][ 20] = {  80,   81}; //   2

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   74,   75,   82,   83,   90,   91}; //  54
  needed_v_smax[x_a][  1] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77}; //  14
  needed_v_smax[x_a][  2] = {  12,   13,   14,   15,   16,   17,   18,   19,   32,   33,   34,   35,   36,   37,   38,   39,   52,   53,   54,   55,   56,   57,   58,   59,   76,   77,   78,   79,   20,   21,   24,   25,   46,   47,   50,   51}; //  36
  needed_v_smax[x_a][  3] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79}; //  14
  needed_v_smax[x_a][  4] = {  72,   73,   80,   81,   84,   85,   86,   87,   88,   89}; //  10
  needed_v_smax[x_a][  5] = {  72,   73,   80,   81,   88,   89}; //   6
  needed_v_smax[x_a][  6] = {  74,   75,   82,   83,   90,   91,    8,    9,   10,   11,   60,   61,   62,   63}; //  14
  needed_v_smax[x_a][  7] = {  76,   77,   78,   79}; //   4
  needed_v_smax[x_a][  8] = {  84,   85}; //   2
  needed_v_smax[x_a][  9] = {  84,   85,   86,   87,   82,   83}; //   6
  needed_v_smax[x_a][ 10] = {  86,   87}; //   2
  needed_v_smax[x_a][ 11] = {   0,    1,    6,    7,   64,   65,   70,   71}; //   8
  needed_v_smax[x_a][ 12] = {   0,    1,    6,    7,   12,   13,   16,   17,   20,   21,   22,   23,   32,   33,   36,   37,   42,   43,   46,   47,   54,   55,   58,   59,   64,   65,   70,   71}; //  28
  needed_v_smax[x_a][ 13] = {   2,    3,    4,    5,   66,   67,   68,   69}; //   8
  needed_v_smax[x_a][ 14] = {   2,    3,    4,    5,   14,   15,   18,   19,   24,   25,   26,   27,   34,   35,   38,   39,   40,   41,   50,   51,   52,   53,   56,   57,   66,   67,   68,   69}; //  28
  needed_v_smax[x_a][ 15] = {   8,    9,   10,   11,   28,   29,   30,   31,   44,   45,   48,   49,   60,   61,   62,   63,   72,   73,   74,   75,   88,   89,   90,   91}; //  24
  needed_v_smax[x_a][ 16] = {  22,   23,   28,   29,   42,   43,   48,   49}; //   8
  needed_v_smax[x_a][ 17] = {  26,   27,   30,   31,   40,   41,   44,   45}; //   8
  needed_v_smax[x_a][ 18] = {  80,   81}; //   2

  g_p[x_a].resize(19);
  needed_g_p[x_a].resize(19);
  needed_g_p[x_a][0] = {   0,    2,    4,    6,    8,   10,   20,   22,   24,   26,   28,   30,   40,   42,   44,   46,   48,   50,   60,   62,   64,   66,   68,   70,   74,   82,   90}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,    5,    7,    9,   11,   21,   23,   25,   27,   29,   31,   41,   43,   45,   47,   49,   51,   61,   63,   65,   67,   69,   71,   75,   83,   91}; //  27
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  12,   14,   32,   34,   52,   54,   76}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  13,   15,   33,   35,   53,   55,   77}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {  16,   18,   36,   38,   56,   58,   78}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][7] = {  17,   19,   37,   39,   57,   59,   79}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][8] = {  72,   73,   80,   81,   84,   85,   86,   87,   88,   89}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][9] = {  72,   80,   88}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax5");
  needed_g_p[x_a][10] = {  73,   81,   89}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax5");
  needed_g_p[x_a][11] = {  74,   75,   82,   83,   90,   91}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax6");
  needed_g_p[x_a][12] = {  76,   77,   78,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax7");
  needed_g_p[x_a][13] = {  84,   85}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax8");
  needed_g_p[x_a][14] = {  84}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax9");
  needed_g_p[x_a][15] = {  85}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax9");
  needed_g_p[x_a][16] = {  86,   87}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][17] = {  86}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax9");
  needed_g_p[x_a][18] = {  87}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax9");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    1,    6,    7,   64,   65,   70,   71}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax11");
  needed_g_f[x_a][1] = {   0,    1,    6,    7,   64,   65,   70,   71}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax12");
  needed_g_f[x_a][2] = {   2,    3,    4,    5,   66,   67,   68,   69}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax13");
  needed_g_f[x_a][3] = {   2,    3,    4,    5,   66,   67,   68,   69}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax14");
  needed_g_f[x_a][4] = {   8,    9,   10,   11,   60,   61,   62,   63}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax6");
  needed_g_f[x_a][5] = {   8,    9,   10,   11,   60,   61,   62,   63,   72,   73,   74,   75,   88,   89,   90,   91}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax15");
  needed_g_f[x_a][6] = {  12,   13,   16,   17,   20,   21,   32,   33,   36,   37,   46,   47,   54,   55,   58,   59}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax12");
  needed_g_f[x_a][7] = {  14,   15,   18,   19,   24,   25,   34,   35,   38,   39,   50,   51,   52,   53,   56,   57}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][8] = {  20,   21,   24,   25,   46,   47,   50,   51}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][9] = {  22,   23,   28,   29,   42,   43,   48,   49}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax16");
  needed_g_f[x_a][10] = {  22,   23,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax12");
  needed_g_f[x_a][11] = {  26,   27,   30,   31,   40,   41,   44,   45}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax17");
  needed_g_f[x_a][12] = {  26,   27,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax14");
  needed_g_f[x_a][13] = {  28,   29,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax15");
  needed_g_f[x_a][14] = {  30,   31,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax15");
  needed_g_f[x_a][15] = {  80,   81}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax18");
  needed_g_f[x_a][16] = {  82,   83}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");

  g_t[x_a].resize(53);
  needed_g_t[x_a].resize(53);
  needed_g_t[x_a][0] = {   0,    1,    6,    7,   12,   13,   16,   17}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,    1,    6,    7}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   2,    3,    4,    5,   14,   15,   18,   19}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][4] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_80");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][6] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__16_64");
  needed_g_t[x_a][7] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__16_32");
  needed_g_t[x_a][8] = {   8,    9,   10,   11,   72,   73,   74,   75}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][9] = {   8,    9,   10,   11,   72,   73}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][10] = {   8,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][11] = {  10,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][12] = {  12,   13,   16,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][13] = {  14,   15,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__64_28");
  needed_g_t[x_a][14] = {  20,   21,   22,   23,   32,   33,   36,   37,   42,   43,   46,   47,   54,   55,   58,   59,   64,   65,   70,   71}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][15] = {  20,   21,   32,   33,   36,   37,   46,   47}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][16] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][17] = {  22,   23,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][18] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][19] = {  24,   25,   26,   27,   34,   35,   38,   39,   40,   41,   50,   51,   52,   53,   56,   57,   66,   67,   68,   69}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][20] = {  24,   25,   34,   35,   38,   39,   50,   51}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][21] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][22] = {  26,   27,   40,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][23] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__64_12");
  needed_g_t[x_a][24] = {  28,   29,   30,   31,   44,   45,   48,   49,   60,   61,   62,   63,   88,   89,   90,   91}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][25] = {  28,   29,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][26] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][27] = {  30,   31,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][28] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_17__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_17__64_12");
  needed_g_t[x_a][29] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][30] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][31] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__64_12");
  needed_g_t[x_a][32] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][33] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__32_12");
  needed_g_t[x_a][34] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][35] = {  52,   53,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][36] = {  54,   55,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][37] = {  60,   61,   62,   63,   90,   91}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][38] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][39] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][40] = {  64,   65,   70,   71}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][41] = {  64,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][42] = {  66,   67,   68,   69}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][43] = {  66,   67}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__16_64");
  needed_g_t[x_a][44] = {  68,   69}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][45] = {  70,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][46] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][47] = {  76,   77,   78,   79,   82,   83}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][48] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][49] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][50] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][51] = {  84,   85,   86,   87}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][52] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77,   84,   85}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {  12,   13,   14,   15,   32,   33,   34,   35,   52,   53,   54,   55,   76,   77,   84,   85}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79,   86,   87}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {  16,   17,   18,   19,   36,   37,   38,   39,   56,   57,   58,   59,   78,   79,   86,   87}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {  72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");

  c_p[x_a].resize(92);
  c_f[x_a].resize(92);
  c_t[x_a].resize(92);
  c_d[x_a].resize(92);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   2}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  3,   4,   5}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  3,   4,   5}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  2,   3}; //   2
  c_t[x_a][4] = {  3,   4,   6}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  2,   3}; //   2
  c_t[x_a][5] = {  3,   4,   6}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  0,   1}; //   2
  c_t[x_a][6] = {  0,   1,   7}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  0,   1}; //   2
  c_t[x_a][7] = {  0,   1,   7}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  4,   5}; //   2
  c_t[x_a][8] = {  8,   9,  10}; //   3
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  1}; //   1
  c_f[x_a][9] = {  4,   5}; //   2
  c_t[x_a][9] = {  8,   9,  10}; //   3
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  4,   5}; //   2
  c_t[x_a][10] = {  8,   9,  11}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {  4,   5}; //   2
  c_t[x_a][11] = {  8,   9,  11}; //   3
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {  6}; //   1
  c_t[x_a][12] = {  0,  12}; //   2
  c_d[x_a][12] = {  1,   2}; //   2

  c_p[x_a][13] = {  2,   4}; //   2
  c_f[x_a][13] = {  6}; //   1
  c_t[x_a][13] = {  0,  12}; //   2
  c_d[x_a][13] = {  1,   2}; //   2

  c_p[x_a][14] = {  2,   3}; //   2
  c_f[x_a][14] = {  7}; //   1
  c_t[x_a][14] = {  3,  13}; //   2
  c_d[x_a][14] = {  1,   2}; //   2

  c_p[x_a][15] = {  2,   4}; //   2
  c_f[x_a][15] = {  7}; //   1
  c_t[x_a][15] = {  3,  13}; //   2
  c_d[x_a][15] = {  1,   2}; //   2

  c_p[x_a][16] = {  5,   6}; //   2
  c_f[x_a][16] = {  6}; //   1
  c_t[x_a][16] = {  0,  12}; //   2
  c_d[x_a][16] = {  3,   4}; //   2

  c_p[x_a][17] = {  5,   7}; //   2
  c_f[x_a][17] = {  6}; //   1
  c_t[x_a][17] = {  0,  12}; //   2
  c_d[x_a][17] = {  3,   4}; //   2

  c_p[x_a][18] = {  5,   6}; //   2
  c_f[x_a][18] = {  7}; //   1
  c_t[x_a][18] = {  3,  13}; //   2
  c_d[x_a][18] = {  3,   4}; //   2

  c_p[x_a][19] = {  5,   7}; //   2
  c_f[x_a][19] = {  7}; //   1
  c_t[x_a][19] = {  3,  13}; //   2
  c_d[x_a][19] = {  3,   4}; //   2

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  8,   6}; //   2
  c_t[x_a][20] = { 14,  15,  16}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  1}; //   1
  c_f[x_a][21] = {  8,   6}; //   2
  c_t[x_a][21] = { 14,  15,  16}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  9,  10}; //   2
  c_t[x_a][22] = { 14,  17,  18}; //   3
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = {  9,  10}; //   2
  c_t[x_a][23] = { 14,  17,  18}; //   3
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  8,   7}; //   2
  c_t[x_a][24] = { 19,  20,  21}; //   3
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = {  8,   7}; //   2
  c_t[x_a][25] = { 19,  20,  21}; //   3
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = { 11,  12}; //   2
  c_t[x_a][26] = { 19,  22,  23}; //   3
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = { 11,  12}; //   2
  c_t[x_a][27] = { 19,  22,  23}; //   3
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = {  9,  13}; //   2
  c_t[x_a][28] = { 24,  25,  26}; //   3
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  1}; //   1
  c_f[x_a][29] = {  9,  13}; //   2
  c_t[x_a][29] = { 24,  25,  26}; //   3
  c_d[x_a][29] = {  0}; //   1

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 11,  14}; //   2
  c_t[x_a][30] = { 24,  27,  28}; //   3
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  1}; //   1
  c_f[x_a][31] = { 11,  14}; //   2
  c_t[x_a][31] = { 24,  27,  28}; //   3
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  2,   3}; //   2
  c_f[x_a][32] = {  6}; //   1
  c_t[x_a][32] = { 14,  15}; //   2
  c_d[x_a][32] = {  1,   2}; //   2

  c_p[x_a][33] = {  2,   4}; //   2
  c_f[x_a][33] = {  6}; //   1
  c_t[x_a][33] = { 14,  15}; //   2
  c_d[x_a][33] = {  1,   2}; //   2

  c_p[x_a][34] = {  2,   3}; //   2
  c_f[x_a][34] = {  7}; //   1
  c_t[x_a][34] = { 19,  20}; //   2
  c_d[x_a][34] = {  1,   2}; //   2

  c_p[x_a][35] = {  2,   4}; //   2
  c_f[x_a][35] = {  7}; //   1
  c_t[x_a][35] = { 19,  20}; //   2
  c_d[x_a][35] = {  1,   2}; //   2

  c_p[x_a][36] = {  5,   6}; //   2
  c_f[x_a][36] = {  6}; //   1
  c_t[x_a][36] = { 14,  15}; //   2
  c_d[x_a][36] = {  3,   4}; //   2

  c_p[x_a][37] = {  5,   7}; //   2
  c_f[x_a][37] = {  6}; //   1
  c_t[x_a][37] = { 14,  15}; //   2
  c_d[x_a][37] = {  3,   4}; //   2

  c_p[x_a][38] = {  5,   6}; //   2
  c_f[x_a][38] = {  7}; //   1
  c_t[x_a][38] = { 19,  20}; //   2
  c_d[x_a][38] = {  3,   4}; //   2

  c_p[x_a][39] = {  5,   7}; //   2
  c_f[x_a][39] = {  7}; //   1
  c_t[x_a][39] = { 19,  20}; //   2
  c_d[x_a][39] = {  3,   4}; //   2

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = { 11,  12}; //   2
  c_t[x_a][40] = { 19,  22,  29}; //   3
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  1}; //   1
  c_f[x_a][41] = { 11,  12}; //   2
  c_t[x_a][41] = { 19,  22,  29}; //   3
  c_d[x_a][41] = {  0}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {  9,  10}; //   2
  c_t[x_a][42] = { 14,  17,  30}; //   3
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  1}; //   1
  c_f[x_a][43] = {  9,  10}; //   2
  c_t[x_a][43] = { 14,  17,  30}; //   3
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = {  0}; //   1
  c_f[x_a][44] = { 11,  14}; //   2
  c_t[x_a][44] = { 24,  27,  31}; //   3
  c_d[x_a][44] = {  0}; //   1

  c_p[x_a][45] = {  1}; //   1
  c_f[x_a][45] = { 11,  14}; //   2
  c_t[x_a][45] = { 24,  27,  31}; //   3
  c_d[x_a][45] = {  0}; //   1

  c_p[x_a][46] = {  0}; //   1
  c_f[x_a][46] = {  8,   6}; //   2
  c_t[x_a][46] = { 14,  15,  32}; //   3
  c_d[x_a][46] = {  0}; //   1

  c_p[x_a][47] = {  1}; //   1
  c_f[x_a][47] = {  8,   6}; //   2
  c_t[x_a][47] = { 14,  15,  32}; //   3
  c_d[x_a][47] = {  0}; //   1

  c_p[x_a][48] = {  0}; //   1
  c_f[x_a][48] = {  9,  13}; //   2
  c_t[x_a][48] = { 24,  25,  33}; //   3
  c_d[x_a][48] = {  0}; //   1

  c_p[x_a][49] = {  1}; //   1
  c_f[x_a][49] = {  9,  13}; //   2
  c_t[x_a][49] = { 24,  25,  33}; //   3
  c_d[x_a][49] = {  0}; //   1

  c_p[x_a][50] = {  0}; //   1
  c_f[x_a][50] = {  8,   7}; //   2
  c_t[x_a][50] = { 19,  20,  34}; //   3
  c_d[x_a][50] = {  0}; //   1

  c_p[x_a][51] = {  1}; //   1
  c_f[x_a][51] = {  8,   7}; //   2
  c_t[x_a][51] = { 19,  20,  34}; //   3
  c_d[x_a][51] = {  0}; //   1

  c_p[x_a][52] = {  2,   3}; //   2
  c_f[x_a][52] = {  7}; //   1
  c_t[x_a][52] = { 19,  35}; //   2
  c_d[x_a][52] = {  1,   2}; //   2

  c_p[x_a][53] = {  2,   4}; //   2
  c_f[x_a][53] = {  7}; //   1
  c_t[x_a][53] = { 19,  35}; //   2
  c_d[x_a][53] = {  1,   2}; //   2

  c_p[x_a][54] = {  2,   3}; //   2
  c_f[x_a][54] = {  6}; //   1
  c_t[x_a][54] = { 14,  36}; //   2
  c_d[x_a][54] = {  1,   2}; //   2

  c_p[x_a][55] = {  2,   4}; //   2
  c_f[x_a][55] = {  6}; //   1
  c_t[x_a][55] = { 14,  36}; //   2
  c_d[x_a][55] = {  1,   2}; //   2

  c_p[x_a][56] = {  5,   6}; //   2
  c_f[x_a][56] = {  7}; //   1
  c_t[x_a][56] = { 19,  35}; //   2
  c_d[x_a][56] = {  3,   4}; //   2

  c_p[x_a][57] = {  5,   7}; //   2
  c_f[x_a][57] = {  7}; //   1
  c_t[x_a][57] = { 19,  35}; //   2
  c_d[x_a][57] = {  3,   4}; //   2

  c_p[x_a][58] = {  5,   6}; //   2
  c_f[x_a][58] = {  6}; //   1
  c_t[x_a][58] = { 14,  36}; //   2
  c_d[x_a][58] = {  3,   4}; //   2

  c_p[x_a][59] = {  5,   7}; //   2
  c_f[x_a][59] = {  6}; //   1
  c_t[x_a][59] = { 14,  36}; //   2
  c_d[x_a][59] = {  3,   4}; //   2

  c_p[x_a][60] = {  0}; //   1
  c_f[x_a][60] = {  4,   5}; //   2
  c_t[x_a][60] = { 24,  37,  38}; //   3
  c_d[x_a][60] = {  0}; //   1

  c_p[x_a][61] = {  1}; //   1
  c_f[x_a][61] = {  4,   5}; //   2
  c_t[x_a][61] = { 24,  37,  38}; //   3
  c_d[x_a][61] = {  0}; //   1

  c_p[x_a][62] = {  0}; //   1
  c_f[x_a][62] = {  4,   5}; //   2
  c_t[x_a][62] = { 24,  37,  39}; //   3
  c_d[x_a][62] = {  0}; //   1

  c_p[x_a][63] = {  1}; //   1
  c_f[x_a][63] = {  4,   5}; //   2
  c_t[x_a][63] = { 24,  37,  39}; //   3
  c_d[x_a][63] = {  0}; //   1

  c_p[x_a][64] = {  0}; //   1
  c_f[x_a][64] = {  0,   1}; //   2
  c_t[x_a][64] = { 14,  40,  41}; //   3
  c_d[x_a][64] = {  0}; //   1

  c_p[x_a][65] = {  1}; //   1
  c_f[x_a][65] = {  0,   1}; //   2
  c_t[x_a][65] = { 14,  40,  41}; //   3
  c_d[x_a][65] = {  0}; //   1

  c_p[x_a][66] = {  0}; //   1
  c_f[x_a][66] = {  2,   3}; //   2
  c_t[x_a][66] = { 19,  42,  43}; //   3
  c_d[x_a][66] = {  0}; //   1

  c_p[x_a][67] = {  1}; //   1
  c_f[x_a][67] = {  2,   3}; //   2
  c_t[x_a][67] = { 19,  42,  43}; //   3
  c_d[x_a][67] = {  0}; //   1

  c_p[x_a][68] = {  0}; //   1
  c_f[x_a][68] = {  2,   3}; //   2
  c_t[x_a][68] = { 19,  42,  44}; //   3
  c_d[x_a][68] = {  0}; //   1

  c_p[x_a][69] = {  1}; //   1
  c_f[x_a][69] = {  2,   3}; //   2
  c_t[x_a][69] = { 19,  42,  44}; //   3
  c_d[x_a][69] = {  0}; //   1

  c_p[x_a][70] = {  0}; //   1
  c_f[x_a][70] = {  0,   1}; //   2
  c_t[x_a][70] = { 14,  40,  45}; //   3
  c_d[x_a][70] = {  0}; //   1

  c_p[x_a][71] = {  1}; //   1
  c_f[x_a][71] = {  0,   1}; //   2
  c_t[x_a][71] = { 14,  40,  45}; //   3
  c_d[x_a][71] = {  0}; //   1

  c_p[x_a][72] = {  8,   9}; //   2
  c_f[x_a][72] = {  5}; //   1
  c_t[x_a][72] = {  8,   9}; //   2
  c_d[x_a][72] = {  0,   5}; //   2

  c_p[x_a][73] = {  8,  10}; //   2
  c_f[x_a][73] = {  5}; //   1
  c_t[x_a][73] = {  8,   9}; //   2
  c_d[x_a][73] = {  0,   5}; //   2

  c_p[x_a][74] = {  0,  11}; //   2
  c_f[x_a][74] = {  5}; //   1
  c_t[x_a][74] = {  8,  46}; //   2
  c_d[x_a][74] = {  5,   0}; //   2

  c_p[x_a][75] = {  1,  11}; //   2
  c_f[x_a][75] = {  5}; //   1
  c_t[x_a][75] = {  8,  46}; //   2
  c_d[x_a][75] = {  5,   0}; //   2

  c_p[x_a][76] = {  2,   3,  12}; //   3
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = { 47}; //   1
  c_d[x_a][76] = {  5,   1,   2}; //   3

  c_p[x_a][77] = {  2,   4,  12}; //   3
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = { 47}; //   1
  c_d[x_a][77] = {  5,   1,   2}; //   3

  c_p[x_a][78] = {  5,   6,  12}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 47}; //   1
  c_d[x_a][78] = {  5,   3,   4}; //   3

  c_p[x_a][79] = {  5,   7,  12}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 47}; //   1
  c_d[x_a][79] = {  5,   3,   4}; //   3

  c_p[x_a][80] = {  8,   9}; //   2
  c_f[x_a][80] = { 15}; //   1
  c_t[x_a][80] = { 48,  49}; //   2
  c_d[x_a][80] = {  0,   5}; //   2

  c_p[x_a][81] = {  8,  10}; //   2
  c_f[x_a][81] = { 15}; //   1
  c_t[x_a][81] = { 48,  49}; //   2
  c_d[x_a][81] = {  0,   5}; //   2

  c_p[x_a][82] = {  0,  11}; //   2
  c_f[x_a][82] = { 16}; //   1
  c_t[x_a][82] = { 47,  50}; //   2
  c_d[x_a][82] = {  5,   0}; //   2

  c_p[x_a][83] = {  1,  11}; //   2
  c_f[x_a][83] = { 16}; //   1
  c_t[x_a][83] = { 47,  50}; //   2
  c_d[x_a][83] = {  5,   0}; //   2

  c_p[x_a][84] = {  8,  13,  14}; //   3
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = { 51}; //   1
  c_d[x_a][84] = {  1,   2,   5}; //   3

  c_p[x_a][85] = {  8,  13,  15}; //   3
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = { 51}; //   1
  c_d[x_a][85] = {  1,   2,   5}; //   3

  c_p[x_a][86] = {  8,  16,  17}; //   3
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = { 51}; //   1
  c_d[x_a][86] = {  3,   4,   5}; //   3

  c_p[x_a][87] = {  8,  16,  18}; //   3
  c_f[x_a][87] = {}; //   0
  c_t[x_a][87] = { 51}; //   1
  c_d[x_a][87] = {  3,   4,   5}; //   3

  c_p[x_a][88] = {  8,   9}; //   2
  c_f[x_a][88] = {  5}; //   1
  c_t[x_a][88] = { 24,  52}; //   2
  c_d[x_a][88] = {  0,   5}; //   2

  c_p[x_a][89] = {  8,  10}; //   2
  c_f[x_a][89] = {  5}; //   1
  c_t[x_a][89] = { 24,  52}; //   2
  c_d[x_a][89] = {  0,   5}; //   2

  c_p[x_a][90] = {  0,  11}; //   2
  c_f[x_a][90] = {  5}; //   1
  c_t[x_a][90] = { 24,  37}; //   2
  c_d[x_a][90] = {  5,   0}; //   2

  c_p[x_a][91] = {  1,  11}; //   2
  c_f[x_a][91] = {  5}; //   1
  c_t[x_a][91] = { 24,  37}; //   2
  c_d[x_a][91] = {  5,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    2: 2v111(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel    3: 2v111(1, 2, 4, 8, 16, 64, 32;  23,   0,   0,   0)
// channel    4: 2v111(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
// channel    5: 2v111(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel    6: 2v111(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel    7: 2v111(1, 2, 4, 8, 32, 16, 64;  23,   0,   0,   0)
// channel    8: 2v111(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel    9: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
// channel   10: 2v111(1, 2, 4, 8, 64, 32, 16;   0,   0,   0,   0)
// channel   11: 2v111(1, 2, 4, 8, 64, 32, 16;  23,   0,   0,   0)
// channel   12: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   13: 3yv11(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   14: 3yv11(1, 2, 4, 8, 16, 64, 32;   0,   0,   0,   0)
// channel   15: 3yv11(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
// channel   16: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   17: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  23,   0,   0)
// channel   18: 3yv11(1, 2, 8, 4, 16, 64, 32;   0,   0,   0,   0)
// channel   19: 3yv11(1, 2, 8, 4, 16, 64, 32;   0,  23,   0,   0)
// channel   20: 12v11(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   21: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
// channel   22: 12v11(1, 2, 64, 4, 8, 32, 16;   0,   0,   0,   0)
// channel   23: 12v11(1, 2, 64, 4, 8, 32, 16;  23,   0,   0,   0)
// channel   24: 12v11(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   25: 12v11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
// channel   26: 12v11(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel   27: 12v11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
// channel   28: 12v11(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   29: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
// channel   30: 12v11(1, 2, 16, 4, 8, 64, 32;   0,   0,   0,   0)
// channel   31: 12v11(1, 2, 16, 4, 8, 64, 32;  23,   0,   0,   0)
// channel   32: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
// channel   33: 13yv1(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
// channel   34: 13yv1(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   35: 13yv1(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   36: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,   0,   0,   0)
// channel   37: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  23,   0,   0)
// channel   38: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   39: 13yv1(1, 2, 32, 8, 4, 16, 64;   0,  23,   0,   0)
// channel   40: 112v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   41: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   42: 112v1(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   43: 112v1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
// channel   44: 112v1(1, 2, 16, 64, 4, 8, 32;   0,   0,   0,   0)
// channel   45: 112v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
// channel   46: 112v1(1, 2, 64, 16, 4, 8, 32;   0,   0,   0,   0)
// channel   47: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
// channel   48: 112v1(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   49: 112v1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel   50: 112v1(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel   51: 112v1(1, 2, 32, 16, 4, 8, 64;  23,   0,   0,   0)
// channel   52: 113yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   53: 113yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   54: 113yv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
// channel   55: 113yv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
// channel   56: 113yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   57: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   58: 113yv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
// channel   59: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
// channel   60: 1112v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   61: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   62: 1112v(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
// channel   63: 1112v(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
// channel   64: 1112v(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
// channel   65: 1112v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
// channel   66: 1112v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   67: 1112v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel   68: 1112v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   69: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   70: 1112v(1, 2, 64, 32, 16, 4, 8;   0,   0,   0,   0)
// channel   71: 1112v(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,   0)
// channel   72: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   73: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
// channel   74: 2v2v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   75: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   76: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel   77: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
// channel   78: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   79: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
// channel   80: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   81: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   82: 2v12v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   83: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   84: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   85: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,  23,   0)
// channel   86: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   87: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  23,   0)
// channel   88: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   89: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
// channel   90: 12v2v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   91: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
