#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_040_aa_emepaa(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_040_aa_emepaa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   4,    8,   14,   18,   21,   22}; //   6
  needed_v_smin[x_a][  1] = {   5,    9,   15,   19,   20,   23}; //   6
  needed_v_smin[x_a][  2] = {   6,   10,   12,   16,   20,   23}; //   6
  needed_v_smin[x_a][  3] = {   7,   11,   13,   17,   21,   22}; //   6
  needed_v_smin[x_a][  4] = {   8,   14,    4,   18}; //   4
  needed_v_smin[x_a][  5] = {   9,   15,    5,   19}; //   4
  needed_v_smin[x_a][  6] = {  10,   12,    6,   16}; //   4
  needed_v_smin[x_a][  7] = {  11,   13,    7,   17}; //   4
  needed_v_smin[x_a][  8] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  9] = {   0,    1}; //   2
  needed_v_smin[x_a][ 10] = {   2,    3}; //   2

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   4,    8,   14,   18,   22}; //   5
  needed_v_smax[x_a][  1] = {   5,    9,   15,   19,   23}; //   5
  needed_v_smax[x_a][  2] = {   6,   10,   12,   16,   20}; //   5
  needed_v_smax[x_a][  3] = {   7,   11,   13,   17,   21}; //   5
  needed_v_smax[x_a][  4] = {   8,    9,   14,   15,    2,    3,    4,    5,   18,   19}; //  10
  needed_v_smax[x_a][  5] = {  10,   11,   12,   13,    0,    1,    6,    7,   16,   17}; //  10
  needed_v_smax[x_a][  6] = {  20}; //   1
  needed_v_smax[x_a][  7] = {  21}; //   1
  needed_v_smax[x_a][  8] = {  22}; //   1
  needed_v_smax[x_a][  9] = {  23}; //   1
  needed_v_smax[x_a][ 10] = {   0,    1,    2,    3}; //   4

  g_p[x_a].resize(12);
  needed_g_p[x_a].resize(12);
  needed_g_p[x_a][0] = {   4,    8,   14,   18,   22}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,    9,   15,   19,   23}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   6,   10,   12,   16,   20}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   7,   11,   13,   17,   21}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   9,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  10,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  11,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax6");
  needed_g_p[x_a][9] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][10] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax8");
  needed_g_p[x_a][11] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax9");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax10");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][2] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax4");
  needed_g_f[x_a][3] = {   4,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][4] = {   5,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][5] = {   6,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax5");
  needed_g_f[x_a][6] = {   7,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    1,   12,   13,   16,   17}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][4] = {   2,    3,   14,   15,   18,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][8] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][11] = {   6,    7,   10,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_32");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_16");
  needed_g_t[x_a][14] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__24_32");
  needed_g_t[x_a][15] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__20_32");
  needed_g_t[x_a][17] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__36_16");
  needed_g_t[x_a][18] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][19] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");
  needed_g_t[x_a][20] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");
  needed_g_t[x_a][21] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(8);
  needed_g_d[x_a].resize(8);
  needed_g_d[x_a][0] = {   4,    8,   14,   18,   21,   22}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   5,    9,   15,   19,   20,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][2] = {   6,   10,   12,   16,   20,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   7,   11,   13,   17,   21,   22}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   8,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   9,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  10,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][7] = {  11,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0,   2}; //   2
  c_t[x_a][2] = {  4,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   2}; //   2
  c_t[x_a][3] = {  4,   5,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  3}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  4}; //   1
  c_t[x_a][5] = {  8,  10}; //   2
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {  5}; //   1
  c_t[x_a][6] = { 11,  12}; //   2
  c_d[x_a][6] = {  2}; //   1

  c_p[x_a][7] = {  3}; //   1
  c_f[x_a][7] = {  6}; //   1
  c_t[x_a][7] = { 11,  13}; //   2
  c_d[x_a][7] = {  3}; //   1

  c_p[x_a][8] = {  0,   4}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  8}; //   1
  c_d[x_a][8] = {  4,   0}; //   2

  c_p[x_a][9] = {  1,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  8}; //   1
  c_d[x_a][9] = {  5,   1}; //   2

  c_p[x_a][10] = {  2,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 11}; //   1
  c_d[x_a][10] = {  6,   2}; //   2

  c_p[x_a][11] = {  3,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 11}; //   1
  c_d[x_a][11] = {  7,   3}; //   2

  c_p[x_a][12] = {  2,   6}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  6,   2}; //   2

  c_p[x_a][13] = {  3,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  7,   3}; //   2

  c_p[x_a][14] = {  0,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  4}; //   1
  c_d[x_a][14] = {  4,   0}; //   2

  c_p[x_a][15] = {  1,   5}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  4}; //   1
  c_d[x_a][15] = {  5,   1}; //   2

  c_p[x_a][16] = {  2}; //   1
  c_f[x_a][16] = {  5}; //   1
  c_t[x_a][16] = {  0,  14}; //   2
  c_d[x_a][16] = {  2}; //   1

  c_p[x_a][17] = {  3}; //   1
  c_f[x_a][17] = {  6}; //   1
  c_t[x_a][17] = {  0,  15}; //   2
  c_d[x_a][17] = {  3}; //   1

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  3}; //   1
  c_t[x_a][18] = {  4,  16}; //   2
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  1}; //   1
  c_f[x_a][19] = {  4}; //   1
  c_t[x_a][19] = {  4,  17}; //   2
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  2,   8}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 18}; //   1
  c_d[x_a][20] = {  1,   2}; //   2

  c_p[x_a][21] = {  3,   9}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 19}; //   1
  c_d[x_a][21] = {  0,   3}; //   2

  c_p[x_a][22] = {  0,  10}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 20}; //   1
  c_d[x_a][22] = {  3,   0}; //   2

  c_p[x_a][23] = {  1,  11}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 21}; //   1
  c_d[x_a][23] = {  2,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    3: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel    4: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    5: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    6: 2v11(1, 2, 8, 16, 32, 4;   0,   0,   0)
// channel    7: 2v11(1, 2, 8, 32, 16, 4;   0,   0,   0)
// channel    8: 3yv1(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel    9: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   10: 3yv1(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel   11: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   12: 13yv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   13: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   14: 13yv(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   15: 13yv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   16: 112v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   17: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   18: 112v(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   19: 112v(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   20: 2v2v(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel   21: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel   22: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
// channel   23: 2v2v(1, 2, 8, 16, 4, 32;   0,   0,   0)
