#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_140_gu_emepepved(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_140_gu_emepepved");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,   10,   11,   14,   15,   18,   19,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47}; //  18
  needed_v_smin[x_a][  1] = {   0,   20}; //   2
  needed_v_smin[x_a][  2] = {   0,    1,   20,   21}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,    3,    8,    9,   12,   13,   16,   17,   21,   22,   23,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45}; //  22
  needed_v_smin[x_a][  4] = {   1,   21}; //   2
  needed_v_smin[x_a][  5] = {   2,    3,   22,   23}; //   4
  needed_v_smin[x_a][  6] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  needed_v_smin[x_a][  7] = {   4,    8,    9,   12,   13,   16,   17,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45}; //  18
  needed_v_smin[x_a][  8] = {   4,   24}; //   2
  needed_v_smin[x_a][  9] = {   4,    5,   24,   25}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,    7,   10,   11,   14,   15,   18,   19,   25,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47}; //  22
  needed_v_smin[x_a][ 11] = {   5,   25}; //   2
  needed_v_smin[x_a][ 12] = {   6,    7,   26,   27}; //   4
  needed_v_smin[x_a][ 13] = {   8,    9,   28,   29,   40,   41,   44,   45}; //   8
  needed_v_smin[x_a][ 14] = {  10,   11,   30,   31,   42,   43,   46,   47}; //   8
  needed_v_smin[x_a][ 15] = {  12,   13,   36,   37}; //   4
  needed_v_smin[x_a][ 16] = {  14,   15,   38,   39}; //   4
  needed_v_smin[x_a][ 17] = {  16,   17,   32,   33}; //   4
  needed_v_smin[x_a][ 18] = {  18,   19,   34,   35}; //   4

  v_smax[x_a].resize(24);
  needed_v_smax[x_a].resize(24);
  needed_v_smax[x_a][  0] = {   0,   10,   11,   14,   15,   20,   30,   31,   34,   35,   42,   43}; //  12
  needed_v_smax[x_a][  1] = {   0,    1,   20,   21}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47}; //  32
  needed_v_smax[x_a][  3] = {   1,    2,    3,   16,   17,   21,   22,   23,   36,   37,   44,   45}; //  12
  needed_v_smax[x_a][  4] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  needed_v_smax[x_a][  5] = {   4,    8,    9,   12,   13,   24,   28,   29,   32,   33,   40,   41}; //  12
  needed_v_smax[x_a][  6] = {   4,    5,   24,   25}; //   4
  needed_v_smax[x_a][  7] = {   5,    6,    7,   18,   19,   25,   26,   27,   38,   39,   46,   47}; //  12
  needed_v_smax[x_a][  8] = {   8,    9,   28,   29,   32,   33,   40,   41}; //   8
  needed_v_smax[x_a][  9] = {  10,   11,   30,   31,   34,   35,   42,   43}; //   8
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2
  needed_v_smax[x_a][ 11] = {  12,   13}; //   2
  needed_v_smax[x_a][ 12] = {  14,   15}; //   2
  needed_v_smax[x_a][ 13] = {  14,   15}; //   2
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  16,   17}; //   2
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  18,   19}; //   2
  needed_v_smax[x_a][ 18] = {  32,   33}; //   2
  needed_v_smax[x_a][ 19] = {  34,   35}; //   2
  needed_v_smax[x_a][ 20] = {  36,   37,   44,   45}; //   4
  needed_v_smax[x_a][ 21] = {  36,   37}; //   2
  needed_v_smax[x_a][ 22] = {  38,   39,   46,   47}; //   4
  needed_v_smax[x_a][ 23] = {  38,   39}; //   2

  g_p[x_a].resize(37);
  needed_g_p[x_a].resize(37);
  needed_g_p[x_a][0] = {   0,   10,   11,   14,   15,   20,   30,   31,   34,   35,   42,   43}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   17,   21,   23,   37,   45}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][5] = {   2,   16,   22,   36,   44}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax2");
  needed_g_p[x_a][8] = {   4,    8,    9,   12,   13,   24,   28,   29,   32,   33,   40,   41}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax5");
  needed_g_p[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,    5,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   5,    7,   19,   25,   27,   39,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax7");
  needed_g_p[x_a][12] = {   5,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][13] = {   6,   18,   26,   38,   46}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][14] = {   6,    7,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax4");
  needed_g_p[x_a][15] = {   8,   28,   32,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax8");
  needed_g_p[x_a][16] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {   9,   29,   33,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax8");
  needed_g_p[x_a][18] = {  10,   30,   34,   42}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax9");
  needed_g_p[x_a][19] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][20] = {  11,   31,   35,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax9");
  needed_g_p[x_a][21] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][22] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax11");
  needed_g_p[x_a][23] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax11");
  needed_g_p[x_a][24] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax12");
  needed_g_p[x_a][25] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax13");
  needed_g_p[x_a][26] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax13");
  needed_g_p[x_a][27] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax14");
  needed_g_p[x_a][28] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax15");
  needed_g_p[x_a][29] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax16");
  needed_g_p[x_a][30] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax17");
  needed_g_p[x_a][31] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax18");
  needed_g_p[x_a][32] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax19");
  needed_g_p[x_a][33] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax20");
  needed_g_p[x_a][34] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax21");
  needed_g_p[x_a][35] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax22");
  needed_g_p[x_a][36] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax23");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][1] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax2");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {  20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   44,   45,   46,   47}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][2] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_84");
  needed_g_t[x_a][3] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][4] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_104");
  needed_g_t[x_a][5] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][6] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_20");
  needed_g_t[x_a][7] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][8] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_40");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   0,   10,   11,   14,   15,   18,   19,   20,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   1,    2,    3,    8,    9,   12,   13,   16,   17,   21,   22,   23,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   4,    8,    9,   12,   13,   16,   17,   24,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][11] = {   5,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][12] = {   5,    6,    7,   10,   11,   14,   15,   18,   19,   25,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][13] = {   6,    7,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {   8,    9,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][15] = {  10,   11,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][17] = {  12,   13,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][19] = {  14,   15,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][21] = {  16,   17,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][23] = {  18,   19,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  3,   4,   2}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   4,   5}; //   4

  c_p[x_a][2] = {  5,   6,   7}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   6,   7,   5}; //   4

  c_p[x_a][3] = {  3,   6,   7}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   6,   7,   5}; //   4

  c_p[x_a][4] = {  8,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   8,   9,  10}; //   4

  c_p[x_a][5] = { 11,  12,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   8,  11,  12}; //   4

  c_p[x_a][6] = { 13,  14,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   6,  13,  12}; //   4

  c_p[x_a][7] = { 11,  14,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,   6,  13,  12}; //   4

  c_p[x_a][8] = {  8,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  14,   5,  10}; //   4

  c_p[x_a][9] = {  8,  17,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  14,   5,  10}; //   4

  c_p[x_a][10] = {  0,  18,  19}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  15,  12,   3}; //   4

  c_p[x_a][11] = {  0,  20,  19}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,  15,  12,   3}; //   4

  c_p[x_a][12] = {  8,  21,  22}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 16,   5,  17,  10}; //   4

  c_p[x_a][13] = {  8,  21,  23}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 16,   5,  17,  10}; //   4

  c_p[x_a][14] = {  0,  24,  25}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 18,  12,  19,   3}; //   4

  c_p[x_a][15] = {  0,  24,  26}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 18,  12,  19,   3}; //   4

  c_p[x_a][16] = {  5,  27,  28}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 20,  10,  21,   5}; //   4

  c_p[x_a][17] = {  3,  27,  28}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 20,  10,  21,   5}; //   4

  c_p[x_a][18] = { 13,  29,  30}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 22,   3,  23,  12}; //   4

  c_p[x_a][19] = { 11,  29,  30}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 22,   3,  23,  12}; //   4

  c_p[x_a][20] = {  0,   1,   2}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  3,   4,   2}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  1,   4,   5}; //   3

  c_p[x_a][22] = {  5,   6,   7}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  6,   7,   5}; //   3

  c_p[x_a][23] = {  3,   6,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  6,   7,   5}; //   3

  c_p[x_a][24] = {  8,   9,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  8,   9,  10}; //   3

  c_p[x_a][25] = { 11,  12,  10}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  8,  11,  12}; //   3

  c_p[x_a][26] = { 13,  14,   7}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  6,  13,  12}; //   3

  c_p[x_a][27] = { 11,  14,   7}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  6,  13,  12}; //   3

  c_p[x_a][28] = {  8,  15,  16}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 14,   5,  10}; //   3

  c_p[x_a][29] = {  8,  17,  16}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 14,   5,  10}; //   3

  c_p[x_a][30] = {  0,  18,  19}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 15,  12,   3}; //   3

  c_p[x_a][31] = {  0,  20,  19}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 15,  12,   3}; //   3

  c_p[x_a][32] = {  8,  15,  31}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  1}; //   1
  c_d[x_a][32] = { 21,   5,  10}; //   3

  c_p[x_a][33] = {  8,  17,  31}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  1}; //   1
  c_d[x_a][33] = { 21,   5,  10}; //   3

  c_p[x_a][34] = {  0,  18,  32}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  2}; //   1
  c_d[x_a][34] = { 23,  12,   3}; //   3

  c_p[x_a][35] = {  0,  20,  32}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = { 23,  12,   3}; //   3

  c_p[x_a][36] = {  5,  33,  34}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  3}; //   1
  c_d[x_a][36] = { 17,  10,   5}; //   3

  c_p[x_a][37] = {  3,  33,  34}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  3}; //   1
  c_d[x_a][37] = { 17,  10,   5}; //   3

  c_p[x_a][38] = { 13,  35,  36}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  4}; //   1
  c_d[x_a][38] = { 19,   3,  12}; //   3

  c_p[x_a][39] = { 11,  35,  36}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  4}; //   1
  c_d[x_a][39] = { 19,   3,  12}; //   3

  c_p[x_a][40] = {  8,  15}; //   2
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  0,   5}; //   2
  c_d[x_a][40] = {  5,  10}; //   2

  c_p[x_a][41] = {  8,  17}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   5}; //   2
  c_d[x_a][41] = {  5,  10}; //   2

  c_p[x_a][42] = {  0,  18}; //   2
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  0,   6}; //   2
  c_d[x_a][42] = { 12,   3}; //   2

  c_p[x_a][43] = {  0,  20}; //   2
  c_f[x_a][43] = {  1}; //   1
  c_t[x_a][43] = {  0,   6}; //   2
  c_d[x_a][43] = { 12,   3}; //   2

  c_p[x_a][44] = {  5,  33}; //   2
  c_f[x_a][44] = {  0}; //   1
  c_t[x_a][44] = {  0,   7}; //   2
  c_d[x_a][44] = { 10,   5}; //   2

  c_p[x_a][45] = {  3,  33}; //   2
  c_f[x_a][45] = {  0}; //   1
  c_t[x_a][45] = {  0,   7}; //   2
  c_d[x_a][45] = { 10,   5}; //   2

  c_p[x_a][46] = { 13,  35}; //   2
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  0,   8}; //   2
  c_d[x_a][46] = {  3,  12}; //   2

  c_p[x_a][47] = { 11,  35}; //   2
  c_f[x_a][47] = {  1}; //   1
  c_t[x_a][47] = {  0,   8}; //   2
  c_d[x_a][47] = {  3,  12}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 5yyyv(1, 2, 64, 16, 4, 8, 32;  24,   0,  24,   0)
// channel    1: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
// channel    2: 5yyyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
// channel    3: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
// channel    4: 5yyyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
// channel    5: 5yyyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel    6: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel    7: 5yyyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel    8: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
// channel    9: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
// channel   10: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   11: 5y2vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   12: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
// channel   13: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,   0,  23,   0)
// channel   14: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,   0,   0)
// channel   15: 52vyv(1, 2, 4, 16, 64, 8, 32;  24,   0,  23,   0)
// channel   16: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,  24,   0)
// channel   17: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,  24,   0)
// channel   18: 52vyv(1, 2, 8, 32, 64, 4, 16;   0,   0,  24,   0)
// channel   19: 52vyv(1, 2, 8, 32, 64, 4, 16;  23,   0,  24,   0)
// channel   20: 14yyv(1, 2, 64, 16, 4, 8, 32;  24,   0,  24,   0)
// channel   21: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
// channel   22: 14yyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
// channel   23: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
// channel   24: 14yyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
// channel   25: 14yyv(1, 2, 64, 8, 32, 4, 16;  23,   0,  24,   0)
// channel   26: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,   0,  24,   0)
// channel   27: 14yyv(1, 2, 64, 32, 8, 4, 16;  23,   0,  24,   0)
// channel   28: 142vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
// channel   29: 142vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
// channel   30: 142vv(1, 2, 64, 4, 16, 8, 32;  24,   0,  24,   0)
// channel   31: 142vv(1, 2, 64, 4, 16, 8, 32;  24,  23,  24,   0)
// channel   32: 3yv2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   33: 3yv2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
// channel   34: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
// channel   35: 3yv2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
// channel   36: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
// channel   37: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
// channel   38: 3yv2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
// channel   39: 3yv2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
// channel   40: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   41: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
// channel   42: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,   0,   0,   0)
// channel   43: 12v2v(1, 2, 64, 4, 16, 8, 32;  24,  23,   0,   0)
// channel   44: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
// channel   45: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
// channel   46: 12v2v(1, 2, 64, 8, 32, 4, 16;   0,  24,   0,   0)
// channel   47: 12v2v(1, 2, 64, 8, 32, 4, 16;  23,  24,   0,   0)
