#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmuux(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmuux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  1] = {   0,   10,   20,   38}; //   4
  needed_v_smin[x_a][  2] = {   0,   10,   20,   38}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  12
  needed_v_smin[x_a][  4] = {   1,    2,   11,   12,   21,   22,   39,   40}; //   8
  needed_v_smin[x_a][  5] = {   1,    2,   11,   12,   21,   22,   39,   40}; //   8
  needed_v_smin[x_a][  6] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  7] = {   3,   13,   23,   41}; //   4
  needed_v_smin[x_a][  8] = {   3,   13,   23,   41}; //   4
  needed_v_smin[x_a][  9] = {   4,    5,   14,   15,   24,   25,   42,   43,   56,   57,   62,   63}; //  12
  needed_v_smin[x_a][ 10] = {   6,    7,   26,   27,   30,   31,   46,   47,   50,   51}; //  10
  needed_v_smin[x_a][ 11] = {   6,    7,   46,   47,   50,   51}; //   6
  needed_v_smin[x_a][ 12] = {   8,    9,   16,   17,   34,   35,   44,   45,   48,   49}; //  10
  needed_v_smin[x_a][ 13] = {   8,    9,   44,   45,   48,   49}; //   6
  needed_v_smin[x_a][ 14] = {  16,   17,   34,   35}; //   4
  needed_v_smin[x_a][ 15] = {  18,   19,   30,   31,   32,   33,   36,   37}; //   8
  needed_v_smin[x_a][ 16] = {  18,   19,   36,   37,   32,   33}; //   6
  needed_v_smin[x_a][ 17] = {  20,   21,   22,   23,   24,   25,   38,   39,   40,   41,   42,   43,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   28,   29}; //  26
  needed_v_smin[x_a][ 18] = {  26,   27}; //   2
  needed_v_smin[x_a][ 19] = {  28,   29,   52,   53,   54,   55}; //   6
  needed_v_smin[x_a][ 20] = {  58,   59,   60,   61}; //   4

  v_smax[x_a].resize(35);
  needed_v_smax[x_a].resize(35);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   10,   11,   12,   16,   17,   18,   19,   20,   21,   22,   46,   47,   50,   51,   60,   61,   62,   63}; //  23
  needed_v_smax[x_a][  1] = {   0,   10,   20}; //   3
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23,   24,   25}; //  18
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   44,   45,   46,   47,   48,   49,   50,   51}; //  24
  needed_v_smax[x_a][  4] = {   1,    2,   11,   12,   21,   22}; //   6
  needed_v_smax[x_a][  5] = {   3,    4,    5,    6,    7,   13,   14,   15,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   48,   49,   54,   55,   56,   57}; //  31
  needed_v_smax[x_a][  6] = {   3,   13,   23}; //   3
  needed_v_smax[x_a][  7] = {   4,    5,   14,   15,   24,   25,   28,   29,   32,   33,   34,   35,   36,   37,   44,   45,   48,   49,   56,   57}; //  20
  needed_v_smax[x_a][  8] = {   6,    7,   26,   27,   30,   31}; //   6
  needed_v_smax[x_a][  9] = {   6,    7,   26,   27,   30,   31}; //   6
  needed_v_smax[x_a][ 10] = {   8,    9,   16,   17}; //   4
  needed_v_smax[x_a][ 11] = {   8,    9}; //   2
  needed_v_smax[x_a][ 12] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][ 13] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][ 14] = {  18,   19}; //   2
  needed_v_smax[x_a][ 15] = {  20,   21,   22,   23,   24,   25}; //   6
  needed_v_smax[x_a][ 16] = {  30,   31}; //   2
  needed_v_smax[x_a][ 17] = {  32,   33,   36,   37}; //   4
  needed_v_smax[x_a][ 18] = {  34,   35,   44,   45,   48,   49}; //   6
  needed_v_smax[x_a][ 19] = {  34,   35,   36,   37,   32,   33,   58,   59,   60,   61}; //  10
  needed_v_smax[x_a][ 20] = {  38,   39,   40,   41,   42,   43,   52,   53,   58,   59}; //  10
  needed_v_smax[x_a][ 21] = {  38,   39,   40,   58,   59}; //   5
  needed_v_smax[x_a][ 22] = {  38}; //   1
  needed_v_smax[x_a][ 23] = {  38,   39,   40,   41,   42,   43,   56,   57,   62,   63}; //  10
  needed_v_smax[x_a][ 24] = {  39,   40}; //   2
  needed_v_smax[x_a][ 25] = {  41,   42,   43,   52,   53}; //   5
  needed_v_smax[x_a][ 26] = {  41}; //   1
  needed_v_smax[x_a][ 27] = {  42,   43,   52,   53,   54,   55}; //   6
  needed_v_smax[x_a][ 28] = {  46,   47,   50,   51,   62,   63}; //   6
  needed_v_smax[x_a][ 29] = {  46,   47,   50,   51}; //   4
  needed_v_smax[x_a][ 30] = {  54,   55}; //   2
  needed_v_smax[x_a][ 31] = {  56,   57,   62,   63,   28,   29}; //   6
  needed_v_smax[x_a][ 32] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 33] = {  60,   61}; //   2
  needed_v_smax[x_a][ 34] = {  26,   27,   28,   29,   52,   53,   54,   55}; //   8

  g_p[x_a].resize(49);
  needed_g_p[x_a].resize(49);
  needed_g_p[x_a][0] = {   0,    2,    9,   10,   12,   17,   19,   20,   22,   47,   51,   61,   63}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    8,   11,   16,   18,   21,   46,   50,   60,   62}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][5] = {   1,    2,   11,   12,   21,   22}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   1,    2,   11,   12,   21,   22}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    4,    5,    6,    7,   13,   14,   15,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   48,   49,   54,   55,   56,   57}; //  31
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   13,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   3,   13,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   24,   28,   32,   34,   36,   44,   48,   56}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax7");
  needed_g_p[x_a][11] = {   4,    5,   14,   15,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][12] = {   5,   15,   25,   29,   33,   35,   37,   45,   49,   57}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax7");
  needed_g_p[x_a][13] = {   6,    7,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   26,   30}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][16] = {   7,   27,   31}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][17] = {   8,    9,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax11");
  needed_g_p[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][20] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax13");
  needed_g_p[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][23] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax12");
  needed_g_p[x_a][24] = {  20,   21,   22,   23,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][25] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax16");
  needed_g_p[x_a][26] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax17");
  needed_g_p[x_a][27] = {  34,   35,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax18");
  needed_g_p[x_a][28] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax19");
  needed_g_p[x_a][29] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax19");
  needed_g_p[x_a][30] = {  38,   39,   40,   41,   42,   43,   52,   53,   58,   59}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][31] = {  38,   40,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax21");
  needed_g_p[x_a][32] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax22");
  needed_g_p[x_a][33] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax23");
  needed_g_p[x_a][34] = {  39,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax21");
  needed_g_p[x_a][35] = {  39,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax24");
  needed_g_p[x_a][36] = {  39,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax23");
  needed_g_p[x_a][37] = {  41,   42,   43,   52,   53}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax25");
  needed_g_p[x_a][38] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax26");
  needed_g_p[x_a][39] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax23");
  needed_g_p[x_a][40] = {  42,   52,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax27");
  needed_g_p[x_a][41] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax23");
  needed_g_p[x_a][42] = {  43,   53,   55}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax27");
  needed_g_p[x_a][43] = {  46,   47,   50,   51,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax28");
  needed_g_p[x_a][44] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax29");
  needed_g_p[x_a][45] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax30");
  needed_g_p[x_a][46] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax31");
  needed_g_p[x_a][47] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax32");
  needed_g_p[x_a][48] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax33");

  g_f[x_a].resize(11);
  needed_g_f[x_a].resize(11);
  needed_g_f[x_a][0] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax34");
  needed_g_f[x_a][2] = {  28,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax31");
  needed_g_f[x_a][3] = {  28,   29,   52,   53,   54,   55}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax34");
  needed_g_f[x_a][4] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax19");
  needed_g_f[x_a][5] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][6] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][7] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax18");
  needed_g_f[x_a][8] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax29");
  needed_g_f[x_a][9] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax23");
  needed_g_f[x_a][10] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax19");

  g_t[x_a].resize(21);
  needed_g_t[x_a].resize(21);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   44,   45,   46,   47,   48,   49,   50,   51}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  16,   17,   18,   19,   58,   59,   60,   61}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][3] = {  20,   21,   22,   23,   24,   25,   56,   57,   62,   63}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][4] = {  26,   27,   28,   29,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][5] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][6] = {  28,   29,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][7] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][8] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][9] = {  32,   33,   34,   35,   36,   37}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][10] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][11] = {  38,   39,   40,   41,   42,   43}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][12] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][13] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][14] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][15] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");
  needed_g_t[x_a][16] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][17] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][18] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][19] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][20] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,   10,   20,   38}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   10,   20,   38}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   1,    2,   11,   12,   21,   22,   39,   40}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   11,   12,   21,   22,   39,   40}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   3,   13,   23,   41}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,   13,   23,   41}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {   4,    5,   14,   15,   24,   25,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][11] = {   6,    7,   26,   27,   30,   31,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][13] = {   8,    9,   16,   17,   34,   35,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][14] = {  16,   17,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][15] = {  18,   19,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");
  needed_g_d[x_a][16] = {  18,   19,   30,   31,   32,   33,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][17] = {  20,   21,   22,   23,   24,   25,   38,   39,   40,   41,   42,   43,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  7,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   9,   3,   8}; //   4

  c_p[x_a][5] = {  7,  12,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,   3,   8}; //   4

  c_p[x_a][6] = {  7,  13,  14,  15}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   3,  11,   8}; //   4

  c_p[x_a][7] = {  7,  13,  16,  15}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   3,  11,   8}; //   4

  c_p[x_a][8] = {  4,  17,  18,  19}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   8,  13,   3}; //   4

  c_p[x_a][9] = {  0,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   8,  13,   3}; //   4

  c_p[x_a][10] = {  0,   1,   2}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  1,   2,   3}; //   3

  c_p[x_a][11] = {  4,   5,   6}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  4,   5,   3}; //   3

  c_p[x_a][12] = {  0,   5,   6}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = {  4,   5,   3}; //   3

  c_p[x_a][13] = {  7,   8,   9}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = {  6,   7,   8}; //   3

  c_p[x_a][14] = {  7,  10,  11}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = {  9,   3,   8}; //   3

  c_p[x_a][15] = {  7,  12,  11}; //   3
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   1}; //   2
  c_d[x_a][15] = {  9,   3,   8}; //   3

  c_p[x_a][16] = {  4,  17,  20,  21}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  8,  14,  13,   3}; //   4

  c_p[x_a][17] = {  0,  17,  20,  21}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = {  8,  14,  13,   3}; //   4

  c_p[x_a][18] = {  4,  22,  23,  21}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = {  8,  15,  16,   3}; //   4

  c_p[x_a][19] = {  0,  22,  23,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = {  8,  15,  16,   3}; //   4

  c_p[x_a][20] = {  0,   1,   2,  24}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = { 17,   1,   2,   3}; //   4

  c_p[x_a][21] = {  4,   5,   6,  24}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = { 17,   4,   5,   3}; //   4

  c_p[x_a][22] = {  0,   5,   6,  24}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = { 17,   4,   5,   3}; //   4

  c_p[x_a][23] = {  7,   8,   9,  24}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  3}; //   1
  c_d[x_a][23] = { 17,   6,   7,   8}; //   4

  c_p[x_a][24] = {  7,  10,  11,  24}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  3}; //   1
  c_d[x_a][24] = { 17,   9,   3,   8}; //   4

  c_p[x_a][25] = {  7,  12,  11,  24}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  3}; //   1
  c_d[x_a][25] = { 17,   9,   3,   8}; //   4

  c_p[x_a][26] = {  7,  13,  14}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  4,   5}; //   2
  c_d[x_a][26] = {  3,  11,   8}; //   3

  c_p[x_a][27] = {  7,  13,  16}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  4,   5}; //   2
  c_d[x_a][27] = {  3,  11,   8}; //   3

  c_p[x_a][28] = {  7,  10}; //   2
  c_f[x_a][28] = {  2,   3}; //   2
  c_t[x_a][28] = {  4,   6,   7}; //   3
  c_d[x_a][28] = {  3,   8}; //   2

  c_p[x_a][29] = {  7,  12}; //   2
  c_f[x_a][29] = {  2,   3}; //   2
  c_t[x_a][29] = {  4,   6,   7}; //   3
  c_d[x_a][29] = {  3,   8}; //   2

  c_p[x_a][30] = {  7,  13,  14,  25}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  8}; //   1
  c_d[x_a][30] = { 16,   3,  11,   8}; //   4

  c_p[x_a][31] = {  7,  13,  16,  25}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  8}; //   1
  c_d[x_a][31] = { 16,   3,  11,   8}; //   4

  c_p[x_a][32] = {  7,  10,  26}; //   3
  c_f[x_a][32] = {  4}; //   1
  c_t[x_a][32] = {  9,  10}; //   2
  c_d[x_a][32] = { 16,   3,   8}; //   3

  c_p[x_a][33] = {  7,  12,  26}; //   3
  c_f[x_a][33] = {  4}; //   1
  c_t[x_a][33] = {  9,  10}; //   2
  c_d[x_a][33] = { 16,   3,   8}; //   3

  c_p[x_a][34] = {  7,  10,  27,  28}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  9}; //   1
  c_d[x_a][34] = { 14,  13,   3,   8}; //   4

  c_p[x_a][35] = {  7,  12,  27,  28}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  9}; //   1
  c_d[x_a][35] = { 14,  13,   3,   8}; //   4

  c_p[x_a][36] = {  7,  10,  26,  29}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  9}; //   1
  c_d[x_a][36] = { 15,  16,   3,   8}; //   4

  c_p[x_a][37] = {  7,  12,  26,  29}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  9}; //   1
  c_d[x_a][37] = { 15,  16,   3,   8}; //   4

  c_p[x_a][38] = { 30,  31,  32,  33}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 11}; //   1
  c_d[x_a][38] = {  1,   2,   3,  17}; //   4

  c_p[x_a][39] = { 30,  34,  35,  36}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 11}; //   1
  c_d[x_a][39] = {  4,   5,   3,  17}; //   4

  c_p[x_a][40] = { 30,  31,  35,  36}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 11}; //   1
  c_d[x_a][40] = {  4,   5,   3,  17}; //   4

  c_p[x_a][41] = { 30,  37,  38,  39}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 11}; //   1
  c_d[x_a][41] = {  6,   7,   8,  17}; //   4

  c_p[x_a][42] = { 30,  37,  40,  41}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = {  9,   3,   8,  17}; //   4

  c_p[x_a][43] = { 30,  37,  42,  41}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 11}; //   1
  c_d[x_a][43] = {  9,   3,   8,  17}; //   4

  c_p[x_a][44] = {  7,  10,  27}; //   3
  c_f[x_a][44] = {  5}; //   1
  c_t[x_a][44] = {  0,  12}; //   2
  c_d[x_a][44] = { 13,   3,   8}; //   3

  c_p[x_a][45] = {  7,  12,  27}; //   3
  c_f[x_a][45] = {  5}; //   1
  c_t[x_a][45] = {  0,  12}; //   2
  c_d[x_a][45] = { 13,   3,   8}; //   3

  c_p[x_a][46] = {  4,  43,  44}; //   3
  c_f[x_a][46] = {  6}; //   1
  c_t[x_a][46] = {  0,  13}; //   2
  c_d[x_a][46] = { 11,   8,   3}; //   3

  c_p[x_a][47] = {  0,  43,  44}; //   3
  c_f[x_a][47] = {  6}; //   1
  c_t[x_a][47] = {  0,  13}; //   2
  c_d[x_a][47] = { 11,   8,   3}; //   3

  c_p[x_a][48] = {  7,  10}; //   2
  c_f[x_a][48] = {  7,   5}; //   2
  c_t[x_a][48] = {  0,  12,  14}; //   3
  c_d[x_a][48] = {  3,   8}; //   2

  c_p[x_a][49] = {  7,  12}; //   2
  c_f[x_a][49] = {  7,   5}; //   2
  c_t[x_a][49] = {  0,  12,  14}; //   3
  c_d[x_a][49] = {  3,   8}; //   2

  c_p[x_a][50] = {  4,  43}; //   2
  c_f[x_a][50] = {  8,   6}; //   2
  c_t[x_a][50] = {  0,  13,  15}; //   3
  c_d[x_a][50] = {  8,   3}; //   2

  c_p[x_a][51] = {  0,  43}; //   2
  c_f[x_a][51] = {  8,   6}; //   2
  c_t[x_a][51] = {  0,  13,  15}; //   3
  c_d[x_a][51] = {  8,   3}; //   2

  c_p[x_a][52] = { 30,  37,  40}; //   3
  c_f[x_a][52] = {  3}; //   1
  c_t[x_a][52] = {  4,  16}; //   2
  c_d[x_a][52] = {  3,   8,  17}; //   3

  c_p[x_a][53] = { 30,  37,  42}; //   3
  c_f[x_a][53] = {  3}; //   1
  c_t[x_a][53] = {  4,  16}; //   2
  c_d[x_a][53] = {  3,   8,  17}; //   3

  c_p[x_a][54] = {  7,  45,  40}; //   3
  c_f[x_a][54] = {  3}; //   1
  c_t[x_a][54] = {  4,   6}; //   2
  c_d[x_a][54] = {  3,  17,   8}; //   3

  c_p[x_a][55] = {  7,  45,  42}; //   3
  c_f[x_a][55] = {  3}; //   1
  c_t[x_a][55] = {  4,   6}; //   2
  c_d[x_a][55] = {  3,  17,   8}; //   3

  c_p[x_a][56] = {  7,  10,  46}; //   3
  c_f[x_a][56] = {  9}; //   1
  c_t[x_a][56] = {  3,  17}; //   2
  c_d[x_a][56] = { 17,   3,   8}; //   3

  c_p[x_a][57] = {  7,  12,  46}; //   3
  c_f[x_a][57] = {  9}; //   1
  c_t[x_a][57] = {  3,  17}; //   2
  c_d[x_a][57] = { 17,   3,   8}; //   3

  c_p[x_a][58] = { 30,  34,  47}; //   3
  c_f[x_a][58] = { 10}; //   1
  c_t[x_a][58] = {  2,  18}; //   2
  c_d[x_a][58] = {  8,   3,  17}; //   3

  c_p[x_a][59] = { 30,  31,  47}; //   3
  c_f[x_a][59] = { 10}; //   1
  c_t[x_a][59] = {  2,  18}; //   2
  c_d[x_a][59] = {  8,   3,  17}; //   3

  c_p[x_a][60] = {  4,  48,  47}; //   3
  c_f[x_a][60] = { 10}; //   1
  c_t[x_a][60] = {  2,  19}; //   2
  c_d[x_a][60] = {  8,  17,   3}; //   3

  c_p[x_a][61] = {  0,  48,  47}; //   3
  c_f[x_a][61] = { 10}; //   1
  c_t[x_a][61] = {  2,  19}; //   2
  c_d[x_a][61] = {  8,  17,   3}; //   3

  c_p[x_a][62] = {  4,  43,  46}; //   3
  c_f[x_a][62] = {  9}; //   1
  c_t[x_a][62] = {  3,  20}; //   2
  c_d[x_a][62] = { 17,   8,   3}; //   3

  c_p[x_a][63] = {  0,  43,  46}; //   3
  c_f[x_a][63] = {  9}; //   1
  c_t[x_a][63] = {  3,  20}; //   2
  c_d[x_a][63] = { 17,   8,   3}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel    4: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel    5: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel    6: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel    7: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel    8: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
// channel    9: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   10: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   11: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   12: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   13: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   14: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   15: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   16: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  24,   0)
// channel   17: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  24,   0)
// channel   18: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  24,   0)
// channel   19: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  24,   0)
// channel   20: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
// channel   21: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
// channel   22: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
// channel   23: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
// channel   24: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
// channel   25: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
// channel   26: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   27: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   28: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   29: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   30: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   31: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   32: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   33: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
// channel   34: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   35: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   36: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   37: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   38: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   39: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,   0,  24,   0)
// channel   40: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  24,   0)
// channel   41: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   42: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   43: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,  24,   0)
// channel   44: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   45: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   46: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   47: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   48: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   49: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   50: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   51: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
// channel   52: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   53: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,   0,   0)
// channel   54: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
// channel   55: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
// channel   56: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
// channel   57: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
// channel   58: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  24,   0,   0)
// channel   59: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  24,   0,   0)
// channel   60: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
// channel   61: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
// channel   62: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
// channel   63: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
