#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_140_gu_emepmupvmd(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_140_gu_emepmupvmd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  needed_v_smin[x_a][  1] = {   0,   10}; //   2
  needed_v_smin[x_a][  2] = {   0,   10}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  needed_v_smin[x_a][  6] = {   3,   13}; //   2
  needed_v_smin[x_a][  7] = {   3,   13}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   14,   15,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  9] = {   6,    7,   18,   19}; //   4
  needed_v_smin[x_a][ 10] = {   8,    9,   16,   17}; //   4

  v_smax[x_a].resize(14);
  needed_v_smax[x_a].resize(14);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   10,   11,   12,   18,   19,   22,   23}; //  12
  needed_v_smax[x_a][  1] = {   0,   10}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  16
  needed_v_smax[x_a][  3] = {   1,    2,   11,   12}; //   4
  needed_v_smax[x_a][  4] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21}; //  12
  needed_v_smax[x_a][  5] = {   3,   13}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   14,   15,   16,   17,   20,   21}; //   8
  needed_v_smax[x_a][  7] = {   6,    7}; //   2
  needed_v_smax[x_a][  8] = {   6,    7}; //   2
  needed_v_smax[x_a][  9] = {   8,    9}; //   2
  needed_v_smax[x_a][ 10] = {   8,    9}; //   2
  needed_v_smax[x_a][ 11] = {  16,   17}; //   2
  needed_v_smax[x_a][ 12] = {  18,   19,   22,   23}; //   4
  needed_v_smax[x_a][ 13] = {  18,   19}; //   2

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   0,    2,    9,   10,   12,   19,   23}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    8,   11,   18,   22}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,    6,    7,   13,   14,   15,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   14,   16,   20}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   15,   17,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax8");
  needed_g_p[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][15] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax9");
  needed_g_p[x_a][16] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax11");
  needed_g_p[x_a][18] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax12");
  needed_g_p[x_a][19] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax13");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {  10,   11,   12,   13,   14,   15,   20,   21,   22,   23}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][2] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][3] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][4] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   0,    1,    2,    4,    5,    6,    7,    8,    9,   10,   11,   12,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   3,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][11] = {   6,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][13] = {   8,    9,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(24);
  c_f[x_a].resize(24);
  c_t[x_a].resize(24);
  c_d[x_a].resize(24);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   4,   5,   3}; //   4

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  6,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   9,   3,   8}; //   4

  c_p[x_a][5] = {  6,  11,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   9,   3,   8}; //   4

  c_p[x_a][6] = {  6,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = { 10,   3,  11,   8}; //   4

  c_p[x_a][7] = {  6,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   3,  11,   8}; //   4

  c_p[x_a][8] = {  3,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 12,   8,  13,   3}; //   4

  c_p[x_a][9] = {  0,  15,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 12,   8,  13,   3}; //   4

  c_p[x_a][10] = {  0,   1,   2}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  1,   2,   3}; //   3

  c_p[x_a][11] = {  3,   4,   5}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  4,   5,   3}; //   3

  c_p[x_a][12] = {  0,   4,   5}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  4,   5,   3}; //   3

  c_p[x_a][13] = {  6,   7,   8}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  6,   7,   8}; //   3

  c_p[x_a][14] = {  6,   9,  10}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  9,   3,   8}; //   3

  c_p[x_a][15] = {  6,  11,  10}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  9,   3,   8}; //   3

  c_p[x_a][16] = {  6,   9,  17}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = { 13,   3,   8}; //   3

  c_p[x_a][17] = {  6,  11,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = { 13,   3,   8}; //   3

  c_p[x_a][18] = {  3,  18,  19}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = { 11,   8,   3}; //   3

  c_p[x_a][19] = {  0,  18,  19}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 11,   8,   3}; //   3

  c_p[x_a][20] = {  6,   9}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  0,   3}; //   2
  c_d[x_a][20] = {  3,   8}; //   2

  c_p[x_a][21] = {  6,  11}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  0,   3}; //   2
  c_d[x_a][21] = {  3,   8}; //   2

  c_p[x_a][22] = {  3,  18}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   4}; //   2
  c_d[x_a][22] = {  8,   3}; //   2

  c_p[x_a][23] = {  0,  18}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  0,   4}; //   2
  c_d[x_a][23] = {  8,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
// channel    1: 5yyyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
// channel    2: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
// channel    3: 5yyyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
// channel    4: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
// channel    5: 5y2vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
// channel    6: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,   0,   0,   0)
// channel    7: 52vyv(1, 2, 4, 8, 64, 16, 32;  24,   0,  23,   0)
// channel    8: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,  24,   0)
// channel    9: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,  24,   0)
// channel   10: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  24,   0)
// channel   11: 14yyv(1, 2, 64, 32, 16, 4, 8;   0,   0,  24,   0)
// channel   12: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  24,   0)
// channel   13: 14yyv(1, 2, 64, 8, 4, 16, 32;  24,   0,  24,   0)
// channel   14: 142vv(1, 2, 64, 4, 8, 16, 32;  24,   0,  24,   0)
// channel   15: 142vv(1, 2, 64, 4, 8, 16, 32;  24,  23,  24,   0)
// channel   16: 3yv2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   17: 3yv2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
// channel   18: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
// channel   19: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
// channel   20: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   21: 12v2v(1, 2, 64, 4, 8, 16, 32;  24,  23,   0,   0)
// channel   22: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  24,   0,   0)
// channel   23: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  24,   0,   0)
