#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ac_psp_340_gg_emepvevexg(int x_a, int channel){
  static Logger logger("ppeexnenex04_phasespace_set::ac_psp_340_gg_emepvevexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  3] = smin_opt[x_a][24];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][100], 2);
      c_propagator(x_a,  24,  24, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][56]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][68], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  4], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  6], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  8], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  9], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][ 10], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 11], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 12], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][ 12], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 13] = smin_opt[x_a][36];
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][88], 2);
      c_propagator(x_a,  24,  36, v_smin[x_a][ 13], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][72], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 14], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][ 15], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][112]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  7], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 16], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  35,  60, v_smin[x_a][ 16], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  36,  60, v_smin[x_a][ 16], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][112]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  7], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  25,  60, v_smin[x_a][ 16], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][ 13] = smin_opt[x_a][36];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], sqrtsmin_opt[x_a][88]), 2);
      c_propagator(x_a,  24,  36, v_smin[x_a][ 13], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 25));
    }
    else if (c_p[x_a][channel][i_p] ==  26){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 26));
    }
    else if (c_p[x_a][channel][i_p] ==  27){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  25,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 27));
    }
    else if (c_p[x_a][channel][i_p] ==  28){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  35,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 28));
    }
    else if (c_p[x_a][channel][i_p] ==  29){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,  36,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 29));
    }
    else if (c_p[x_a][channel][i_p] ==  30){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][ 18], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 30));
    }
    else if (c_p[x_a][channel][i_p] ==  31){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][112], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  7], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 31));
    }
    else if (c_p[x_a][channel][i_p] ==  32){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][112], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  7], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 32));
    }
    else if (c_p[x_a][channel][i_p] ==  33){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,  35, 112, v_smin[x_a][ 18], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 33));
    }
    else if (c_p[x_a][channel][i_p] ==  34){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,  36, 112, v_smin[x_a][ 18], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 34));
    }
    else if (c_p[x_a][channel][i_p] ==  35){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 19], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 35));
    }
    else if (c_p[x_a][channel][i_p] ==  36){
      v_smin[x_a][ 13] = smin_opt[x_a][36];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][88], 2);
      c_propagator(x_a,  24,  36, v_smin[x_a][ 13], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 36));
    }
    else if (c_p[x_a][channel][i_p] ==  37){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,  36,  88, v_smin[x_a][ 19], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 37));
    }
    else if (c_p[x_a][channel][i_p] ==  38){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,  35,  88, v_smin[x_a][ 19], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 38));
    }
    else if (c_p[x_a][channel][i_p] ==  39){
      v_smin[x_a][  7] = smin_opt[x_a][12];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 39));
    }
    else if (c_p[x_a][channel][i_p] ==  40){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 20], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 40));
    }
    else if (c_p[x_a][channel][i_p] ==  41){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][76], 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 41));
    }
    else if (c_p[x_a][channel][i_p] ==  42){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,  35,  76, v_smin[x_a][ 20], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 42));
    }
    else if (c_p[x_a][channel][i_p] ==  43){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,  36,  76, v_smin[x_a][ 20], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 43));
    }
    else if (c_p[x_a][channel][i_p] ==  44){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][ 21], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 44));
    }
    else if (c_p[x_a][channel][i_p] ==  45){
      v_smin[x_a][  3] = smin_opt[x_a][24];
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][100], 2);
      c_propagator(x_a,  24,  24, v_smin[x_a][  3], v_smax[x_a][ 18], random_manager.get_random(x_a, 0, 45));
    }
    else if (c_p[x_a][channel][i_p] ==  46){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,  35, 100, v_smin[x_a][ 21], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 46));
    }
    else if (c_p[x_a][channel][i_p] ==  47){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,  36, 100, v_smin[x_a][ 21], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 47));
    }
    else if (c_p[x_a][channel][i_p] ==  48){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][76]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 19], random_manager.get_random(x_a, 0, 48));
    }
    else if (c_p[x_a][channel][i_p] ==  49){
      v_smin[x_a][  3] = smin_opt[x_a][24];
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], sqrtsmin_opt[x_a][100]), 2);
      c_propagator(x_a,  24,  24, v_smin[x_a][  3], v_smax[x_a][ 20], random_manager.get_random(x_a, 0, 49));
    }
    else if (c_p[x_a][channel][i_p] ==  50){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 20], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 50));
    }
    else if (c_p[x_a][channel][i_p] ==  51){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,  35,  76, v_smin[x_a][ 20], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 51));
    }
    else if (c_p[x_a][channel][i_p] ==  52){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,  36,  76, v_smin[x_a][ 20], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 52));
    }
    else if (c_p[x_a][channel][i_p] ==  53){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][24], 2);
      c_propagator(x_a,   0, 100, v_smin[x_a][ 21], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 53));
    }
    else if (c_p[x_a][channel][i_p] ==  54){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][24], 2);
      c_propagator(x_a,  35, 100, v_smin[x_a][ 21], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 54));
    }
    else if (c_p[x_a][channel][i_p] ==  55){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][24], 2);
      c_propagator(x_a,  36, 100, v_smin[x_a][ 21], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 55));
    }
    else if (c_p[x_a][channel][i_p] ==  56){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][ 18], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 56));
    }
    else if (c_p[x_a][channel][i_p] ==  57){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,  35, 112, v_smin[x_a][ 18], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 57));
    }
    else if (c_p[x_a][channel][i_p] ==  58){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,  36, 112, v_smin[x_a][ 18], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 58));
    }
    else if (c_p[x_a][channel][i_p] ==  59){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,   0,  88, v_smin[x_a][ 19], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 59));
    }
    else if (c_p[x_a][channel][i_p] ==  60){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,  36,  88, v_smin[x_a][ 19], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 60));
    }
    else if (c_p[x_a][channel][i_p] ==  61){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,  35,  88, v_smin[x_a][ 19], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 61));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 16], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][24] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 17], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 18], v_smax[x_a][ 23], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][88]);
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_timelikeinvariant(x_a,  88, v_smin[x_a][ 19], v_smax[x_a][ 24], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_timelikeinvariant(x_a,  76, v_smin[x_a][ 20], v_smax[x_a][ 21], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][100]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][24], 2);
      c_timelikeinvariant(x_a, 100, v_smin[x_a][ 21], v_smax[x_a][ 22], random_manager.get_random(x_a, 1, 5));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,  35, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,  36, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  64,  60, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,  35, 124,   1,   2,  64,  60, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,  36, 124,   1,   2,  64,  60, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  12,  48, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,  35,  60,   1,  66,  12,  48, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,  36,  60,   1,  66,  12,  48, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  36,  24, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,  36,  60,   1,  66,  36,  24, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,  35,  60,   1,  66,  36,  24, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  48,  12, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,  35,  60,   1,  66,  48,  12, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,  36,  60,   1,  66,  48,  12, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  24,  36, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,  35,  60,   1,  66,  24,  36, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,  36,  60,   1,  66,  24,  36, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  12, 112, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel_opt(x_a,  35, 124,   1,   2,  12, 112, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel_opt(x_a,  36, 124,   1,   2,  12, 112, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  36,  88, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel_opt(x_a,  36, 124,   1,   2,  36,  88, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,  35, 124,   1,   2,  36,  88, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
    else if (c_t[x_a][channel][i_t] ==  24){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  48,  76, random_manager.get_random(x_a, 2, 24), random_manager.get_random(x_a, 3, 24));
    }
    else if (c_t[x_a][channel][i_t] ==  25){
      c_tchannel_opt(x_a,  35, 124,   1,   2,  48,  76, random_manager.get_random(x_a, 2, 25), random_manager.get_random(x_a, 3, 25));
    }
    else if (c_t[x_a][channel][i_t] ==  26){
      c_tchannel_opt(x_a,  36, 124,   1,   2,  48,  76, random_manager.get_random(x_a, 2, 26), random_manager.get_random(x_a, 3, 26));
    }
    else if (c_t[x_a][channel][i_t] ==  27){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  24, 100, random_manager.get_random(x_a, 2, 27), random_manager.get_random(x_a, 3, 27));
    }
    else if (c_t[x_a][channel][i_t] ==  28){
      c_tchannel_opt(x_a,  35, 124,   1,   2,  24, 100, random_manager.get_random(x_a, 2, 28), random_manager.get_random(x_a, 3, 28));
    }
    else if (c_t[x_a][channel][i_t] ==  29){
      c_tchannel_opt(x_a,  36, 124,   1,   2,  24, 100, random_manager.get_random(x_a, 2, 29), random_manager.get_random(x_a, 3, 29));
    }
    else if (c_t[x_a][channel][i_t] ==  30){
      c_tchannel_opt(x_a,   0, 112,   2,  13,  48,  64, random_manager.get_random(x_a, 2, 30), random_manager.get_random(x_a, 3, 30));
    }
    else if (c_t[x_a][channel][i_t] ==  31){
      c_tchannel_opt(x_a,  35, 112,   2,  13,  48,  64, random_manager.get_random(x_a, 2, 31), random_manager.get_random(x_a, 3, 31));
    }
    else if (c_t[x_a][channel][i_t] ==  32){
      c_tchannel_opt(x_a,  36, 112,   2,  13,  48,  64, random_manager.get_random(x_a, 2, 32), random_manager.get_random(x_a, 3, 32));
    }
    else if (c_t[x_a][channel][i_t] ==  33){
      c_tchannel_opt(x_a,   0,  88,   2,  37,  24,  64, random_manager.get_random(x_a, 2, 33), random_manager.get_random(x_a, 3, 33));
    }
    else if (c_t[x_a][channel][i_t] ==  34){
      c_tchannel_opt(x_a,  36,  88,   2,  37,  24,  64, random_manager.get_random(x_a, 2, 34), random_manager.get_random(x_a, 3, 34));
    }
    else if (c_t[x_a][channel][i_t] ==  35){
      c_tchannel_opt(x_a,  35,  88,   2,  37,  24,  64, random_manager.get_random(x_a, 2, 35), random_manager.get_random(x_a, 3, 35));
    }
    else if (c_t[x_a][channel][i_t] ==  36){
      c_tchannel_opt(x_a,   0,  76,   2,  49,  12,  64, random_manager.get_random(x_a, 2, 36), random_manager.get_random(x_a, 3, 36));
    }
    else if (c_t[x_a][channel][i_t] ==  37){
      c_tchannel_opt(x_a,  35,  76,   2,  49,  12,  64, random_manager.get_random(x_a, 2, 37), random_manager.get_random(x_a, 3, 37));
    }
    else if (c_t[x_a][channel][i_t] ==  38){
      c_tchannel_opt(x_a,  36,  76,   2,  49,  12,  64, random_manager.get_random(x_a, 2, 38), random_manager.get_random(x_a, 3, 38));
    }
    else if (c_t[x_a][channel][i_t] ==  39){
      c_tchannel_opt(x_a,   0, 100,   2,  25,  36,  64, random_manager.get_random(x_a, 2, 39), random_manager.get_random(x_a, 3, 39));
    }
    else if (c_t[x_a][channel][i_t] ==  40){
      c_tchannel_opt(x_a,  35, 100,   2,  25,  36,  64, random_manager.get_random(x_a, 2, 40), random_manager.get_random(x_a, 3, 40));
    }
    else if (c_t[x_a][channel][i_t] ==  41){
      c_tchannel_opt(x_a,  36, 100,   2,  25,  36,  64, random_manager.get_random(x_a, 2, 41), random_manager.get_random(x_a, 3, 41));
    }
    else if (c_t[x_a][channel][i_t] ==  42){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  48,  76, random_manager.get_random(x_a, 2, 42), random_manager.get_random(x_a, 3, 42));
    }
    else if (c_t[x_a][channel][i_t] ==  43){
      c_tchannel_opt(x_a,  35, 124,   2,   1,  48,  76, random_manager.get_random(x_a, 2, 43), random_manager.get_random(x_a, 3, 43));
    }
    else if (c_t[x_a][channel][i_t] ==  44){
      c_tchannel_opt(x_a,  36, 124,   2,   1,  48,  76, random_manager.get_random(x_a, 2, 44), random_manager.get_random(x_a, 3, 44));
    }
    else if (c_t[x_a][channel][i_t] ==  45){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  24, 100, random_manager.get_random(x_a, 2, 45), random_manager.get_random(x_a, 3, 45));
    }
    else if (c_t[x_a][channel][i_t] ==  46){
      c_tchannel_opt(x_a,  35, 124,   2,   1,  24, 100, random_manager.get_random(x_a, 2, 46), random_manager.get_random(x_a, 3, 46));
    }
    else if (c_t[x_a][channel][i_t] ==  47){
      c_tchannel_opt(x_a,  36, 124,   2,   1,  24, 100, random_manager.get_random(x_a, 2, 47), random_manager.get_random(x_a, 3, 47));
    }
    else if (c_t[x_a][channel][i_t] ==  48){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  12, 112, random_manager.get_random(x_a, 2, 48), random_manager.get_random(x_a, 3, 48));
    }
    else if (c_t[x_a][channel][i_t] ==  49){
      c_tchannel_opt(x_a,  35, 124,   2,   1,  12, 112, random_manager.get_random(x_a, 2, 49), random_manager.get_random(x_a, 3, 49));
    }
    else if (c_t[x_a][channel][i_t] ==  50){
      c_tchannel_opt(x_a,  36, 124,   2,   1,  12, 112, random_manager.get_random(x_a, 2, 50), random_manager.get_random(x_a, 3, 50));
    }
    else if (c_t[x_a][channel][i_t] ==  51){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  36,  88, random_manager.get_random(x_a, 2, 51), random_manager.get_random(x_a, 3, 51));
    }
    else if (c_t[x_a][channel][i_t] ==  52){
      c_tchannel_opt(x_a,  36, 124,   2,   1,  36,  88, random_manager.get_random(x_a, 2, 52), random_manager.get_random(x_a, 3, 52));
    }
    else if (c_t[x_a][channel][i_t] ==  53){
      c_tchannel_opt(x_a,  35, 124,   2,   1,  36,  88, random_manager.get_random(x_a, 2, 53), random_manager.get_random(x_a, 3, 53));
    }
    else if (c_t[x_a][channel][i_t] ==  54){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  48,  12, random_manager.get_random(x_a, 2, 54), random_manager.get_random(x_a, 3, 54));
    }
    else if (c_t[x_a][channel][i_t] ==  55){
      c_tchannel_opt(x_a,  35,  60,   2,  65,  48,  12, random_manager.get_random(x_a, 2, 55), random_manager.get_random(x_a, 3, 55));
    }
    else if (c_t[x_a][channel][i_t] ==  56){
      c_tchannel_opt(x_a,  36,  60,   2,  65,  48,  12, random_manager.get_random(x_a, 2, 56), random_manager.get_random(x_a, 3, 56));
    }
    else if (c_t[x_a][channel][i_t] ==  57){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  24,  36, random_manager.get_random(x_a, 2, 57), random_manager.get_random(x_a, 3, 57));
    }
    else if (c_t[x_a][channel][i_t] ==  58){
      c_tchannel_opt(x_a,  35,  60,   2,  65,  24,  36, random_manager.get_random(x_a, 2, 58), random_manager.get_random(x_a, 3, 58));
    }
    else if (c_t[x_a][channel][i_t] ==  59){
      c_tchannel_opt(x_a,  36,  60,   2,  65,  24,  36, random_manager.get_random(x_a, 2, 59), random_manager.get_random(x_a, 3, 59));
    }
    else if (c_t[x_a][channel][i_t] ==  60){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  12,  48, random_manager.get_random(x_a, 2, 60), random_manager.get_random(x_a, 3, 60));
    }
    else if (c_t[x_a][channel][i_t] ==  61){
      c_tchannel_opt(x_a,  35,  60,   2,  65,  12,  48, random_manager.get_random(x_a, 2, 61), random_manager.get_random(x_a, 3, 61));
    }
    else if (c_t[x_a][channel][i_t] ==  62){
      c_tchannel_opt(x_a,  36,  60,   2,  65,  12,  48, random_manager.get_random(x_a, 2, 62), random_manager.get_random(x_a, 3, 62));
    }
    else if (c_t[x_a][channel][i_t] ==  63){
      c_tchannel_opt(x_a,   0,  60,   2,  65,  36,  24, random_manager.get_random(x_a, 2, 63), random_manager.get_random(x_a, 3, 63));
    }
    else if (c_t[x_a][channel][i_t] ==  64){
      c_tchannel_opt(x_a,  36,  60,   2,  65,  36,  24, random_manager.get_random(x_a, 2, 64), random_manager.get_random(x_a, 3, 64));
    }
    else if (c_t[x_a][channel][i_t] ==  65){
      c_tchannel_opt(x_a,  35,  60,   2,  65,  36,  24, random_manager.get_random(x_a, 2, 65), random_manager.get_random(x_a, 3, 65));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  56,  32,  24, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  24,   8,  16, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  28,   4,  24, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  44,  32,  12, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  52,  16,  36, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
    else if (c_d[x_a][channel][i_d] ==  15){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 15), random_manager.get_random(x_a, 5, 15));
    }
    else if (c_d[x_a][channel][i_d] ==  16){
      c_decay(x_a,  60,  12,  48, random_manager.get_random(x_a, 4, 16), random_manager.get_random(x_a, 5, 16));
    }
    else if (c_d[x_a][channel][i_d] ==  17){
      c_decay(x_a,  60,  36,  24, random_manager.get_random(x_a, 4, 17), random_manager.get_random(x_a, 5, 17));
    }
    else if (c_d[x_a][channel][i_d] ==  18){
      c_decay(x_a, 124,  64,  60, random_manager.get_random(x_a, 4, 18), random_manager.get_random(x_a, 5, 18));
    }
    else if (c_d[x_a][channel][i_d] ==  19){
      c_decay(x_a, 124,  12, 112, random_manager.get_random(x_a, 4, 19), random_manager.get_random(x_a, 5, 19));
    }
    else if (c_d[x_a][channel][i_d] ==  20){
      c_decay(x_a, 112,  64,  48, random_manager.get_random(x_a, 4, 20), random_manager.get_random(x_a, 5, 20));
    }
    else if (c_d[x_a][channel][i_d] ==  21){
      c_decay(x_a, 124,  36,  88, random_manager.get_random(x_a, 4, 21), random_manager.get_random(x_a, 5, 21));
    }
    else if (c_d[x_a][channel][i_d] ==  22){
      c_decay(x_a,  88,  64,  24, random_manager.get_random(x_a, 4, 22), random_manager.get_random(x_a, 5, 22));
    }
    else if (c_d[x_a][channel][i_d] ==  23){
      c_decay(x_a, 124,  48,  76, random_manager.get_random(x_a, 4, 23), random_manager.get_random(x_a, 5, 23));
    }
    else if (c_d[x_a][channel][i_d] ==  24){
      c_decay(x_a,  76,  64,  12, random_manager.get_random(x_a, 4, 24), random_manager.get_random(x_a, 5, 24));
    }
    else if (c_d[x_a][channel][i_d] ==  25){
      c_decay(x_a, 124,  24, 100, random_manager.get_random(x_a, 4, 25), random_manager.get_random(x_a, 5, 25));
    }
    else if (c_d[x_a][channel][i_d] ==  26){
      c_decay(x_a, 100,  64,  36, random_manager.get_random(x_a, 4, 26), random_manager.get_random(x_a, 5, 26));
    }
  }

  /*
  if      (channel ==    0){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    1){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    2){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==    3){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==    4){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==    5){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==    6){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==    7){ac_channel_4yyv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==    8){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==    9){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==   10){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==   11){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==   12){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   13){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   14){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   15){ac_channel_4yyv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==   16){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   17){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   18){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   19){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==   20){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   21){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   22){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==   23){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==   24){ac_channel_4yyv1(r, 1, 2, 32, 16, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   25){ac_channel_4yyv1(r, 1, 2, 32, 16, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   26){ac_channel_4yyv1(r, 1, 2, 32, 16, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==   27){ac_channel_4yyv1(r, 1, 2, 32, 16, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==   28){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   29){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   30){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==   31){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==   32){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   33){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   34){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==   35){ac_channel_4yyv1(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==   36){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==   37){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==   38){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==   39){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==   40){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   41){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   42){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   43){ac_channel_4yyv1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==   44){ac_channel_4yyv1(r, 1, 2, 16, 8, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   45){ac_channel_4yyv1(r, 1, 2, 16, 8, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   46){ac_channel_4yyv1(r, 1, 2, 16, 8, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   47){ac_channel_4yyv1(r, 1, 2, 16, 8, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==   48){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   49){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   50){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,   0, psi);}
  else if (channel ==   51){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==   52){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,   0, psi);}
  else if (channel ==   53){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==   54){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,   0, psi);}
  else if (channel ==   55){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  35, psi);}
  else if (channel ==   56){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  36, psi);}
  else if (channel ==   57){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==   58){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==   59){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,   0, psi);}
  else if (channel ==   60){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==   61){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,   0, psi);}
  else if (channel ==   62){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==   63){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==   64){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==   65){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==   66){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==   67){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==   68){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==   69){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  35, psi);}
  else if (channel ==   70){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  36, psi);}
  else if (channel ==   71){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,   0, psi);}
  else if (channel ==   72){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  35, psi);}
  else if (channel ==   73){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  36, psi);}
  else if (channel ==   74){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==   75){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==   76){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,   0, psi);}
  else if (channel ==   77){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==   78){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,   0, psi);}
  else if (channel ==   79){ac_channel_42vv1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==   80){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   81){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   82){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==   83){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==   84){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   85){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==   86){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==   87){ac_channel_5yyyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==   88){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==   89){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==   90){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==   91){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==   92){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   93){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   94){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   95){ac_channel_5yyyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==   96){ac_channel_5yyyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   97){ac_channel_5yyyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==   98){ac_channel_5yyyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==   99){ac_channel_5yyyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  100){ac_channel_5yyyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  101){ac_channel_5yyyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  102){ac_channel_5yyyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  103){ac_channel_5yyyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  104){ac_channel_5yyyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  105){ac_channel_5yyyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  106){ac_channel_5yyyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  107){ac_channel_5yyyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  108){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  109){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  110){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==  111){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==  112){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  113){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  114){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  115){ac_channel_5yyyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  116){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  117){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  118){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==  119){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==  120){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  121){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  122){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  123){ac_channel_5yyyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  124){ac_channel_5yyyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  125){ac_channel_5yyyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  126){ac_channel_5yyyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  127){ac_channel_5yyyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  128){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  129){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  130){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,   0, psi);}
  else if (channel ==  131){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  132){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,   0, psi);}
  else if (channel ==  133){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  134){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,   0, psi);}
  else if (channel ==  135){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  35, psi);}
  else if (channel ==  136){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  36, psi);}
  else if (channel ==  137){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  138){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  139){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,   0, psi);}
  else if (channel ==  140){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  141){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,   0, psi);}
  else if (channel ==  142){ac_channel_5y2vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  143){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  144){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  145){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  146){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  147){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==  148){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==  149){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  35, psi);}
  else if (channel ==  150){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  36, psi);}
  else if (channel ==  151){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,   0, psi);}
  else if (channel ==  152){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  35, psi);}
  else if (channel ==  153){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  36, psi);}
  else if (channel ==  154){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  155){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  156){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,   0, psi);}
  else if (channel ==  157){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  158){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,   0, psi);}
  else if (channel ==  159){ac_channel_5y2vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  160){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  161){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  162){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  163){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  164){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,   0,   0, psi);}
  else if (channel ==  165){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,   0,  35, psi);}
  else if (channel ==  166){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,   0, psi);}
  else if (channel ==  167){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,  35, psi);}
  else if (channel ==  168){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0,   0, psi);}
  else if (channel ==  169){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0,  36, psi);}
  else if (channel ==  170){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,   0, psi);}
  else if (channel ==  171){ac_channel_52vyv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,  36, psi);}
  else if (channel ==  172){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  173){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  174){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,   0, psi);}
  else if (channel ==  175){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,  35, psi);}
  else if (channel ==  176){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,   0, psi);}
  else if (channel ==  177){ac_channel_52vyv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,  36, psi);}
  else if (channel ==  178){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23,   0, psi);}
  else if (channel ==  179){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23,   0, psi);}
  else if (channel ==  180){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  35,  23,   0, psi);}
  else if (channel ==  181){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  35,  23,  35, psi);}
  else if (channel ==  182){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  23,   0, psi);}
  else if (channel ==  183){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  23,  36, psi);}
  else if (channel ==  184){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  185){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  186){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,   0, psi);}
  else if (channel ==  187){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,  35, psi);}
  else if (channel ==  188){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,   0, psi);}
  else if (channel ==  189){ac_channel_52vyv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,  36, psi);}
  else if (channel ==  190){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  191){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  192){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,   0, psi);}
  else if (channel ==  193){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,  36, psi);}
  else if (channel ==  194){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,   0, psi);}
  else if (channel ==  195){ac_channel_52vyv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,  35, psi);}
  else if (channel ==  196){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  197){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  198){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==  199){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==  200){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  201){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  202){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  203){ac_channel_14yyv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  204){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  205){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  206){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==  207){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==  208){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  209){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  210){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  211){ac_channel_14yyv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  212){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  213){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  214){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  215){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  216){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  217){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  218){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  219){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  220){ac_channel_14yyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  221){ac_channel_14yyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  222){ac_channel_14yyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  223){ac_channel_14yyv(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  224){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  225){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  226){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==  227){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==  228){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  229){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  230){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  35, psi);}
  else if (channel ==  231){ac_channel_14yyv(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,  36, psi);}
  else if (channel ==  232){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  233){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,   0, psi);}
  else if (channel ==  234){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  35, psi);}
  else if (channel ==  235){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,   0,  36, psi);}
  else if (channel ==  236){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  237){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  238){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  239){ac_channel_14yyv(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  240){ac_channel_14yyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  241){ac_channel_14yyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,   0, psi);}
  else if (channel ==  242){ac_channel_14yyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  35, psi);}
  else if (channel ==  243){ac_channel_14yyv(r, 1, 2, 64, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  23,  36, psi);}
  else if (channel ==  244){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  245){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  246){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,   0, psi);}
  else if (channel ==  247){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  248){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,   0, psi);}
  else if (channel ==  249){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  250){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,   0, psi);}
  else if (channel ==  251){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  35, psi);}
  else if (channel ==  252){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  25,  36, psi);}
  else if (channel ==  253){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  254){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  255){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,   0, psi);}
  else if (channel ==  256){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  257){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,   0, psi);}
  else if (channel ==  258){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  259){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  260){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  261){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  262){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  263){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==  264){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,   0, psi);}
  else if (channel ==  265){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  35, psi);}
  else if (channel ==  266){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  23,  36, psi);}
  else if (channel ==  267){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,   0, psi);}
  else if (channel ==  268){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  35, psi);}
  else if (channel ==  269){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  25,  36, psi);}
  else if (channel ==  270){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  271){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  272){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,   0, psi);}
  else if (channel ==  273){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  274){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,   0, psi);}
  else if (channel ==  275){ac_channel_142vv(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  276){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  277){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==  278){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==  279){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  280){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  281){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  282){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  283){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  35, psi);}
  else if (channel ==  284){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  36, psi);}
  else if (channel ==  285){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  286){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  287){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  288){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  289){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  290){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  291){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  292){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  35, psi);}
  else if (channel ==  293){ac_channel_2v2v1(r, 1, 2, 4, 32, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  36, psi);}
  else if (channel ==  294){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  295){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,  35, psi);}
  else if (channel ==  296){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,  36, psi);}
  else if (channel ==  297){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  298){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  35,  35, psi);}
  else if (channel ==  299){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36,  36, psi);}
  else if (channel ==  300){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  301){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  35, psi);}
  else if (channel ==  302){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  36, psi);}
  else if (channel ==  303){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  304){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  305){ac_channel_2v2v1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  306){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  307){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  308){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  309){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  310){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  36, psi);}
  else if (channel ==  311){ac_channel_2v2v1(r, 1, 2, 8, 16, 4, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  35, psi);}
  else if (channel ==  312){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  313){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  314){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,   0,  35, psi);}
  else if (channel ==  315){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,  35, psi);}
  else if (channel ==  316){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,   0,  36, psi);}
  else if (channel ==  317){ac_channel_2v3yv(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,  36, psi);}
  else if (channel ==  318){ac_channel_2v3yv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  319){ac_channel_2v3yv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,  36, psi);}
  else if (channel ==  320){ac_channel_2v3yv(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,  35, psi);}
  else if (channel ==  321){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,  23,   0, psi);}
  else if (channel ==  322){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  35,  23,  35, psi);}
  else if (channel ==  323){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,  23,  36, psi);}
  else if (channel ==  324){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  23,   0, psi);}
  else if (channel ==  325){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  35,  23,  35, psi);}
  else if (channel ==  326){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  36,  23,  36, psi);}
  else if (channel ==  327){ac_channel_2v3yv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,   0,  24,   0, psi);}
  else if (channel ==  328){ac_channel_2v3yv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  35,  24,  35, psi);}
  else if (channel ==  329){ac_channel_2v3yv(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  36,  24,  36, psi);}
  else if (channel ==  330){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  331){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  332){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  333){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  334){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  335){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  336){ac_channel_2v12v(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  337){ac_channel_2v12v(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  338){ac_channel_2v12v(r, 1, 2, 4, 32, 64, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  339){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  340){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  35,  35, psi);}
  else if (channel ==  341){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36,  36, psi);}
  else if (channel ==  342){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  343){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  344){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  345){ac_channel_2v12v(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  346){ac_channel_2v12v(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  347){ac_channel_2v12v(r, 1, 2, 8, 16, 64, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  348){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  349){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  350){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  351){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  352){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  353){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  354){ac_channel_3yv2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  355){ac_channel_3yv2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  356){ac_channel_3yv2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  357){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  358){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  35,  35, psi);}
  else if (channel ==  359){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36,  36, psi);}
  else if (channel ==  360){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  361){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  362){ac_channel_3yv2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  363){ac_channel_3yv2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  364){ac_channel_3yv2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  36, psi);}
  else if (channel ==  365){ac_channel_3yv2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  35, psi);}
  else if (channel ==  366){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  367){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  35, psi);}
  else if (channel ==  368){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,  36, psi);}
  else if (channel ==  369){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  370){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  35,  35, psi);}
  else if (channel ==  371){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,  36,  36, psi);}
  else if (channel ==  372){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  373){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  35, psi);}
  else if (channel ==  374){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  36, psi);}
  else if (channel ==  375){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  376){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  377){ac_channel_12v2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  378){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  379){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  380){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  381){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  382){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  36, psi);}
  else if (channel ==  383){ac_channel_12v2v(r, 1, 2, 64, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  35, psi);}
  else if (channel ==  384){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  385){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,  35, psi);}
  else if (channel ==  386){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,  36, psi);}
  else if (channel ==  387){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  388){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  35,  35, psi);}
  else if (channel ==  389){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,  36,  36, psi);}
  else if (channel ==  390){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  391){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  35, psi);}
  else if (channel ==  392){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,  36, psi);}
  else if (channel ==  393){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,   0,   0, psi);}
  else if (channel ==  394){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  35,  35, psi);}
  else if (channel ==  395){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,  23,  36,  36, psi);}
  else if (channel ==  396){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  397){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  36, psi);}
  else if (channel ==  398){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,  35, psi);}
  else if (channel ==  399){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,   0,   0, psi);}
  else if (channel ==  400){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  36,  35, psi);}
  else if (channel ==  401){ac_channel_12v2v(r, 1, 2, 64, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  24,  24,  35,  36, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
