#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_040_aa_emepvmvmx(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_040_aa_emepvmvmx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smin[x_a][  1] = {   0,    5,    3}; //   3
  needed_v_smin[x_a][  2] = {   1,    4,    2}; //   3

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smax[x_a][  1] = {   0,    5,    3}; //   3
  needed_v_smax[x_a][  2] = {   1,    4,    2}; //   3

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][2] = {   2,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][4] = {   3,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");

  g_d[x_a].resize(3);
  needed_g_d[x_a].resize(3);
  needed_g_d[x_a][0] = {   0,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   1,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");

  c_p[x_a].resize(6);
  c_f[x_a].resize(6);
  c_t[x_a].resize(6);
  c_d[x_a].resize(6);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   2}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  2,   1}; //   2

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  1}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  4,   5}; //   2
  c_d[x_a][3] = {  1}; //   1

  c_p[x_a][4] = {  0,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  2,   1}; //   2

  c_p[x_a][5] = {  0,   1}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  4}; //   1
  c_d[x_a][5] = {  0,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv1(1, 2, 4, 16, 32, 8;  23,   0,   0)
// channel    1: 3yv1(1, 2, 8, 16, 32, 4;  23,   0,   0)
// channel    2: 12v1(1, 2, 4, 16, 32, 8;  23,   0,   0)
// channel    3: 12v1(1, 2, 8, 16, 32, 4;  23,   0,   0)
// channel    4: 13yv(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    5: 13yv(1, 2, 8, 4, 16, 32;  23,   0,   0)
