#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_240_uc_emepvmvmxuc(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_240_uc_emepvmvmxuc");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(27);
  needed_v_smin[x_a].resize(27);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  56
  needed_v_smin[x_a][  1] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    8,    9,   12,   13,   14,   15,   18,   19,   22,   23,   24,   25,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smin[x_a][  4] = {   2,    8,   18,   28}; //   4
  needed_v_smin[x_a][  5] = {   2,    8,   18,   28}; //   4
  needed_v_smin[x_a][  6] = {   3,    9,   19,   29}; //   4
  needed_v_smin[x_a][  7] = {   3,    9,   19,   29}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  needed_v_smin[x_a][ 10] = {   6,    7,    8,    9,   10,   11,    0,    1,    2,    3,    4,    5}; //  12
  needed_v_smin[x_a][ 11] = {  12,   13,   36,   37,   50,   51,   54,   55,   32,   33}; //  10
  needed_v_smin[x_a][ 12] = {  12,   13,   32,   33,   36,   37}; //   6
  needed_v_smin[x_a][ 13] = {  14,   15,   38,   39,   48,   49,   52,   53,   34,   35}; //  10
  needed_v_smin[x_a][ 14] = {  14,   15,   34,   35,   38,   39}; //   6
  needed_v_smin[x_a][ 15] = {  16,   17,   18,   19,   20,   21,   26,   27,   28,   29,   30,   31}; //  12
  needed_v_smin[x_a][ 16] = {  22,   23,   40,   41,   48,   49,   58,   59,   62,   63}; //  10
  needed_v_smin[x_a][ 17] = {  22,   23,   58,   59,   62,   63}; //   6
  needed_v_smin[x_a][ 18] = {  24,   25,   42,   43,   50,   51,   56,   57,   60,   61}; //  10
  needed_v_smin[x_a][ 19] = {  24,   25,   56,   57,   60,   61}; //   6
  needed_v_smin[x_a][ 20] = {  40,   41}; //   2
  needed_v_smin[x_a][ 21] = {  42,   43}; //   2
  needed_v_smin[x_a][ 22] = {  44,   45,   46,   47}; //   4
  needed_v_smin[x_a][ 23] = {  44,   45}; //   2
  needed_v_smin[x_a][ 24] = {  46,   47}; //   2
  needed_v_smin[x_a][ 25] = {  52,   53}; //   2
  needed_v_smin[x_a][ 26] = {  54,   55}; //   2

  v_smax[x_a].resize(28);
  needed_v_smax[x_a].resize(28);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  36
  needed_v_smax[x_a][  1] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  3] = {   2,    3,    8,    9,   14,   15,   18,   19,   24,   25,   28,   29,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  28
  needed_v_smax[x_a][  4] = {   2,    8,   18,   28}; //   4
  needed_v_smax[x_a][  5] = {   3,    9,   19,   29}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,    0,    1,    2,    3,    4,    5,   32,   33,   34,   35,   36,   37,   38,   39}; //  24
  needed_v_smax[x_a][  8] = {  12,   13,   36,   37}; //   4
  needed_v_smax[x_a][  9] = {  12,   13,   36,   37}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15,   38,   39}; //   4
  needed_v_smax[x_a][ 11] = {  14,   15,   38,   39}; //   4
  needed_v_smax[x_a][ 12] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  needed_v_smax[x_a][ 13] = {  22,   23,   40,   41,   48,   49}; //   6
  needed_v_smax[x_a][ 14] = {  22,   23,   40,   41,   48,   49}; //   6
  needed_v_smax[x_a][ 15] = {  24,   25,   42,   43,   50,   51}; //   6
  needed_v_smax[x_a][ 16] = {  24,   25,   42,   43,   50,   51}; //   6
  needed_v_smax[x_a][ 17] = {  32,   33,   44,   45,   52,   53,   56,   57,   60,   61}; //  10
  needed_v_smax[x_a][ 18] = {  34,   35,   46,   47,   54,   55,   58,   59,   62,   63}; //  10
  needed_v_smax[x_a][ 19] = {  48,   49}; //   2
  needed_v_smax[x_a][ 20] = {  50,   51}; //   2
  needed_v_smax[x_a][ 21] = {  52,   53,   34,   35}; //   4
  needed_v_smax[x_a][ 22] = {  54,   55,   32,   33}; //   4
  needed_v_smax[x_a][ 23] = {  56,   57,   60,   61}; //   4
  needed_v_smax[x_a][ 24] = {  58,   59,   62,   63}; //   4
  needed_v_smax[x_a][ 25] = {  40,   41,   44,   45,   54,   55}; //   6
  needed_v_smax[x_a][ 26] = {  42,   43,   46,   47,   52,   53}; //   6
  needed_v_smax[x_a][ 27] = {  44,   45,   46,   47}; //   4

  g_p[x_a].resize(38);
  needed_g_p[x_a].resize(38);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   20,   21,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  36
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6,   16,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    7,   17,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    8,    9,   15,   18,   19,   25,   28,   29,   35,   39,   43,   47,   51,   55,   59,   63}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    8,   18,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,    8,   18,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   10,   20,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   11,   21,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][13] = {  12,   13,   36,   37}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][14] = {  12,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][15] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax7");
  needed_g_p[x_a][16] = {  13,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax9");
  needed_g_p[x_a][17] = {  14,   24,   34,   38,   42,   46,   50,   54,   58,   62}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][18] = {  14,   15,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][19] = {  14,   15,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][20] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][21] = {  16,   17,   18,   19,   20,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][22] = {  22,   23,   40,   41,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][23] = {  22,   40,   48}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax14");
  needed_g_p[x_a][24] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax12");
  needed_g_p[x_a][25] = {  23,   41,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax14");
  needed_g_p[x_a][26] = {  24,   25,   42,   43,   50,   51}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax15");
  needed_g_p[x_a][27] = {  24,   25,   42,   43,   50,   51}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][28] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax12");
  needed_g_p[x_a][29] = {  32,   44,   52,   56,   60}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax17");
  needed_g_p[x_a][30] = {  33,   45,   53,   57,   61}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax17");
  needed_g_p[x_a][31] = {  34,   35,   46,   47,   54,   55,   58,   59,   62,   63}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][32] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax19");
  needed_g_p[x_a][33] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax20");
  needed_g_p[x_a][34] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax21");
  needed_g_p[x_a][35] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax22");
  needed_g_p[x_a][36] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax23");
  needed_g_p[x_a][37] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax24");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][1] = {  26,   27,   28,   29,   30,   31}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax12");
  needed_g_f[x_a][2] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax22");
  needed_g_f[x_a][3] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][4] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][5] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax7");
  needed_g_f[x_a][6] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax25");
  needed_g_f[x_a][7] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax26");
  needed_g_f[x_a][8] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax27");
  needed_g_f[x_a][9] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax25");
  needed_g_f[x_a][10] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax26");
  needed_g_f[x_a][11] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax26");
  needed_g_f[x_a][12] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax25");
  needed_g_f[x_a][13] = {  56,   57,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax12");
  needed_g_f[x_a][14] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax12");
  needed_g_f[x_a][15] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax23");
  needed_g_f[x_a][16] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax24");

  g_t[x_a].resize(26);
  needed_g_t[x_a].resize(26);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   32,   33,   34,   35,   36,   37,   38,   39}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  26,   27,   28,   29,   30,   31}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][5] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][6] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][7] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][8] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][9] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][10] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__140_64");
  needed_g_t[x_a][12] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][13] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][14] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][15] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][16] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][17] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__112_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__112_140");
  needed_g_t[x_a][18] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][19] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][20] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][21] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__112_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__112_128");
  needed_g_t[x_a][22] = {  56,   57,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][23] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][24] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][25] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    6,    7,   16,   17,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  56
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    8,   18,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2,    8,   18,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,    8,    9,   12,   13,   14,   15,   18,   19,   22,   23,   24,   25,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][11] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][12] = {  12,   13,   36,   37,   50,   51,   54,   55}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][13] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][14] = {  14,   15,   38,   39,   48,   49,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][15] = {  16,   17,   18,   19,   20,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][16] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][17] = {  22,   23,   40,   41,   48,   49,   58,   59}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][18] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][19] = {  24,   25,   42,   43,   50,   51,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,   1,   2,  12}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   0,   1,   2}; //   4

  c_p[x_a][7] = {  0,   1,   3,  12}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   0,   1,   2}; //   4

  c_p[x_a][8] = {  4,   5,   6,  12}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 10,   3,   4,   5}; //   4

  c_p[x_a][9] = {  4,   7,   8,  12}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 10,   6,   7,   5}; //   4

  c_p[x_a][10] = {  0,   9,  10,  12}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 10,   8,   9,   2}; //   4

  c_p[x_a][11] = {  0,   9,  11,  12}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 10,   8,   9,   2}; //   4

  c_p[x_a][12] = {  0,  13,  14,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 11,   5,  12,   2}; //   4

  c_p[x_a][13] = {  0,  13,  16,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 11,   5,  12,   2}; //   4

  c_p[x_a][14] = { 17,  18,  19,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 13,   2,  14,   5}; //   4

  c_p[x_a][15] = {  4,  18,  19,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 13,   2,  14,   5}; //   4

  c_p[x_a][16] = {  0,   1,   2,  21}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = { 15,   0,   1,   2}; //   4

  c_p[x_a][17] = {  0,   1,   3,  21}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = { 15,   0,   1,   2}; //   4

  c_p[x_a][18] = {  4,   5,   6,  21}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = { 15,   3,   4,   5}; //   4

  c_p[x_a][19] = {  4,   7,   8,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 15,   6,   7,   5}; //   4

  c_p[x_a][20] = {  0,   9,  10,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = { 15,   8,   9,   2}; //   4

  c_p[x_a][21] = {  0,   9,  11,  21}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = { 15,   8,   9,   2}; //   4

  c_p[x_a][22] = {  0,  22,  23,  24}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 16,   5,  17,   2}; //   4

  c_p[x_a][23] = {  0,  22,  25,  24}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 16,   5,  17,   2}; //   4

  c_p[x_a][24] = { 17,  26,  27,  28}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 18,   2,  19,   5}; //   4

  c_p[x_a][25] = {  4,  26,  27,  28}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 18,   2,  19,   5}; //   4

  c_p[x_a][26] = {  0,   1,   2}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  2,   3}; //   2
  c_d[x_a][26] = {  0,   1,   2}; //   3

  c_p[x_a][27] = {  0,   1,   3}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  2,   3}; //   2
  c_d[x_a][27] = {  0,   1,   2}; //   3

  c_p[x_a][28] = {  4,   5,   6}; //   3
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  2,   3}; //   2
  c_d[x_a][28] = {  3,   4,   5}; //   3

  c_p[x_a][29] = {  4,   7,   8}; //   3
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  2,   3}; //   2
  c_d[x_a][29] = {  6,   7,   5}; //   3

  c_p[x_a][30] = {  0,   9,  10}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  2,   3}; //   2
  c_d[x_a][30] = {  8,   9,   2}; //   3

  c_p[x_a][31] = {  0,   9,  11}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  2,   3}; //   2
  c_d[x_a][31] = {  8,   9,   2}; //   3

  c_p[x_a][32] = {  0,  29}; //   2
  c_f[x_a][32] = {  2,   3}; //   2
  c_t[x_a][32] = {  0,   4,   5}; //   3
  c_d[x_a][32] = {  5,   2}; //   2

  c_p[x_a][33] = {  0,  30}; //   2
  c_f[x_a][33] = {  2,   3}; //   2
  c_t[x_a][33] = {  0,   4,   5}; //   3
  c_d[x_a][33] = {  5,   2}; //   2

  c_p[x_a][34] = { 17,  31}; //   2
  c_f[x_a][34] = {  4,   5}; //   2
  c_t[x_a][34] = {  0,   6,   7}; //   3
  c_d[x_a][34] = {  2,   5}; //   2

  c_p[x_a][35] = {  4,  31}; //   2
  c_f[x_a][35] = {  4,   5}; //   2
  c_t[x_a][35] = {  0,   6,   7}; //   3
  c_d[x_a][35] = {  2,   5}; //   2

  c_p[x_a][36] = {  0,  13,  14}; //   3
  c_f[x_a][36] = {  3}; //   1
  c_t[x_a][36] = {  0,   4}; //   2
  c_d[x_a][36] = {  5,  12,   2}; //   3

  c_p[x_a][37] = {  0,  13,  16}; //   3
  c_f[x_a][37] = {  3}; //   1
  c_t[x_a][37] = {  0,   4}; //   2
  c_d[x_a][37] = {  5,  12,   2}; //   3

  c_p[x_a][38] = { 17,  18,  19}; //   3
  c_f[x_a][38] = {  5}; //   1
  c_t[x_a][38] = {  0,   6}; //   2
  c_d[x_a][38] = {  2,  14,   5}; //   3

  c_p[x_a][39] = {  4,  18,  19}; //   3
  c_f[x_a][39] = {  5}; //   1
  c_t[x_a][39] = {  0,   6}; //   2
  c_d[x_a][39] = {  2,  14,   5}; //   3

  c_p[x_a][40] = {  0,  22,  23}; //   3
  c_f[x_a][40] = {  6}; //   1
  c_t[x_a][40] = {  8,   9}; //   2
  c_d[x_a][40] = {  5,  17,   2}; //   3

  c_p[x_a][41] = {  0,  22,  25}; //   3
  c_f[x_a][41] = {  6}; //   1
  c_t[x_a][41] = {  8,   9}; //   2
  c_d[x_a][41] = {  5,  17,   2}; //   3

  c_p[x_a][42] = { 17,  26,  27}; //   3
  c_f[x_a][42] = {  7}; //   1
  c_t[x_a][42] = { 10,  11}; //   2
  c_d[x_a][42] = {  2,  19,   5}; //   3

  c_p[x_a][43] = {  4,  26,  27}; //   3
  c_f[x_a][43] = {  7}; //   1
  c_t[x_a][43] = { 10,  11}; //   2
  c_d[x_a][43] = {  2,  19,   5}; //   3

  c_p[x_a][44] = {  0,  29}; //   2
  c_f[x_a][44] = {  8,   9}; //   2
  c_t[x_a][44] = {  8,  12,  13}; //   3
  c_d[x_a][44] = {  5,   2}; //   2

  c_p[x_a][45] = {  0,  30}; //   2
  c_f[x_a][45] = {  8,   9}; //   2
  c_t[x_a][45] = {  8,  12,  13}; //   3
  c_d[x_a][45] = {  5,   2}; //   2

  c_p[x_a][46] = { 17,  31}; //   2
  c_f[x_a][46] = {  8,  10}; //   2
  c_t[x_a][46] = { 10,  14,  15}; //   3
  c_d[x_a][46] = {  2,   5}; //   2

  c_p[x_a][47] = {  4,  31}; //   2
  c_f[x_a][47] = {  8,  10}; //   2
  c_t[x_a][47] = { 10,  14,  15}; //   3
  c_d[x_a][47] = {  2,   5}; //   2

  c_p[x_a][48] = {  0,  22,  23,  32}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 16}; //   1
  c_d[x_a][48] = { 14,   5,  17,   2}; //   4

  c_p[x_a][49] = {  0,  22,  25,  32}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 16}; //   1
  c_d[x_a][49] = { 14,   5,  17,   2}; //   4

  c_p[x_a][50] = { 17,  26,  27,  33}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 17}; //   1
  c_d[x_a][50] = { 12,   2,  19,   5}; //   4

  c_p[x_a][51] = {  4,  26,  27,  33}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 17}; //   1
  c_d[x_a][51] = { 12,   2,  19,   5}; //   4

  c_p[x_a][52] = {  0,  29,  34}; //   3
  c_f[x_a][52] = { 11}; //   1
  c_t[x_a][52] = { 18,  19}; //   2
  c_d[x_a][52] = { 14,   5,   2}; //   3

  c_p[x_a][53] = {  0,  30,  34}; //   3
  c_f[x_a][53] = { 11}; //   1
  c_t[x_a][53] = { 18,  19}; //   2
  c_d[x_a][53] = { 14,   5,   2}; //   3

  c_p[x_a][54] = { 17,  31,  35}; //   3
  c_f[x_a][54] = { 12}; //   1
  c_t[x_a][54] = { 20,  21}; //   2
  c_d[x_a][54] = { 12,   2,   5}; //   3

  c_p[x_a][55] = {  4,  31,  35}; //   3
  c_f[x_a][55] = { 12}; //   1
  c_t[x_a][55] = { 20,  21}; //   2
  c_d[x_a][55] = { 12,   2,   5}; //   3

  c_p[x_a][56] = {  0,  29,  36}; //   3
  c_f[x_a][56] = { 13}; //   1
  c_t[x_a][56] = {  2,  22}; //   2
  c_d[x_a][56] = { 19,   5,   2}; //   3

  c_p[x_a][57] = {  0,  30,  36}; //   3
  c_f[x_a][57] = { 13}; //   1
  c_t[x_a][57] = {  2,  22}; //   2
  c_d[x_a][57] = { 19,   5,   2}; //   3

  c_p[x_a][58] = { 17,  31,  37}; //   3
  c_f[x_a][58] = { 14}; //   1
  c_t[x_a][58] = {  2,  23}; //   2
  c_d[x_a][58] = { 17,   2,   5}; //   3

  c_p[x_a][59] = {  4,  31,  37}; //   3
  c_f[x_a][59] = { 14}; //   1
  c_t[x_a][59] = {  2,  23}; //   2
  c_d[x_a][59] = { 17,   2,   5}; //   3

  c_p[x_a][60] = {  0,  29}; //   2
  c_f[x_a][60] = { 15,  13}; //   2
  c_t[x_a][60] = {  2,  22,  24}; //   3
  c_d[x_a][60] = {  5,   2}; //   2

  c_p[x_a][61] = {  0,  30}; //   2
  c_f[x_a][61] = { 15,  13}; //   2
  c_t[x_a][61] = {  2,  22,  24}; //   3
  c_d[x_a][61] = {  5,   2}; //   2

  c_p[x_a][62] = { 17,  31}; //   2
  c_f[x_a][62] = { 16,  14}; //   2
  c_t[x_a][62] = {  2,  23,  25}; //   3
  c_d[x_a][62] = {  2,   5}; //   2

  c_p[x_a][63] = {  4,  31}; //   2
  c_f[x_a][63] = { 16,  14}; //   2
  c_t[x_a][63] = {  2,  23,  25}; //   3
  c_d[x_a][63] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,  23,   0,   0)
// channel    2: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  23,   0,   0)
// channel    3: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  23,   0,   0)
// channel    4: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel    5: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  23,   0,  23,   0,   0)
// channel    6: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,   0,   0,   0)
// channel    7: 5yyyv1(1, 2, 64, 4, 8, 16, 32, 128;  23,   0,  23,   0,   0)
// channel    8: 5yyyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  23,   0,   0)
// channel    9: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   10: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   11: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   12: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   13: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   14: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
// channel   15: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   16: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   17: 15yyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
// channel   18: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
// channel   19: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
// channel   20: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
// channel   21: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
// channel   22: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   23: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
// channel   24: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
// channel   25: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
// channel   26: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   27: 114yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
// channel   28: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
// channel   29: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
// channel   30: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
// channel   31: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
// channel   32: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,   0,   0,   0,   0)
// channel   33: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  23,  23,   0,   0,   0)
// channel   34: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,   0,   0)
// channel   35: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  23,   0,   0,   0)
// channel   36: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,   0,   0,   0)
// channel   37: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  23,   0,  23,   0,   0)
// channel   38: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  23,   0,   0)
// channel   39: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  23,   0,   0)
// channel   40: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   41: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
// channel   42: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
// channel   43: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
// channel   44: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   45: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  23,  23,   0,   0,   0)
// channel   46: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  23,   0,   0,   0)
// channel   47: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  23,   0,   0,   0)
// channel   48: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   49: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
// channel   50: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
// channel   51: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
// channel   52: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
// channel   53: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   0,   0,   0)
// channel   54: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   0,   0,   0)
// channel   55: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   0,   0,   0)
// channel   56: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   57: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
// channel   58: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
// channel   59: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
// channel   60: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
// channel   61: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
// channel   62: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
// channel   63: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
