#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_050_bbx_emepvmvmxa(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_050_bbx_emepvmvmxa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51}; //  44
  needed_v_smin[x_a][  1] = {   0,    1,    7,    8,   19,   20,   25,   26}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   25,   26}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,    6,   27,   28,   31,   32,   33,   34,   35,   40,   41,   42,   43,   48,   49,   50,   51}; //  18
  needed_v_smin[x_a][  4] = {   2,   27}; //   2
  needed_v_smin[x_a][  5] = {   2,   27}; //   2
  needed_v_smin[x_a][  6] = {   3,   28}; //   2
  needed_v_smin[x_a][  7] = {   3,   28}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   11,   12,   22,   23,   29,   30}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,   29,   30}; //   4
  needed_v_smin[x_a][ 10] = {   6,   31,   32,   33,   34,   35,   48,   49,   50,   51}; //  10
  needed_v_smin[x_a][ 11] = {   7,    8}; //   2
  needed_v_smin[x_a][ 12] = {   9,   10,   15,   16,   21,   22,   23,   36,   37,   44,   45}; //  11
  needed_v_smin[x_a][ 13] = {   9,   10,   21,   36,   37,   44,   45}; //   7
  needed_v_smin[x_a][ 14] = {   9,   13}; //   2
  needed_v_smin[x_a][ 15] = {  10,   14}; //   2
  needed_v_smin[x_a][ 16] = {  11,   12}; //   2
  needed_v_smin[x_a][ 17] = {  13,   14,   17,   18,   19,   20,   24,   38,   39,   46,   47}; //  11
  needed_v_smin[x_a][ 18] = {  13,   14,   24,   38,   39,   46,   47}; //   7
  needed_v_smin[x_a][ 19] = {  15,   16}; //   2
  needed_v_smin[x_a][ 20] = {  17,   18}; //   2
  needed_v_smin[x_a][ 21] = {  40,   41}; //   2
  needed_v_smin[x_a][ 22] = {  42,   43}; //   2

  v_smax[x_a].resize(23);
  needed_v_smax[x_a].resize(23);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   20,   22,   23,   25,   26,   29,   30,   31,   32,   33,   40,   41,   44,   45,   46,   47,   48,   49}; //  32
  needed_v_smax[x_a][  1] = {   0,    1,    7,    8,   19,   20,   25,   26}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   48,   49,   50,   51}; //  22
  needed_v_smax[x_a][  3] = {   2,    3,   27,   28,   34,   35,   42,   43,   50,   51}; //  10
  needed_v_smax[x_a][  4] = {   2,   27}; //   2
  needed_v_smax[x_a][  5] = {   3,   28}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   11,   12,   22,   23,   29,   30}; //   8
  needed_v_smax[x_a][  7] = {   6,   31,   32,   33,   40,   41,   48,   49}; //   8
  needed_v_smax[x_a][  8] = {   7,    8,   15,   16}; //   4
  needed_v_smax[x_a][  9] = {   9,   10,   21,   36,   37}; //   5
  needed_v_smax[x_a][ 10] = {   9,   10,   13,   14,   21,   24,   36,   37,   38,   39}; //  10
  needed_v_smax[x_a][ 11] = {   9,   13}; //   2
  needed_v_smax[x_a][ 12] = {  10,   14}; //   2
  needed_v_smax[x_a][ 13] = {  11,   12,   17,   18}; //   4
  needed_v_smax[x_a][ 14] = {  13,   14,   24,   38,   39}; //   5
  needed_v_smax[x_a][ 15] = {  15,   16,   44,   45}; //   4
  needed_v_smax[x_a][ 16] = {  17,   18,   46,   47}; //   4
  needed_v_smax[x_a][ 17] = {  19,   20}; //   2
  needed_v_smax[x_a][ 18] = {  21,   24,   36,   37,   38,   39}; //   6
  needed_v_smax[x_a][ 19] = {  22,   23}; //   2
  needed_v_smax[x_a][ 20] = {  34,   35,   42,   43,   50,   51}; //   6
  needed_v_smax[x_a][ 21] = {  44,   45,   46,   47,   42,   43}; //   6
  needed_v_smax[x_a][ 22] = {  40,   41}; //   2

  g_p[x_a].resize(38);
  needed_g_p[x_a].resize(38);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   20,   22,   23,   25,   26,   29,   30,   31,   32,   33,   40,   41,   44,   45,   46,   47,   48,   49}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    7,    8,   19,   20,   25,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,   27,   28,   35,   43,   51}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5,   11,   12,   22,   23,   29,   30}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,   31,   33,   41,   49}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][13] = {   6,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][14] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][15] = {   9,   10,   21,   36,   37}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][16] = {   9,   10,   21,   37}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax10");
  needed_g_p[x_a][17] = {   9,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][18] = {  10,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][19] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][20] = {  13,   14,   24,   38,   39}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax14");
  needed_g_p[x_a][21] = {  13,   14,   24,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin18_smax10");
  needed_g_p[x_a][22] = {  15,   16,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax15");
  needed_g_p[x_a][23] = {  15,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax8");
  needed_g_p[x_a][24] = {  17,   18,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax16");
  needed_g_p[x_a][25] = {  17,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax13");
  needed_g_p[x_a][26] = {  19,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][27] = {  21,   24,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][28] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax19");
  needed_g_p[x_a][29] = {  32,   40,   48}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][30] = {  34,   42,   50}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][31] = {  34,   35,   42,   43,   50,   51}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][32] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][33] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax10");
  needed_g_p[x_a][34] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax21");
  needed_g_p[x_a][35] = {  45}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin13_smax21");
  needed_g_p[x_a][36] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax21");
  needed_g_p[x_a][37] = {  47}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin18_smax21");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  32,   33,   34,   35,   48,   49,   50,   51}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax22");
  needed_g_f[x_a][2] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax21");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,   32,   33,   34,   35}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][1] = {  25,   26,   27,   28,   29,   30,   31,   48,   49,   50,   51}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_60");
  needed_g_t[x_a][2] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__12_48");
  needed_g_t[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_66__48_12");
  needed_g_t[x_a][4] = {  36,   37,   38,   39,   42,   43}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_76");
  needed_g_t[x_a][5] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__12_112");
  needed_g_t[x_a][6] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_13__48_64");
  needed_g_t[x_a][7] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_49__12_64");
  needed_g_t[x_a][8] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__48_76");
  needed_g_t[x_a][9] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__48_12");
  needed_g_t[x_a][10] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__12_48");

  g_d[x_a].resize(28);
  needed_g_d[x_a].resize(28);
  needed_g_d[x_a][0] = {   0,    1,   25,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    7,    8,   19,   20,   25,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51}; //  44
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,    6,   27,   28,   31,   32,   33,   34,   35,   40,   41,   42,   43,   48,   49,   50,   51}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5,   29,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5,   11,   12,   22,   23,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   6,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {   7,    8,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][13] = {   9,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][14] = {   9,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][15] = {   9,   10,   21,   36,   37,   44,   45}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][16] = {   9,   10,   15,   16,   21,   22,   23,   36,   37,   44,   45}; //  11
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][17] = {  10,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][18] = {  10,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][19] = {  11,   12,   17,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][20] = {  11,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][21] = {  13,   14,   24,   38,   39,   46,   47}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][22] = {  13,   14,   17,   18,   19,   20,   24,   38,   39,   46,   47}; //  11
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][23] = {  15,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");
  needed_g_d[x_a][24] = {  17,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][25] = {  19,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][26] = {  21,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][27] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(52);
  c_f[x_a].resize(52);
  c_t[x_a].resize(52);
  c_d[x_a].resize(52);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   5,   2}; //   3

  c_p[x_a][7] = {  0,   1,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 11,  12,   1,   2}; //   4

  c_p[x_a][8] = {  0,   1,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 11,  12,   1,   2}; //   4

  c_p[x_a][9] = { 15,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 13,  14,  15,  16}; //   4

  c_p[x_a][10] = { 15,  16,  18}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 17,  18,  15,  16}; //   4

  c_p[x_a][11] = {  0,   9,  19}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 19,  20,   9,   2}; //   4

  c_p[x_a][12] = {  0,   9,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 19,  20,   9,   2}; //   4

  c_p[x_a][13] = { 20,  21,  17}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 13,  14,  21,  22}; //   4

  c_p[x_a][14] = { 20,  21,  18}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 17,  18,  21,  22}; //   4

  c_p[x_a][15] = {  0,  22,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 11,  23,  16,   2}; //   4

  c_p[x_a][16] = {  0,  22,  23}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 11,  23,  16,   2}; //   4

  c_p[x_a][17] = {  0,  24,  25}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 19,  24,  22,   2}; //   4

  c_p[x_a][18] = {  0,  24,  25}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 19,  24,  22,   2}; //   4

  c_p[x_a][19] = {  0,   1,  26}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 25,  22,   1,   2}; //   4

  c_p[x_a][20] = {  0,   1,  26}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 25,  22,   1,   2}; //   4

  c_p[x_a][21] = { 15,  16,  27}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 26,   2,  15,  16}; //   4

  c_p[x_a][22] = {  0,   9,  28}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 27,  16,   9,   2}; //   4

  c_p[x_a][23] = {  0,   9,  28}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 27,  16,   9,   2}; //   4

  c_p[x_a][24] = { 20,  21,  27}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 26,   2,  21,  22}; //   4

  c_p[x_a][25] = {  0,   1,   2}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  1}; //   1
  c_d[x_a][25] = {  0,   1,   2}; //   3

  c_p[x_a][26] = {  0,   1,   3}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = {  0,   1,   2}; //   3

  c_p[x_a][27] = {  4,   5,   6}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  1}; //   1
  c_d[x_a][27] = {  3,   4,   5}; //   3

  c_p[x_a][28] = {  4,   7,   8}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = {  6,   7,   5}; //   3

  c_p[x_a][29] = {  0,   9,  10}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  1}; //   1
  c_d[x_a][29] = {  8,   9,   2}; //   3

  c_p[x_a][30] = {  0,   9,  11}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  1}; //   1
  c_d[x_a][30] = {  8,   9,   2}; //   3

  c_p[x_a][31] = {  0,  12,  13}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  1}; //   1
  c_d[x_a][31] = { 10,   5,   2}; //   3

  c_p[x_a][32] = {  0,  29}; //   2
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  0,   2}; //   2
  c_d[x_a][32] = {  5,   2}; //   2

  c_p[x_a][33] = {  0,  12}; //   2
  c_f[x_a][33] = {  0}; //   1
  c_t[x_a][33] = {  0,   2}; //   2
  c_d[x_a][33] = {  5,   2}; //   2

  c_p[x_a][34] = { 30,  31}; //   2
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  0,   3}; //   2
  c_d[x_a][34] = {  2,   5}; //   2

  c_p[x_a][35] = {  4,  31}; //   2
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  0,   3}; //   2
  c_d[x_a][35] = {  2,   5}; //   2

  c_p[x_a][36] = { 15,  32,  27}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  4}; //   1
  c_d[x_a][36] = {  2,  15,  16}; //   3

  c_p[x_a][37] = { 15,  16,  27}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  4}; //   1
  c_d[x_a][37] = {  2,  15,  16}; //   3

  c_p[x_a][38] = { 20,  33,  27}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  4}; //   1
  c_d[x_a][38] = {  2,  21,  22}; //   3

  c_p[x_a][39] = { 20,  21,  27}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  4}; //   1
  c_d[x_a][39] = {  2,  21,  22}; //   3

  c_p[x_a][40] = {  0,  29}; //   2
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  5,   6}; //   2
  c_d[x_a][40] = {  5,   2}; //   2

  c_p[x_a][41] = {  0,  12}; //   2
  c_f[x_a][41] = {  1}; //   1
  c_t[x_a][41] = {  5,   6}; //   2
  c_d[x_a][41] = {  5,   2}; //   2

  c_p[x_a][42] = { 30,  31}; //   2
  c_f[x_a][42] = {  2}; //   1
  c_t[x_a][42] = {  4,   7}; //   2
  c_d[x_a][42] = {  2,   5}; //   2

  c_p[x_a][43] = {  4,  31}; //   2
  c_f[x_a][43] = {  2}; //   1
  c_t[x_a][43] = {  4,   7}; //   2
  c_d[x_a][43] = {  2,   5}; //   2

  c_p[x_a][44] = {  0,  22,  34}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  8}; //   1
  c_d[x_a][44] = { 15,  16,   2}; //   3

  c_p[x_a][45] = {  0,  22,  35}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  8}; //   1
  c_d[x_a][45] = { 15,  16,   2}; //   3

  c_p[x_a][46] = {  0,  24,  36}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  8}; //   1
  c_d[x_a][46] = { 21,  22,   2}; //   3

  c_p[x_a][47] = {  0,  24,  37}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  8}; //   1
  c_d[x_a][47] = { 21,  22,   2}; //   3

  c_p[x_a][48] = {  0,  29}; //   2
  c_f[x_a][48] = {  0}; //   1
  c_t[x_a][48] = {  1,   9}; //   2
  c_d[x_a][48] = {  5,   2}; //   2

  c_p[x_a][49] = {  0,  12}; //   2
  c_f[x_a][49] = {  0}; //   1
  c_t[x_a][49] = {  1,   9}; //   2
  c_d[x_a][49] = {  5,   2}; //   2

  c_p[x_a][50] = { 30,  31}; //   2
  c_f[x_a][50] = {  0}; //   1
  c_t[x_a][50] = {  1,  10}; //   2
  c_d[x_a][50] = {  2,   5}; //   2

  c_p[x_a][51] = {  4,  31}; //   2
  c_f[x_a][51] = {  0}; //   1
  c_t[x_a][51] = {  1,  10}; //   2
  c_d[x_a][51] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   5)
// channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   5)
// channel    2: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   5)
// channel    3: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   5)
// channel    4: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   5)
// channel    5: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   5)
// channel    6: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  25,   5)
// channel    7: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel    8: 5yyyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel    9: 5yyyv(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  23)
// channel   10: 5yyyv(1, 2, 32, 16, 4, 8, 64;   0,  23,   0,  23)
// channel   11: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   12: 5yyyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   13: 5yyyv(1, 2, 16, 32, 8, 4, 64;   0,  23,   0,  23)
// channel   14: 5yyyv(1, 2, 32, 16, 8, 4, 64;   0,  23,   0,  23)
// channel   15: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
// channel   16: 5y2vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,  23)
// channel   17: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
// channel   18: 5y2vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,  23)
// channel   19: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
// channel   20: 52vyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,  23)
// channel   21: 52vyv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,  25)
// channel   22: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
// channel   23: 52vyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,  23)
// channel   24: 52vyv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,  25)
// channel   25: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
// channel   26: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
// channel   27: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
// channel   28: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
// channel   29: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
// channel   30: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
// channel   31: 142vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
// channel   32: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   5,   5)
// channel   33: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   5,   5)
// channel   34: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   5,   5)
// channel   35: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   5,   5)
// channel   36: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,  23,   5)
// channel   37: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,  23,  23,   5)
// channel   38: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,  23,   5)
// channel   39: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,  23,  23,   5)
// channel   40: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   5,   5)
// channel   41: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   5,   5)
// channel   42: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   5,   5)
// channel   43: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   5,   5)
// channel   44: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   5)
// channel   45: 3yv2v(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   5)
// channel   46: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   5)
// channel   47: 3yv2v(1, 2, 8, 4, 64, 16, 32;  23,   0,  23,   5)
// channel   48: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   5,   5)
// channel   49: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   5,   5)
// channel   50: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   5,   5)
// channel   51: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   5,   5)
