#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_140_gb_emepvmvmxb(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_140_gb_emepvmvmxb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  needed_v_smin[x_a][  0] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25}; //  22
  needed_v_smin[x_a][  1] = {   0,    1,   11,   12}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   11,   12}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,    6,    7,    8,    9,   10,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25}; //  18
  needed_v_smin[x_a][  4] = {   2,   13}; //   2
  needed_v_smin[x_a][  5] = {   2,   13}; //   2
  needed_v_smin[x_a][  6] = {   3,   14}; //   2
  needed_v_smin[x_a][  7] = {   3,   14}; //   2
  needed_v_smin[x_a][  8] = {   4,    5,   15,   16}; //   4
  needed_v_smin[x_a][  9] = {   4,    5,   15,   16}; //   4
  needed_v_smin[x_a][ 10] = {   6,   17,   22,   23,   24,   25}; //   6
  needed_v_smin[x_a][ 11] = {   7,    8,   20,   21}; //   4
  needed_v_smin[x_a][ 12] = {   9,   10,   18,   19}; //   4

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  needed_v_smax[x_a][  0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   22,   23}; //  16
  needed_v_smax[x_a][  1] = {   0,    1,   11,   12}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,   11,   12,   13,   14,   15,   16,   17,   22,   23,   24,   25}; //  18
  needed_v_smax[x_a][  3] = {   2,    3,    9,   10,   13,   14,   20,   21,   24,   25}; //  10
  needed_v_smax[x_a][  4] = {   2,   13}; //   2
  needed_v_smax[x_a][  5] = {   3,   14}; //   2
  needed_v_smax[x_a][  6] = {   4,    5,   15,   16}; //   4
  needed_v_smax[x_a][  7] = {   6,   17,   18,   19,   22,   23}; //   6
  needed_v_smax[x_a][  8] = {   7,    8}; //   2
  needed_v_smax[x_a][  9] = {   7,    8}; //   2
  needed_v_smax[x_a][ 10] = {   9,   10}; //   2
  needed_v_smax[x_a][ 11] = {   9,   10}; //   2
  needed_v_smax[x_a][ 12] = {  18,   19}; //   2
  needed_v_smax[x_a][ 13] = {  20,   21,   24,   25}; //   4
  needed_v_smax[x_a][ 14] = {  20,   21}; //   2

  g_p[x_a].resize(24);
  needed_g_p[x_a].resize(24);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,   11,   12,   15,   16,   17,   18,   19,   22,   23}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,   10,   13,   14,   21,   25}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5,   15,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,   17,   19,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][13] = {   6,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][14] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax8");
  needed_g_p[x_a][15] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][16] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax9");
  needed_g_p[x_a][17] = {   9,   20,   24}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin12_smax10");
  needed_g_p[x_a][19] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][20] = {  18,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][21] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin12_smax12");
  needed_g_p[x_a][22] = {  20,   21,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][23] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax14");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {  22,   23,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {  11,   12,   13,   14,   15,   16,   17,   22,   23,   24,   25}; //  11
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_60");
  needed_g_t[x_a][1] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__48_76");
  needed_g_t[x_a][2] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__12_112");
  needed_g_t[x_a][3] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__48_12");
  needed_g_t[x_a][4] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_65__12_48");

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][3] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25}; //  22
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {   2,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   2,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,    8,    9,   10,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {   3,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   3,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][9] = {   4,    5,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   4,    5,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][11] = {   6,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][13] = {   7,    8,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][14] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][15] = {   9,   10,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(26);
  c_f[x_a].resize(26);
  c_t[x_a].resize(26);
  c_d[x_a].resize(26);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   4,   5,   6}; //   4

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   7,   8,   6}; //   4

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   9,  10,   3}; //   4

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   9,  10,   3}; //   4

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,  11,   6,   3}; //   4

  c_p[x_a][7] = {  0,  14,  15}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 12,   6,  13,   3}; //   4

  c_p[x_a][8] = {  0,  14,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 12,   6,  13,   3}; //   4

  c_p[x_a][9] = { 17,  18,  19}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 14,   3,  15,   6}; //   4

  c_p[x_a][10] = {  4,  18,  19}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   3,  15,   6}; //   4

  c_p[x_a][11] = {  0,   1,   2}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  1,   2,   3}; //   3

  c_p[x_a][12] = {  0,   1,   3}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  1,   2,   3}; //   3

  c_p[x_a][13] = {  4,   5,   6}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  4,   5,   6}; //   3

  c_p[x_a][14] = {  4,   7,   8}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  7,   8,   6}; //   3

  c_p[x_a][15] = {  0,   9,  10}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  9,  10,   3}; //   3

  c_p[x_a][16] = {  0,   9,  11}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  9,  10,   3}; //   3

  c_p[x_a][17] = {  0,  12,  13}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 11,   6,   3}; //   3

  c_p[x_a][18] = {  0,  20,  21}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  1}; //   1
  c_d[x_a][18] = { 15,   6,   3}; //   3

  c_p[x_a][19] = {  0,  12,  21}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  1}; //   1
  c_d[x_a][19] = { 15,   6,   3}; //   3

  c_p[x_a][20] = { 17,  22,  23}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = { 13,   3,   6}; //   3

  c_p[x_a][21] = {  4,  22,  23}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = { 13,   3,   6}; //   3

  c_p[x_a][22] = {  0,  20}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   3}; //   2
  c_d[x_a][22] = {  6,   3}; //   2

  c_p[x_a][23] = {  0,  12}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  0,   3}; //   2
  c_d[x_a][23] = {  6,   3}; //   2

  c_p[x_a][24] = { 17,  22}; //   2
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   4}; //   2
  c_d[x_a][24] = {  3,   6}; //   2

  c_p[x_a][25] = {  4,  22}; //   2
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   4}; //   2
  c_d[x_a][25] = {  3,   6}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
// channel    1: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
// channel    2: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
// channel    3: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
// channel    4: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
// channel    5: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
// channel    6: 5y2vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
// channel    7: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,   0,   5)
// channel    8: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   5,  23,   5)
// channel    9: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   5,  23,   5)
// channel   10: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   5,  23,   5)
// channel   11: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   5)
// channel   12: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   5)
// channel   13: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   5)
// channel   14: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   5)
// channel   15: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   5)
// channel   16: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   5)
// channel   17: 142vv(1, 2, 64, 4, 8, 16, 32;  23,  23,  25,   5)
// channel   18: 3yv2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   5,   5)
// channel   19: 3yv2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   5,   5)
// channel   20: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   5,   5)
// channel   21: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   5,   5)
// channel   22: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   5,   5)
// channel   23: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   5,   5)
// channel   24: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   5,   5)
// channel   25: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   5,   5)
void ppeexnmnmx04_phasespace_set::ax_psp_340_gb_emepvmvmxb(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_340_gb_emepvmvmxb");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  int needed_v_smin_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  31
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 31);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  29
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 29);
  int needed_v_smin_4[] = {   2}; //   1
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   2}; //   1
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 1);
  int needed_v_smin_6[] = {   3}; //   1
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 1);
  int needed_v_smin_7[] = {   3}; //   1
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 1);
  int needed_v_smin_8[] = {   4,    5}; //   2
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   4,    5}; //   2
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  19
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 19);
  int needed_v_smin_11[] = {  25,   26,   29,   30}; //   4
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {  27,   28,   31,   32}; //   4
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);

  v_smax[x_a].resize(15);
  needed_v_smax[x_a].resize(15);
  int needed_v_smax_0[] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   25,   26,   29,   30}; //  21
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 21);
  int needed_v_smax_1[] = {   0,    1}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  25
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 25);
  int needed_v_smax_3[] = {   2,    3,   19,   20,   21,   22,   23,   24,   27,   28,   31,   32}; //  12
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   2}; //   1
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 1);
  int needed_v_smax_5[] = {   3}; //   1
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 1);
  int needed_v_smax_6[] = {   4,    5}; //   2
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   29,   30}; //  15
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 15);
  int needed_v_smax_8[] = {  19,   20,   21,   22,   23,   24,   31,   32}; //   8
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 8);
  int needed_v_smax_9[] = {  25,   26}; //   2
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 2);
  int needed_v_smax_10[] = {  25,   26}; //   2
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 2);
  int needed_v_smax_11[] = {  27,   28}; //   2
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 2);
  int needed_v_smax_12[] = {  27,   28}; //   2
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  29,   30}; //   2
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {  31,   32}; //   2
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   25,   26,   29,   30}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,   22,   23,   24,   28,   32}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax2");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,   13,   14,   15,   29}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax7");
  needed_g_p[x_a][13] = {   6,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin10_smax2");
  needed_g_p[x_a][15] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin10_smax2");
  needed_g_p[x_a][16] = {   9,   10,   11,   12,   16,   17,   18,   30}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax7");
  needed_g_p[x_a][17] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][18] = {  19,   20,   21,   27,   31}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][19] = {  19,   20,   21,   22,   23,   24,   31,   32}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][20] = {  25,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax9");
  needed_g_p[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][22] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax10");
  needed_g_p[x_a][23] = {  27,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin12_smax11");
  needed_g_p[x_a][24] = {  27,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  29,   30}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax13");
  needed_g_f[x_a][2] = {  31,   32}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24}; //  25
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  13,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {  14,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__12_48");
  needed_g_t[x_a][3] = {  15,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__12_48");
  needed_g_t[x_a][4] = {  19,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][5] = {  20,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__48_12");
  needed_g_t[x_a][6] = {  21,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__48_12");
  needed_g_t[x_a][7] = {  25,   26,   29,   30}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][8] = {  27,   28,   31,   32}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][9] = {  29,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_13__48_64");
  needed_g_t[x_a][10] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_49__12_64");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  31
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   2,    3,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32}; //  29
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][8] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   6,    7,    8,    9,   10,   11,   12}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {  25,   26}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][12] = {  27,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(33);
  c_f[x_a].resize(33);
  c_t[x_a].resize(33);
  c_d[x_a].resize(33);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   6}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  4,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  8,   9,   2}; //   3

  c_p[x_a][5] = {  0,   9,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   2}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   5,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   5,   2}; //   3

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 10,   5,   2}; //   3

  c_p[x_a][9] = {  0,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 10,   5,   2}; //   3

  c_p[x_a][10] = {  0,  16,  13}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 10,   5,   2}; //   3

  c_p[x_a][11] = {  0,  16,  14}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 10,   5,   2}; //   3

  c_p[x_a][12] = {  0,  16,  15}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 10,   5,   2}; //   3

  c_p[x_a][13] = {  0,  12}; //   2
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = {  5,   2}; //   2

  c_p[x_a][14] = {  0,  12}; //   2
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   2}; //   2
  c_d[x_a][14] = {  5,   2}; //   2

  c_p[x_a][15] = {  0,  12}; //   2
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   3}; //   2
  c_d[x_a][15] = {  5,   2}; //   2

  c_p[x_a][16] = {  0,  16}; //   2
  c_f[x_a][16] = {  0}; //   1
  c_t[x_a][16] = {  0,   1}; //   2
  c_d[x_a][16] = {  5,   2}; //   2

  c_p[x_a][17] = {  0,  16}; //   2
  c_f[x_a][17] = {  0}; //   1
  c_t[x_a][17] = {  0,   2}; //   2
  c_d[x_a][17] = {  5,   2}; //   2

  c_p[x_a][18] = {  0,  16}; //   2
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  0,   3}; //   2
  c_d[x_a][18] = {  5,   2}; //   2

  c_p[x_a][19] = { 18,  19}; //   2
  c_f[x_a][19] = {  0}; //   1
  c_t[x_a][19] = {  0,   4}; //   2
  c_d[x_a][19] = {  2,   5}; //   2

  c_p[x_a][20] = { 18,  19}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  0,   5}; //   2
  c_d[x_a][20] = {  2,   5}; //   2

  c_p[x_a][21] = { 18,  19}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  0,   6}; //   2
  c_d[x_a][21] = {  2,   5}; //   2

  c_p[x_a][22] = {  4,  19}; //   2
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  0,   4}; //   2
  c_d[x_a][22] = {  2,   5}; //   2

  c_p[x_a][23] = {  4,  19}; //   2
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  0,   5}; //   2
  c_d[x_a][23] = {  2,   5}; //   2

  c_p[x_a][24] = {  4,  19}; //   2
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  0,   6}; //   2
  c_d[x_a][24] = {  2,   5}; //   2

  c_p[x_a][25] = {  0,  20,  21}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  7}; //   1
  c_d[x_a][25] = {  5,  11,   2}; //   3

  c_p[x_a][26] = {  0,  20,  22}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  7}; //   1
  c_d[x_a][26] = {  5,  11,   2}; //   3

  c_p[x_a][27] = { 18,  23,  24}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  8}; //   1
  c_d[x_a][27] = {  2,  12,   5}; //   3

  c_p[x_a][28] = {  4,  23,  24}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  8}; //   1
  c_d[x_a][28] = {  2,  12,   5}; //   3

  c_p[x_a][29] = {  0,  12}; //   2
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  7,   9}; //   2
  c_d[x_a][29] = {  5,   2}; //   2

  c_p[x_a][30] = {  0,  16}; //   2
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  7,   9}; //   2
  c_d[x_a][30] = {  5,   2}; //   2

  c_p[x_a][31] = { 18,  19}; //   2
  c_f[x_a][31] = {  2}; //   1
  c_t[x_a][31] = {  8,  10}; //   2
  c_d[x_a][31] = {  2,   5}; //   2

  c_p[x_a][32] = {  4,  19}; //   2
  c_f[x_a][32] = {  2}; //   1
  c_t[x_a][32] = {  8,  10}; //   2
  c_d[x_a][32] = {  2,   5}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
