#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ac_psp_240_uxcx_emmumepvmxdxcx(int x_a, int channel){
  static Logger logger("ppemexnmx04_phasespace_set::ac_psp_240_uxcx_emmumepvmxdxcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][212], 2);
      c_propagator(x_a,  24,  40, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][196], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  24,  60, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][232], 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][200], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  24,  60, v_smin[x_a][  5], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][232], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][224], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  6], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  24,  60, v_smin[x_a][  7], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][232]), 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  24,  60, v_smin[x_a][  8], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][232]), 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][60], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][  9], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][148], 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][104], sqrtsmin_opt[x_a][232]), 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  3], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][ 11], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][  3] = smin_opt[x_a][20];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][104], sqrtsmin_opt[x_a][232]), 2);
      c_propagator(x_a,  23,  20, v_smin[x_a][  3], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][168], 2);
      c_propagator(x_a,   0,  84, v_smin[x_a][ 12], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][84], sqrtsmin_opt[x_a][212]), 2);
      c_propagator(x_a,  24,  40, v_smin[x_a][  0], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][ 13], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][212]), 2);
      c_propagator(x_a,  24,  40, v_smin[x_a][  0], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][148]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][104], 2);
      c_propagator(x_a,   0, 148, v_smin[x_a][ 14], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][  0] = smin_opt[x_a][40];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][148], sqrtsmin_opt[x_a][212]), 2);
      c_propagator(x_a,  24,  40, v_smin[x_a][  0], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][148], 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][ 10], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][148]), 2);
      c_propagator(x_a,   0, 104, v_smin[x_a][ 10], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 24));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][60], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_timelikeinvariant(x_a, 124, v_smin[x_a][  9], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][104]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][20], sqrtsmin_opt[x_a][148]), 2);
      c_timelikeinvariant(x_a, 104, v_smin[x_a][ 10], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_timelikeinvariant(x_a, 124, v_smin[x_a][ 11], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][84]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][168]), 2);
      c_timelikeinvariant(x_a,  84, v_smin[x_a][ 12], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][40] + xbsqrts_all[x_a][84], 2), smin_opt[x_a][124]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_timelikeinvariant(x_a, 124, v_smin[x_a][ 13], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][148], 2), smin_opt[x_a][212]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_timelikeinvariant(x_a, 212, v_smin[x_a][ 15], v_smax[x_a][ 18], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][ 16] = smin_opt[x_a][192];
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][40], sqrtsmin_opt[x_a][60]), 2);
      c_timelikeinvariant(x_a, 192, v_smin[x_a][ 16], v_smax[x_a][ 19], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][20] + xbsqrts_all[x_a][192], 2), smin_opt[x_a][212]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_timelikeinvariant(x_a, 212, v_smin[x_a][ 17], v_smax[x_a][ 18], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][104], 2), smin_opt[x_a][232]);
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][20], 2);
      c_timelikeinvariant(x_a, 232, v_smin[x_a][ 18], v_smax[x_a][ 20], random_manager.get_random(x_a, 1, 8));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 252,   2,   1, 128, 124, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0, 124, 130,   1,  64,  60, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,   0, 124,   1, 130,  20, 104, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel(x_a,   0, 104, 130,  21,  64,  40, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0, 124,   1, 130,  40,  84, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel(x_a,   0,  84, 130,  41,  64,  20, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0, 252,   1,   2,  40, 212, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,   0, 212,   2,  41, 148,  64, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,   0, 212,   2,  41,  20, 192, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel(x_a,   0, 192,  41,  22,  64, 128, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0, 252,   1,   2, 104, 148, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,   0, 252,   2,   1,  20, 232, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0, 232,   1,  22, 104, 128, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  52,  32,  20, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  60,  20,  40, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a, 124,  64,  60, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a, 124,  20, 104, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a, 104,  64,  40, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a, 124,  40,  84, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  84,  64,  20, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a, 148, 128,  20, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
