#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_dsx_emmumepvmxusx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_dsx_emmumepvmxusx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  needed_v_smin[x_a][  1] = {   0,    6}; //   2
  needed_v_smin[x_a][  2] = {   0,    6}; //   2
  needed_v_smin[x_a][  3] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  needed_v_smin[x_a][  4] = {   1,    7}; //   2
  needed_v_smin[x_a][  5] = {   1,    7}; //   2
  needed_v_smin[x_a][  6] = {   2,    3,    8,    9}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,    8,    9}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11}; //   4
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   10,   11,    0,    1,    2,    3,    4,    5}; //  12
  needed_v_smin[x_a][ 10] = {  12,   13,   20,   21,   28,   29,   30,   31,   16,   17}; //  10
  needed_v_smin[x_a][ 11] = {  12,   13,   16,   17,   20,   21}; //   6
  needed_v_smin[x_a][ 12] = {  14,   15,   22,   23,   18,   19}; //   6
  needed_v_smin[x_a][ 13] = {  14,   15,   18,   19,   22,   23}; //   6
  needed_v_smin[x_a][ 14] = {  24,   25,   28,   29}; //   4
  needed_v_smin[x_a][ 15] = {  24,   25}; //   2
  needed_v_smin[x_a][ 16] = {  26,   27}; //   2
  needed_v_smin[x_a][ 17] = {  26,   27}; //   2
  needed_v_smin[x_a][ 18] = {  30,   31}; //   2

  v_smax[x_a].resize(21);
  needed_v_smax[x_a].resize(21);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  needed_v_smax[x_a][  1] = {   0,    6}; //   2
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  needed_v_smax[x_a][  3] = {   1,    2,    3,    7,    8,    9,   14,   15,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  20
  needed_v_smax[x_a][  4] = {   1,    7}; //   2
  needed_v_smax[x_a][  5] = {   2,    3,    8,    9}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   16,   17}; //   6
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,    0,    1,    2,    3,    4,    5,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  8] = {  12,   13,   20,   21}; //   4
  needed_v_smax[x_a][  9] = {  12,   13,   20,   21}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15,   22,   23}; //   4
  needed_v_smax[x_a][ 11] = {  14,   15,   22,   23}; //   4
  needed_v_smax[x_a][ 12] = {  18,   19,   26,   27,   30,   31}; //   6
  needed_v_smax[x_a][ 13] = {  24,   25,   28,   29}; //   4
  needed_v_smax[x_a][ 14] = {  24,   25,   28,   29}; //   4
  needed_v_smax[x_a][ 15] = {  28,   29}; //   2
  needed_v_smax[x_a][ 16] = {  30,   31,   16,   17}; //   4
  needed_v_smax[x_a][ 17] = {  18,   19}; //   2
  needed_v_smax[x_a][ 18] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 19] = {  26,   27}; //   2
  needed_v_smax[x_a][ 20] = {  30,   31}; //   2

  g_p[x_a].resize(25);
  needed_g_p[x_a].resize(25);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,   10,   11,   12,   13,   16,   17,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    7,    9,   15,   19,   23,   25,   27,   29,   31}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][6] = {   2,    8,   14,   18,   22,   24,   26,   28,   30}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  12,   13,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {  12,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][15] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][16] = {  13,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax9");
  needed_g_p[x_a][17] = {  14,   15,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {  14,   15,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][19] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][20] = {  18,   19,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax12");
  needed_g_p[x_a][21] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][22] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][23] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax15");
  needed_g_p[x_a][24] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax16");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax16");
  needed_g_f[x_a][2] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][3] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax17");
  needed_g_f[x_a][4] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][5] = {  24,   25}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax18");
  needed_g_f[x_a][6] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax19");
  needed_g_f[x_a][7] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax18");
  needed_g_f[x_a][8] = {  30,   31}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax20");

  g_t[x_a].resize(13);
  needed_g_t[x_a].resize(13);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__20_104");
  needed_g_t[x_a][3] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_21__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_21__64_40");
  needed_g_t[x_a][4] = {  18,   19,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__40_84");
  needed_g_t[x_a][5] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_41__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_41__64_20");
  needed_g_t[x_a][6] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][7] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__148_64");
  needed_g_t[x_a][8] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][9] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__64_128");
  needed_g_t[x_a][10] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__104_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__104_148");
  needed_g_t[x_a][11] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][12] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__104_128");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    4,    5,    6,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   1,    2,    3,    4,    5,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   2,    3,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   4,    5,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][11] = {  12,   13,   20,   21,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][12] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][13] = {  14,   15,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][14] = {  24,   25,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");

  c_p[x_a].resize(32);
  c_f[x_a].resize(32);
  c_t[x_a].resize(32);
  c_d[x_a].resize(32);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  3,   4,   5}; //   3

  c_p[x_a][2] = {  6,   7,   8}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  6,   7,   5}; //   3

  c_p[x_a][3] = {  3,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  6,   7,   5}; //   3

  c_p[x_a][4] = {  0,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  8,   5,   2}; //   3

  c_p[x_a][5] = {  0,  11,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   5,   2}; //   3

  c_p[x_a][6] = {  0,   1,   2,  12}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  9,   0,   1,   2}; //   4

  c_p[x_a][7] = {  3,   4,   5,  12}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  9,   3,   4,   5}; //   4

  c_p[x_a][8] = {  6,   7,   8,  12}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  9,   6,   7,   5}; //   4

  c_p[x_a][9] = {  3,   7,   8,  12}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  9,   6,   7,   5}; //   4

  c_p[x_a][10] = {  0,   9,  10,  12}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  9,   8,   5,   2}; //   4

  c_p[x_a][11] = {  0,  11,  10,  12}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  9,   8,   5,   2}; //   4

  c_p[x_a][12] = {  0,  13,  14,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 10,   5,  11,   2}; //   4

  c_p[x_a][13] = {  0,  13,  16,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 10,   5,  11,   2}; //   4

  c_p[x_a][14] = {  6,  17,  18,  19}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 12,   2,  13,   5}; //   4

  c_p[x_a][15] = {  3,  17,  18,  19}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 12,   2,  13,   5}; //   4

  c_p[x_a][16] = {  0,   9}; //   2
  c_f[x_a][16] = {  1,   2}; //   2
  c_t[x_a][16] = {  0,   2,   3}; //   3
  c_d[x_a][16] = {  5,   2}; //   2

  c_p[x_a][17] = {  0,  11}; //   2
  c_f[x_a][17] = {  1,   2}; //   2
  c_t[x_a][17] = {  0,   2,   3}; //   3
  c_d[x_a][17] = {  5,   2}; //   2

  c_p[x_a][18] = {  6,  20}; //   2
  c_f[x_a][18] = {  3,   4}; //   2
  c_t[x_a][18] = {  0,   4,   5}; //   3
  c_d[x_a][18] = {  2,   5}; //   2

  c_p[x_a][19] = {  3,  20}; //   2
  c_f[x_a][19] = {  3,   4}; //   2
  c_t[x_a][19] = {  0,   4,   5}; //   3
  c_d[x_a][19] = {  2,   5}; //   2

  c_p[x_a][20] = {  0,  13,  14}; //   3
  c_f[x_a][20] = {  2}; //   1
  c_t[x_a][20] = {  0,   2}; //   2
  c_d[x_a][20] = {  5,  11,   2}; //   3

  c_p[x_a][21] = {  0,  13,  16}; //   3
  c_f[x_a][21] = {  2}; //   1
  c_t[x_a][21] = {  0,   2}; //   2
  c_d[x_a][21] = {  5,  11,   2}; //   3

  c_p[x_a][22] = {  6,  17,  18}; //   3
  c_f[x_a][22] = {  4}; //   1
  c_t[x_a][22] = {  0,   4}; //   2
  c_d[x_a][22] = {  2,  13,   5}; //   3

  c_p[x_a][23] = {  3,  17,  18}; //   3
  c_f[x_a][23] = {  4}; //   1
  c_t[x_a][23] = {  0,   4}; //   2
  c_d[x_a][23] = {  2,  13,   5}; //   3

  c_p[x_a][24] = {  6,  21,  22}; //   3
  c_f[x_a][24] = {  5}; //   1
  c_t[x_a][24] = {  6,   7}; //   2
  c_d[x_a][24] = {  2,  14,   5}; //   3

  c_p[x_a][25] = {  3,  21,  22}; //   3
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  6,   7}; //   2
  c_d[x_a][25] = {  2,  14,   5}; //   3

  c_p[x_a][26] = {  6,  20}; //   2
  c_f[x_a][26] = {  6,   7}; //   2
  c_t[x_a][26] = {  6,   8,   9}; //   3
  c_d[x_a][26] = {  2,   5}; //   2

  c_p[x_a][27] = {  3,  20}; //   2
  c_f[x_a][27] = {  6,   7}; //   2
  c_t[x_a][27] = {  6,   8,   9}; //   3
  c_d[x_a][27] = {  2,   5}; //   2

  c_p[x_a][28] = {  6,  21,  22,  23}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 10}; //   1
  c_d[x_a][28] = { 11,   2,  14,   5}; //   4

  c_p[x_a][29] = {  3,  21,  22,  23}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 10}; //   1
  c_d[x_a][29] = { 11,   2,  14,   5}; //   4

  c_p[x_a][30] = {  6,  20,  24}; //   3
  c_f[x_a][30] = {  8}; //   1
  c_t[x_a][30] = { 11,  12}; //   2
  c_d[x_a][30] = { 11,   2,   5}; //   3

  c_p[x_a][31] = {  3,  20,  24}; //   3
  c_f[x_a][31] = {  8}; //   1
  c_t[x_a][31] = { 11,  12}; //   2
  c_d[x_a][31] = { 11,   2,   5}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    1: 4yyv11(1, 2, 8, 32, 4, 16, 64, 128;  23,   0,  24,   0,   0)
// channel    2: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,  24,   0,   0)
// channel    3: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;  23,   0,  24,   0,   0)
// channel    4: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    5: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,  24,   0,   0)
// channel    6: 5yyyv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
// channel    7: 5yyyv1(1, 2, 64, 8, 32, 4, 16, 128;  23,   0,  24,   0,   0)
// channel    8: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;   0,   0,  24,   0,   0)
// channel    9: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   10: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
// channel   11: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,  23,  24,   0,   0)
// channel   12: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
// channel   13: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
// channel   14: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
// channel   15: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   16: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,   0,   0,   0)
// channel   17: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,   0,   0,   0)
// channel   18: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;   0,  24,   0,   0,   0)
// channel   19: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;  23,  24,   0,   0,   0)
// channel   20: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
// channel   21: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
// channel   22: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
// channel   23: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   24: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   25: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   26: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;   0,  24,   0,   0,   0)
// channel   27: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;  23,  24,   0,   0,   0)
// channel   28: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   29: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   30: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
// channel   31: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
