#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_du_emmumepvmxuu(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_du_emmumepvmxuu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(25);
  needed_v_smin[x_a].resize(25);
  needed_v_smin[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  1] = {   0,    1,   12,   13}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,   12,   13}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  4] = {   2,    3,   14,   15}; //   4
  needed_v_smin[x_a][  5] = {   2,    3,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  needed_v_smin[x_a][  7] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  needed_v_smin[x_a][  8] = {   8,    9,   10,   11,   20,   21,   22,   23}; //   8
  needed_v_smin[x_a][  9] = {  12,   14,   16,   17,   20,   21,    1,    3,    6,    7,   10,   11}; //  12
  needed_v_smin[x_a][ 10] = {  13,   15,   18,   19,   22,   23,    0,    2,    4,    5,    8,    9}; //  12
  needed_v_smin[x_a][ 11] = {  24,   25,   40,   41,   56,   57,   60,   61,   34,   35}; //  10
  needed_v_smin[x_a][ 12] = {  24,   25,   34,   35,   40,   41}; //   6
  needed_v_smin[x_a][ 13] = {  26,   27,   42,   43,   58,   59,   62,   63,   32,   33}; //  10
  needed_v_smin[x_a][ 14] = {  26,   27,   32,   33,   42,   43}; //   6
  needed_v_smin[x_a][ 15] = {  28,   29,   44,   45,   48,   49,   58,   59,   38,   39}; //  10
  needed_v_smin[x_a][ 16] = {  28,   29,   38,   39,   44,   45}; //   6
  needed_v_smin[x_a][ 17] = {  30,   31,   46,   47,   50,   51,   56,   57,   36,   37}; //  10
  needed_v_smin[x_a][ 18] = {  30,   31,   36,   37,   46,   47}; //   6
  needed_v_smin[x_a][ 19] = {  48,   49}; //   2
  needed_v_smin[x_a][ 20] = {  50,   51}; //   2
  needed_v_smin[x_a][ 21] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 22] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 23] = {  60,   61}; //   2
  needed_v_smin[x_a][ 24] = {  62,   63}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   42,   43}; //  24
  needed_v_smax[x_a][  1] = {   0,    1,   12,   13}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  3] = {   2,    3,    4,    5,    6,    7,   14,   15,   16,   17,   18,   19,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  40
  needed_v_smax[x_a][  4] = {   2,    3,   14,   15}; //   4
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  needed_v_smax[x_a][  6] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35}; //  12
  needed_v_smax[x_a][  7] = {  12,   14,   16,   17,   20,   21,   24,   25,   28,   29,    1,    3,    6,    7,   10,   11,   34,   35,   38,   39,   40,   41,   44,   45}; //  24
  needed_v_smax[x_a][  8] = {  13,   15,   18,   19,   22,   23,   26,   27,   30,   31,    0,    2,    4,    5,    8,    9,   32,   33,   36,   37,   42,   43,   46,   47}; //  24
  needed_v_smax[x_a][  9] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 10] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 11] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 12] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 13] = {  28,   29,   44,   45,   48,   49,   58,   59}; //   8
  needed_v_smax[x_a][ 14] = {  28,   29,   44,   45,   48,   49,   58,   59}; //   8
  needed_v_smax[x_a][ 15] = {  30,   31,   46,   47,   50,   51,   56,   57}; //   8
  needed_v_smax[x_a][ 16] = {  30,   31,   46,   47,   50,   51,   56,   57}; //   8
  needed_v_smax[x_a][ 17] = {  36,   37,   38,   39,   52,   53,   54,   55,   60,   61,   62,   63}; //  12
  needed_v_smax[x_a][ 18] = {  56,   57}; //   2
  needed_v_smax[x_a][ 19] = {  58,   59}; //   2
  needed_v_smax[x_a][ 20] = {  60,   61,   34,   35}; //   4
  needed_v_smax[x_a][ 21] = {  62,   63,   32,   33}; //   4
  needed_v_smax[x_a][ 22] = {  36,   37}; //   2
  needed_v_smax[x_a][ 23] = {  38,   39}; //   2
  needed_v_smax[x_a][ 24] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8
  needed_v_smax[x_a][ 25] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 26] = {  60,   61,   62,   63}; //   4

  g_p[x_a].resize(33);
  needed_g_p[x_a].resize(33);
  needed_g_p[x_a][0] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27,   32,   33,   34,   35,   40,   41,   42,   43}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    3,    5,    7,   14,   15,   17,   19,   29,   31,   37,   39,   45,   47,   49,   51,   53,   55,   57,   59,   61,   63}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax2");
  needed_g_p[x_a][6] = {   4,    6,   16,   18,   28,   30,   36,   38,   44,   46,   48,   50,   52,   54,   56,   58,   60,   62}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][7] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   8,   10,   20,   22,   32,   34}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax6");
  needed_g_p[x_a][10] = {   8,    9,   10,   11,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   9,   11,   21,   23,   33,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax6");
  needed_g_p[x_a][12] = {  12,   14,   16,   17,   20,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  13,   15,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {  24,   25,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][15] = {  24,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][16] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax7");
  needed_g_p[x_a][17] = {  25,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax10");
  needed_g_p[x_a][18] = {  26,   27,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][19] = {  26,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax12");
  needed_g_p[x_a][20] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax8");
  needed_g_p[x_a][21] = {  27,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax12");
  needed_g_p[x_a][22] = {  28,   29,   44,   45,   48,   49,   58,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][23] = {  28,   29,   44,   45,   48,   49,   58,   59}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax7");
  needed_g_p[x_a][25] = {  30,   31,   46,   47,   50,   51,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][26] = {  30,   31,   46,   47,   50,   51,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][27] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax8");
  needed_g_p[x_a][28] = {  36,   37,   38,   39,   52,   53,   54,   55,   60,   61,   62,   63}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax17");
  needed_g_p[x_a][29] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax18");
  needed_g_p[x_a][30] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax19");
  needed_g_p[x_a][31] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax20");
  needed_g_p[x_a][32] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax21");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {   0,    2,    4,    5,    8,    9}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][1] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][2] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][3] = {  32,   33,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");
  needed_g_f[x_a][4] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax20");
  needed_g_f[x_a][5] = {  34,   35,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax22");
  needed_g_f[x_a][7] = {  36,   37,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax8");
  needed_g_f[x_a][8] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax23");
  needed_g_f[x_a][9] = {  38,   39,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax7");
  needed_g_f[x_a][10] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax24");
  needed_g_f[x_a][11] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax24");
  needed_g_f[x_a][12] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax25");
  needed_g_f[x_a][13] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax24");
  needed_g_f[x_a][14] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax26");
  needed_g_f[x_a][15] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax26");

  g_t[x_a].resize(23);
  needed_g_t[x_a].resize(23);
  needed_g_t[x_a][0] = {   0,    2,    4,    5,    8,    9,   13,   15,   18,   19,   22,   23,   26,   27,   30,   31,   32,   33,   36,   37,   42,   43,   46,   47}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    2,    4,    5,    8,    9}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {   1,    3,    6,    7,   10,   11,   12,   14,   16,   17,   20,   21,   24,   25,   28,   29,   34,   35,   38,   39,   40,   41,   44,   45}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][3] = {   1,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__128_60");
  needed_g_t[x_a][4] = {  32,   33,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__20_104");
  needed_g_t[x_a][5] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_21__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_21__64_40");
  needed_g_t[x_a][6] = {  34,   35,   40,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__20_168");
  needed_g_t[x_a][7] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_21__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_21__128_40");
  needed_g_t[x_a][8] = {  36,   37,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__40_84");
  needed_g_t[x_a][9] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_41__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_41__64_20");
  needed_g_t[x_a][10] = {  38,   39,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__40_148");
  needed_g_t[x_a][11] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_41__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_41__128_20");
  needed_g_t[x_a][12] = {  48,   49,   50,   51,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][13] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__148_64");
  needed_g_t[x_a][14] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__84_128");
  needed_g_t[x_a][15] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][16] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__64_128");
  needed_g_t[x_a][17] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__128_64");
  needed_g_t[x_a][18] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__168_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__168_84");
  needed_g_t[x_a][19] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__104_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__104_148");
  needed_g_t[x_a][20] = {  60,   61,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][21] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__168_64");
  needed_g_t[x_a][22] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__104_128");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][2] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][4] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   4,    5,    6,    7,   16,   17,   18,   19}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][8] = {   8,    9,   10,   11,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][9] = {  12,   14,   16,   17,   20,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][10] = {  13,   15,   18,   19,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][11] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][12] = {  24,   25,   40,   41,   56,   57,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][13] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][14] = {  26,   27,   42,   43,   58,   59,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][15] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][16] = {  28,   29,   44,   45,   48,   49,   58,   59}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][17] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][18] = {  30,   31,   46,   47,   50,   51,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   2}; //   3
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  3,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   5}; //   3

  c_p[x_a][3] = {  3,   4,   5}; //   3
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  3,   4,   5}; //   3

  c_p[x_a][4] = {  6,   7,   8}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  6,   7,   5}; //   3

  c_p[x_a][5] = {  3,   7,   8}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  6,   7,   5}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  1}; //   1
  c_t[x_a][6] = {  2,   3}; //   2
  c_d[x_a][6] = {  6,   7,   5}; //   3

  c_p[x_a][7] = {  3,   7,   8}; //   3
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = {  2,   3}; //   2
  c_d[x_a][7] = {  6,   7,   5}; //   3

  c_p[x_a][8] = {  0,   9,  10}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = {  8,   5,   2}; //   3

  c_p[x_a][9] = {  0,  11,  10}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  8,   5,   2}; //   3

  c_p[x_a][10] = {  0,   9,  10}; //   3
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  2,   3}; //   2
  c_d[x_a][10] = {  8,   5,   2}; //   3

  c_p[x_a][11] = {  0,  11,  10}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   5,   2}; //   3

  c_p[x_a][12] = {  0,   1,   2,  12}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  2}; //   1
  c_d[x_a][12] = {  9,   0,   1,   2}; //   4

  c_p[x_a][13] = {  0,   1,   2,  13}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 10,   0,   1,   2}; //   4

  c_p[x_a][14] = {  3,   4,   5,  12}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  2}; //   1
  c_d[x_a][14] = {  9,   3,   4,   5}; //   4

  c_p[x_a][15] = {  3,   4,   5,  13}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 10,   3,   4,   5}; //   4

  c_p[x_a][16] = {  6,   7,   8,  12}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  9,   6,   7,   5}; //   4

  c_p[x_a][17] = {  3,   7,   8,  12}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = {  9,   6,   7,   5}; //   4

  c_p[x_a][18] = {  6,   7,   8,  13}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 10,   6,   7,   5}; //   4

  c_p[x_a][19] = {  3,   7,   8,  13}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 10,   6,   7,   5}; //   4

  c_p[x_a][20] = {  0,   9,  10,  12}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = {  9,   8,   5,   2}; //   4

  c_p[x_a][21] = {  0,  11,  10,  12}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = {  9,   8,   5,   2}; //   4

  c_p[x_a][22] = {  0,   9,  10,  13}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 10,   8,   5,   2}; //   4

  c_p[x_a][23] = {  0,  11,  10,  13}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 10,   8,   5,   2}; //   4

  c_p[x_a][24] = {  0,  14,  15,  16}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 11,   5,  12,   2}; //   4

  c_p[x_a][25] = {  0,  14,  17,  16}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 11,   5,  12,   2}; //   4

  c_p[x_a][26] = {  0,  18,  19,  20}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 13,   5,  14,   2}; //   4

  c_p[x_a][27] = {  0,  18,  21,  20}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 13,   5,  14,   2}; //   4

  c_p[x_a][28] = {  6,  22,  23,  24}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  2}; //   1
  c_d[x_a][28] = { 15,   2,  16,   5}; //   4

  c_p[x_a][29] = {  3,  22,  23,  24}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  2}; //   1
  c_d[x_a][29] = { 15,   2,  16,   5}; //   4

  c_p[x_a][30] = {  6,  25,  26,  27}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 17,   2,  18,   5}; //   4

  c_p[x_a][31] = {  3,  25,  26,  27}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 17,   2,  18,   5}; //   4

  c_p[x_a][32] = {  0,   9}; //   2
  c_f[x_a][32] = {  2,   3}; //   2
  c_t[x_a][32] = {  0,   4,   5}; //   3
  c_d[x_a][32] = {  5,   2}; //   2

  c_p[x_a][33] = {  0,  11}; //   2
  c_f[x_a][33] = {  2,   3}; //   2
  c_t[x_a][33] = {  0,   4,   5}; //   3
  c_d[x_a][33] = {  5,   2}; //   2

  c_p[x_a][34] = {  0,   9}; //   2
  c_f[x_a][34] = {  4,   5}; //   2
  c_t[x_a][34] = {  2,   6,   7}; //   3
  c_d[x_a][34] = {  5,   2}; //   2

  c_p[x_a][35] = {  0,  11}; //   2
  c_f[x_a][35] = {  4,   5}; //   2
  c_t[x_a][35] = {  2,   6,   7}; //   3
  c_d[x_a][35] = {  5,   2}; //   2

  c_p[x_a][36] = {  6,  28}; //   2
  c_f[x_a][36] = {  6,   7}; //   2
  c_t[x_a][36] = {  0,   8,   9}; //   3
  c_d[x_a][36] = {  2,   5}; //   2

  c_p[x_a][37] = {  3,  28}; //   2
  c_f[x_a][37] = {  6,   7}; //   2
  c_t[x_a][37] = {  0,   8,   9}; //   3
  c_d[x_a][37] = {  2,   5}; //   2

  c_p[x_a][38] = {  6,  28}; //   2
  c_f[x_a][38] = {  8,   9}; //   2
  c_t[x_a][38] = {  2,  10,  11}; //   3
  c_d[x_a][38] = {  2,   5}; //   2

  c_p[x_a][39] = {  3,  28}; //   2
  c_f[x_a][39] = {  8,   9}; //   2
  c_t[x_a][39] = {  2,  10,  11}; //   3
  c_d[x_a][39] = {  2,   5}; //   2

  c_p[x_a][40] = {  0,  14,  15}; //   3
  c_f[x_a][40] = {  5}; //   1
  c_t[x_a][40] = {  2,   6}; //   2
  c_d[x_a][40] = {  5,  12,   2}; //   3

  c_p[x_a][41] = {  0,  14,  17}; //   3
  c_f[x_a][41] = {  5}; //   1
  c_t[x_a][41] = {  2,   6}; //   2
  c_d[x_a][41] = {  5,  12,   2}; //   3

  c_p[x_a][42] = {  0,  18,  19}; //   3
  c_f[x_a][42] = {  3}; //   1
  c_t[x_a][42] = {  0,   4}; //   2
  c_d[x_a][42] = {  5,  14,   2}; //   3

  c_p[x_a][43] = {  0,  18,  21}; //   3
  c_f[x_a][43] = {  3}; //   1
  c_t[x_a][43] = {  0,   4}; //   2
  c_d[x_a][43] = {  5,  14,   2}; //   3

  c_p[x_a][44] = {  6,  22,  23}; //   3
  c_f[x_a][44] = {  9}; //   1
  c_t[x_a][44] = {  2,  10}; //   2
  c_d[x_a][44] = {  2,  16,   5}; //   3

  c_p[x_a][45] = {  3,  22,  23}; //   3
  c_f[x_a][45] = {  9}; //   1
  c_t[x_a][45] = {  2,  10}; //   2
  c_d[x_a][45] = {  2,  16,   5}; //   3

  c_p[x_a][46] = {  6,  25,  26}; //   3
  c_f[x_a][46] = {  7}; //   1
  c_t[x_a][46] = {  0,   8}; //   2
  c_d[x_a][46] = {  2,  18,   5}; //   3

  c_p[x_a][47] = {  3,  25,  26}; //   3
  c_f[x_a][47] = {  7}; //   1
  c_t[x_a][47] = {  0,   8}; //   2
  c_d[x_a][47] = {  2,  18,   5}; //   3

  c_p[x_a][48] = {  6,  22,  23}; //   3
  c_f[x_a][48] = { 10}; //   1
  c_t[x_a][48] = { 12,  13}; //   2
  c_d[x_a][48] = {  2,  16,   5}; //   3

  c_p[x_a][49] = {  3,  22,  23}; //   3
  c_f[x_a][49] = { 10}; //   1
  c_t[x_a][49] = { 12,  13}; //   2
  c_d[x_a][49] = {  2,  16,   5}; //   3

  c_p[x_a][50] = {  6,  25,  26}; //   3
  c_f[x_a][50] = { 11}; //   1
  c_t[x_a][50] = { 12,  14}; //   2
  c_d[x_a][50] = {  2,  18,   5}; //   3

  c_p[x_a][51] = {  3,  25,  26}; //   3
  c_f[x_a][51] = { 11}; //   1
  c_t[x_a][51] = { 12,  14}; //   2
  c_d[x_a][51] = {  2,  18,   5}; //   3

  c_p[x_a][52] = {  6,  28}; //   2
  c_f[x_a][52] = { 12,  13}; //   2
  c_t[x_a][52] = { 12,  15,  16}; //   3
  c_d[x_a][52] = {  2,   5}; //   2

  c_p[x_a][53] = {  3,  28}; //   2
  c_f[x_a][53] = { 12,  13}; //   2
  c_t[x_a][53] = { 12,  15,  16}; //   3
  c_d[x_a][53] = {  2,   5}; //   2

  c_p[x_a][54] = {  6,  28}; //   2
  c_f[x_a][54] = { 12,  13}; //   2
  c_t[x_a][54] = { 12,  15,  17}; //   3
  c_d[x_a][54] = {  2,   5}; //   2

  c_p[x_a][55] = {  3,  28}; //   2
  c_f[x_a][55] = { 12,  13}; //   2
  c_t[x_a][55] = { 12,  15,  17}; //   3
  c_d[x_a][55] = {  2,   5}; //   2

  c_p[x_a][56] = {  6,  25,  26,  29}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 18}; //   1
  c_d[x_a][56] = { 12,   2,  18,   5}; //   4

  c_p[x_a][57] = {  3,  25,  26,  29}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 18}; //   1
  c_d[x_a][57] = { 12,   2,  18,   5}; //   4

  c_p[x_a][58] = {  6,  22,  23,  30}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 19}; //   1
  c_d[x_a][58] = { 14,   2,  16,   5}; //   4

  c_p[x_a][59] = {  3,  22,  23,  30}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 19}; //   1
  c_d[x_a][59] = { 14,   2,  16,   5}; //   4

  c_p[x_a][60] = {  6,  28,  31}; //   3
  c_f[x_a][60] = { 14}; //   1
  c_t[x_a][60] = { 20,  21}; //   2
  c_d[x_a][60] = { 12,   2,   5}; //   3

  c_p[x_a][61] = {  3,  28,  31}; //   3
  c_f[x_a][61] = { 14}; //   1
  c_t[x_a][61] = { 20,  21}; //   2
  c_d[x_a][61] = { 12,   2,   5}; //   3

  c_p[x_a][62] = {  6,  28,  32}; //   3
  c_f[x_a][62] = { 15}; //   1
  c_t[x_a][62] = { 20,  22}; //   2
  c_d[x_a][62] = { 14,   2,   5}; //   3

  c_p[x_a][63] = {  3,  28,  32}; //   3
  c_f[x_a][63] = { 15}; //   1
  c_t[x_a][63] = { 20,  22}; //   2
  c_d[x_a][63] = { 14,   2,   5}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 16, 8, 32, 128, 64;  24,   0,  24,   0,   0)
// channel    2: 4yyv11(1, 2, 8, 32, 4, 16, 64, 128;  23,   0,  24,   0,   0)
// channel    3: 4yyv11(1, 2, 8, 32, 4, 16, 128, 64;  23,   0,  24,   0,   0)
// channel    4: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,  24,   0,   0)
// channel    5: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;  23,   0,  24,   0,   0)
// channel    6: 4yyv11(1, 2, 32, 8, 4, 16, 128, 64;   0,   0,  24,   0,   0)
// channel    7: 4yyv11(1, 2, 32, 8, 4, 16, 128, 64;  23,   0,  24,   0,   0)
// channel    8: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
// channel    9: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,  24,   0,   0)
// channel   10: 42vv11(1, 2, 4, 16, 8, 32, 128, 64;  24,   0,  24,   0,   0)
// channel   11: 42vv11(1, 2, 4, 16, 8, 32, 128, 64;  24,  23,  24,   0,   0)
// channel   12: 5yyyv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
// channel   13: 5yyyv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
// channel   14: 5yyyv1(1, 2, 128, 8, 32, 4, 16, 64;  23,   0,  24,   0,   0)
// channel   15: 5yyyv1(1, 2, 64, 8, 32, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   16: 5yyyv1(1, 2, 128, 32, 8, 4, 16, 64;   0,   0,  24,   0,   0)
// channel   17: 5yyyv1(1, 2, 128, 32, 8, 4, 16, 64;  23,   0,  24,   0,   0)
// channel   18: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;   0,   0,  24,   0,   0)
// channel   19: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   20: 5y2vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,   0,  24,   0,   0)
// channel   21: 5y2vv1(1, 2, 128, 4, 16, 8, 32, 64;  24,  23,  24,   0,   0)
// channel   22: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
// channel   23: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,  23,  24,   0,   0)
// channel   24: 52vyv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,   0,   0,   0)
// channel   25: 52vyv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,  23,   0,   0)
// channel   26: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
// channel   27: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
// channel   28: 52vyv1(1, 2, 8, 32, 128, 4, 16, 64;   0,   0,  24,   0,   0)
// channel   29: 52vyv1(1, 2, 8, 32, 128, 4, 16, 64;  23,   0,  24,   0,   0)
// channel   30: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
// channel   31: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   32: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,   0,   0,   0)
// channel   33: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,   0,   0,   0)
// channel   34: 2v2v11(1, 2, 4, 16, 8, 32, 128, 64;  24,   0,   0,   0,   0)
// channel   35: 2v2v11(1, 2, 4, 16, 8, 32, 128, 64;  24,  23,   0,   0,   0)
// channel   36: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;   0,  24,   0,   0,   0)
// channel   37: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;  23,  24,   0,   0,   0)
// channel   38: 2v2v11(1, 2, 8, 32, 4, 16, 128, 64;   0,  24,   0,   0,   0)
// channel   39: 2v2v11(1, 2, 8, 32, 4, 16, 128, 64;  23,  24,   0,   0,   0)
// channel   40: 2v3yv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,   0,   0,   0)
// channel   41: 2v3yv1(1, 2, 4, 16, 128, 8, 32, 64;  24,   0,  23,   0,   0)
// channel   42: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
// channel   43: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
// channel   44: 2v3yv1(1, 2, 8, 32, 128, 4, 16, 64;   0,   0,  24,   0,   0)
// channel   45: 2v3yv1(1, 2, 8, 32, 128, 4, 16, 64;  23,   0,  24,   0,   0)
// channel   46: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
// channel   47: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
// channel   48: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   49: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   50: 2v13yv(1, 2, 8, 32, 128, 64, 4, 16;   0,   0,  24,   0,   0)
// channel   51: 2v13yv(1, 2, 8, 32, 128, 64, 4, 16;  23,   0,  24,   0,   0)
// channel   52: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;   0,  24,   0,   0,   0)
// channel   53: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;  23,  24,   0,   0,   0)
// channel   54: 2v112v(1, 2, 8, 32, 128, 64, 4, 16;   0,  24,   0,   0,   0)
// channel   55: 2v112v(1, 2, 8, 32, 128, 64, 4, 16;  23,  24,   0,   0,   0)
// channel   56: 3yv3yv(1, 2, 128, 8, 32, 64, 4, 16;   0,   0,  24,   0,   0)
// channel   57: 3yv3yv(1, 2, 128, 8, 32, 64, 4, 16;  23,   0,  24,   0,   0)
// channel   58: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   59: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   60: 3yv12v(1, 2, 128, 8, 32, 64, 4, 16;   0,  24,   0,   0,   0)
// channel   61: 3yv12v(1, 2, 128, 8, 32, 64, 4, 16;  23,  24,   0,   0,   0)
// channel   62: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
// channel   63: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
