#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_dux_emmumepvmxccx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_dux_emmumepvmxccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    8,    9,   10,   11,   12,   13,   14,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  needed_v_smin[x_a][  1] = {   0,   10}; //   2
  needed_v_smin[x_a][  2] = {   0,   10}; //   2
  needed_v_smin[x_a][  3] = {   0,    5,    6,    7,    8,    9,   10,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smin[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  needed_v_smin[x_a][  5] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  6] = {   1,    2,   11,   12}; //   4
  needed_v_smin[x_a][  7] = {   3,    4,   13,   14}; //   4
  needed_v_smin[x_a][  8] = {   3,    4,   13,   14}; //   4
  needed_v_smin[x_a][  9] = {   5,   15}; //   2
  needed_v_smin[x_a][ 10] = {   5,   15}; //   2
  needed_v_smin[x_a][ 11] = {   6,    7,   16,   17}; //   4
  needed_v_smin[x_a][ 12] = {   6,    7,   16,   17}; //   4
  needed_v_smin[x_a][ 13] = {   8,    9,   18,   19,   24,   25,   30,   31}; //   8
  needed_v_smin[x_a][ 14] = {  20,   21,   22,   23}; //   4
  needed_v_smin[x_a][ 15] = {  26,   27,   28,   29}; //   4

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    8,    9,   11,   12,   13,   14,   22,   23,   24,   25}; //  11
  needed_v_smax[x_a][  1] = {   0}; //   1
  needed_v_smax[x_a][  2] = {   0,    5,    6,    7,    8,    9}; //   6
  needed_v_smax[x_a][  3] = {   0,    5,    6,    7,    8,    9}; //   6
  needed_v_smax[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,   28,   29,   30,   31}; //  11
  needed_v_smax[x_a][  5] = {   1,    2}; //   2
  needed_v_smax[x_a][  6] = {   1,    2,    3,    4}; //   4
  needed_v_smax[x_a][  7] = {   1,    2,    3,    4}; //   4
  needed_v_smax[x_a][  8] = {   3,    4}; //   2
  needed_v_smax[x_a][  9] = {   5}; //   1
  needed_v_smax[x_a][ 10] = {   6,    7}; //   2
  needed_v_smax[x_a][ 11] = {   8,    9,   11,   12,   13,   14,   24,   25}; //   8
  needed_v_smax[x_a][ 12] = {  10,   15,   16,   17,   18,   19,   20,   21,   26,   27}; //  10
  needed_v_smax[x_a][ 13] = {  10,   18,   19,   20,   21}; //   5
  needed_v_smax[x_a][ 14] = {  10}; //   1
  needed_v_smax[x_a][ 15] = {  10,   15,   16,   17,   18,   19,   24,   25,   30,   31}; //  10
  needed_v_smax[x_a][ 16] = {  11,   12}; //   2
  needed_v_smax[x_a][ 17] = {  11,   12,   13,   14,   26,   27,   28,   29}; //   8
  needed_v_smax[x_a][ 18] = {  13,   14}; //   2
  needed_v_smax[x_a][ 19] = {  15,   16,   17,   26,   27}; //   5
  needed_v_smax[x_a][ 20] = {  15}; //   1
  needed_v_smax[x_a][ 21] = {  16,   17}; //   2
  needed_v_smax[x_a][ 22] = {  18,   19,   20,   21,   22,   23}; //   6
  needed_v_smax[x_a][ 23] = {  22,   23}; //   2
  needed_v_smax[x_a][ 24] = {  24,   25,   30,   31}; //   4
  needed_v_smax[x_a][ 25] = {  26,   27,   28,   29}; //   4
  needed_v_smax[x_a][ 26] = {  28,   29}; //   2
  needed_v_smax[x_a][ 27] = {  30,   31}; //   2
  needed_v_smax[x_a][ 28] = {  20,   21,   22,   23}; //   4

  g_p[x_a].resize(40);
  needed_g_p[x_a].resize(40);
  needed_g_p[x_a][0] = {   0,    8,    9,   11,   12,   13,   14,   22,   23,   24,   25}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    5,    6,    7,    8,    9}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    6,   28,   30}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {   1,    2,    3,    4}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax7");
  needed_g_p[x_a][8] = {   2,    4,    5,    7,   29,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax8");
  needed_g_p[x_a][10] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax9");
  needed_g_p[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax2");
  needed_g_p[x_a][13] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax10");
  needed_g_p[x_a][14] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax2");
  needed_g_p[x_a][15] = {   8,   11,   13,   24}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax11");
  needed_g_p[x_a][16] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {   9,   12,   14,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax11");
  needed_g_p[x_a][18] = {  10,   15,   16,   17,   18,   19,   20,   21,   26,   27}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax12");
  needed_g_p[x_a][19] = {  10,   18,   19,   20,   21}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax14");
  needed_g_p[x_a][21] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax15");
  needed_g_p[x_a][22] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax16");
  needed_g_p[x_a][23] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax17");
  needed_g_p[x_a][24] = {  13,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax18");
  needed_g_p[x_a][25] = {  13,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax17");
  needed_g_p[x_a][26] = {  15,   17,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax19");
  needed_g_p[x_a][27] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax20");
  needed_g_p[x_a][28] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax15");
  needed_g_p[x_a][29] = {  16,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax19");
  needed_g_p[x_a][30] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax21");
  needed_g_p[x_a][31] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax15");
  needed_g_p[x_a][32] = {  18,   20,   22}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax22");
  needed_g_p[x_a][33] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax15");
  needed_g_p[x_a][34] = {  19,   21,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax22");
  needed_g_p[x_a][35] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax23");
  needed_g_p[x_a][36] = {  24,   25,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax24");
  needed_g_p[x_a][37] = {  26,   27,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax25");
  needed_g_p[x_a][38] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax26");
  needed_g_p[x_a][39] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax27");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax28");
  needed_g_f[x_a][1] = {  24,   25,   30,   31}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][2] = {  26,   27,   28,   29}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");

  g_t[x_a].resize(11);
  needed_g_t[x_a].resize(11);
  needed_g_t[x_a][0] = {   0,    5,    6,    7,    8,    9,   24,   25,   30,   31}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][1] = {   1,    2,    3,    4,   26,   27,   28,   29}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][2] = {  10,   15,   16,   17,   18,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][3] = {  11,   12,   13,   14}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][4] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][5] = {  20,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__192_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__192_40");
  needed_g_t[x_a][6] = {  22,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][7] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__40_20");
  needed_g_t[x_a][8] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__192_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__192_20");
  needed_g_t[x_a][9] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][10] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__20_40");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   0,    5,    6,    7,    8,    9,   10,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,    4,    8,    9,   10,   11,   12,   13,   14,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__64_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__64_148");
  needed_g_d[x_a][5] = {   1,    2,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][6] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   3,    4,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__128_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__128_84");
  needed_g_d[x_a][8] = {   3,    4,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][9] = {   5,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {   5,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][12] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(32);
  c_f[x_a].resize(32);
  c_t[x_a].resize(32);
  c_d[x_a].resize(32);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   7}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  3,   4,   5,   6}; //   4

  c_p[x_a][2] = {  8,   5,   6,   7}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  3,   4,   5,   6}; //   4

  c_p[x_a][3] = {  4,   9,  10,   7}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  3,   7,   8,   6}; //   4

  c_p[x_a][4] = {  8,   9,  10,   7}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  1}; //   1
  c_d[x_a][4] = {  3,   7,   8,   6}; //   4

  c_p[x_a][5] = {  8,  11,  12,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,  10,   6}; //   4

  c_p[x_a][6] = {  4,  13,  14,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,  11,  12,   6}; //   4

  c_p[x_a][7] = {  8,  13,  14,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,  11,  12,   6}; //   4

  c_p[x_a][8] = {  0,  15,  16,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  13,   6,   3}; //   4

  c_p[x_a][9] = {  0,  17,  16,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  0,  13,   6,   3}; //   4

  c_p[x_a][10] = { 18,  19,  20,  21}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = {  1,   2,   3,   0}; //   4

  c_p[x_a][11] = {  0,  15,  22,  23}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  3}; //   1
  c_d[x_a][11] = {  4,   5,   6,   3}; //   4

  c_p[x_a][12] = {  0,  17,  22,  23}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  3}; //   1
  c_d[x_a][12] = {  4,   5,   6,   3}; //   4

  c_p[x_a][13] = {  0,  15,  24,  25}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  7,   8,   6,   3}; //   4

  c_p[x_a][14] = {  0,  17,  24,  25}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  7,   8,   6,   3}; //   4

  c_p[x_a][15] = { 18,  26,  27,  28}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  2}; //   1
  c_d[x_a][15] = {  9,  10,   6,   0}; //   4

  c_p[x_a][16] = { 18,  29,  30,  31}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = { 11,  12,   6,   0}; //   4

  c_p[x_a][17] = { 18,  26,  30,  31}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = { 11,  12,   6,   0}; //   4

  c_p[x_a][18] = { 18,  19,  32,  33}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = { 13,   6,   3,   0}; //   4

  c_p[x_a][19] = { 18,  19,  34,  33}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 13,   6,   3,   0}; //   4

  c_p[x_a][20] = { 18,  19,  32}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  4,   5}; //   2
  c_d[x_a][20] = {  6,   3,   0}; //   3

  c_p[x_a][21] = { 18,  19,  34}; //   3
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  4,   5}; //   2
  c_d[x_a][21] = {  6,   3,   0}; //   3

  c_p[x_a][22] = {  0,  35,  32}; //   3
  c_f[x_a][22] = {  0}; //   1
  c_t[x_a][22] = {  4,   6}; //   2
  c_d[x_a][22] = {  6,   0,   3}; //   3

  c_p[x_a][23] = {  0,  35,  34}; //   3
  c_f[x_a][23] = {  0}; //   1
  c_t[x_a][23] = {  4,   6}; //   2
  c_d[x_a][23] = {  6,   0,   3}; //   3

  c_p[x_a][24] = {  0,  15,  36}; //   3
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  0,   7}; //   2
  c_d[x_a][24] = {  0,   6,   3}; //   3

  c_p[x_a][25] = {  0,  17,  36}; //   3
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  0,   7}; //   2
  c_d[x_a][25] = {  0,   6,   3}; //   3

  c_p[x_a][26] = { 18,  29,  37}; //   3
  c_f[x_a][26] = {  2}; //   1
  c_t[x_a][26] = {  1,   8}; //   2
  c_d[x_a][26] = {  3,   6,   0}; //   3

  c_p[x_a][27] = { 18,  26,  37}; //   3
  c_f[x_a][27] = {  2}; //   1
  c_t[x_a][27] = {  1,   8}; //   2
  c_d[x_a][27] = {  3,   6,   0}; //   3

  c_p[x_a][28] = {  4,  38,  37}; //   3
  c_f[x_a][28] = {  2}; //   1
  c_t[x_a][28] = {  1,   9}; //   2
  c_d[x_a][28] = {  3,   0,   6}; //   3

  c_p[x_a][29] = {  8,  38,  37}; //   3
  c_f[x_a][29] = {  2}; //   1
  c_t[x_a][29] = {  1,   9}; //   2
  c_d[x_a][29] = {  3,   0,   6}; //   3

  c_p[x_a][30] = {  4,  39,  36}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  0,  10}; //   2
  c_d[x_a][30] = {  0,   3,   6}; //   3

  c_p[x_a][31] = {  8,  39,  36}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  0,  10}; //   2
  c_d[x_a][31] = {  0,   3,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v4yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    1: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,   0,  24,   0)
// channel    2: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,   0,  24,   0)
// channel    3: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;   0,   0,   0,  24,   0)
// channel    4: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;  23,   0,   0,  24,   0)
// channel    5: 2v4yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    6: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    7: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    8: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    9: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   10: 4yyv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   11: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   12: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   13: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   14: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   15: 4yyv2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,   0,  24,   0)
// channel   16: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,   0,  24,   0)
// channel   17: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,  23,   0,  24,   0)
// channel   18: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   19: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,  24,   0)
// channel   20: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   21: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,   0,   0)
// channel   22: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   23: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   24: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   25: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   26: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,   0,  24,   0,   0)
// channel   27: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,  24,   0,   0)
// channel   28: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   29: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   30: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   31: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
