#include "header.hpp"

#include "ppemexnmx04.phasespace.set.hpp"

void ppemexnmx04_phasespace_set::ax_psp_240_dux_emmumepvmxddx(int x_a){
  static Logger logger("ppemexnmx04_phasespace_set::ax_psp_240_dux_emmumepvmxddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    4,    5,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  1] = {   0,   10,   16,   34}; //   4
  needed_v_smin[x_a][  2] = {   0,   10,   16,   34}; //   4
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15}; //  12
  needed_v_smin[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  5] = {   1,   11,   21,   39}; //   4
  needed_v_smin[x_a][  6] = {   1,   11,   21,   39}; //   4
  needed_v_smin[x_a][  7] = {   2,    3,   12,   13,   22,   23,   40,   41}; //   8
  needed_v_smin[x_a][  8] = {   2,    3,   12,   13,   22,   23,   40,   41}; //   8
  needed_v_smin[x_a][  9] = {   4,    5,   14,   15,   24,   25,   42,   43,   56,   57,   62,   63}; //  12
  needed_v_smin[x_a][ 10] = {   6,    7,   26,   27,   30,   31,   46,   47,   50,   51}; //  10
  needed_v_smin[x_a][ 11] = {   6,    7,   46,   47,   50,   51}; //   6
  needed_v_smin[x_a][ 12] = {   8,    9,   17,   18,   35,   36,   44,   45,   48,   49}; //  10
  needed_v_smin[x_a][ 13] = {   8,    9,   44,   45,   48,   49}; //   6
  needed_v_smin[x_a][ 14] = {  16,   21,   22,   23,   24,   25,   34,   39,   40,   41,   42,   43,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   28,   29}; //  26
  needed_v_smin[x_a][ 15] = {  17,   18,   35,   36}; //   4
  needed_v_smin[x_a][ 16] = {  19,   20,   30,   31,   32,   33,   37,   38}; //   8
  needed_v_smin[x_a][ 17] = {  19,   20,   37,   38,   32,   33}; //   6
  needed_v_smin[x_a][ 18] = {  26,   27}; //   2
  needed_v_smin[x_a][ 19] = {  28,   29,   52,   53,   54,   55}; //   6
  needed_v_smin[x_a][ 20] = {  58,   59,   60,   61}; //   4

  v_smax[x_a].resize(35);
  needed_v_smax[x_a].resize(35);
  needed_v_smax[x_a][  0] = {   0,    4,    5,    6,    7,   10,   14,   15,   16,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   44,   45,   48,   49,   54,   55,   56,   57}; //  31
  needed_v_smax[x_a][  1] = {   0,   10,   16}; //   3
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   16,   21,   22,   23,   24,   25}; //  18
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   44,   45,   46,   47,   48,   49,   50,   51}; //  24
  needed_v_smax[x_a][  4] = {   1,    2,    3,    8,    9,   11,   12,   13,   17,   18,   19,   20,   21,   22,   23,   46,   47,   50,   51,   60,   61,   62,   63}; //  23
  needed_v_smax[x_a][  5] = {   1,   11,   21}; //   3
  needed_v_smax[x_a][  6] = {   2,    3,   12,   13,   22,   23}; //   6
  needed_v_smax[x_a][  7] = {   4,    5,   14,   15,   24,   25,   28,   29,   32,   33,   35,   36,   37,   38,   44,   45,   48,   49,   56,   57}; //  20
  needed_v_smax[x_a][  8] = {   6,    7,   26,   27,   30,   31}; //   6
  needed_v_smax[x_a][  9] = {   6,    7,   26,   27,   30,   31}; //   6
  needed_v_smax[x_a][ 10] = {   8,    9,   17,   18}; //   4
  needed_v_smax[x_a][ 11] = {   8,    9}; //   2
  needed_v_smax[x_a][ 12] = {  16,   21,   22,   23,   24,   25}; //   6
  needed_v_smax[x_a][ 13] = {  17,   18,   19,   20}; //   4
  needed_v_smax[x_a][ 14] = {  17,   18,   19,   20}; //   4
  needed_v_smax[x_a][ 15] = {  19,   20}; //   2
  needed_v_smax[x_a][ 16] = {  30,   31}; //   2
  needed_v_smax[x_a][ 17] = {  32,   33,   37,   38}; //   4
  needed_v_smax[x_a][ 18] = {  34,   39,   40,   41,   42,   43,   52,   53,   58,   59}; //  10
  needed_v_smax[x_a][ 19] = {  34,   42,   43,   52,   53}; //   5
  needed_v_smax[x_a][ 20] = {  34}; //   1
  needed_v_smax[x_a][ 21] = {  34,   39,   40,   41,   42,   43,   56,   57,   62,   63}; //  10
  needed_v_smax[x_a][ 22] = {  35,   36,   44,   45,   48,   49}; //   6
  needed_v_smax[x_a][ 23] = {  35,   36,   37,   38,   32,   33,   58,   59,   60,   61}; //  10
  needed_v_smax[x_a][ 24] = {  39,   40,   41,   58,   59}; //   5
  needed_v_smax[x_a][ 25] = {  39}; //   1
  needed_v_smax[x_a][ 26] = {  40,   41}; //   2
  needed_v_smax[x_a][ 27] = {  42,   43,   52,   53,   54,   55}; //   6
  needed_v_smax[x_a][ 28] = {  46,   47,   50,   51,   62,   63}; //   6
  needed_v_smax[x_a][ 29] = {  46,   47,   50,   51}; //   4
  needed_v_smax[x_a][ 30] = {  54,   55}; //   2
  needed_v_smax[x_a][ 31] = {  56,   57,   62,   63,   28,   29}; //   6
  needed_v_smax[x_a][ 32] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 33] = {  60,   61}; //   2
  needed_v_smax[x_a][ 34] = {  26,   27,   28,   29,   52,   53,   54,   55}; //   8

  g_p[x_a].resize(49);
  needed_g_p[x_a].resize(49);
  needed_g_p[x_a][0] = {   0,    4,    5,    6,    7,   10,   14,   15,   16,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   44,   45,   48,   49,   54,   55,   56,   57}; //  31
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   10,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   10,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    9,   11,   13,   18,   20,   21,   23,   47,   51,   61,   63}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][5] = {   1,   11,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   1,   11,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax2");
  needed_g_p[x_a][7] = {   2,    8,   12,   17,   19,   22,   46,   50,   60,   62}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][8] = {   2,    3,   12,   13,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   2,    3,   12,   13,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   14,   24,   28,   32,   35,   37,   44,   48,   56}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax7");
  needed_g_p[x_a][11] = {   4,    5,   14,   15,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][12] = {   5,   15,   25,   29,   33,   36,   38,   45,   49,   57}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax7");
  needed_g_p[x_a][13] = {   6,    7,   26,   27,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {   6,   26,   30}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax9");
  needed_g_p[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][16] = {   7,   27,   31}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax9");
  needed_g_p[x_a][17] = {   8,    9,   17,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][19] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][20] = {  16,   21,   22,   23,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax12");
  needed_g_p[x_a][21] = {  17,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][22] = {  17,   18,   19,   20}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][23] = {  19,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax15");
  needed_g_p[x_a][24] = {  19,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax13");
  needed_g_p[x_a][25] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax16");
  needed_g_p[x_a][26] = {  32,   33,   37,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax17");
  needed_g_p[x_a][27] = {  34,   39,   40,   41,   42,   43,   52,   53,   58,   59}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax18");
  needed_g_p[x_a][28] = {  34,   42,   43,   52,   53}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][29] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax20");
  needed_g_p[x_a][30] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax21");
  needed_g_p[x_a][31] = {  35,   36,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax22");
  needed_g_p[x_a][32] = {  35,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax23");
  needed_g_p[x_a][33] = {  37,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax23");
  needed_g_p[x_a][34] = {  39,   41,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax24");
  needed_g_p[x_a][35] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax25");
  needed_g_p[x_a][36] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax21");
  needed_g_p[x_a][37] = {  40,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax24");
  needed_g_p[x_a][38] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax26");
  needed_g_p[x_a][39] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax21");
  needed_g_p[x_a][40] = {  42,   52,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax27");
  needed_g_p[x_a][41] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax21");
  needed_g_p[x_a][42] = {  43,   53,   55}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax27");
  needed_g_p[x_a][43] = {  46,   47,   50,   51,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax28");
  needed_g_p[x_a][44] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax29");
  needed_g_p[x_a][45] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax30");
  needed_g_p[x_a][46] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax31");
  needed_g_p[x_a][47] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax32");
  needed_g_p[x_a][48] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax33");

  g_f[x_a].resize(11);
  needed_g_f[x_a].resize(11);
  needed_g_f[x_a][0] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {  26,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax34");
  needed_g_f[x_a][2] = {  28,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax31");
  needed_g_f[x_a][3] = {  28,   29,   52,   53,   54,   55}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax34");
  needed_g_f[x_a][4] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax23");
  needed_g_f[x_a][5] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][6] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][7] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax22");
  needed_g_f[x_a][8] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax29");
  needed_g_f[x_a][9] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax21");
  needed_g_f[x_a][10] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax23");

  g_t[x_a].resize(21);
  needed_g_t[x_a].resize(21);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   44,   45,   46,   47,   48,   49,   50,   51}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][1] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][2] = {  16,   21,   22,   23,   24,   25,   56,   57,   62,   63}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][3] = {  17,   18,   19,   20,   58,   59,   60,   61}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][4] = {  26,   27,   28,   29,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][5] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__168_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__168_64");
  needed_g_t[x_a][6] = {  28,   29,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][7] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__21_42__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__21_42__64_128");
  needed_g_t[x_a][8] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__84_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__84_168");
  needed_g_t[x_a][9] = {  32,   33,   35,   36,   37,   38}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][10] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_42__84_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_42__84_128");
  needed_g_t[x_a][11] = {  34,   39,   40,   41,   42,   43}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][12] = {  44,   45,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__40_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__40_148");
  needed_g_t[x_a][13] = {  46,   47,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__20_168");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__20_168");
  needed_g_t[x_a][14] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_42__128_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_42__128_20");
  needed_g_t[x_a][15] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_22__128_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_22__128_40");
  needed_g_t[x_a][16] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__192_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__192_40");
  needed_g_t[x_a][17] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__40_20");
  needed_g_t[x_a][18] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__192_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__192_20");
  needed_g_t[x_a][19] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][20] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__20_40");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,   10,   16,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,   10,   16,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   0,    4,    5,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,   11,   21,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][5] = {   1,   11,   21,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][6] = {   1,    2,    3,    4,    5,    6,    7,    8,    9,   11,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {   2,    3,   12,   13,   22,   23,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   2,    3,   12,   13,   22,   23,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][9] = {   4,    5,   14,   15,   24,   25,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][10] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__20_168");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__20_168");
  needed_g_d[x_a][11] = {   6,    7,   26,   27,   30,   31,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_168__128_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_168__128_40");
  needed_g_d[x_a][12] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__40_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__40_148");
  needed_g_d[x_a][13] = {   8,    9,   17,   18,   35,   36,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][14] = {  16,   21,   22,   23,   24,   25,   34,   39,   40,   41,   42,   43,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][15] = {  17,   18,   35,   36}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__64_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__64_148");
  needed_g_d[x_a][16] = {  19,   20,   37,   38}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__128_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__128_84");
  needed_g_d[x_a][17] = {  19,   20,   30,   31,   32,   33,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   4,   5,   6}; //   4

  c_p[x_a][2] = {  7,   8,   9,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   7,   8,   6}; //   4

  c_p[x_a][3] = {  4,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   7,   8,   6}; //   4

  c_p[x_a][4] = {  0,  10,  11,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   9,   6,   3}; //   4

  c_p[x_a][5] = {  0,  12,  11,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,   6,   3}; //   4

  c_p[x_a][6] = {  0,  13,  14,  15}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   6,  11,   3}; //   4

  c_p[x_a][7] = {  0,  13,  16,  15}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   6,  11,   3}; //   4

  c_p[x_a][8] = {  7,  17,  18,  19}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   3,  13,   6}; //   4

  c_p[x_a][9] = {  4,  17,  18,  19}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   3,  13,   6}; //   4

  c_p[x_a][10] = {  0,   1,   2}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  1,   2,   3}; //   3

  c_p[x_a][11] = {  4,   5,   6}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  4,   5,   6}; //   3

  c_p[x_a][12] = {  7,   8,   9}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = {  7,   8,   6}; //   3

  c_p[x_a][13] = {  4,   8,   9}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = {  7,   8,   6}; //   3

  c_p[x_a][14] = {  0,  10,  11}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = {  9,   6,   3}; //   3

  c_p[x_a][15] = {  0,  12,  11}; //   3
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  0,   1}; //   2
  c_d[x_a][15] = {  9,   6,   3}; //   3

  c_p[x_a][16] = {  0,   1,   2,  20}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = { 14,   1,   2,   3}; //   4

  c_p[x_a][17] = {  7,  17,  21,  22}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  3}; //   1
  c_d[x_a][17] = {  3,  15,  13,   6}; //   4

  c_p[x_a][18] = {  4,  17,  21,  22}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  3}; //   1
  c_d[x_a][18] = {  3,  15,  13,   6}; //   4

  c_p[x_a][19] = {  7,  23,  24,  22}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  3}; //   1
  c_d[x_a][19] = {  3,  16,  17,   6}; //   4

  c_p[x_a][20] = {  4,  23,  24,  22}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = {  3,  16,  17,   6}; //   4

  c_p[x_a][21] = {  4,   5,   6,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = { 14,   4,   5,   6}; //   4

  c_p[x_a][22] = {  7,   8,   9,  20}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 14,   7,   8,   6}; //   4

  c_p[x_a][23] = {  4,   8,   9,  20}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 14,   7,   8,   6}; //   4

  c_p[x_a][24] = {  0,  10,  11,  20}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 14,   9,   6,   3}; //   4

  c_p[x_a][25] = {  0,  12,  11,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 14,   9,   6,   3}; //   4

  c_p[x_a][26] = {  0,  13,  14}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  4,   5}; //   2
  c_d[x_a][26] = {  6,  11,   3}; //   3

  c_p[x_a][27] = {  0,  13,  16}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  4,   5}; //   2
  c_d[x_a][27] = {  6,  11,   3}; //   3

  c_p[x_a][28] = {  0,  10}; //   2
  c_f[x_a][28] = {  2,   3}; //   2
  c_t[x_a][28] = {  4,   6,   7}; //   3
  c_d[x_a][28] = {  6,   3}; //   2

  c_p[x_a][29] = {  0,  12}; //   2
  c_f[x_a][29] = {  2,   3}; //   2
  c_t[x_a][29] = {  4,   6,   7}; //   3
  c_d[x_a][29] = {  6,   3}; //   2

  c_p[x_a][30] = {  0,  13,  14,  25}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  8}; //   1
  c_d[x_a][30] = { 17,   6,  11,   3}; //   4

  c_p[x_a][31] = {  0,  13,  16,  25}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  8}; //   1
  c_d[x_a][31] = { 17,   6,  11,   3}; //   4

  c_p[x_a][32] = {  0,  10,  26}; //   3
  c_f[x_a][32] = {  4}; //   1
  c_t[x_a][32] = {  9,  10}; //   2
  c_d[x_a][32] = { 17,   6,   3}; //   3

  c_p[x_a][33] = {  0,  12,  26}; //   3
  c_f[x_a][33] = {  4}; //   1
  c_t[x_a][33] = {  9,  10}; //   2
  c_d[x_a][33] = { 17,   6,   3}; //   3

  c_p[x_a][34] = { 27,  28,  29,  30}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 11}; //   1
  c_d[x_a][34] = {  1,   2,   3,  14}; //   4

  c_p[x_a][35] = {  0,  10,  31,  32}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  9}; //   1
  c_d[x_a][35] = { 15,  13,   6,   3}; //   4

  c_p[x_a][36] = {  0,  12,  31,  32}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  9}; //   1
  c_d[x_a][36] = { 15,  13,   6,   3}; //   4

  c_p[x_a][37] = {  0,  10,  26,  33}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  9}; //   1
  c_d[x_a][37] = { 16,  17,   6,   3}; //   4

  c_p[x_a][38] = {  0,  12,  26,  33}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  9}; //   1
  c_d[x_a][38] = { 16,  17,   6,   3}; //   4

  c_p[x_a][39] = { 27,  34,  35,  36}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 11}; //   1
  c_d[x_a][39] = {  4,   5,   6,  14}; //   4

  c_p[x_a][40] = { 27,  37,  38,  39}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 11}; //   1
  c_d[x_a][40] = {  7,   8,   6,  14}; //   4

  c_p[x_a][41] = { 27,  34,  38,  39}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 11}; //   1
  c_d[x_a][41] = {  7,   8,   6,  14}; //   4

  c_p[x_a][42] = { 27,  28,  40,  41}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = {  9,   6,   3,  14}; //   4

  c_p[x_a][43] = { 27,  28,  42,  41}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 11}; //   1
  c_d[x_a][43] = {  9,   6,   3,  14}; //   4

  c_p[x_a][44] = {  0,  10,  31}; //   3
  c_f[x_a][44] = {  5}; //   1
  c_t[x_a][44] = {  0,  12}; //   2
  c_d[x_a][44] = { 13,   6,   3}; //   3

  c_p[x_a][45] = {  0,  12,  31}; //   3
  c_f[x_a][45] = {  5}; //   1
  c_t[x_a][45] = {  0,  12}; //   2
  c_d[x_a][45] = { 13,   6,   3}; //   3

  c_p[x_a][46] = {  7,  43,  44}; //   3
  c_f[x_a][46] = {  6}; //   1
  c_t[x_a][46] = {  0,  13}; //   2
  c_d[x_a][46] = { 11,   3,   6}; //   3

  c_p[x_a][47] = {  4,  43,  44}; //   3
  c_f[x_a][47] = {  6}; //   1
  c_t[x_a][47] = {  0,  13}; //   2
  c_d[x_a][47] = { 11,   3,   6}; //   3

  c_p[x_a][48] = {  0,  10}; //   2
  c_f[x_a][48] = {  7,   5}; //   2
  c_t[x_a][48] = {  0,  12,  14}; //   3
  c_d[x_a][48] = {  6,   3}; //   2

  c_p[x_a][49] = {  0,  12}; //   2
  c_f[x_a][49] = {  7,   5}; //   2
  c_t[x_a][49] = {  0,  12,  14}; //   3
  c_d[x_a][49] = {  6,   3}; //   2

  c_p[x_a][50] = {  7,  43}; //   2
  c_f[x_a][50] = {  8,   6}; //   2
  c_t[x_a][50] = {  0,  13,  15}; //   3
  c_d[x_a][50] = {  3,   6}; //   2

  c_p[x_a][51] = {  4,  43}; //   2
  c_f[x_a][51] = {  8,   6}; //   2
  c_t[x_a][51] = {  0,  13,  15}; //   3
  c_d[x_a][51] = {  3,   6}; //   2

  c_p[x_a][52] = { 27,  28,  40}; //   3
  c_f[x_a][52] = {  3}; //   1
  c_t[x_a][52] = {  4,  16}; //   2
  c_d[x_a][52] = {  6,   3,  14}; //   3

  c_p[x_a][53] = { 27,  28,  42}; //   3
  c_f[x_a][53] = {  3}; //   1
  c_t[x_a][53] = {  4,  16}; //   2
  c_d[x_a][53] = {  6,   3,  14}; //   3

  c_p[x_a][54] = {  0,  45,  40}; //   3
  c_f[x_a][54] = {  3}; //   1
  c_t[x_a][54] = {  4,   6}; //   2
  c_d[x_a][54] = {  6,  14,   3}; //   3

  c_p[x_a][55] = {  0,  45,  42}; //   3
  c_f[x_a][55] = {  3}; //   1
  c_t[x_a][55] = {  4,   6}; //   2
  c_d[x_a][55] = {  6,  14,   3}; //   3

  c_p[x_a][56] = {  0,  10,  46}; //   3
  c_f[x_a][56] = {  9}; //   1
  c_t[x_a][56] = {  2,  17}; //   2
  c_d[x_a][56] = { 14,   6,   3}; //   3

  c_p[x_a][57] = {  0,  12,  46}; //   3
  c_f[x_a][57] = {  9}; //   1
  c_t[x_a][57] = {  2,  17}; //   2
  c_d[x_a][57] = { 14,   6,   3}; //   3

  c_p[x_a][58] = { 27,  37,  47}; //   3
  c_f[x_a][58] = { 10}; //   1
  c_t[x_a][58] = {  3,  18}; //   2
  c_d[x_a][58] = {  3,   6,  14}; //   3

  c_p[x_a][59] = { 27,  34,  47}; //   3
  c_f[x_a][59] = { 10}; //   1
  c_t[x_a][59] = {  3,  18}; //   2
  c_d[x_a][59] = {  3,   6,  14}; //   3

  c_p[x_a][60] = {  7,  48,  47}; //   3
  c_f[x_a][60] = { 10}; //   1
  c_t[x_a][60] = {  3,  19}; //   2
  c_d[x_a][60] = {  3,  14,   6}; //   3

  c_p[x_a][61] = {  4,  48,  47}; //   3
  c_f[x_a][61] = { 10}; //   1
  c_t[x_a][61] = {  3,  19}; //   2
  c_d[x_a][61] = {  3,  14,   6}; //   3

  c_p[x_a][62] = {  7,  43,  46}; //   3
  c_f[x_a][62] = {  9}; //   1
  c_t[x_a][62] = {  2,  20}; //   2
  c_d[x_a][62] = { 14,   3,   6}; //   3

  c_p[x_a][63] = {  4,  43,  46}; //   3
  c_f[x_a][63] = {  9}; //   1
  c_t[x_a][63] = {  2,  20}; //   2
  c_d[x_a][63] = { 14,   3,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 15yyyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    1: 15yyyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel    2: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel    3: 15yyyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel    4: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel    5: 15y2vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel    6: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel    7: 152vyv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel    8: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
// channel    9: 152vyv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   10: 114yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   11: 114yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   12: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   13: 114yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   14: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   15: 1142vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   16: 2v4yyv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   17: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,   0,  24,   0)
// channel   18: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,   0,  24,   0)
// channel   19: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;   0,   0,   0,  24,   0)
// channel   20: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;  23,   0,   0,  24,   0)
// channel   21: 2v4yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
// channel   22: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
// channel   23: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
// channel   24: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
// channel   25: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
// channel   26: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   27: 2v13yv(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   28: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   29: 2v112v(1, 2, 4, 16, 64, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   30: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   31: 3yv3yv(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   32: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   33: 3yv12v(1, 2, 64, 4, 16, 128, 8, 32;  24,  23,   0,   0,   0)
// channel   34: 4yyv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   35: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   36: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   37: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   38: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   39: 4yyv2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,   0,  24,   0)
// channel   40: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,   0,  24,   0)
// channel   41: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,  23,   0,  24,   0)
// channel   42: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
// channel   43: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,  24,   0)
// channel   44: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   45: 13yv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   46: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   47: 13yv2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   48: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   49: 112v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   50: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   51: 112v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
// channel   52: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   53: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,   0,   0)
// channel   54: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
// channel   55: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
// channel   56: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
// channel   57: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
// channel   58: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,   0,  24,   0,   0)
// channel   59: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,  24,   0,   0)
// channel   60: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
// channel   61: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
// channel   62: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
// channel   63: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
