#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_040_aa_emmupvmvex(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_040_aa_emmupvmvex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(7);
  needed_v_smin[x_a].resize(7);
  needed_v_smin[x_a][  0] = {   2,    4,    7,    9,   10,   11}; //   6
  needed_v_smin[x_a][  1] = {   3,    5,    6,    8,   10,   11}; //   6
  needed_v_smin[x_a][  2] = {   4,    7,    2,    9}; //   4
  needed_v_smin[x_a][  3] = {   5,    6,    3,    8}; //   4
  needed_v_smin[x_a][  4] = {   0,    1}; //   2
  needed_v_smin[x_a][  5] = {   0}; //   1
  needed_v_smin[x_a][  6] = {   1}; //   1

  v_smax[x_a].resize(7);
  needed_v_smax[x_a].resize(7);
  needed_v_smax[x_a][  0] = {   2,    4,    7,    9,   11}; //   5
  needed_v_smax[x_a][  1] = {   3,    5,    6,    8,   10}; //   5
  needed_v_smax[x_a][  2] = {   4,    7,    1,    2,    9}; //   5
  needed_v_smax[x_a][  3] = {   5,    6,    0,    3,    8}; //   5
  needed_v_smax[x_a][  4] = {  10}; //   1
  needed_v_smax[x_a][  5] = {  11}; //   1
  needed_v_smax[x_a][  6] = {   0,    1}; //   2

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {   2,    4,    7,    9,   11}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    5,    6,    8,   10}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   4,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   5,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax4");
  needed_g_p[x_a][5] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax5");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax6");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax2");
  needed_g_f[x_a][3] = {   2,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][4] = {   3,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    6,    8}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_10__32_16");
  needed_g_t[x_a][3] = {   1,    7,    9}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_6__16_32");
  needed_g_t[x_a][6] = {   2,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_10__36_16");
  needed_g_t[x_a][8] = {   3,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_6__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_6__24_32");
  needed_g_t[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_5__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_5__24_32");
  needed_g_t[x_a][11] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_9__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_9__36_16");
  needed_g_t[x_a][12] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__36_24");
  needed_g_t[x_a][13] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__24_36");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   2,    4,    7,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   3,    5,    6,    8,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {   4,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][3] = {   5,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");

  c_p[x_a].resize(12);
  c_f[x_a].resize(12);
  c_t[x_a].resize(12);
  c_d[x_a].resize(12);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   2}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  3}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  8,   9}; //   2
  c_d[x_a][3] = {  1}; //   1

  c_p[x_a][4] = {  0,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  6}; //   1
  c_d[x_a][4] = {  2,   0}; //   2

  c_p[x_a][5] = {  1,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  8}; //   1
  c_d[x_a][5] = {  3,   1}; //   2

  c_p[x_a][6] = {  1,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3,   1}; //   2

  c_p[x_a][7] = {  0,   2}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  3}; //   1
  c_d[x_a][7] = {  2,   0}; //   2

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = {  4}; //   1
  c_t[x_a][8] = {  0,  10}; //   2
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  3}; //   1
  c_t[x_a][9] = {  3,  11}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  1,   4}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 12}; //   1
  c_d[x_a][10] = {  0,   1}; //   2

  c_p[x_a][11] = {  0,   5}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 13}; //   1
  c_d[x_a][11] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 32, 16, 8;   0,   0,  24)
// channel    1: 1111(1, 2, 8, 16, 32, 4;   0,   0,  24)
// channel    2: 2v11(1, 2, 4, 32, 16, 8;  24,   0,  24)
// channel    3: 2v11(1, 2, 8, 16, 32, 4;  24,   0,  24)
// channel    4: 3yv1(1, 2, 16, 4, 32, 8;  24,   0,   0)
// channel    5: 3yv1(1, 2, 32, 8, 16, 4;  24,   0,   0)
// channel    6: 13yv(1, 2, 4, 32, 8, 16;  24,   0,   0)
// channel    7: 13yv(1, 2, 8, 16, 4, 32;  24,   0,   0)
// channel    8: 112v(1, 2, 4, 32, 8, 16;  24,   0,  24)
// channel    9: 112v(1, 2, 8, 16, 4, 32;  24,   0,  24)
// channel   10: 2v2v(1, 2, 4, 32, 8, 16;  24,  24,  24)
// channel   11: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,  24)
