#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_ddx_emmupvmvexddx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_ddx_emmupvmvexddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   51,   52,   53,   54,   55,   56,   57,   61,   62,   63,   64,   65,   69,   70,   71,   72,   73,   74,   75}; //  52
  needed_v_smin[x_a][  1] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56,   63,   64}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56,   63,   64}; //  16
  needed_v_smin[x_a][  3] = {   2,   10,   21,   22,   38,   47,   57,   65}; //   8
  needed_v_smin[x_a][  4] = {   2,   10,   21,   22,   38,   47,   57,   65}; //   8
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   39,   40,   41,   42,   43,   44,   48,   49,   50,   51,   52,   53,   54,   58,   59,   60,   61,   62,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  needed_v_smin[x_a][  6] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59,   66,   67}; //  16
  needed_v_smin[x_a][  7] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59,   66,   67}; //  16
  needed_v_smin[x_a][  8] = {   5,   13,   27,   28,   41,   50,   60,   68}; //   8
  needed_v_smin[x_a][  9] = {   5,   13,   27,   28,   41,   50,   60,   68}; //   8
  needed_v_smin[x_a][ 10] = {   6,    7,   14,   15,   29,   30,   31,   32,   42,   43,   51,   52,   61,   62,   69,   70,   75}; //  17
  needed_v_smin[x_a][ 11] = {   8,    9,   10,   11,   12,   13,   14,   15,   19,   20,   22,   25,   26,   28,   31,   32,    0,    1,    2,    3,    4,    5,    6,    7}; //  24
  needed_v_smin[x_a][ 12] = {  16,   33,   35,   54,   53}; //   5
  needed_v_smin[x_a][ 13] = {  16,   33,   53,   54}; //   4
  needed_v_smin[x_a][ 14] = {  17,   18,   21,   23,   24,   27,   29,   30,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   49,   50,   51,   52}; //  24
  needed_v_smin[x_a][ 15] = {  34,   35,   44,   71,   72}; //   5
  needed_v_smin[x_a][ 16] = {  34,   44,   71,   72}; //   4
  needed_v_smin[x_a][ 17] = {  55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   73,   74,   75}; //  19
  needed_v_smin[x_a][ 18] = {  73,   74}; //   2

  v_smax[x_a].resize(31);
  needed_v_smax[x_a].resize(31);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   29,   30,   31,   32,   33,   36,   37,   38,   42,   43,   45,   46,   47,   51,   52,   53,   54,   55,   56,   57,   61,   62,   71,   72,   74,   75}; //  43
  needed_v_smax[x_a][  1] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56}; //  14
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   49,   50,   51,   52,   55,   56,   57,   58,   59,   60,   61,   62}; //  56
  needed_v_smax[x_a][  3] = {   2,   10,   21,   22,   38,   47,   57}; //   7
  needed_v_smax[x_a][  4] = {   3,    4,    5,   11,   12,   13,   23,   24,   25,   26,   27,   28,   34,   35,   39,   40,   41,   44,   48,   49,   50,   58,   59,   60}; //  24
  needed_v_smax[x_a][  5] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59}; //  14
  needed_v_smax[x_a][  6] = {   5,   13,   27,   28,   41,   50,   60}; //   7
  needed_v_smax[x_a][  7] = {   6,    7,   14,   15,   29,   30,   31,   32,   42,   43,   51,   52,   53,   61,   62,   71,   72,   75}; //  18
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   19,   20,   22,   25,   26,   28,   31,   32,   33,    0,    1,    2,    3,    4,    5,    6,    7,   53,   54}; //  28
  needed_v_smax[x_a][  9] = {  16,   33,   54}; //   3
  needed_v_smax[x_a][ 10] = {  16,   33,   54}; //   3
  needed_v_smax[x_a][ 11] = {  17,   18,   21,   23,   24,   27,   29,   30,   34,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   71,   72}; //  28
  needed_v_smax[x_a][ 12] = {  34,   44}; //   2
  needed_v_smax[x_a][ 13] = {  34,   44}; //   2
  needed_v_smax[x_a][ 14] = {  35}; //   1
  needed_v_smax[x_a][ 15] = {  35,   71,   72}; //   3
  needed_v_smax[x_a][ 16] = {  35}; //   1
  needed_v_smax[x_a][ 17] = {  55,   56,   57,   58,   59,   60,   61,   62}; //   8
  needed_v_smax[x_a][ 18] = {  63,   64,   65,   66,   67,   68,   69,   70,   73}; //   9
  needed_v_smax[x_a][ 19] = {  63,   64,   65,   69,   70,   73}; //   6
  needed_v_smax[x_a][ 20] = {  63,   64}; //   2
  needed_v_smax[x_a][ 21] = {  63,   64,   65,   66,   67,   68,   69,   70,   75}; //   9
  needed_v_smax[x_a][ 22] = {  65}; //   1
  needed_v_smax[x_a][ 23] = {  66,   67,   68}; //   3
  needed_v_smax[x_a][ 24] = {  66,   67}; //   2
  needed_v_smax[x_a][ 25] = {  68}; //   1
  needed_v_smax[x_a][ 26] = {  69,   70,   73,   74}; //   4
  needed_v_smax[x_a][ 27] = {  74}; //   1
  needed_v_smax[x_a][ 28] = {  75}; //   1
  needed_v_smax[x_a][ 29] = {  53}; //   1
  needed_v_smax[x_a][ 30] = {  73,   74}; //   2

  g_p[x_a].resize(45);
  needed_g_p[x_a].resize(45);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   29,   30,   31,   32,   33,   36,   37,   38,   42,   43,   45,   46,   47,   51,   52,   53,   54,   55,   56,   57,   61,   62,   71,   72,   74,   75}; //  43
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    8,   17,   19,   36,   45,   55}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    9,   18,   20,   37,   46,   56}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   10,   21,   22,   38,   47,   57}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   10,   21,   22,   38,   47,   57}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   11,   12,   13,   23,   24,   25,   26,   27,   28,   34,   35,   39,   40,   41,   44,   48,   49,   50,   58,   59,   60}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   11,   23,   25,   39,   48,   58}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   12,   24,   26,   40,   49,   59}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   13,   27,   28,   41,   50,   60}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   13,   27,   28,   41,   50,   60}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,   14,   15,   29,   30,   31,   32,   42,   43,   51,   52,   53,   61,   62,   71,   72,   75}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   14,   29,   31,   42,   51,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   15,   30,   32,   43,   52,   62}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,    9,   10,   11,   12,   13,   14,   15,   19,   20,   22,   25,   26,   28,   31,   32}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][16] = {  16,   33,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][17] = {  16,   33,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][18] = {  16,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][19] = {  17,   18,   21,   23,   24,   27,   29,   30,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][20] = {  34,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][21] = {  34,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][22] = {  34,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][23] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  35,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax15");
  needed_g_p[x_a][25] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax16");
  needed_g_p[x_a][26] = {  55,   56,   57,   58,   59,   60,   61,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][27] = {  63,   64,   65,   66,   67,   68,   69,   70,   73}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax18");
  needed_g_p[x_a][28] = {  63,   64,   65,   69,   70,   73}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][29] = {  63,   64}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax20");
  needed_g_p[x_a][30] = {  63}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax21");
  needed_g_p[x_a][31] = {  64}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax21");
  needed_g_p[x_a][32] = {  65}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax22");
  needed_g_p[x_a][33] = {  65}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax21");
  needed_g_p[x_a][34] = {  66,   67,   68}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax23");
  needed_g_p[x_a][35] = {  66,   67}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax24");
  needed_g_p[x_a][36] = {  66}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax21");
  needed_g_p[x_a][37] = {  67}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax21");
  needed_g_p[x_a][38] = {  68}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax25");
  needed_g_p[x_a][39] = {  68}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax21");
  needed_g_p[x_a][40] = {  69,   70,   73,   74}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax26");
  needed_g_p[x_a][41] = {  69}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax21");
  needed_g_p[x_a][42] = {  70}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax21");
  needed_g_p[x_a][43] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax27");
  needed_g_p[x_a][44] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax28");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][1] = {  45,   46,   47,   48,   49,   50,   51,   52}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax11");
  needed_g_f[x_a][2] = {  53}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax29");
  needed_g_f[x_a][3] = {  53,   54}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][4] = {  71,   72}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax11");
  needed_g_f[x_a][5] = {  72}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax15");
  needed_g_f[x_a][6] = {  73,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax30");
  needed_g_f[x_a][7] = {  75}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax21");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   53,   54}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   71,   72}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  45,   46,   47,   48,   49,   50,   51,   52}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  53,   54}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__36_88");
  needed_g_t[x_a][5] = {  53}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__64_24");
  needed_g_t[x_a][6] = {  55,   56,   57,   58,   59,   60,   61,   62,   75}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][7] = {  63,   64,   65,   66,   67,   68,   69,   70}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][8] = {  71,   72}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_164");
  needed_g_t[x_a][9] = {  72}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__128_36");
  needed_g_t[x_a][10] = {  73,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][11] = {  73}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__192_24");
  needed_g_t[x_a][12] = {  74}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_192");
  needed_g_t[x_a][13] = {  75}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__24_36");

  g_d[x_a].resize(21);
  needed_g_d[x_a].resize(21);
  needed_g_d[x_a][0] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56,   63,   64}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    8,    9,   17,   18,   19,   20,   36,   37,   45,   46,   55,   56,   63,   64}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   20,   21,   22,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   51,   52,   53,   54,   55,   56,   57,   61,   62,   63,   64,   65,   69,   70,   71,   72,   73,   74,   75}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   10,   21,   22,   38,   47,   57,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   10,   21,   22,   38,   47,   57,   65}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   11,   12,   23,   24,   25,   26,   39,   40,   48,   49,   58,   59,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   39,   40,   41,   42,   43,   44,   48,   49,   50,   51,   52,   53,   54,   58,   59,   60,   61,   62,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   13,   27,   28,   41,   50,   60,   68}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   13,   27,   28,   41,   50,   60,   68}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,   14,   15,   29,   30,   31,   32,   42,   43,   51,   52,   61,   62,   69,   70}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   8,    9,   10,   11,   12,   13,   14,   15,   19,   20,   22,   25,   26,   28,   31,   32}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  16,   33}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][13] = {  16,   33,   35,   54}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  17,   18,   21,   23,   24,   27,   29,   30,   34}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  17,   18,   21,   23,   24,   27,   29,   30,   36,   37,   38,   39,   40,   41,   42,   43}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][16] = {  19,   20,   22,   25,   26,   28,   31,   32,   33}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][17] = {  34,   44}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][18] = {  34,   35,   44,   71}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][19] = {  35}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");
  needed_g_d[x_a][20] = {  55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   73,   74,   75}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(76);
  c_f[x_a].resize(76);
  c_t[x_a].resize(76);
  c_d[x_a].resize(76);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,   1,   2,  15}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,   0,   1,   2}; //   4

  c_p[x_a][9] = {  0,   1,   3,  15}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,   0,   1,   2}; //   4

  c_p[x_a][10] = {  0,   4,   5,  15}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,   3,   4,   2}; //   4

  c_p[x_a][11] = {  6,   7,   8,  15}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 11,   5,   6,   7}; //   4

  c_p[x_a][12] = {  6,   7,   9,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 11,   5,   6,   7}; //   4

  c_p[x_a][13] = {  6,  10,  11,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 11,   8,   9,   7}; //   4

  c_p[x_a][14] = {  0,  12,  13,  15}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 11,  10,   7,   2}; //   4

  c_p[x_a][15] = {  0,  12,  14,  15}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 11,  10,   7,   2}; //   4

  c_p[x_a][16] = {  0,  16,  17,  18}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 12,   7,  13,   2}; //   4

  c_p[x_a][17] = {  0,   1,   2,  19}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,  15,   0,   1,   2}; //   5

  c_p[x_a][18] = {  0,   1,   3,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 14,  15,   0,   1,   2}; //   5

  c_p[x_a][19] = {  0,   1,   2,  15}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 16,  11,   0,   1,   2}; //   5

  c_p[x_a][20] = {  0,   1,   3,  15}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 16,  11,   0,   1,   2}; //   5

  c_p[x_a][21] = {  0,   4,   5,  19}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 14,  15,   3,   4,   2}; //   5

  c_p[x_a][22] = {  0,   4,   5,  15}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 16,  11,   3,   4,   2}; //   5

  c_p[x_a][23] = {  6,   7,   8,  19}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 14,  15,   5,   6,   7}; //   5

  c_p[x_a][24] = {  6,   7,   9,  19}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 14,  15,   5,   6,   7}; //   5

  c_p[x_a][25] = {  6,   7,   8,  15}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 16,  11,   5,   6,   7}; //   5

  c_p[x_a][26] = {  6,   7,   9,  15}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 16,  11,   5,   6,   7}; //   5

  c_p[x_a][27] = {  6,  10,  11,  19}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 14,  15,   8,   9,   7}; //   5

  c_p[x_a][28] = {  6,  10,  11,  15}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 16,  11,   8,   9,   7}; //   5

  c_p[x_a][29] = {  0,  12,  13,  19}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 14,  15,  10,   7,   2}; //   5

  c_p[x_a][30] = {  0,  12,  14,  19}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 14,  15,  10,   7,   2}; //   5

  c_p[x_a][31] = {  0,  12,  13,  15}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 16,  11,  10,   7,   2}; //   5

  c_p[x_a][32] = {  0,  12,  14,  15}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 16,  11,  10,   7,   2}; //   5

  c_p[x_a][33] = {  0,  16,  17,  18}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 16,  12,   7,  13,   2}; //   5

  c_p[x_a][34] = {  6,  20,  21,  22}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 14,  17,   2,  18,   7}; //   5

  c_p[x_a][35] = {  6,  23,  24,  25}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 19,  13,  18,   2,   7}; //   5

  c_p[x_a][36] = {  0,   1,   2,  19}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  2}; //   1
  c_d[x_a][36] = { 15,   0,   1,   2}; //   4

  c_p[x_a][37] = {  0,   1,   3,  19}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  2}; //   1
  c_d[x_a][37] = { 15,   0,   1,   2}; //   4

  c_p[x_a][38] = {  0,   4,   5,  19}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  2}; //   1
  c_d[x_a][38] = { 15,   3,   4,   2}; //   4

  c_p[x_a][39] = {  6,   7,   8,  19}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  2}; //   1
  c_d[x_a][39] = { 15,   5,   6,   7}; //   4

  c_p[x_a][40] = {  6,   7,   9,  19}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = { 15,   5,   6,   7}; //   4

  c_p[x_a][41] = {  6,  10,  11,  19}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = { 15,   8,   9,   7}; //   4

  c_p[x_a][42] = {  0,  12,  13,  19}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = { 15,  10,   7,   2}; //   4

  c_p[x_a][43] = {  0,  12,  14,  19}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = { 15,  10,   7,   2}; //   4

  c_p[x_a][44] = {  6,  20,  21,  22}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  2}; //   1
  c_d[x_a][44] = { 17,   2,  18,   7}; //   4

  c_p[x_a][45] = {  0,   1,   2}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  2,   3}; //   2
  c_d[x_a][45] = {  0,   1,   2}; //   3

  c_p[x_a][46] = {  0,   1,   3}; //   3
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  2,   3}; //   2
  c_d[x_a][46] = {  0,   1,   2}; //   3

  c_p[x_a][47] = {  0,   4,   5}; //   3
  c_f[x_a][47] = {  1}; //   1
  c_t[x_a][47] = {  2,   3}; //   2
  c_d[x_a][47] = {  3,   4,   2}; //   3

  c_p[x_a][48] = {  6,   7,   8}; //   3
  c_f[x_a][48] = {  1}; //   1
  c_t[x_a][48] = {  2,   3}; //   2
  c_d[x_a][48] = {  5,   6,   7}; //   3

  c_p[x_a][49] = {  6,   7,   9}; //   3
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  2,   3}; //   2
  c_d[x_a][49] = {  5,   6,   7}; //   3

  c_p[x_a][50] = {  6,  10,  11}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  2,   3}; //   2
  c_d[x_a][50] = {  8,   9,   7}; //   3

  c_p[x_a][51] = {  0,  12,  13}; //   3
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  2,   3}; //   2
  c_d[x_a][51] = { 10,   7,   2}; //   3

  c_p[x_a][52] = {  0,  12,  14}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  2,   3}; //   2
  c_d[x_a][52] = { 10,   7,   2}; //   3

  c_p[x_a][53] = {  0,  12}; //   2
  c_f[x_a][53] = {  2,   3}; //   2
  c_t[x_a][53] = {  0,   4,   5}; //   3
  c_d[x_a][53] = {  7,   2}; //   2

  c_p[x_a][54] = {  0,  16,  17}; //   3
  c_f[x_a][54] = {  3}; //   1
  c_t[x_a][54] = {  0,   4}; //   2
  c_d[x_a][54] = {  7,  13,   2}; //   3

  c_p[x_a][55] = {  0,   1,   2,  26}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  6}; //   1
  c_d[x_a][55] = { 20,   0,   1,   2}; //   4

  c_p[x_a][56] = {  0,   1,   3,  26}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  6}; //   1
  c_d[x_a][56] = { 20,   0,   1,   2}; //   4

  c_p[x_a][57] = {  0,   4,   5,  26}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  6}; //   1
  c_d[x_a][57] = { 20,   3,   4,   2}; //   4

  c_p[x_a][58] = {  6,   7,   8,  26}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  6}; //   1
  c_d[x_a][58] = { 20,   5,   6,   7}; //   4

  c_p[x_a][59] = {  6,   7,   9,  26}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  6}; //   1
  c_d[x_a][59] = { 20,   5,   6,   7}; //   4

  c_p[x_a][60] = {  6,  10,  11,  26}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  6}; //   1
  c_d[x_a][60] = { 20,   8,   9,   7}; //   4

  c_p[x_a][61] = {  0,  12,  13,  26}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  6}; //   1
  c_d[x_a][61] = { 20,  10,   7,   2}; //   4

  c_p[x_a][62] = {  0,  12,  14,  26}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  6}; //   1
  c_d[x_a][62] = { 20,  10,   7,   2}; //   4

  c_p[x_a][63] = { 27,  28,  29,  30}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  7}; //   1
  c_d[x_a][63] = {  0,   1,   2,  20}; //   4

  c_p[x_a][64] = { 27,  28,  29,  31}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  7}; //   1
  c_d[x_a][64] = {  0,   1,   2,  20}; //   4

  c_p[x_a][65] = { 27,  28,  32,  33}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  7}; //   1
  c_d[x_a][65] = {  3,   4,   2,  20}; //   4

  c_p[x_a][66] = { 27,  34,  35,  36}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  7}; //   1
  c_d[x_a][66] = {  5,   6,   7,  20}; //   4

  c_p[x_a][67] = { 27,  34,  35,  37}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  7}; //   1
  c_d[x_a][67] = {  5,   6,   7,  20}; //   4

  c_p[x_a][68] = { 27,  34,  38,  39}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  7}; //   1
  c_d[x_a][68] = {  8,   9,   7,  20}; //   4

  c_p[x_a][69] = { 27,  28,  40,  41}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  7}; //   1
  c_d[x_a][69] = { 10,   7,   2,  20}; //   4

  c_p[x_a][70] = { 27,  28,  40,  42}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  7}; //   1
  c_d[x_a][70] = { 10,   7,   2,  20}; //   4

  c_p[x_a][71] = {  0,  12,  24}; //   3
  c_f[x_a][71] = {  4}; //   1
  c_t[x_a][71] = {  2,   8}; //   2
  c_d[x_a][71] = { 18,   7,   2}; //   3

  c_p[x_a][72] = {  0,  12}; //   2
  c_f[x_a][72] = {  5,   4}; //   2
  c_t[x_a][72] = {  2,   8,   9}; //   3
  c_d[x_a][72] = {  7,   2}; //   2

  c_p[x_a][73] = { 27,  28,  40}; //   3
  c_f[x_a][73] = {  6}; //   1
  c_t[x_a][73] = { 10,  11}; //   2
  c_d[x_a][73] = {  7,   2,  20}; //   3

  c_p[x_a][74] = {  0,  43,  40}; //   3
  c_f[x_a][74] = {  6}; //   1
  c_t[x_a][74] = { 10,  12}; //   2
  c_d[x_a][74] = {  7,  20,   2}; //   3

  c_p[x_a][75] = {  0,  12,  44}; //   3
  c_f[x_a][75] = {  7}; //   1
  c_t[x_a][75] = {  6,  13}; //   2
  c_d[x_a][75] = { 20,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    2: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    3: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
// channel    4: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel    5: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel    6: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel    7: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
// channel    8: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
// channel    9: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   10: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   11: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
// channel   12: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   13: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   14: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
// channel   16: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   17: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   18: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   19: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   20: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   21: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   22: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   23: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   24: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   25: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   26: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   27: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   28: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   29: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   30: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   31: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   32: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   33: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   0,  24,   0,   0)
// channel   34: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
// channel   35: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   0,   0,   0)
// channel   36: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   37: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   38: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   39: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   40: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   41: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   42: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   43: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   44: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
// channel   45: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   46: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   47: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   48: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   49: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   50: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   51: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   52: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   53: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   54: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   55: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   56: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   57: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   58: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   59: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   60: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   61: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   62: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   63: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   0)
// channel   64: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   0)
// channel   65: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   0)
// channel   66: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   0)
// channel   67: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   0)
// channel   68: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   0)
// channel   69: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
// channel   70: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   0)
// channel   71: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   72: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   73: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
// channel   74: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   0,   0)
// channel   75: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
