#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_dux_emmupvmvexdux(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_dux_emmupvmvexdux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41}; //  30
  needed_v_smin[x_a][  1] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  needed_v_smin[x_a][  3] = {   2,   10,   19,   28}; //   4
  needed_v_smin[x_a][  4] = {   2,   10,   19,   28}; //   4
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   20,   21,   22,   23,   24,   25,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41}; //  30
  needed_v_smin[x_a][  6] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  needed_v_smin[x_a][  7] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  needed_v_smin[x_a][  8] = {   5,   13,   22,   31}; //   4
  needed_v_smin[x_a][  9] = {   5,   13,   22,   31}; //   4
  needed_v_smin[x_a][ 10] = {   6,    7,   14,   15,   23,   24,   32,   33}; //   8
  needed_v_smin[x_a][ 11] = {   8,    9,   10,   11,   12,   13,   14,   15,    0,    1,    2,    3,    4,    5,    6,    7}; //  16
  needed_v_smin[x_a][ 12] = {  16,   35,   37,   39,   34}; //   5
  needed_v_smin[x_a][ 13] = {  16,   34,   35}; //   3
  needed_v_smin[x_a][ 14] = {  17,   18,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   32,   33}; //  16
  needed_v_smin[x_a][ 15] = {  25,   36,   38,   40,   41}; //   5
  needed_v_smin[x_a][ 16] = {  25,   40,   41}; //   3
  needed_v_smin[x_a][ 17] = {  36,   38}; //   2
  needed_v_smin[x_a][ 18] = {  37,   39}; //   2

  v_smax[x_a].resize(20);
  needed_v_smax[x_a].resize(20);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   32,   33,   34,   35,   36,   37}; //  26
  needed_v_smax[x_a][  1] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   17,   18,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   32,   33}; //  32
  needed_v_smax[x_a][  3] = {   2,   10,   19,   28}; //   4
  needed_v_smax[x_a][  4] = {   3,    4,    5,   11,   12,   13,   20,   21,   22,   29,   30,   31,   38,   39,   40,   41}; //  16
  needed_v_smax[x_a][  5] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  needed_v_smax[x_a][  6] = {   5,   13,   22,   31}; //   4
  needed_v_smax[x_a][  7] = {   6,    7,   14,   15,   23,   24,   32,   33,   34}; //   9
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,    0,    1,    2,    3,    4,    5,    6,    7,   34,   35}; //  19
  needed_v_smax[x_a][  9] = {  16,   35,   37}; //   3
  needed_v_smax[x_a][ 10] = {  16,   35}; //   2
  needed_v_smax[x_a][ 11] = {  17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   40,   41}; //  19
  needed_v_smax[x_a][ 12] = {  25,   36}; //   2
  needed_v_smax[x_a][ 13] = {  25}; //   1
  needed_v_smax[x_a][ 14] = {  36,   37}; //   2
  needed_v_smax[x_a][ 15] = {  36,   37}; //   2
  needed_v_smax[x_a][ 16] = {  38,   39,   40,   41}; //   4
  needed_v_smax[x_a][ 17] = {  38,   40,   41}; //   3
  needed_v_smax[x_a][ 18] = {  38,   39}; //   2
  needed_v_smax[x_a][ 19] = {  39,   34}; //   2

  g_p[x_a].resize(31);
  needed_g_p[x_a].resize(31);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   32,   33,   34,   35,   36,   37}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    8,   17,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    9,   18,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   10,   19,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   10,   19,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   11,   12,   13,   20,   21,   22,   29,   30,   31,   38,   39,   40,   41}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   11,   20,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   12,   21,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   13,   22,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   13,   22,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,   14,   15,   23,   24,   32,   33,   34}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   14,   23,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   15,   24,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,    9,   10,   11,   12,   13,   14,   15}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][16] = {  16,   35,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][17] = {  16,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][18] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][19] = {  17,   18,   19,   20,   21,   22,   23,   24}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][20] = {  25,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax13");
  needed_g_p[x_a][22] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][23] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax14");
  needed_g_p[x_a][24] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax15");
  needed_g_p[x_a][25] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax14");
  needed_g_p[x_a][26] = {  38,   39,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][27] = {  38,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax17");
  needed_g_p[x_a][28] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax18");
  needed_g_p[x_a][29] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax19");
  needed_g_p[x_a][30] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax18");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][1] = {  26,   27,   28,   29,   30,   31,   32,   33}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax11");
  needed_g_f[x_a][2] = {  34}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax19");
  needed_g_f[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][4] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax11");
  needed_g_f[x_a][5] = {  41}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   34,   35}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   40,   41}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  26,   27,   28,   29,   30,   31,   32,   33}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__36_88");
  needed_g_t[x_a][5] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__64_24");
  needed_g_t[x_a][6] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][7] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_216");
  needed_g_t[x_a][8] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_152");
  needed_g_t[x_a][9] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__128_24");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    8,    9,   17,   18,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18,   19,   23,   24,   25,   26,   27,   28,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   10,   19,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   10,   19,   28}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   11,   12,   20,   21,   29,   30}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   20,   21,   22,   23,   24,   25,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   13,   22,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   13,   22,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,   14,   15,   23,   24,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   8,    9,   10,   11,   12,   13,   14,   15}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][13] = {  16,   35,   37,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  17,   18,   19,   20,   21,   22,   23,   24}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][15] = {  25}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][16] = {  25,   36,   38,   40}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][17] = {  36,   38}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__64_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__64_152");
  needed_g_d[x_a][18] = {  37,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__128_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__128_88");

  c_p[x_a].resize(42);
  c_f[x_a].resize(42);
  c_t[x_a].resize(42);
  c_d[x_a].resize(42);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,   1,   2,  15}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,   0,   1,   2}; //   4

  c_p[x_a][9] = {  0,   1,   3,  15}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,   0,   1,   2}; //   4

  c_p[x_a][10] = {  0,   4,   5,  15}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,   3,   4,   2}; //   4

  c_p[x_a][11] = {  6,   7,   8,  15}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 11,   5,   6,   7}; //   4

  c_p[x_a][12] = {  6,   7,   9,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 11,   5,   6,   7}; //   4

  c_p[x_a][13] = {  6,  10,  11,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 11,   8,   9,   7}; //   4

  c_p[x_a][14] = {  0,  12,  13,  15}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 11,  10,   7,   2}; //   4

  c_p[x_a][15] = {  0,  12,  14,  15}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 11,  10,   7,   2}; //   4

  c_p[x_a][16] = {  0,  16,  17,  18}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 12,   7,  13,   2}; //   4

  c_p[x_a][17] = {  0,   1,   2,  19}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = { 14,   0,   1,   2}; //   4

  c_p[x_a][18] = {  0,   1,   3,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = { 14,   0,   1,   2}; //   4

  c_p[x_a][19] = {  0,   4,   5,  19}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = { 14,   3,   4,   2}; //   4

  c_p[x_a][20] = {  6,   7,   8,  19}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = { 14,   5,   6,   7}; //   4

  c_p[x_a][21] = {  6,   7,   9,  19}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = { 14,   5,   6,   7}; //   4

  c_p[x_a][22] = {  6,  10,  11,  19}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 14,   8,   9,   7}; //   4

  c_p[x_a][23] = {  0,  12,  13,  19}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 14,  10,   7,   2}; //   4

  c_p[x_a][24] = {  0,  12,  14,  19}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 14,  10,   7,   2}; //   4

  c_p[x_a][25] = {  0,  20,  21,  22}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 15,   7,  16,   2}; //   4

  c_p[x_a][26] = {  0,   1,   2}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  2,   3}; //   2
  c_d[x_a][26] = {  0,   1,   2}; //   3

  c_p[x_a][27] = {  0,   1,   3}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  2,   3}; //   2
  c_d[x_a][27] = {  0,   1,   2}; //   3

  c_p[x_a][28] = {  0,   4,   5}; //   3
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  2,   3}; //   2
  c_d[x_a][28] = {  3,   4,   2}; //   3

  c_p[x_a][29] = {  6,   7,   8}; //   3
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = {  2,   3}; //   2
  c_d[x_a][29] = {  5,   6,   7}; //   3

  c_p[x_a][30] = {  6,   7,   9}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  2,   3}; //   2
  c_d[x_a][30] = {  5,   6,   7}; //   3

  c_p[x_a][31] = {  6,  10,  11}; //   3
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  2,   3}; //   2
  c_d[x_a][31] = {  8,   9,   7}; //   3

  c_p[x_a][32] = {  0,  12,  13}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  2,   3}; //   2
  c_d[x_a][32] = { 10,   7,   2}; //   3

  c_p[x_a][33] = {  0,  12,  14}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  2,   3}; //   2
  c_d[x_a][33] = { 10,   7,   2}; //   3

  c_p[x_a][34] = {  0,  12}; //   2
  c_f[x_a][34] = {  2,   3}; //   2
  c_t[x_a][34] = {  0,   4,   5}; //   3
  c_d[x_a][34] = {  7,   2}; //   2

  c_p[x_a][35] = {  0,  16,  17}; //   3
  c_f[x_a][35] = {  3}; //   1
  c_t[x_a][35] = {  0,   4}; //   2
  c_d[x_a][35] = {  7,  13,   2}; //   3

  c_p[x_a][36] = {  0,  20,  23,  24}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  6}; //   1
  c_d[x_a][36] = {  7,  17,  16,   2}; //   4

  c_p[x_a][37] = {  0,  16,  25,  24}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  6}; //   1
  c_d[x_a][37] = {  7,  18,  13,   2}; //   4

  c_p[x_a][38] = {  6,  26,  27,  28}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  7}; //   1
  c_d[x_a][38] = { 17,  16,   2,   7}; //   4

  c_p[x_a][39] = {  6,  26,  29,  30}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  7}; //   1
  c_d[x_a][39] = { 18,  13,   2,   7}; //   4

  c_p[x_a][40] = {  6,  26,  27}; //   3
  c_f[x_a][40] = {  4}; //   1
  c_t[x_a][40] = {  2,   8}; //   2
  c_d[x_a][40] = { 16,   2,   7}; //   3

  c_p[x_a][41] = {  6,  26}; //   2
  c_f[x_a][41] = {  5,   4}; //   2
  c_t[x_a][41] = {  2,   8,   9}; //   3
  c_d[x_a][41] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
// channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    2: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
// channel    3: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
// channel    4: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel    5: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
// channel    6: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel    7: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
// channel    8: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
// channel    9: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   10: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
// channel   11: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
// channel   12: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   13: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
// channel   14: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
// channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
// channel   16: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   17: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   18: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   19: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   20: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   21: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   22: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   23: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   24: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   25: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   0,  24,   0,   0)
// channel   26: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
// channel   27: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
// channel   28: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
// channel   29: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
// channel   30: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
// channel   31: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
// channel   32: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
// channel   33: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
// channel   34: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
// channel   35: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   0,  24,   0,   0)
// channel   36: 2v4yyv(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,   0,  24,   0)
// channel   37: 2v4yyv(1, 2, 4, 32, 128, 64, 8, 16;  24,   0,   0,  24,   0)
// channel   38: 4yyv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
// channel   39: 4yyv2v(1, 2, 128, 64, 8, 16, 4, 32;  24,  24,   0,   0,   0)
// channel   40: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
// channel   41: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
