#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_ucx_emmupvmvexdsx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_ucx_emmupvmvexdsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  1] = {   0,    2}; //   2
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  3] = {   2,    3}; //   2
  needed_v_smin[x_a][  4] = {   0}; //   1
  needed_v_smin[x_a][  5] = {   1}; //   1
  needed_v_smin[x_a][  6] = {   1}; //   1
  needed_v_smin[x_a][  7] = {   3}; //   1

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = {   0,    2}; //   2
  needed_v_smax[x_a][  2] = {   0,    2}; //   2
  needed_v_smax[x_a][  3] = {   1,    3}; //   2
  needed_v_smax[x_a][  4] = {   2}; //   1
  needed_v_smax[x_a][  5] = {   3}; //   1
  needed_v_smax[x_a][  6] = {   0,    1}; //   2
  needed_v_smax[x_a][  7] = {   1}; //   1
  needed_v_smax[x_a][  8] = {   3}; //   1

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax3");
  needed_g_p[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax4");
  needed_g_p[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");

  g_f[x_a].resize(4);
  needed_g_f[x_a].resize(4);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax6");
  needed_g_f[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax7");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax8");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_228");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__164_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__164_64");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_192");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__25_38__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__25_38__64_128");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__88_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__88_164");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_216");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_38__88_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_38__88_128");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][2] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");

  c_p[x_a].resize(4);
  c_f[x_a].resize(4);
  c_t[x_a].resize(4);
  c_d[x_a].resize(4);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   3}; //   2
  c_f[x_a][1] = {  1,   2}; //   2
  c_t[x_a][1] = {  0,   2,   3}; //   3
  c_d[x_a][1] = {  0,   2}; //   2

  c_p[x_a][2] = {  0,   1,   2,   4}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  4}; //   1
  c_d[x_a][2] = {  3,   0,   1,   2}; //   4

  c_p[x_a][3] = {  0,   3,   5}; //   3
  c_f[x_a][3] = {  3}; //   1
  c_t[x_a][3] = {  5,   6}; //   2
  c_d[x_a][3] = {  3,   0,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v13yv(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,  24,   0,   0)
// channel    1: 2v112v(1, 2, 8, 16, 64, 128, 4, 32;  24,  24,   0,   0,   0)
// channel    2: 3yv3yv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
// channel    3: 3yv12v(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   0,   0,   0)
