#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_050_bbx_emmupvmvexa(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_050_bbx_emmupvmvexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(25);
  needed_v_smin[x_a].resize(25);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   25,   27,   28,   29,   30,   31,   35,   36,   37,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52,   53,   55,   56,   57,   58}; //  35
  needed_v_smin[x_a][  1] = {   0,    1,   11,   12,   30,   31,   43,   44}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   43,   44}; //   4
  needed_v_smin[x_a][  3] = {   2,   45}; //   2
  needed_v_smin[x_a][  4] = {   2,   45}; //   2
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,    8,   17,   18,   19,   20,   23,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   58}; //  35
  needed_v_smin[x_a][  6] = {   3,    4,   19,   20,   38,   39,   46,   47}; //   8
  needed_v_smin[x_a][  7] = {   3,    4,   46,   47}; //   4
  needed_v_smin[x_a][  8] = {   5,   48}; //   2
  needed_v_smin[x_a][  9] = {   5,   48}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7,    8,   49,   50,   51,   52,   58}; //   8
  needed_v_smin[x_a][ 11] = {   9,   10,   13,   27,   28,   29,   53,   55}; //   8
  needed_v_smin[x_a][ 12] = {   9,   10,   14,   15}; //   4
  needed_v_smin[x_a][ 13] = {  11,   12}; //   2
  needed_v_smin[x_a][ 14] = {  13,   16}; //   2
  needed_v_smin[x_a][ 15] = {  14,   15,   16,   26,   32,   33,   34,   38,   39,   54}; //  10
  needed_v_smin[x_a][ 16] = {  14,   15,   16,   32,   33,   34,   54}; //   7
  needed_v_smin[x_a][ 17] = {  17,   18,   23,   35,   36,   37,   56}; //   7
  needed_v_smin[x_a][ 18] = {  17,   18,   21,   22}; //   4
  needed_v_smin[x_a][ 19] = {  19,   20}; //   2
  needed_v_smin[x_a][ 20] = {  21,   22,   24,   25,   30,   31,   40,   41,   42,   57}; //  10
  needed_v_smin[x_a][ 21] = {  21,   22,   24,   40,   41,   42,   57}; //   7
  needed_v_smin[x_a][ 22] = {  23,   24}; //   2
  needed_v_smin[x_a][ 23] = {  25}; //   1
  needed_v_smin[x_a][ 24] = {  26}; //   1

  v_smax[x_a].resize(24);
  needed_v_smax[x_a].resize(24);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   25,   27,   28,   29,   30,   31,   43,   44,   45,   49,   50,   51,   52,   53,   55,   56,   57,   58}; //  29
  needed_v_smax[x_a][  1] = {   0,    1,   11,   12,   30,   31,   43,   44}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   58}; //  20
  needed_v_smax[x_a][  3] = {   2,   45}; //   2
  needed_v_smax[x_a][  4] = {   3,    4,    5,   17,   18,   19,   20,   23,   35,   36,   37,   38,   39,   46,   47,   48}; //  16
  needed_v_smax[x_a][  5] = {   3,    4,   19,   20,   38,   39,   46,   47}; //   8
  needed_v_smax[x_a][  6] = {   5,   48}; //   2
  needed_v_smax[x_a][  7] = {   6,    7,    8,   49,   50,   51,   52,   55,   56,   58}; //  10
  needed_v_smax[x_a][  8] = {   9,   10,   13,   14,   15,   16,   27,   28,   29,   32,   33,   34,   53,   54}; //  14
  needed_v_smax[x_a][  9] = {   9,   10,   11,   12,   14,   15}; //   6
  needed_v_smax[x_a][ 10] = {  13,   16,   25}; //   3
  needed_v_smax[x_a][ 11] = {  14,   15,   16,   26,   32,   33,   34,   54}; //   8
  needed_v_smax[x_a][ 12] = {  17,   18,   21,   22,   23,   24,   35,   36,   37,   40,   41,   42}; //  12
  needed_v_smax[x_a][ 13] = {  17,   18,   19,   20,   21,   22}; //   6
  needed_v_smax[x_a][ 14] = {  21,   22,   24,   40,   41,   42}; //   6
  needed_v_smax[x_a][ 15] = {  23,   24,   26}; //   3
  needed_v_smax[x_a][ 16] = {  25,   57}; //   2
  needed_v_smax[x_a][ 17] = {  26}; //   1
  needed_v_smax[x_a][ 18] = {  27,   28,   29,   32,   33,   34,   53,   54}; //   8
  needed_v_smax[x_a][ 19] = {  30,   31}; //   2
  needed_v_smax[x_a][ 20] = {  35,   36,   37,   40,   41,   42}; //   6
  needed_v_smax[x_a][ 21] = {  38,   39}; //   2
  needed_v_smax[x_a][ 22] = {  56,   57}; //   2
  needed_v_smax[x_a][ 23] = {  55}; //   1

  g_p[x_a].resize(38);
  needed_g_p[x_a].resize(38);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   25,   27,   28,   29,   30,   31,   43,   44,   45,   49,   50,   51,   52,   53,   55,   56,   57,   58}; //  29
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   11,   12,   30,   31,   43,   44}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   17,   18,   19,   20,   23,   35,   36,   37,   38,   39,   46,   47,   48}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   19,   20,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,   49,   50,   51,   52,   55,   56,   58}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {   9,   10,   13,   27,   28,   29,   53}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax8");
  needed_g_p[x_a][17] = {   9,   10,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][18] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][19] = {  13,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][20] = {  14,   15,   16,   26,   32,   33,   34,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax11");
  needed_g_p[x_a][21] = {  14,   15,   16,   32,   33,   34,   54}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin16_smax8");
  needed_g_p[x_a][22] = {  17,   18,   23,   35,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin17_smax12");
  needed_g_p[x_a][23] = {  17,   18,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][24] = {  19,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax13");
  needed_g_p[x_a][25] = {  21,   22,   24,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax14");
  needed_g_p[x_a][26] = {  21,   22,   24,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin21_smax12");
  needed_g_p[x_a][27] = {  23,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax15");
  needed_g_p[x_a][28] = {  25,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax16");
  needed_g_p[x_a][29] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][30] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax17");
  needed_g_p[x_a][31] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax15");
  needed_g_p[x_a][32] = {  27,   28,   29,   32,   33,   34,   53,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax18");
  needed_g_p[x_a][33] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax19");
  needed_g_p[x_a][34] = {  35,   36,   37,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax20");
  needed_g_p[x_a][35] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax21");
  needed_g_p[x_a][36] = {  56}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin17_smax22");
  needed_g_p[x_a][37] = {  57}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin21_smax22");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  52,   58}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  55}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax23");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   52}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__64_60");
  needed_g_t[x_a][1] = {  43,   44,   45,   46,   47,   48,   49,   50,   51,   58}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__64_60");
  needed_g_t[x_a][2] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_66__36_24");
  needed_g_t[x_a][3] = {  53,   54,   55}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_88");
  needed_g_t[x_a][4] = {  55}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_37__24_64");
  needed_g_t[x_a][5] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__24_100");
  needed_g_t[x_a][6] = {  58}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__24_36");

  g_d[x_a].resize(33);
  needed_g_d[x_a].resize(33);
  needed_g_d[x_a][0] = {   0,    1,   43,   44}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   11,   12,   30,   31,   43,   44}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   25,   27,   28,   29,   30,   31,   35,   36,   37,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52,   53,   55,   56,   57,   58}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   45}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   19,   20,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,    8,   17,   18,   19,   20,   23,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   58}; //  35
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   48}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   48}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,    8,   49,   50,   51}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   9,   10,   11,   12,   14,   15}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][12] = {   9,   10,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][13] = {   9,   10,   13,   27,   28,   29,   53}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  11,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][15] = {  13,   16,   25}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][16] = {  13,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][17] = {  14,   15,   16,   32,   33,   34,   54}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][18] = {  14,   15,   16,   26,   32,   33,   34,   38,   39,   54}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][19] = {  17,   18,   19,   20,   21,   22}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][20] = {  17,   18,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][21] = {  17,   18,   23,   35,   36,   37,   56}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][22] = {  19,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][23] = {  21,   22,   24,   40,   41,   42,   57}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][24] = {  21,   22,   24,   25,   30,   31,   40,   41,   42,   57}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][25] = {  23,   24,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][26] = {  23,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__8_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__8_100");
  needed_g_d[x_a][27] = {  25}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__68_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__68_24");
  needed_g_d[x_a][28] = {  26}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__36_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__36_72");
  needed_g_d[x_a][29] = {  27,   28,   29,   32,   33,   34}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][30] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][31] = {  35,   36,   37,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][32] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(59);
  c_f[x_a].resize(59);
  c_t[x_a].resize(59);
  c_d[x_a].resize(59);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 10,   7,   2}; //   3

  c_p[x_a][9] = {  0,  16,  17}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  12,  13,   2}; //   4

  c_p[x_a][10] = {  0,  16,  17}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 11,  12,  13,   2}; //   4

  c_p[x_a][11] = {  0,   1,  18}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 11,  14,   1,   2}; //   4

  c_p[x_a][12] = {  0,   1,  18}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 11,  14,   1,   2}; //   4

  c_p[x_a][13] = {  0,  16,  19}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 15,  16,  13,   2}; //   4

  c_p[x_a][14] = { 20,  21,  17}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 11,  12,  17,  18}; //   4

  c_p[x_a][15] = { 20,  21,  17}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 11,  12,  17,  18}; //   4

  c_p[x_a][16] = { 20,  21,  19}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 15,  16,  17,  18}; //   4

  c_p[x_a][17] = {  6,  22,  23}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 19,  20,  21,   7}; //   4

  c_p[x_a][18] = {  6,  22,  23}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 19,  20,  21,   7}; //   4

  c_p[x_a][19] = {  6,   7,  24}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 19,  22,   6,   7}; //   4

  c_p[x_a][20] = {  6,   7,  24}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 19,  22,   6,   7}; //   4

  c_p[x_a][21] = { 25,  26,  23}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 19,  20,  23,  24}; //   4

  c_p[x_a][22] = { 25,  26,  23}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 19,  20,  23,  24}; //   4

  c_p[x_a][23] = {  6,  22,  27}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 25,  26,  21,   7}; //   4

  c_p[x_a][24] = { 25,  26,  27}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 25,  26,  23,  24}; //   4

  c_p[x_a][25] = {  0,  28,  29}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 15,  27,  24,   2}; //   4

  c_p[x_a][26] = { 20,  30,  31}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 25,  28,   7,  18}; //   4

  c_p[x_a][27] = {  0,  16,  32}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 29,   7,  13,   2}; //   4

  c_p[x_a][28] = {  0,  16,  32}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 29,   7,  13,   2}; //   4

  c_p[x_a][29] = {  0,  16,  32}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 29,   7,  13,   2}; //   4

  c_p[x_a][30] = {  0,   1,  33}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 30,  24,   1,   2}; //   4

  c_p[x_a][31] = {  0,   1,  33}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 30,  24,   1,   2}; //   4

  c_p[x_a][32] = { 20,  21,  32}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 29,   7,  17,  18}; //   4

  c_p[x_a][33] = { 20,  21,  32}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 29,   7,  17,  18}; //   4

  c_p[x_a][34] = { 20,  21,  32}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 29,   7,  17,  18}; //   4

  c_p[x_a][35] = {  6,  22,  34}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 31,   2,  21,   7}; //   4

  c_p[x_a][36] = {  6,  22,  34}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 31,   2,  21,   7}; //   4

  c_p[x_a][37] = {  6,  22,  34}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 31,   2,  21,   7}; //   4

  c_p[x_a][38] = {  6,   7,  35}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 32,  18,   6,   7}; //   4

  c_p[x_a][39] = {  6,   7,  35}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 32,  18,   6,   7}; //   4

  c_p[x_a][40] = { 25,  26,  34}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 31,   2,  23,  24}; //   4

  c_p[x_a][41] = { 25,  26,  34}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 31,   2,  23,  24}; //   4

  c_p[x_a][42] = { 25,  26,  34}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 31,   2,  23,  24}; //   4

  c_p[x_a][43] = {  0,   1,   2}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  1}; //   1
  c_d[x_a][43] = {  0,   1,   2}; //   3

  c_p[x_a][44] = {  0,   1,   3}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  1}; //   1
  c_d[x_a][44] = {  0,   1,   2}; //   3

  c_p[x_a][45] = {  0,   4,   5}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  1}; //   1
  c_d[x_a][45] = {  3,   4,   2}; //   3

  c_p[x_a][46] = {  6,   7,   8}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  1}; //   1
  c_d[x_a][46] = {  5,   6,   7}; //   3

  c_p[x_a][47] = {  6,   7,   9}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  1}; //   1
  c_d[x_a][47] = {  5,   6,   7}; //   3

  c_p[x_a][48] = {  6,  10,  11}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  1}; //   1
  c_d[x_a][48] = {  8,   9,   7}; //   3

  c_p[x_a][49] = {  0,  12,  13}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  1}; //   1
  c_d[x_a][49] = { 10,   7,   2}; //   3

  c_p[x_a][50] = {  0,  12,  14}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  1}; //   1
  c_d[x_a][50] = { 10,   7,   2}; //   3

  c_p[x_a][51] = {  0,  12,  15}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  1}; //   1
  c_d[x_a][51] = { 10,   7,   2}; //   3

  c_p[x_a][52] = {  0,  12}; //   2
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  0,   2}; //   2
  c_d[x_a][52] = {  7,   2}; //   2

  c_p[x_a][53] = {  0,  16,  32}; //   3
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  3}; //   1
  c_d[x_a][53] = {  7,  13,   2}; //   3

  c_p[x_a][54] = { 20,  21,  32}; //   3
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  3}; //   1
  c_d[x_a][54] = {  7,  17,  18}; //   3

  c_p[x_a][55] = {  0,  12}; //   2
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  3,   4}; //   2
  c_d[x_a][55] = {  7,   2}; //   2

  c_p[x_a][56] = {  0,  12,  36}; //   3
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  5}; //   1
  c_d[x_a][56] = { 21,   7,   2}; //   3

  c_p[x_a][57] = {  0,  28,  37}; //   3
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  5}; //   1
  c_d[x_a][57] = { 23,  24,   2}; //   3

  c_p[x_a][58] = {  0,  12}; //   2
  c_f[x_a][58] = {  0}; //   1
  c_t[x_a][58] = {  1,   6}; //   2
  c_d[x_a][58] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   5)
// channel    1: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   5)
// channel    2: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   5)
// channel    3: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   5)
// channel    4: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   5)
// channel    5: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   5)
// channel    6: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   5)
// channel    7: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   5)
// channel    8: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  25,   5)
// channel    9: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
// channel   10: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  23)
// channel   11: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
// channel   12: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
// channel   13: 5yyyv(1, 2, 32, 4, 64, 8, 16;  24,  24,   0,  23)
// channel   14: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
// channel   15: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  23)
// channel   16: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,  24,   0,  23)
// channel   17: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
// channel   18: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  23)
// channel   19: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
// channel   20: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
// channel   21: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
// channel   22: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  23)
// channel   23: 5yyyv(1, 2, 16, 8, 64, 4, 32;  24,  24,   0,  23)
// channel   24: 5yyyv(1, 2, 16, 8, 32, 4, 64;   0,  24,   0,  23)
// channel   25: 5y2vv(1, 2, 32, 4, 64, 8, 16;  24,   0,   0,  23)
// channel   26: 5y2vv(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,  23)
// channel   27: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   0)
// channel   28: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  23)
// channel   29: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  25)
// channel   30: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
// channel   31: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
// channel   32: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
// channel   33: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  23)
// channel   34: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  25)
// channel   35: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
// channel   36: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  23)
// channel   37: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  25)
// channel   38: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
// channel   39: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
// channel   40: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
// channel   41: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  23)
// channel   42: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  25)
// channel   43: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   5)
// channel   44: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   5)
// channel   45: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   5)
// channel   46: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   5)
// channel   47: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   5)
// channel   48: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   5)
// channel   49: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   5)
// channel   50: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   5)
// channel   51: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,   5)
// channel   52: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   5,   6)
// channel   53: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   6)
// channel   54: 2v3yv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   6)
// channel   55: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,   6,   6)
// channel   56: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  24,   6)
// channel   57: 3yv2v(1, 2, 32, 4, 64, 8, 16;  24,   0,  24,   6)
// channel   58: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   5,   6)
