#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_050_dxa_emmupvmvexdx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_050_dxa_emmupvmvexdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  needed_v_smin[x_a][  0] = {   6,    8,    9,   10,   14,   15,   16,   17,   18,   22,   23,   24,   27,   28,   31,   32,   34,   35,   36,   39,   40,   41,   45,   46,   47,   48,   49,   50,   51,   52,   42,   43,   44}; //  33
  needed_v_smin[x_a][  1] = {   7,   11,   12,   13,   14,   15,   19,   20,   21,   22,   23,   24,   25,   26,   29,   30,   33,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   39,   40,   41}; //  33
  needed_v_smin[x_a][  2] = {   7,   24,   46,   48,   47}; //   5
  needed_v_smin[x_a][  3] = {   8,    9,   16,   17,   31,   32,   35,   36,   27,   28,   34}; //  11
  needed_v_smin[x_a][  4] = {   8,    9,   16,   17,    3,    4,    5,   27,   28,   31,   32,   34,   35,   36}; //  14
  needed_v_smin[x_a][  5] = {  10,   18}; //   2
  needed_v_smin[x_a][  6] = {  10,   18}; //   2
  needed_v_smin[x_a][  7] = {  11,   12,   19,   20,   29,   30,   37,   38,   25,   26,   33}; //  11
  needed_v_smin[x_a][  8] = {  11,   12,   19,   20,    0,    1,    2,   25,   26,   29,   30,   33,   37,   38}; //  14
  needed_v_smin[x_a][  9] = {  13,   21}; //   2
  needed_v_smin[x_a][ 10] = {  13,   21}; //   2
  needed_v_smin[x_a][ 11] = {  14,   15,   22,   23,   39,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52}; //  15
  needed_v_smin[x_a][ 12] = {   0,    1,    3,    4}; //   4
  needed_v_smin[x_a][ 13] = {   0,    1}; //   2
  needed_v_smin[x_a][ 14] = {   2}; //   1
  needed_v_smin[x_a][ 15] = {   2}; //   1
  needed_v_smin[x_a][ 16] = {   3,    4}; //   2
  needed_v_smin[x_a][ 17] = {   5}; //   1
  needed_v_smin[x_a][ 18] = {   5}; //   1
  needed_v_smin[x_a][ 19] = {   6}; //   1
  needed_v_smin[x_a][ 20] = {   6}; //   1
  needed_v_smin[x_a][ 21] = {   7}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   6,    8,    9,   10,   14,   15,   16,   17,   18,   22,   23,   27,   28,   31,   32,   34,   35,   36,   39,   40,   41,   48,   49,   50}; //  24
  needed_v_smax[x_a][  1] = {   7,   11,   12,   13,   19,   20,   21,   24,   25,   26,   29,   30,   33,   37,   38,   42,   43,   44,   45,   46,   47,   51,   52}; //  23
  needed_v_smax[x_a][  2] = {   7,   24,   46}; //   3
  needed_v_smax[x_a][  3] = {   8,    9,   16,   17,   31,   32,   35,   36,    3,    4,    5,   27,   28,   34}; //  14
  needed_v_smax[x_a][  4] = {   8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,    4,    5,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52}; //  47
  needed_v_smax[x_a][  5] = {  10,   18}; //   2
  needed_v_smax[x_a][  6] = {  11,   12,   19,   20,   29,   30,   37,   38,    0,    1,    2,   25,   26,   33}; //  14
  needed_v_smax[x_a][  7] = {  13,   21}; //   2
  needed_v_smax[x_a][  8] = {  14,   15,   22,   23,   48,   49,   50,   39,   40,   41}; //  10
  needed_v_smax[x_a][  9] = {  24,   46}; //   2
  needed_v_smax[x_a][ 10] = {  45,   47,   51,   52,   42,   43,   44}; //   7
  needed_v_smax[x_a][ 11] = {  48,   47}; //   2
  needed_v_smax[x_a][ 12] = {   0,    1,    3,    4}; //   4
  needed_v_smax[x_a][ 13] = {   2}; //   1
  needed_v_smax[x_a][ 14] = {   5}; //   1
  needed_v_smax[x_a][ 15] = {   6}; //   1
  needed_v_smax[x_a][ 16] = {   6}; //   1
  needed_v_smax[x_a][ 17] = {   7}; //   1

  g_p[x_a].resize(19);
  needed_g_p[x_a].resize(19);
  needed_g_p[x_a][0] = {   6,    8,    9,   10,   14,   15,   16,   17,   18,   22,   23,   27,   28,   31,   32,   34,   35,   36,   39,   40,   41,   48,   49,   50}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   7,   11,   12,   13,   19,   20,   21,   24,   25,   26,   29,   30,   33,   37,   38,   42,   43,   44,   45,   46,   47,   51,   52}; //  23
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   24,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   8,    9,   16,   17,   31,   32,   35,   36}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   9,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {  10,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax4");
  needed_g_p[x_a][8] = {  11,   12,   19,   20,   29,   30,   37,   38}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {  11,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {  12,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax4");
  needed_g_p[x_a][11] = {  13,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {  13,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax4");
  needed_g_p[x_a][13] = {  14,   15,   22,   23,   48,   49,   50}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax8");
  needed_g_p[x_a][14] = {  14,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax4");
  needed_g_p[x_a][15] = {  15,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax4");
  needed_g_p[x_a][16] = {  24,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][17] = {  45,   47,   51,   52}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][18] = {  48}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax11");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    1,    3,    4}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax12");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax6");
  needed_g_f[x_a][2] = {   0,    1,    2,   25,   26,   29,   30,   33,   37,   38}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");
  needed_g_f[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax13");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax6");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][6] = {   3,    4,    5,   27,   28,   31,   32,   34,   35,   36}; //  10
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax14");
  needed_g_f[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax3");
  needed_g_f[x_a][9] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax15");
  needed_g_f[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax16");
  needed_g_f[x_a][11] = {   7}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax17");
  needed_g_f[x_a][12] = {  25,   26,   33}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][13] = {  27,   28,   34}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][14] = {  39,   40,   41}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax8");
  needed_g_f[x_a][15] = {  39,   40,   41,   42,   43,   44,   45,   49,   50,   51,   52}; //  11
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax4");
  needed_g_f[x_a][16] = {  42,   43,   44}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax10");
  needed_g_f[x_a][17] = {  47}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax11");

  g_t[x_a].resize(34);
  needed_g_t[x_a].resize(34);
  needed_g_t[x_a][0] = {   0,    3,   25,   27,   29,   31,   35,   37,   39,   42,   49,   51}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,    2,   25,   26,   29,   30,   33}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][3] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][4] = {   1,    2,    4,    5,   26,   28,   30,   32,   33,   34,   36,   38,   40,   41,   43,   44,   50,   52}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_97__16_4");
  needed_g_t[x_a][7] = {   3,    4,    5,   27,   28,   31,   32,   34}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][8] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_81__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_81__32_8");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__24_96");
  needed_g_t[x_a][14] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_25__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_25__32_64");
  needed_g_t[x_a][15] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][16] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__10_1__16_100");
  needed_g_t[x_a][17] = {   8,    9,   10,   11,   12,   13,   14,   15,   45}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][18] = {  25,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_65__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_65__16_36");
  needed_g_t[x_a][19] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_65__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_65__32_24");
  needed_g_t[x_a][20] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][21] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][22] = {  35,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][23] = {  37,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][24] = {  39,   40,   41,   49,   50}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__24_36");
  needed_g_t[x_a][25] = {  39,   40}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__4_32");
  needed_g_t[x_a][26] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__32_4");
  needed_g_t[x_a][27] = {  42,   43,   44,   51,   52}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_65__36_24");
  needed_g_t[x_a][28] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__8_16");
  needed_g_t[x_a][29] = {  44}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__16_8");
  needed_g_t[x_a][30] = {  45}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][31] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][32] = {  47}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_25__36_64");
  needed_g_t[x_a][33] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__24_100");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   6,    8,    9,   10,   14,   15,   16,   17,   18,   22,   23,   24,   27,   28,   31,   32,   34,   35,   36,   39,   40,   41,   45,   46,   47,   48,   49,   50,   51,   52}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][1] = {   7,   24,   46,   48}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][2] = {   7,   11,   12,   13,   14,   15,   19,   20,   21,   22,   23,   24,   25,   26,   29,   30,   33,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][3] = {   8,    9,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][4] = {   8,    9,   16,   17,   31,   32,   35,   36}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][5] = {  10,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {  10,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {  11,   12,   19,   20}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {  11,   12,   19,   20,   29,   30,   37,   38}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][9] = {  13,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {  13,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][11] = {  14,   15,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][12] = {  16,   17,   18,   19,   20,   21,   22,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  24}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");

  c_p[x_a].resize(53);
  c_f[x_a].resize(53);
  c_t[x_a].resize(53);
  c_d[x_a].resize(53);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  4,   1,   2,   3}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  4,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5,   6}; //   3
  c_t[x_a][3] = {  0,   7,   8,   9}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   5,   6}; //   3
  c_t[x_a][4] = {  4,   7,   8,   9}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  7,   8,   6}; //   3
  c_t[x_a][5] = {  4,   7,  10,  11}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  9,  10}; //   2
  c_t[x_a][6] = { 12,  13,  14}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1,   2}; //   2
  c_f[x_a][7] = { 11}; //   1
  c_t[x_a][7] = { 15,  16}; //   2
  c_d[x_a][7] = {  1,   2}; //   2

  c_p[x_a][8] = {  0,   3,   4}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 17}; //   1
  c_d[x_a][8] = {  3,   4,   0}; //   3

  c_p[x_a][9] = {  0,   3,   5}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 17}; //   1
  c_d[x_a][9] = {  3,   4,   0}; //   3

  c_p[x_a][10] = {  0,   6,   7}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 17}; //   1
  c_d[x_a][10] = {  5,   6,   0}; //   3

  c_p[x_a][11] = {  1,   8,   9}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 17}; //   1
  c_d[x_a][11] = {  7,   8,   2}; //   3

  c_p[x_a][12] = {  1,   8,  10}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 17}; //   1
  c_d[x_a][12] = {  7,   8,   2}; //   3

  c_p[x_a][13] = {  1,  11,  12}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 17}; //   1
  c_d[x_a][13] = {  9,  10,   2}; //   3

  c_p[x_a][14] = {  0,  13,  14}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 17}; //   1
  c_d[x_a][14] = { 11,   2,   0}; //   3

  c_p[x_a][15] = {  0,  13,  15}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 17}; //   1
  c_d[x_a][15] = { 11,   2,   0}; //   3

  c_p[x_a][16] = {  0,   3,   4}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 12,   3,   4,   0}; //   4

  c_p[x_a][17] = {  0,   3,   5}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,   3,   4,   0}; //   4

  c_p[x_a][18] = {  0,   6,   7}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 12,   5,   6,   0}; //   4

  c_p[x_a][19] = {  1,   8,   9}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 12,   7,   8,   2}; //   4

  c_p[x_a][20] = {  1,   8,  10}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 12,   7,   8,   2}; //   4

  c_p[x_a][21] = {  1,  11,  12}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 12,   9,  10,   2}; //   4

  c_p[x_a][22] = {  0,  13,  14}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 12,  11,   2,   0}; //   4

  c_p[x_a][23] = {  0,  13,  15}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 12,  11,   2,   0}; //   4

  c_p[x_a][24] = {  1,   2,  16}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 13,   0,   1,   2}; //   4

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = { 12,   2}; //   2
  c_t[x_a][25] = {  0,   1,  18}; //   3
  c_d[x_a][25] = {  2}; //   1

  c_p[x_a][26] = {  1}; //   1
  c_f[x_a][26] = { 12,   2}; //   2
  c_t[x_a][26] = {  4,   1,  18}; //   3
  c_d[x_a][26] = {  2}; //   1

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = { 13,   6}; //   2
  c_t[x_a][27] = {  0,   7,  19}; //   3
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = { 13,   6}; //   2
  c_t[x_a][28] = {  4,   7,  19}; //   3
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  1,   8}; //   2
  c_f[x_a][29] = {  2}; //   1
  c_t[x_a][29] = {  0,   1}; //   2
  c_d[x_a][29] = {  8,   2}; //   2

  c_p[x_a][30] = {  1,   8}; //   2
  c_f[x_a][30] = {  2}; //   1
  c_t[x_a][30] = {  4,   1}; //   2
  c_d[x_a][30] = {  8,   2}; //   2

  c_p[x_a][31] = {  0,   3}; //   2
  c_f[x_a][31] = {  6}; //   1
  c_t[x_a][31] = {  0,   7}; //   2
  c_d[x_a][31] = {  4,   0}; //   2

  c_p[x_a][32] = {  0,   3}; //   2
  c_f[x_a][32] = {  6}; //   1
  c_t[x_a][32] = {  4,   7}; //   2
  c_d[x_a][32] = {  4,   0}; //   2

  c_p[x_a][33] = {  1}; //   1
  c_f[x_a][33] = { 12,   2}; //   2
  c_t[x_a][33] = {  4,   1,  20}; //   3
  c_d[x_a][33] = {  2}; //   1

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = { 13,   6}; //   2
  c_t[x_a][34] = {  4,   7,  21}; //   3
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  0,   3}; //   2
  c_f[x_a][35] = {  6}; //   1
  c_t[x_a][35] = {  0,  22}; //   2
  c_d[x_a][35] = {  4,   0}; //   2

  c_p[x_a][36] = {  0,   3}; //   2
  c_f[x_a][36] = {  6}; //   1
  c_t[x_a][36] = {  4,  22}; //   2
  c_d[x_a][36] = {  4,   0}; //   2

  c_p[x_a][37] = {  1,   8}; //   2
  c_f[x_a][37] = {  2}; //   1
  c_t[x_a][37] = {  0,  23}; //   2
  c_d[x_a][37] = {  8,   2}; //   2

  c_p[x_a][38] = {  1,   8}; //   2
  c_f[x_a][38] = {  2}; //   1
  c_t[x_a][38] = {  4,  23}; //   2
  c_d[x_a][38] = {  8,   2}; //   2

  c_p[x_a][39] = {  0}; //   1
  c_f[x_a][39] = { 14,  15}; //   2
  c_t[x_a][39] = {  0,  24,  25}; //   3
  c_d[x_a][39] = {  0}; //   1

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = { 14,  15}; //   2
  c_t[x_a][40] = {  4,  24,  25}; //   3
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  0}; //   1
  c_f[x_a][41] = { 14,  15}; //   2
  c_t[x_a][41] = {  4,  24,  26}; //   3
  c_d[x_a][41] = {  0}; //   1

  c_p[x_a][42] = {  1}; //   1
  c_f[x_a][42] = { 16,  15}; //   2
  c_t[x_a][42] = {  0,  27,  28}; //   3
  c_d[x_a][42] = {  2}; //   1

  c_p[x_a][43] = {  1}; //   1
  c_f[x_a][43] = { 16,  15}; //   2
  c_t[x_a][43] = {  4,  27,  28}; //   3
  c_d[x_a][43] = {  2}; //   1

  c_p[x_a][44] = {  1}; //   1
  c_f[x_a][44] = { 16,  15}; //   2
  c_t[x_a][44] = {  4,  27,  29}; //   3
  c_d[x_a][44] = {  2}; //   1

  c_p[x_a][45] = {  1,  17}; //   2
  c_f[x_a][45] = { 15}; //   1
  c_t[x_a][45] = { 17,  30}; //   2
  c_d[x_a][45] = {  0,   2}; //   2

  c_p[x_a][46] = {  1,   2,  16}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 31}; //   1
  c_d[x_a][46] = {  0,   1,   2}; //   3

  c_p[x_a][47] = {  1,  17}; //   2
  c_f[x_a][47] = { 17}; //   1
  c_t[x_a][47] = { 31,  32}; //   2
  c_d[x_a][47] = {  0,   2}; //   2

  c_p[x_a][48] = {  0,  13,  18}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 33}; //   1
  c_d[x_a][48] = {  1,   2,   0}; //   3

  c_p[x_a][49] = {  0,  13}; //   2
  c_f[x_a][49] = { 15}; //   1
  c_t[x_a][49] = {  0,  24}; //   2
  c_d[x_a][49] = {  2,   0}; //   2

  c_p[x_a][50] = {  0,  13}; //   2
  c_f[x_a][50] = { 15}; //   1
  c_t[x_a][50] = {  4,  24}; //   2
  c_d[x_a][50] = {  2,   0}; //   2

  c_p[x_a][51] = {  1,  17}; //   2
  c_f[x_a][51] = { 15}; //   1
  c_t[x_a][51] = {  0,  27}; //   2
  c_d[x_a][51] = {  0,   2}; //   2

  c_p[x_a][52] = {  1,  17}; //   2
  c_f[x_a][52] = { 15}; //   1
  c_t[x_a][52] = {  4,  27}; //   2
  c_d[x_a][52] = {  0,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 64, 4, 32, 16, 8;   0,   0,   0,  24)
// channel    1: 11111(1, 2, 64, 4, 32, 16, 8;  23,   0,   0,  24)
// channel    2: 11111(1, 2, 64, 32, 4, 16, 8;  23,   0,   0,  24)
// channel    3: 11111(1, 2, 64, 8, 16, 32, 4;   0,   0,   0,  24)
// channel    4: 11111(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,  24)
// channel    5: 11111(1, 2, 64, 16, 8, 32, 4;  23,   0,   0,  24)
// channel    6: 2v111(1, 2, 8, 16, 64, 32, 4;  24,   0,   0,  24)
// channel    7: 3yv11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
// channel    8: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
// channel    9: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
// channel   10: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
// channel   11: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
// channel   12: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
// channel   13: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
// channel   14: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
// channel   15: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
// channel   16: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
// channel   17: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
// channel   18: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
// channel   19: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   20: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
// channel   21: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
// channel   22: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
// channel   23: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
// channel   24: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,   0)
// channel   25: 12v11(1, 2, 64, 4, 32, 16, 8;  24,   0,   0,  24)
// channel   26: 12v11(1, 2, 64, 4, 32, 16, 8;  24,  23,   0,  24)
// channel   27: 12v11(1, 2, 64, 8, 16, 32, 4;  24,   0,   0,  24)
// channel   28: 12v11(1, 2, 64, 8, 16, 32, 4;  24,  23,   0,  24)
// channel   29: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
// channel   30: 13yv1(1, 2, 64, 16, 4, 32, 8;  24,   0,  23,   0)
// channel   31: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
// channel   32: 13yv1(1, 2, 64, 32, 8, 16, 4;  24,   0,  23,   0)
// channel   33: 112v1(1, 2, 64, 16, 4, 32, 8;  24,  23,   0,   0)
// channel   34: 112v1(1, 2, 64, 32, 8, 16, 4;  24,  23,   0,   0)
// channel   35: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
// channel   36: 113yv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
// channel   37: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
// channel   38: 113yv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
// channel   39: 1112v(1, 2, 64, 4, 32, 8, 16;  24,   0,  24,   0)
// channel   40: 1112v(1, 2, 64, 4, 32, 8, 16;  24,  23,  24,   0)
// channel   41: 1112v(1, 2, 64, 32, 4, 8, 16;  24,  23,  24,   0)
// channel   42: 1112v(1, 2, 64, 8, 16, 4, 32;  24,   0,  24,   0)
// channel   43: 1112v(1, 2, 64, 8, 16, 4, 32;  24,  23,  24,   0)
// channel   44: 1112v(1, 2, 64, 16, 8, 4, 32;  24,  23,  24,   0)
// channel   45: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
// channel   46: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,   0)
// channel   47: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  24)
// channel   48: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
// channel   49: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,  24)
// channel   50: 12v2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,  24)
// channel   51: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,  24)
// channel   52: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  23,  24)
