#include "header.hpp"

#include "ppenex02.phasespace.set.hpp"

void ppenex02_phasespace_set::ax_psp_220_dux_emvexssx(int x_a){
  static Logger logger("ppenex02_phasespace_set::ax_psp_220_dux_emvexssx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = {   0,    1}; //   2

  v_smax[x_a].resize(4);
  needed_v_smax[x_a].resize(4);
  needed_v_smax[x_a][  0] = {   0}; //   1
  needed_v_smax[x_a][  1] = {   0}; //   1
  needed_v_smax[x_a][  2] = {   1}; //   1
  needed_v_smax[x_a][  3] = {   1}; //   1

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax3");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(2);
  c_f[x_a].resize(2);
  c_t[x_a].resize(2);
  c_d[x_a].resize(2);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v2v(1, 2, 4, 8, 16, 32;   0,  24,   0)
// channel    1: 2v2v(1, 2, 16, 32, 4, 8;  24,   0,   0)
