#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ac_psp_230_du_emvexauu(int x_a, int channel){
  static Logger logger("ppenexa03_phasespace_set::ac_psp_230_du_emvexauu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_propagator(x_a,  24,  28, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = smin_opt[x_a][20];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][104], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][96], 2);
      c_propagator(x_a,  24,  28, v_smin[x_a][  5], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][92]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][  6], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][92]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  8], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  9], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][ 10] = smin_opt[x_a][48];
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][ 10], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][112]), 2);
      c_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 11], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 12] = smin_opt[x_a][80];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][44], 2);
      c_propagator(x_a,   0,  80, v_smin[x_a][ 12], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][80], sqrtsmin_opt[x_a][112]), 2);
      c_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][92]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  92, v_smin[x_a][ 13], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][  1], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][80], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  2], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 17));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][ 10] = smin_opt[x_a][48];
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][76]), 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][ 10], v_smax[x_a][ 13], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 11], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 12] = smin_opt[x_a][80];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][44]), 2);
      c_timelikeinvariant(x_a,  80, v_smin[x_a][ 12], v_smax[x_a][ 14], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][92]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][ 13], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 14] = smin_opt[x_a][96];
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][28]), 2);
      c_timelikeinvariant(x_a,  96, v_smin[x_a][ 14], v_smax[x_a][ 15], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][96], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 15], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 16], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][108]);
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a, 108, v_smin[x_a][ 17], v_smax[x_a][ 16], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][  9], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][92]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  92, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][80], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  76, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 18], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 12));
    }
    else if (c_f[x_a][channel][i_f] ==  13){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][80], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_timelikeinvariant(x_a, 112, v_smin[x_a][ 19], v_smax[x_a][ 17], random_manager.get_random(x_a, 1, 13));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  64,  60, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  60,   1,  66,  12,  48, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  48,  66,  13,  32,  16, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  32,  92, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0,  92,   1,  34,  12,  80, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel(x_a,   0,  80,  34,  13,  64,  16, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  16, 108, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,   0, 108,   1,  18,  12,  96, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel(x_a,   0,  96,  18,  13,  64,  32, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel(x_a,   0,  96,  18,  13,  32,  64, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0, 108,  18,   1,  32,  76, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,   0, 108,  18,   1,  64,  44, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0,  60,  66,   1,  32,  28, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0,  92,  34,   1,  64,  28, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  16, 108, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  64,  44, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel(x_a,   0,  44,  66,  17,  32,  12, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,   0, 108,   2,  17,  32,  76, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel(x_a,   0,  76,  34,  17,  64,  12, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel_opt(x_a,   0, 124,   1,   2,  12, 112, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel_opt(x_a,   0, 112,   2,  13,  48,  64, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,   0, 112,   2,  13,  80,  32, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  48,  76, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel_opt(x_a,   0, 124,   2,   1,  80,  44, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  76,  64,  12, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  44,  32,  12, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  92,  16,  76, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  92,  64,  28, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  12,  48, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  92,  12,  80, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  80,  16,  64, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
