#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_230_dc_emvexauc(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_230_dc_emvexauc");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13}; //  12
  needed_v_smin[x_a][  1] = {   2,    5,   10,   13,    9}; //   5
  needed_v_smin[x_a][  2] = {   3,    6}; //   2
  needed_v_smin[x_a][  3] = {   4,    7}; //   2
  needed_v_smin[x_a][  4] = {   4,    7}; //   2
  needed_v_smin[x_a][  5] = {   5}; //   1
  needed_v_smin[x_a][  6] = {   6,    7,    3,    4}; //   4
  needed_v_smin[x_a][  7] = {   8,   11,    0}; //   3
  needed_v_smin[x_a][  8] = {   8,    0,   11}; //   3
  needed_v_smin[x_a][  9] = {  12,   13}; //   2
  needed_v_smin[x_a][ 10] = {   1}; //   1
  needed_v_smin[x_a][ 11] = {   1}; //   1
  needed_v_smin[x_a][ 12] = {   2,    9,   10}; //   3
  needed_v_smin[x_a][ 13] = {  12}; //   1

  v_smax[x_a].resize(14);
  needed_v_smax[x_a].resize(14);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    5,    6,    9,   10}; //   8
  needed_v_smax[x_a][  1] = {   2,    5,   10,    9}; //   4
  needed_v_smax[x_a][  2] = {   3,    4,    6,    7}; //   4
  needed_v_smax[x_a][  3] = {   4,    7}; //   2
  needed_v_smax[x_a][  4] = {   5,    6,    7,    8,    0,    3,    4,   11}; //   8
  needed_v_smax[x_a][  5] = {   8,   11}; //   2
  needed_v_smax[x_a][  6] = {   8,   11}; //   2
  needed_v_smax[x_a][  7] = {  12,   13}; //   2
  needed_v_smax[x_a][  8] = {  12,   13}; //   2
  needed_v_smax[x_a][  9] = {  13}; //   1
  needed_v_smax[x_a][ 10] = {   0}; //   1
  needed_v_smax[x_a][ 11] = {   1}; //   1
  needed_v_smax[x_a][ 12] = {   1,    2,    9,   10}; //   4
  needed_v_smax[x_a][ 13] = {  12}; //   1

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    5,    6,    9,   10}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    5,   10}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {   8,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   8,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");
  needed_g_p[x_a][9] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax9");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax10");
  needed_g_f[x_a][1] = {   0,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax11");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax12");
  needed_g_f[x_a][4] = {   2,    9,   10}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax12");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][6] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax13");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    3,    4,    5,    6,    7,    8,   11}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][8] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][12] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][13] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    5,   10,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   4,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][8] = {   8,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {  5}; //   1
  c_t[x_a][3] = {  0,   7}; //   2
  c_d[x_a][3] = {  2,   0}; //   2

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  0,   7}; //   2
  c_d[x_a][4] = {  3,   4}; //   2

  c_p[x_a][5] = {  0,   1,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  5,   1,   0}; //   3

  c_p[x_a][6] = {  0,   2,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  6,   2,   0}; //   3

  c_p[x_a][7] = {  3,   4,   6}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  6,   3,   4}; //   3

  c_p[x_a][8] = {  7,   8,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  7,   0,   8}; //   3

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  6,   4}; //   2
  c_t[x_a][9] = {  8,   9,  10}; //   3
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = {  4}; //   1
  c_t[x_a][10] = {  8,   9}; //   2
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  7,   8}; //   2
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  0,   8}; //   2

  c_p[x_a][12] = { 10,  11}; //   2
  c_f[x_a][12] = {  7}; //   1
  c_t[x_a][12] = { 11,  12}; //   2
  c_d[x_a][12] = {  0,   9}; //   2

  c_p[x_a][13] = { 10,  11,  12}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 13}; //   1
  c_d[x_a][13] = {  1,   0,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
// channel    3: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
// channel    4: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
// channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel    8: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel    9: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
// channel   10: 13yv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   11: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   12: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
// channel   13: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
