#include "header.hpp"

#include "ppenexa03.phasespace.set.hpp"

void ppenexa03_phasespace_set::ax_psp_130_dux_emvexag(int x_a){
  static Logger logger("ppenexa03_phasespace_set::ax_psp_130_dux_emvexag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(5);
  needed_v_smin[x_a].resize(5);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  needed_v_smin[x_a][  1] = {   2,    6,    0,    4,    9}; //   5
  needed_v_smin[x_a][  2] = {   3,    7}; //   2
  needed_v_smin[x_a][  3] = {   3,    7}; //   2
  needed_v_smin[x_a][  4] = {   1,    5,    8}; //   3

  v_smax[x_a].resize(4);
  needed_v_smax[x_a].resize(4);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  needed_v_smax[x_a][  1] = {   2,    3,    6,    7,    0,    4,    9}; //   7
  needed_v_smax[x_a][  2] = {   3,    7}; //   2
  needed_v_smax[x_a][  3] = {   1,    5,    8}; //   3

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax1");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    4,    9}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   1,    5,    8}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    2,    3}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {   4,    6,    7,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {   5,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   0,    1,    2,    4,    5,    6,    8,    9}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   3,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][3] = {   3,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(10);
  c_f[x_a].resize(10);
  c_t[x_a].resize(10);
  c_d[x_a].resize(10);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  2,   3}; //   2

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  4,   5}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  6,   7}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  4}; //   1
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  4}; //   1
  c_d[x_a][7] = {  2,   3}; //   2

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  6,   8}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  4,   9}; //   2
  c_d[x_a][9] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v11(1, 2, 4, 8, 16, 32;  24,   0,   0)
// channel    1: 2v11(1, 2, 4, 8, 32, 16;  24,   0,   0)
// channel    2: 3yv1(1, 2, 16, 4, 8, 32;  24,  24,   0)
// channel    3: 3yv1(1, 2, 8, 4, 16, 32;   0,  24,   0)
// channel    4: 12v1(1, 2, 32, 4, 8, 16;  24,   0,   0)
// channel    5: 12v1(1, 2, 16, 4, 8, 32;  24,   0,   0)
// channel    6: 13yv(1, 2, 32, 16, 4, 8;  24,  24,   0)
// channel    7: 13yv(1, 2, 32, 8, 4, 16;   0,  24,   0)
// channel    8: 112v(1, 2, 16, 32, 4, 8;  24,   0,   0)
// channel    9: 112v(1, 2, 32, 16, 4, 8;  24,   0,   0)
