#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_dxux_epveauxux(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_dxux_epveauxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   4,   10,   20,   26,   19}; //   5
  needed_v_smin[x_a][  2] = {   5,   12,   21,   27,   18}; //   5
  needed_v_smin[x_a][  3] = {   6,    7,   11,   13}; //   4
  needed_v_smin[x_a][  4] = {   8,    9,   14,   15}; //   4
  needed_v_smin[x_a][  5] = {   8,    9,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {  10}; //   1
  needed_v_smin[x_a][  7] = {  11,   14,    7,    9}; //   4
  needed_v_smin[x_a][  8] = {  12}; //   1
  needed_v_smin[x_a][  9] = {  13,   15,    6,    8}; //   4
  needed_v_smin[x_a][ 10] = {  16,   22,   24,   26,    0}; //   5
  needed_v_smin[x_a][ 11] = {  16,    0,   22}; //   3
  needed_v_smin[x_a][ 12] = {  17,   23,   25,   27,    1}; //   5
  needed_v_smin[x_a][ 13] = {  17,    1,   23}; //   3
  needed_v_smin[x_a][ 14] = {   2,    3}; //   2
  needed_v_smin[x_a][ 15] = {   2,    3}; //   2
  needed_v_smin[x_a][ 16] = {   4,   19,   20}; //   3
  needed_v_smin[x_a][ 17] = {   5,   18,   21}; //   3
  needed_v_smin[x_a][ 18] = {  24}; //   1
  needed_v_smin[x_a][ 19] = {  25}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   18,   19,   20,   21}; //  16
  needed_v_smax[x_a][  1] = {   4,   10,   20,   19}; //   4
  needed_v_smax[x_a][  2] = {   5,   12,   21,   18}; //   4
  needed_v_smax[x_a][  3] = {   6,    7,    8,    9,   11,   13,   14,   15}; //   8
  needed_v_smax[x_a][  4] = {   8,    9,   14,   15}; //   4
  needed_v_smax[x_a][  5] = {  10,   11,   14,   17,    1,    7,    9,   23}; //   8
  needed_v_smax[x_a][  6] = {  12,   13,   15,   16,    0,    6,    8,   22}; //   8
  needed_v_smax[x_a][  7] = {  16,   22,   24,   26}; //   4
  needed_v_smax[x_a][  8] = {  16,   22,   24,   26}; //   4
  needed_v_smax[x_a][  9] = {  17,   23,   25,   27}; //   4
  needed_v_smax[x_a][ 10] = {  17,   23,   25,   27}; //   4
  needed_v_smax[x_a][ 11] = {  26}; //   1
  needed_v_smax[x_a][ 12] = {  27}; //   1
  needed_v_smax[x_a][ 13] = {   0}; //   1
  needed_v_smax[x_a][ 14] = {   1}; //   1
  needed_v_smax[x_a][ 15] = {   2,    3}; //   2
  needed_v_smax[x_a][ 16] = {   2,    3,    4,    5,   18,   19,   20,   21}; //   8
  needed_v_smax[x_a][ 17] = {  24,   25}; //   2

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   18,   19,   20,   21}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   4,   10,   20}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   5,   12,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   6,    7,   11,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][4] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax3");
  needed_g_p[x_a][6] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {  11,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {  13,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][10] = {  16,   22,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {  16,   22,   24,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][13] = {  17,   23,   25,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][14] = {  17,   23,   25,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][15] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax5");
  needed_g_p[x_a][16] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][17] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax12");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax13");
  needed_g_f[x_a][1] = {   0,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax6");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][3] = {   1,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax5");
  needed_g_f[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax15");
  needed_g_f[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax16");
  needed_g_f[x_a][6] = {   4,   19,   20}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][7] = {   5,   18,   21}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax16");
  needed_g_f[x_a][8] = {   6,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][9] = {   7,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][10] = {  18}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][11] = {  19}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][12] = {  24}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax17");
  needed_g_f[x_a][13] = {  25}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax17");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    6,    8,   12,   13,   15,   16,   22}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    7,    9,   10,   11,   14,   17,   23}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][4] = {   1,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_80");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_13__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_13__64_16");
  needed_g_t[x_a][6] = {   2,    3,    4,    5}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__32_64");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][12] = {   6,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][13] = {   7,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__64_28");
  needed_g_t[x_a][14] = {  18,   19,   20,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][15] = {  18,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][17] = {  19,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_76");
  needed_g_t[x_a][18] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_17__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_17__64_12");
  needed_g_t[x_a][19] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][20] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][22] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][23] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   10,   11,   12,   13,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,   10,   20,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   5,   12,   21,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   6,    7,   11,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][4] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][5] = {   8,    9,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][7] = {  11,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][8] = {  12}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  13,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {  16,   22,   24,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {  17}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][13] = {  17,   23,   25,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  6,   7,   8}; //   3
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   9}; //   3
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = {  6,  10}; //   2
  c_d[x_a][4] = {  1,   0}; //   2

  c_p[x_a][5] = {  0,   2}; //   2
  c_f[x_a][5] = {  7}; //   1
  c_t[x_a][5] = {  6,  11}; //   2
  c_d[x_a][5] = {  2,   0}; //   2

  c_p[x_a][6] = {  0,   3}; //   2
  c_f[x_a][6] = {  8}; //   1
  c_t[x_a][6] = {  0,  12}; //   2
  c_d[x_a][6] = {  3,   0}; //   2

  c_p[x_a][7] = {  0,   3}; //   2
  c_f[x_a][7] = {  9}; //   1
  c_t[x_a][7] = {  3,  13}; //   2
  c_d[x_a][7] = {  3,   0}; //   2

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {  8}; //   1
  c_t[x_a][8] = {  0,  12}; //   2
  c_d[x_a][8] = {  4,   5}; //   2

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {  9}; //   1
  c_t[x_a][9] = {  3,  13}; //   2
  c_d[x_a][9] = {  4,   5}; //   2

  c_p[x_a][10] = {  0,   1,   6}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  3}; //   1
  c_d[x_a][10] = {  6,   1,   0}; //   3

  c_p[x_a][11] = {  0,   3,   7}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  3}; //   1
  c_d[x_a][11] = {  7,   3,   0}; //   3

  c_p[x_a][12] = {  0,   2,   8}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  8,   2,   0}; //   3

  c_p[x_a][13] = {  0,   3,   9}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  9,   3,   0}; //   3

  c_p[x_a][14] = {  4,   5,   7}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  7,   4,   5}; //   3

  c_p[x_a][15] = {  4,   5,   9}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  9,   4,   5}; //   3

  c_p[x_a][16] = { 10,  11,  12}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 10,   0,  11}; //   3

  c_p[x_a][17] = { 13,  14,  15}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  3}; //   1
  c_d[x_a][17] = { 12,   0,  13}; //   3

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = { 10,   7}; //   2
  c_t[x_a][18] = { 14,  15,  16}; //   3
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = { 11,   6}; //   2
  c_t[x_a][19] = { 14,  17,  18}; //   3
  c_d[x_a][19] = {  0}; //   1

  c_p[x_a][20] = {  0,   1}; //   2
  c_f[x_a][20] = {  6}; //   1
  c_t[x_a][20] = { 14,  17}; //   2
  c_d[x_a][20] = {  1,   0}; //   2

  c_p[x_a][21] = {  0,   2}; //   2
  c_f[x_a][21] = {  7}; //   1
  c_t[x_a][21] = { 14,  15}; //   2
  c_d[x_a][21] = {  2,   0}; //   2

  c_p[x_a][22] = { 10,  11}; //   2
  c_f[x_a][22] = {  1}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  0,  11}; //   2

  c_p[x_a][23] = { 13,  14}; //   2
  c_f[x_a][23] = {  3}; //   1
  c_t[x_a][23] = {  3,   4}; //   2
  c_d[x_a][23] = {  0,  13}; //   2

  c_p[x_a][24] = { 10,  11}; //   2
  c_f[x_a][24] = { 12}; //   1
  c_t[x_a][24] = { 19,  20}; //   2
  c_d[x_a][24] = {  0,  11}; //   2

  c_p[x_a][25] = { 13,  14}; //   2
  c_f[x_a][25] = { 13}; //   1
  c_t[x_a][25] = { 19,  21}; //   2
  c_d[x_a][25] = {  0,  13}; //   2

  c_p[x_a][26] = { 10,  11,  16}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 22}; //   1
  c_d[x_a][26] = {  1,   0,  11}; //   3

  c_p[x_a][27] = { 13,  14,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 23}; //   1
  c_d[x_a][27] = {  2,   0,  13}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 16, 64, 32;  24,   0,   0,   0)
// channel    2: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
// channel    3: 2v111(1, 2, 4, 8, 64, 32, 16;  24,   0,   0,   0)
// channel    4: 3yv11(1, 2, 64, 4, 8, 32, 16;  24,   0,   0,   0)
// channel    5: 3yv11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
// channel    6: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
// channel    7: 3yv11(1, 2, 16, 4, 8, 64, 32;  24,  24,   0,   0)
// channel    8: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
// channel    9: 3yv11(1, 2, 8, 4, 16, 64, 32;   0,  24,   0,   0)
// channel   10: 4yyv1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel   11: 4yyv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
// channel   12: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   13: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel   14: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
// channel   15: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel   16: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   17: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  24,   0,   0)
// channel   18: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
// channel   19: 12v11(1, 2, 16, 4, 8, 64, 32;  24,   0,   0,   0)
// channel   20: 13yv1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel   21: 13yv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   22: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   23: 2v2v1(1, 2, 4, 8, 16, 64, 32;   0,  24,   0,   0)
// channel   24: 2v12v(1, 2, 4, 8, 64, 16, 32;   0,  24,   0,   0)
// channel   25: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
// channel   26: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   27: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
