#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_gdx_epveagux(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_gdx_epveagux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    6,    7,    8,    9,   10,   12,   13,   14,   15,   16,   18,   19,   20,   21,   23,   24,   26,   27,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45}; //  38
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,    8,    9,   20,   23,   27}; //   9
  needed_v_smin[x_a][  2] = {   2,    8,    1}; //   3
  needed_v_smin[x_a][  3] = {   3,    9,   23,    0,   20,   27}; //   6
  needed_v_smin[x_a][  4] = {   4,   10,   16,   21,   24,   30,   31,   39,   18,   29,   42}; //  11
  needed_v_smin[x_a][  5] = {   4,    5,   10,   11,   24,   25,   30,   32}; //   8
  needed_v_smin[x_a][  6] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  needed_v_smin[x_a][  7] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  needed_v_smin[x_a][  8] = {   6,   12,   15,   26,   38,   41,   44,   45,   35}; //   9
  needed_v_smin[x_a][  9] = {   6,   12,   26,   35,   38,   45}; //   6
  needed_v_smin[x_a][ 10] = {   7,   13,   14,   16,   17,   37,   39,   40,   42,   43}; //  10
  needed_v_smin[x_a][ 11] = {   7,   13,   37}; //   3
  needed_v_smin[x_a][ 12] = {  14,   43}; //   2
  needed_v_smin[x_a][ 13] = {  15,   44}; //   2
  needed_v_smin[x_a][ 14] = {  18,   21,   22,   29,   31,   33}; //   6
  needed_v_smin[x_a][ 15] = {  19,   28,   41}; //   3
  needed_v_smin[x_a][ 16] = {  19,   28}; //   2
  needed_v_smin[x_a][ 17] = {  34,   36}; //   2
  needed_v_smin[x_a][ 18] = {  34,   36}; //   2

  v_smax[x_a].resize(21);
  needed_v_smax[x_a].resize(21);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    8,    9,   10,   16,   18,   19,   20,   21,   23,   24,   27,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45}; //  31
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    8,    9,   20,   23,   27}; //   9
  needed_v_smax[x_a][  2] = {   2,    7,    8,   13,    1,   37}; //   6
  needed_v_smax[x_a][  3] = {   3,    4,    5,    6,    9,   10,   11,   12,   23,   24,   25,   26,    0,   20,   27,   30,   32,   35,   38,   45}; //  20
  needed_v_smax[x_a][  4] = {   4,    5,   10,   11,   16,   17,   21,   22,   24,   25,   30,   31,   32,   33,   39,   40,   18,   29}; //  18
  needed_v_smax[x_a][  5] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  needed_v_smax[x_a][  6] = {   6,   12,   15,   26}; //   4
  needed_v_smax[x_a][  7] = {   6,   12,   26}; //   3
  needed_v_smax[x_a][  8] = {   7,   13,   14}; //   3
  needed_v_smax[x_a][  9] = {   7,   13}; //   2
  needed_v_smax[x_a][ 10] = {  14,   15}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15}; //   2
  needed_v_smax[x_a][ 12] = {  16,   17,   39,   40}; //   4
  needed_v_smax[x_a][ 13] = {  37,   42,   43}; //   3
  needed_v_smax[x_a][ 14] = {  38,   41,   44,   45,   35}; //   5
  needed_v_smax[x_a][ 15] = {  43,   44}; //   2
  needed_v_smax[x_a][ 16] = {  18,   19,   21,   22,   28,   29,   31,   33,   34,   36}; //  10
  needed_v_smax[x_a][ 17] = {  19,   28}; //   2
  needed_v_smax[x_a][ 18] = {  34,   36}; //   2
  needed_v_smax[x_a][ 19] = {  41}; //   1
  needed_v_smax[x_a][ 20] = {  42}; //   1

  g_p[x_a].resize(22);
  needed_g_p[x_a].resize(22);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    8,    9,   10,   16,   18,   19,   20,   21,   23,   24,   27,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45}; //  31
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,    8,    9,   20,   23}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,    9,   23}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,   10,   16,   21,   24,   30,   31,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax4");
  needed_g_p[x_a][5] = {   4,    5,   10,   11,   24,   25}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax3");
  needed_g_p[x_a][6] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax4");
  needed_g_p[x_a][8] = {   6,   12,   15,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   6,   12,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax7");
  needed_g_p[x_a][10] = {   6,   12,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax3");
  needed_g_p[x_a][11] = {   7,   13,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {   7,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax9");
  needed_g_p[x_a][13] = {   7,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][14] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][15] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][16] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][17] = {  16,   17,   39,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax12");
  needed_g_p[x_a][18] = {  37,   42,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax13");
  needed_g_p[x_a][19] = {  38,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax14");
  needed_g_p[x_a][20] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax15");
  needed_g_p[x_a][21] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax15");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,   20,   27}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {  18,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][3] = {  18,   21,   22,   29,   31,   33}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax16");
  needed_g_f[x_a][4] = {  19,   28}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax17");
  needed_g_f[x_a][5] = {  19,   28}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][6] = {  27}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  30,   32}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax3");
  needed_g_f[x_a][8] = {  34,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax18");
  needed_g_f[x_a][9] = {  34,   36}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax16");
  needed_g_f[x_a][10] = {  35}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax14");
  needed_g_f[x_a][11] = {  35,   38,   45}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax3");
  needed_g_f[x_a][12] = {  37}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax2");
  needed_g_f[x_a][13] = {  41}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax19");
  needed_g_f[x_a][14] = {  42}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax20");

  g_t[x_a].resize(28);
  needed_g_t[x_a].resize(28);
  needed_g_t[x_a][0] = {   0,    3,    4,    5,    6,   38}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   1,    2,    7,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__32_76");
  needed_g_t[x_a][4] = {  18,   19,   21,   22,   28,   29,   31,   33,   34,   36}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  18,   21,   22,   29}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  19,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][8] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_65__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_65__32_12");
  needed_g_t[x_a][9] = {  20,   23,   24,   25,   26,   27,   30,   32,   35,   45}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][10] = {  20,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][11] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][12] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][13] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][14] = {  30,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][15] = {  31,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][16] = {  34,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][17] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__16_32");
  needed_g_t[x_a][18] = {  35,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][19] = {  35}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][20] = {  36}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][21] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][22] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][23] = {  39,   40,   42}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][24] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][25] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");
  needed_g_t[x_a][26] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][27] = {  43,   44}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    8,    9,   20,   23}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    6,    7,    8,    9,   10,   12,   13,   14,   15,   16,   18,   19,   20,   21,   23,   24,   26,   27,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   41,   42,   43,   44,   45}; //  38
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   2,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][3] = {   3,    9,   23}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][4] = {   4,    5,   10,   11,   24,   25}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][5] = {   4,   10,   16,   21,   24,   30,   31,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][6] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][7] = {   5,   11,   17,   22,   25,   32,   33,   40}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][8] = {   6,   12,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][9] = {   6,   12,   15,   26,   38,   41,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][10] = {   7,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__12_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__12_96");
  needed_g_d[x_a][11] = {   7,   13,   14,   16,   17,   37,   39,   40,   42,   43}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][12] = {   8,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][13] = {   9,   10,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][14] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][15] = {  14,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__16_96");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__16_96");
  needed_g_d[x_a][16] = {  15,   44}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__96_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__96_28");

  c_p[x_a].resize(46);
  c_f[x_a].resize(46);
  c_t[x_a].resize(46);
  c_d[x_a].resize(46);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0,   1}; //   2

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {  2,   0,   1}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   0,   1}; //   3

  c_p[x_a][4] = {  0,   4,   5}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  4,   5,   1}; //   3

  c_p[x_a][5] = {  6,   7,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  4,   6,   7}; //   3

  c_p[x_a][6] = {  8,   9,  10}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  8,   1,   9}; //   3

  c_p[x_a][7] = { 11,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = { 10,   1,  11}; //   3

  c_p[x_a][8] = {  0,   1,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 12,   2,   0,   1}; //   4

  c_p[x_a][9] = {  0,   1,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 13,   3,   0,   1}; //   4

  c_p[x_a][10] = {  0,   4,   5}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 13,   4,   5,   1}; //   4

  c_p[x_a][11] = {  6,   7,   5}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 13,   4,   6,   7}; //   4

  c_p[x_a][12] = {  8,   9,  10}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 13,   8,   1,   9}; //   4

  c_p[x_a][13] = { 11,  12,  13}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 12,  10,   1,  11}; //   4

  c_p[x_a][14] = { 11,  14,  15}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 14,   1,  15,  11}; //   4

  c_p[x_a][15] = {  8,  16,  15}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   1,  16,   9}; //   4

  c_p[x_a][16] = {  0,   4,  17}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 17,  11,   5,   1}; //   4

  c_p[x_a][17] = {  6,   7,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 17,  11,   6,   7}; //   4

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  2,   3}; //   2
  c_t[x_a][18] = {  4,   5,   6}; //   3
  c_d[x_a][18] = {  1}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  4,   5}; //   2
  c_t[x_a][19] = {  4,   7,   8}; //   3
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  0,   1}; //   2
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  9,  10}; //   2
  c_d[x_a][20] = {  0,   1}; //   2

  c_p[x_a][21] = {  0,   4}; //   2
  c_f[x_a][21] = {  3}; //   1
  c_t[x_a][21] = {  4,   5}; //   2
  c_d[x_a][21] = {  5,   1}; //   2

  c_p[x_a][22] = {  6,   7}; //   2
  c_f[x_a][22] = {  3}; //   1
  c_t[x_a][22] = {  4,   5}; //   2
  c_d[x_a][22] = {  6,   7}; //   2

  c_p[x_a][23] = {  0,   1,   3}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  9}; //   1
  c_d[x_a][23] = {  3,   0,   1}; //   3

  c_p[x_a][24] = {  0,   4,   5}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  9}; //   1
  c_d[x_a][24] = {  4,   5,   1}; //   3

  c_p[x_a][25] = {  6,   7,   5}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  9}; //   1
  c_d[x_a][25] = {  4,   6,   7}; //   3

  c_p[x_a][26] = {  8,   9,  10}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  9}; //   1
  c_d[x_a][26] = {  8,   1,   9}; //   3

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = {  6,   0}; //   2
  c_t[x_a][27] = {  9,  10,  11}; //   3
  c_d[x_a][27] = {  1}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = {  4,   5}; //   2
  c_t[x_a][28] = {  4,   7,  12}; //   3
  c_d[x_a][28] = {  1}; //   1

  c_p[x_a][29] = {  0}; //   1
  c_f[x_a][29] = {  2,   3}; //   2
  c_t[x_a][29] = {  4,   5,  13}; //   3
  c_d[x_a][29] = {  1}; //   1

  c_p[x_a][30] = {  0,   4}; //   2
  c_f[x_a][30] = {  7}; //   1
  c_t[x_a][30] = {  9,  14}; //   2
  c_d[x_a][30] = {  5,   1}; //   2

  c_p[x_a][31] = {  0,   4}; //   2
  c_f[x_a][31] = {  3}; //   1
  c_t[x_a][31] = {  4,  15}; //   2
  c_d[x_a][31] = {  5,   1}; //   2

  c_p[x_a][32] = {  6,   7}; //   2
  c_f[x_a][32] = {  7}; //   1
  c_t[x_a][32] = {  9,  14}; //   2
  c_d[x_a][32] = {  6,   7}; //   2

  c_p[x_a][33] = {  6,   7}; //   2
  c_f[x_a][33] = {  3}; //   1
  c_t[x_a][33] = {  4,  15}; //   2
  c_d[x_a][33] = {  6,   7}; //   2

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = {  8,   9}; //   2
  c_t[x_a][34] = {  4,  16,  17}; //   3
  c_d[x_a][34] = {  1}; //   1

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = { 10,  11}; //   2
  c_t[x_a][35] = {  9,  18,  19}; //   3
  c_d[x_a][35] = {  1}; //   1

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = {  8,   9}; //   2
  c_t[x_a][36] = {  4,  16,  20}; //   3
  c_d[x_a][36] = {  1}; //   1

  c_p[x_a][37] = {  0,  18}; //   2
  c_f[x_a][37] = { 12}; //   1
  c_t[x_a][37] = {  2,  21}; //   2
  c_d[x_a][37] = { 11,   1}; //   2

  c_p[x_a][38] = {  0,  19}; //   2
  c_f[x_a][38] = { 11}; //   1
  c_t[x_a][38] = {  0,  22}; //   2
  c_d[x_a][38] = {  9,   1}; //   2

  c_p[x_a][39] = {  0,   4,  17}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 23}; //   1
  c_d[x_a][39] = { 11,   5,   1}; //   3

  c_p[x_a][40] = {  6,   7,  17}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 23}; //   1
  c_d[x_a][40] = { 11,   6,   7}; //   3

  c_p[x_a][41] = {  0,  19}; //   2
  c_f[x_a][41] = { 13}; //   1
  c_t[x_a][41] = { 24,  25}; //   2
  c_d[x_a][41] = {  9,   1}; //   2

  c_p[x_a][42] = {  0,  18}; //   2
  c_f[x_a][42] = { 14}; //   1
  c_t[x_a][42] = { 23,  26}; //   2
  c_d[x_a][42] = { 11,   1}; //   2

  c_p[x_a][43] = {  0,  18,  20}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 27}; //   1
  c_d[x_a][43] = { 15,  11,   1}; //   3

  c_p[x_a][44] = {  0,  19,  21}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 27}; //   1
  c_d[x_a][44] = { 16,   9,   1}; //   3

  c_p[x_a][45] = {  0,  19}; //   2
  c_f[x_a][45] = { 11}; //   1
  c_t[x_a][45] = {  9,  18}; //   2
  c_d[x_a][45] = {  9,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel    1: 3yv11(1, 2, 64, 4, 8, 32, 16;  24,   0,   0,   0)
// channel    2: 4yyv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel    4: 4yyv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
// channel    5: 4yyv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
// channel    6: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  24,   0,   0)
// channel    7: 42vv1(1, 2, 4, 8, 32, 64, 16;   0,  24,   0,   0)
// channel    8: 5yyyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel    9: 5yyyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   10: 5yyyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   11: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   12: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   13: 5y2vv(1, 2, 16, 4, 8, 32, 64;   0,  24,   0,   0)
// channel   14: 52vyv(1, 2, 4, 8, 16, 32, 64;   0,   0,  24,   0)
// channel   15: 52vyv(1, 2, 4, 8, 32, 16, 64;   0,   0,  24,   0)
// channel   16: 52vyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   17: 52vyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   18: 12v11(1, 2, 64, 4, 8, 16, 32;  24,   0,   0,   0)
// channel   19: 12v11(1, 2, 64, 4, 8, 32, 16;  24,   0,   0,   0)
// channel   20: 13yv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel   21: 13yv1(1, 2, 64, 16, 4, 8, 32;  24,  24,   0,   0)
// channel   22: 13yv1(1, 2, 64, 8, 4, 16, 32;   0,  24,   0,   0)
// channel   23: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   24: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   25: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   26: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   27: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel   28: 112v1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
// channel   29: 112v1(1, 2, 64, 16, 4, 8, 32;  24,   0,   0,   0)
// channel   30: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   31: 113yv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   32: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   33: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   34: 1112v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   35: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
// channel   36: 1112v(1, 2, 64, 32, 16, 4, 8;  24,   0,   0,   0)
// channel   37: 2v2v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel   38: 2v2v1(1, 2, 16, 64, 4, 8, 32;  24,   0,   0,   0)
// channel   39: 2v3yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   40: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   41: 2v12v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   42: 2v12v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
// channel   43: 3yv2v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   44: 3yv2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   45: 12v2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
