#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_udx_epveaddx(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_udx_epveaddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(16);
  needed_v_smin[x_a].resize(16);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   24,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   2,    5,   10,   21,    9}; //   5
  needed_v_smin[x_a][  2] = {   3,    6,   16,   22,   20}; //   5
  needed_v_smin[x_a][  3] = {   4,    7,   17,   25}; //   4
  needed_v_smin[x_a][  4] = {   4,    7,   17,   25}; //   4
  needed_v_smin[x_a][  5] = {   5}; //   1
  needed_v_smin[x_a][  6] = {   6,    7,    3,    4}; //   4
  needed_v_smin[x_a][  7] = {   8,   11,   14,   23,    0}; //   5
  needed_v_smin[x_a][  8] = {   8,    0,   11}; //   3
  needed_v_smin[x_a][  9] = {  12,   13,   16,   17,   18,   20,   22,   25,   26,   27,    1}; //  11
  needed_v_smin[x_a][ 10] = {  14,   23}; //   2
  needed_v_smin[x_a][ 11] = {  15,   19,   21,   24}; //   4
  needed_v_smin[x_a][ 12] = {  15,   24,   19}; //   3
  needed_v_smin[x_a][ 13] = {   1,   12,   13,   26,   27}; //   5
  needed_v_smin[x_a][ 14] = {   2,    9,   10}; //   3
  needed_v_smin[x_a][ 15] = {  18}; //   1

  v_smax[x_a].resize(22);
  needed_v_smax[x_a].resize(22);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    5,    6,    9,   10,   13,   16,   20,   23,   24,   27}; //  14
  needed_v_smax[x_a][  1] = {   2,    5,   10,    9}; //   4
  needed_v_smax[x_a][  2] = {   3,    4,    6,    7,   16,   17}; //   6
  needed_v_smax[x_a][  3] = {   4,    7,   17}; //   3
  needed_v_smax[x_a][  4] = {   5,    6,    7,    8,    0,    3,    4,   11}; //   8
  needed_v_smax[x_a][  5] = {   8,   11,   14}; //   3
  needed_v_smax[x_a][  6] = {   8,   11}; //   2
  needed_v_smax[x_a][  7] = {  12,   18,   22,   25,   26}; //   5
  needed_v_smax[x_a][  8] = {  12,   18,   22,   26}; //   4
  needed_v_smax[x_a][  9] = {  13,   20,   27,    1}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15}; //   2
  needed_v_smax[x_a][ 12] = {  15,   19,   21}; //   3
  needed_v_smax[x_a][ 13] = {  16,   17}; //   2
  needed_v_smax[x_a][ 14] = {  19,   21}; //   2
  needed_v_smax[x_a][ 15] = {  21}; //   1
  needed_v_smax[x_a][ 16] = {  22,   25,   20}; //   3
  needed_v_smax[x_a][ 17] = {  23,    0}; //   2
  needed_v_smax[x_a][ 18] = {  23,   24,   18,   19}; //   4
  needed_v_smax[x_a][ 19] = {  24}; //   1
  needed_v_smax[x_a][ 20] = {  25}; //   1
  needed_v_smax[x_a][ 21] = {   1,    2,    9,   10,   12,   13,   26,   27}; //   8

  g_p[x_a].resize(27);
  needed_g_p[x_a].resize(27);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    5,    6,    9,   10,   13,   16,   20,   23,   24,   27}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    5,   10}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    6,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    7,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    7,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {   8,   11,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   8,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax6");
  needed_g_p[x_a][9] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][10] = {  12,   18,   22,   25,   26}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  12,   18,   22,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {  13,   20,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax9");
  needed_g_p[x_a][13] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax10");
  needed_g_p[x_a][14] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][15] = {  15,   19,   21}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax12");
  needed_g_p[x_a][16] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][17] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax13");
  needed_g_p[x_a][18] = {  19,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][19] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax15");
  needed_g_p[x_a][20] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax16");
  needed_g_p[x_a][21] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax17");
  needed_g_p[x_a][22] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax18");
  needed_g_p[x_a][23] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax19");
  needed_g_p[x_a][24] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax18");
  needed_g_p[x_a][25] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax20");
  needed_g_p[x_a][26] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax16");

  g_f[x_a].resize(10);
  needed_g_f[x_a].resize(10);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax17");
  needed_g_f[x_a][1] = {   0,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax4");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax9");
  needed_g_f[x_a][3] = {   1,   12,   13,   26,   27}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][4] = {   2,    9,   10}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax21");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][6] = {   9}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  18}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax18");
  needed_g_f[x_a][8] = {  19}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax18");
  needed_g_f[x_a][9] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax16");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    3,    4,    5,    6,    7,    8,   11}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2,   12,   13}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][8] = {   9,   10,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][12] = {  14,   15,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][13] = {  16,   17,   20}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][14] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][15] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][16] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][17] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][18] = {  22,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][19] = {  23,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][20] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][21] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    5,    6,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18,   19,   20,   21,   22,   23,   24,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    5,   10,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,    6,   16,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    7,   17,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   4,    7,   17,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][8] = {   8,   11,   14,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][9] = {  12,   13,   16,   17,   18,   20,   22,   25,   26,   27}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][10] = {  14,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][11] = {  15,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");
  needed_g_d[x_a][12] = {  15,   19,   21,   24}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {  5}; //   1
  c_t[x_a][3] = {  0,   7}; //   2
  c_d[x_a][3] = {  2,   0}; //   2

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  0,   7}; //   2
  c_d[x_a][4] = {  3,   4}; //   2

  c_p[x_a][5] = {  0,   1,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  5,   1,   0}; //   3

  c_p[x_a][6] = {  0,   2,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  6,   2,   0}; //   3

  c_p[x_a][7] = {  3,   4,   6}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  6,   3,   4}; //   3

  c_p[x_a][8] = {  7,   8,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  7,   0,   8}; //   3

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  6,   4}; //   2
  c_t[x_a][9] = {  8,   9,  10}; //   3
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = {  4}; //   1
  c_t[x_a][10] = {  8,   9}; //   2
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  7,   8}; //   2
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = {  0,   8}; //   2

  c_p[x_a][12] = { 10,  11}; //   2
  c_f[x_a][12] = {  3}; //   1
  c_t[x_a][12] = {  3,   4}; //   2
  c_d[x_a][12] = {  0,   9}; //   2

  c_p[x_a][13] = {  0,  12}; //   2
  c_f[x_a][13] = {  3}; //   1
  c_t[x_a][13] = {  3,  11}; //   2
  c_d[x_a][13] = {  9,   0}; //   2

  c_p[x_a][14] = {  7,  13,  14}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 12}; //   1
  c_d[x_a][14] = {  0,  10,   8}; //   3

  c_p[x_a][15] = { 15,  16,  14}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 12}; //   1
  c_d[x_a][15] = {  0,  11,  12}; //   3

  c_p[x_a][16] = {  0,   2,  17}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 13}; //   1
  c_d[x_a][16] = {  9,   2,   0}; //   3

  c_p[x_a][17] = {  3,   4,  17}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 13}; //   1
  c_d[x_a][17] = {  9,   3,   4}; //   3

  c_p[x_a][18] = { 10,  11}; //   2
  c_f[x_a][18] = {  7}; //   1
  c_t[x_a][18] = { 12,  14}; //   2
  c_d[x_a][18] = {  0,   9}; //   2

  c_p[x_a][19] = { 15,  18}; //   2
  c_f[x_a][19] = {  8}; //   1
  c_t[x_a][19] = { 12,  15}; //   2
  c_d[x_a][19] = {  0,  12}; //   2

  c_p[x_a][20] = {  0,  12}; //   2
  c_f[x_a][20] = {  9}; //   1
  c_t[x_a][20] = { 13,  16}; //   2
  c_d[x_a][20] = {  9,   0}; //   2

  c_p[x_a][21] = { 15,  18,  19}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 17}; //   1
  c_d[x_a][21] = {  1,   0,  12}; //   3

  c_p[x_a][22] = { 10,  11,  20}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 18}; //   1
  c_d[x_a][22] = {  2,   0,   9}; //   3

  c_p[x_a][23] = {  0,  21,  22}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 19}; //   1
  c_d[x_a][23] = { 10,   8,   0}; //   3

  c_p[x_a][24] = {  0,  23,  24}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 19}; //   1
  c_d[x_a][24] = { 11,  12,   0}; //   3

  c_p[x_a][25] = { 10,  25,  26}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 18}; //   1
  c_d[x_a][25] = {  3,   4,   9}; //   3

  c_p[x_a][26] = { 10,  11}; //   2
  c_f[x_a][26] = {  3}; //   1
  c_t[x_a][26] = {  8,  20}; //   2
  c_d[x_a][26] = {  0,   9}; //   2

  c_p[x_a][27] = {  0,  12}; //   2
  c_f[x_a][27] = {  3}; //   1
  c_t[x_a][27] = {  8,  21}; //   2
  c_d[x_a][27] = {  9,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
// channel    3: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
// channel    4: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
// channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel    7: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel    8: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel    9: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
// channel   10: 13yv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   11: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   12: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  24,   0,   0)
// channel   13: 2v2v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel   14: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  24,   0)
// channel   15: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  24,   0)
// channel   16: 2v3yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   17: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   18: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   19: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
// channel   20: 2v12v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
// channel   21: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   22: 3yv2v(1, 2, 16, 4, 8, 32, 64;   0,  24,  24,   0)
// channel   23: 3yv2v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   24: 3yv2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   25: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  24,   0)
// channel   26: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  24,   0,   0)
// channel   27: 12v2v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
