#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_uux_epveadux(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_uux_epveadux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   2,    6,    7,   11,   20,   22,   24,   27,   21}; //   9
  needed_v_smin[x_a][  2] = {   3,    8,   13,   14}; //   4
  needed_v_smin[x_a][  3] = {   4,    9,   15,   16}; //   4
  needed_v_smin[x_a][  4] = {   4,    9,   15,   16}; //   4
  needed_v_smin[x_a][  5] = {   5,   12,   19,   23}; //   4
  needed_v_smin[x_a][  6] = {   5,   23}; //   2
  needed_v_smin[x_a][  7] = {   6,   24,    2,   21,   22}; //   5
  needed_v_smin[x_a][  8] = {   7,   11}; //   2
  needed_v_smin[x_a][  9] = {   8,    9,   14,   16,    3,    4}; //   6
  needed_v_smin[x_a][ 10] = {  10,   17,   19,   25,    0}; //   5
  needed_v_smin[x_a][ 11] = {  10,   17,    0,   25}; //   4
  needed_v_smin[x_a][ 12] = {  12}; //   1
  needed_v_smin[x_a][ 13] = {  13,   15}; //   2
  needed_v_smin[x_a][ 14] = {  18,   20,   26,   27}; //   4
  needed_v_smin[x_a][ 15] = {  18}; //   1
  needed_v_smin[x_a][ 16] = {   1}; //   1
  needed_v_smin[x_a][ 17] = {   1}; //   1
  needed_v_smin[x_a][ 18] = {  26}; //   1

  v_smax[x_a].resize(18);
  needed_v_smax[x_a].resize(18);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    5,    6,    7,    8,   11,   12,   13,   14,   19,   20,   21,   22,   23,   24}; //  18
  needed_v_smax[x_a][  1] = {   2,    6,    7,   11,   20,   22,   24,   21}; //   8
  needed_v_smax[x_a][  2] = {   3,    4,    8,    9,   13,   14,   15,   16}; //   8
  needed_v_smax[x_a][  3] = {   4,    9,   15,   16}; //   4
  needed_v_smax[x_a][  4] = {   5,   12,   19,   23}; //   4
  needed_v_smax[x_a][  5] = {   5,    6,   23,   24,    1,    2,   21,   22}; //   8
  needed_v_smax[x_a][  6] = {   7,    8,    9,   10,   11,   14,   16,   17,    0,    3,    4,   25}; //  12
  needed_v_smax[x_a][  7] = {  10,   17,   25}; //   3
  needed_v_smax[x_a][  8] = {  10,   17,   25}; //   3
  needed_v_smax[x_a][  9] = {  12,   13,   15,   18}; //   4
  needed_v_smax[x_a][ 10] = {  18,   26,   27}; //   3
  needed_v_smax[x_a][ 11] = {  18,   26,   27}; //   3
  needed_v_smax[x_a][ 12] = {  19}; //   1
  needed_v_smax[x_a][ 13] = {  20}; //   1
  needed_v_smax[x_a][ 14] = {  27}; //   1
  needed_v_smax[x_a][ 15] = {   0}; //   1
  needed_v_smax[x_a][ 16] = {   1}; //   1
  needed_v_smax[x_a][ 17] = {  26}; //   1

  g_p[x_a].resize(21);
  needed_g_p[x_a].resize(21);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    5,    6,    7,    8,   11,   12,   13,   14,   19,   20,   21,   22,   23,   24}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    6,    7,   11,   20,   22,   24}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    8,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   4,    9,   15,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,    9,   15,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][5] = {   5,   12,   19,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   5,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   6,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {   7,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   8,    9,   14,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][10] = {  10,   17,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {  10,   17,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {  10,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][13] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][14] = {  13,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][15] = {  18,   26,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][16] = {  18,   26,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][17] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax9");
  needed_g_p[x_a][18] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax12");
  needed_g_p[x_a][19] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][20] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax14");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax15");
  needed_g_f[x_a][1] = {   0,   25}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax6");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax5");
  needed_g_f[x_a][4] = {   2,   21,   22}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][6] = {  21}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {  26}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax17");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    3,    4,    7,    8,    9,   10,   25}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2,    5,    6}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__32_28");
  needed_g_t[x_a][8] = {  21,   22,   23,   24}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][9] = {  21,   22}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][10] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][11] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][12] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][13] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   14,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    6,    7,   11,   20,   22,   24,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,    8,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   4,    9,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   4,    9,   15,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {   5,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][6] = {   5,   12,   19,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][7] = {   6,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][8] = {   7,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   8,    9,   14,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {  10,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {  10,   17,   19,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {  11,   14,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  12,   13,   15,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][14] = {  12}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][15] = {  13,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][16] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][17] = {  18,   20,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][18] = {  19}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][19] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2}; //   2
  c_f[x_a][3] = {  5}; //   1
  c_t[x_a][3] = {  0,   7}; //   2
  c_d[x_a][3] = {  2,   0}; //   2

  c_p[x_a][4] = {  3,   4}; //   2
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  0,   7}; //   2
  c_d[x_a][4] = {  3,   4}; //   2

  c_p[x_a][5] = {  0,   5,   6}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  3}; //   1
  c_d[x_a][5] = {  5,   6,   0}; //   3

  c_p[x_a][6] = {  0,   1,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  3}; //   1
  c_d[x_a][6] = {  7,   1,   0}; //   3

  c_p[x_a][7] = {  0,   1,   8}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  8,   1,   0}; //   3

  c_p[x_a][8] = {  0,   2,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  9,   2,   0}; //   3

  c_p[x_a][9] = {  3,   4,   9}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  9,   3,   4}; //   3

  c_p[x_a][10] = { 10,  11,  12}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 10,   0,  11}; //   3

  c_p[x_a][11] = {  0,   1,   8}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 12,   8,   1,   0}; //   4

  c_p[x_a][12] = {  0,   5,  13}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 13,  14,   6,   0}; //   4

  c_p[x_a][13] = {  0,   2,  14}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 13,  15,   2,   0}; //   4

  c_p[x_a][14] = {  0,   2,   9}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 12,   9,   2,   0}; //   4

  c_p[x_a][15] = {  3,   4,  14}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 13,  15,   3,   4}; //   4

  c_p[x_a][16] = {  3,   4,   9}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 12,   9,   3,   4}; //   4

  c_p[x_a][17] = { 10,  11,  12}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,  10,   0,  11}; //   4

  c_p[x_a][18] = { 15,  16,  17}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 13,  16,   0,  17}; //   4

  c_p[x_a][19] = {  0,   5,  18}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 18,  11,   6,   0}; //   4

  c_p[x_a][20] = {  0,   1,  19}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 19,  17,   1,   0}; //   4

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  6,   4}; //   2
  c_t[x_a][21] = {  8,   9,  10}; //   3
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  0,   1}; //   2
  c_f[x_a][22] = {  4}; //   1
  c_t[x_a][22] = {  8,   9}; //   2
  c_d[x_a][22] = {  1,   0}; //   2

  c_p[x_a][23] = {  0,   5,   6}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  8}; //   1
  c_d[x_a][23] = {  5,   6,   0}; //   3

  c_p[x_a][24] = {  0,   1,   7}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  8}; //   1
  c_d[x_a][24] = {  7,   1,   0}; //   3

  c_p[x_a][25] = { 10,  11}; //   2
  c_f[x_a][25] = {  1}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  0,  11}; //   2

  c_p[x_a][26] = { 15,  16}; //   2
  c_f[x_a][26] = {  7}; //   1
  c_t[x_a][26] = { 11,  12}; //   2
  c_d[x_a][26] = {  0,  17}; //   2

  c_p[x_a][27] = { 15,  16,  20}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 13}; //   1
  c_d[x_a][27] = {  1,   0,  17}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  24,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  24,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  24,   0,   0,   0)
// channel    3: 3yv11(1, 2, 16, 4, 8, 32, 64;  24,  24,   0,   0)
// channel    4: 3yv11(1, 2, 8, 4, 16, 32, 64;   0,  24,   0,   0)
// channel    5: 4yyv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
// channel    6: 4yyv1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
// channel    7: 4yyv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel    8: 4yyv1(1, 2, 32, 16, 4, 8, 64;  24,  24,   0,   0)
// channel    9: 4yyv1(1, 2, 32, 8, 4, 16, 64;   0,  24,   0,   0)
// channel   10: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   11: 5yyyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
// channel   12: 5yyyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
// channel   13: 5yyyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
// channel   14: 5yyyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
// channel   15: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
// channel   16: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
// channel   17: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
// channel   18: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
// channel   19: 52vyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   20: 52vyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   21: 12v11(1, 2, 16, 4, 8, 32, 64;  24,   0,   0,   0)
// channel   22: 13yv1(1, 2, 16, 32, 4, 8, 64;  24,   0,   0,   0)
// channel   23: 14yyv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
// channel   24: 14yyv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
// channel   25: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  24,   0,   0)
// channel   26: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  24,   0,   0)
// channel   27: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
