#include "header.hpp"

#include "ppnenex02.phasespace.set.hpp"

void ppnenex02_phasespace_set::ax_psp_220_bbx_vevexbbx(int x_a){
  static Logger logger("ppnenex02_phasespace_set::ax_psp_220_bbx_vevexbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  needed_v_smin[x_a][  1] = {   1,    3,    0}; //   3
  needed_v_smin[x_a][  2] = {   2,    4,    5}; //   3
  needed_v_smin[x_a][  3] = {   6,    7}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    7}; //   7
  needed_v_smax[x_a][  1] = {   1,    3,    0}; //   3
  needed_v_smax[x_a][  2] = {   2,    4,    5}; //   3
  needed_v_smax[x_a][  3] = {   6}; //   1
  needed_v_smax[x_a][  4] = {   6}; //   1
  needed_v_smax[x_a][  5] = {   7}; //   1

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    7}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax4");
  needed_g_p[x_a][5] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][3] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][5] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   1,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   2,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(8);
  c_f[x_a].resize(8);
  c_t[x_a].resize(8);
  c_d[x_a].resize(8);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  1,   0}; //   2

  c_p[x_a][2] = {  0,   2}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  2,   3,   0}; //   3

  c_p[x_a][3] = {  0,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  4,   1,   0}; //   3

  c_p[x_a][4] = {  0,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  3,   0}; //   2

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  3,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  4}; //   1
  c_d[x_a][6] = {  0,   5}; //   2

  c_p[x_a][7] = {  0,   5}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  5}; //   1
  c_d[x_a][7] = {  5,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    1: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel    2: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel    3: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel    4: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel    5: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel    6: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
// channel    7: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
