#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_uxbx_vevexauxbx(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_uxbx_vevexauxbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  needed_v_smin[x_a][  1] = {   2,    3,    7,   18,    5}; //   5
  needed_v_smin[x_a][  2] = {   3}; //   1
  needed_v_smin[x_a][  3] = {   4,   14,   15,   17,    0}; //   5
  needed_v_smin[x_a][  4] = {   4,    0,   14}; //   3
  needed_v_smin[x_a][  5] = {   6,    8,   11,   15,   10,   17}; //   6
  needed_v_smin[x_a][  6] = {   8,    6,   10}; //   3
  needed_v_smin[x_a][  7] = {   9,   16,   18,   19,   13}; //   5
  needed_v_smin[x_a][  8] = {   9,   13,   19}; //   3
  needed_v_smin[x_a][  9] = {   1,   12}; //   2
  needed_v_smin[x_a][ 10] = {   1,   12}; //   2
  needed_v_smin[x_a][ 11] = {   2,    5,    7}; //   3
  needed_v_smin[x_a][ 12] = {  11}; //   1
  needed_v_smin[x_a][ 13] = {  16}; //   1

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   15,   17,   19}; //  15
  needed_v_smax[x_a][  1] = {   2,    3,    7,    5}; //   4
  needed_v_smax[x_a][  2] = {   3,    4,    0,   14}; //   4
  needed_v_smax[x_a][  3] = {   4,   14}; //   2
  needed_v_smax[x_a][  4] = {   4,   14}; //   2
  needed_v_smax[x_a][  5] = {   6,    8,   11,   15,   10}; //   5
  needed_v_smax[x_a][  6] = {   8,    9,    6,   10,   13,   19}; //   6
  needed_v_smax[x_a][  7] = {   9,   16,   18}; //   3
  needed_v_smax[x_a][  8] = {   9,   16,   18}; //   3
  needed_v_smax[x_a][  9] = {  15}; //   1
  needed_v_smax[x_a][ 10] = {  17,    0}; //   2
  needed_v_smax[x_a][ 11] = {  18}; //   1
  needed_v_smax[x_a][ 12] = {  19,   13}; //   2
  needed_v_smax[x_a][ 13] = {   1,   12}; //   2
  needed_v_smax[x_a][ 14] = {   1,    2,    5,    7,   11,   12}; //   6
  needed_v_smax[x_a][ 15] = {  16}; //   1
  needed_v_smax[x_a][ 16] = {  17}; //   1

  g_p[x_a].resize(15);
  needed_g_p[x_a].resize(15);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    5,    6,    7,    8,   10,   11,   12,   13,   15,   17,   19}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    3,    7}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   4,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax4");
  needed_g_p[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    8,   11,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][8] = {   9,   16,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");
  needed_g_p[x_a][9] = {   9,   16,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][10] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax9");
  needed_g_p[x_a][12] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax10");
  needed_g_p[x_a][13] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][14] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax12");

  g_f[x_a].resize(13);
  needed_g_f[x_a].resize(13);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax10");
  needed_g_f[x_a][1] = {   0,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][2] = {   1,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax13");
  needed_g_f[x_a][3] = {   1,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax14");
  needed_g_f[x_a][4] = {   2,    5,    7}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax14");
  needed_g_f[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][6] = {   6,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][7] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][8] = {  11}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][9] = {  13}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax12");
  needed_g_f[x_a][10] = {  13,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax6");
  needed_g_f[x_a][11] = {  16}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][12] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax16");

  g_t[x_a].resize(23);
  needed_g_t[x_a].resize(23);
  needed_g_t[x_a][0] = {   0,    3,    4,   14}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {   5,    7,   11,   12}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][8] = {   5,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][10] = {   6,    8,    9,   10,   13,   19}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][11] = {   6,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][12] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][13] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][14] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][15] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][16] = {  13,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][17] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][18] = {  15,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][19] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][20] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][21] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][22] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");

  g_d[x_a].resize(9);
  needed_g_d[x_a].resize(9);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    3,    7,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][3] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][4] = {   4,   14,   15,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   6,    8,   11,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][6] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][7] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][8] = {   9,   16,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(20);
  c_f[x_a].resize(20);
  c_t[x_a].resize(20);
  c_d[x_a].resize(20);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   1,   2}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  2,   1,   0}; //   3

  c_p[x_a][4] = {  3,   4,   5}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  3,   0,   4}; //   3

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  5,   4}; //   2
  c_t[x_a][5] = {  7,   8,   9}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0,   6}; //   2
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = { 10,  11}; //   2
  c_d[x_a][6] = {  5,   0}; //   2

  c_p[x_a][7] = {  0,   1}; //   2
  c_f[x_a][7] = {  4}; //   1
  c_t[x_a][7] = {  7,   8}; //   2
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  0,   6,   7}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 10}; //   1
  c_d[x_a][8] = {  6,   5,   0}; //   3

  c_p[x_a][9] = {  8,   9,  10}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 10}; //   1
  c_d[x_a][9] = {  7,   0,   8}; //   3

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  7,   6}; //   2
  c_t[x_a][10] = { 10,  11,  12}; //   3
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  0,   6}; //   2
  c_f[x_a][11] = {  8}; //   1
  c_t[x_a][11] = {  7,  13}; //   2
  c_d[x_a][11] = {  5,   0}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  2,   3}; //   2
  c_t[x_a][12] = {  7,  14,  15}; //   3
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  9,  10}; //   2
  c_t[x_a][13] = { 10,  16,  17}; //   3
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  3,   4}; //   2
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = {  0,   4}; //   2

  c_p[x_a][15] = {  0,   6,  11}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 18}; //   1
  c_d[x_a][15] = {  4,   5,   0}; //   3

  c_p[x_a][16] = {  8,   9}; //   2
  c_f[x_a][16] = { 11}; //   1
  c_t[x_a][16] = { 19,  20}; //   2
  c_d[x_a][16] = {  0,   8}; //   2

  c_p[x_a][17] = {  0,  12}; //   2
  c_f[x_a][17] = { 12}; //   1
  c_t[x_a][17] = { 18,  21}; //   2
  c_d[x_a][17] = {  4,   0}; //   2

  c_p[x_a][18] = {  8,   9,  13}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 22}; //   1
  c_d[x_a][18] = {  1,   0,   8}; //   3

  c_p[x_a][19] = {  0,  14}; //   2
  c_f[x_a][19] = { 10}; //   1
  c_t[x_a][19] = { 10,  16}; //   2
  c_d[x_a][19] = {  8,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
// channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
// channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
// channel    3: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel    4: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel    5: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
// channel    6: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel    7: 13yv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
// channel    8: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
// channel    9: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   10: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
// channel   11: 113yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   12: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   13: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
// channel   14: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
// channel   15: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   16: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  23,   0,   0)
// channel   17: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
// channel   18: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
// channel   19: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
