#include "header.hpp"

#include "ppwx01.phasespace.set.hpp"

void ppwx01_phasespace_set::ag_psp_210_udx_wpbdx(int x_a, int zero){
  static Logger logger("ppwx01_phasespace_set::ag_psp_210_udx_wpbdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][5] == nullvector){xbp_all[x_a][5] = xbp_all[x_a][1] - xbp_all[x_a][4];}
  if (xbs_all[x_a][5] == 0.){xbs_all[x_a][5] = xbp_all[x_a][5].m2();}
  if (xbs_all[x_a][5] > 0.){xbs_all[x_a][5] = 0.;}
  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][24] == nullvector){xbp_all[x_a][24] = xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][24] == 0.){xbs_all[x_a][24] = xbp_all[x_a][24].m2();}
  if (xbs_all[x_a][24] < 0.){xbs_all[x_a][24] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 1 times
  v_smin[x_a][  1] = smin_opt[x_a][24]; // 1 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 1 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2); // 1 times

  //  vector<double> g_p(1);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 1 times

  //  vector<double> g_f(1);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  1], v_smax[x_a][  1]); /* nfp 2 */} // 1 times

  //  vector<double> g_t(3);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24); /* ntp 0 */} // 1 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8); /* ntp 1 */} // 1 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12); /* ntp 0 */} // 1 times

  //  vector<double> g_d(1);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 1 times


  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(1);
    inv_r[1].resize(1);
    inv_r[2].resize(3);
    inv_r[3].resize(3);
    inv_r[4].resize(1);
    inv_r[5].resize(1);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 1 times

    {inv_timelikeinvariant(x_a,  24, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[1][0]);} // 1 times

    {inv_tchannel_opt(x_a,   0,  28,   1,   2,   4,  24, inv_r[2][0], inv_r[3][0]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  24,   2,   5,  16,   8, inv_r[2][1], inv_r[3][1]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  28,   2,   1,  16,  12, inv_r[2][2], inv_r[3][2]);} // 1 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 1 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(2, vector<double> (5));
      vector<double> g_IS(2, 1.);
      for (int i_c = 0; i_c < 2; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 5; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}

    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(1, 1.);
      g_IS[1].resize(1, 1.);
      g_IS[2].resize(3, 1.);
      g_IS[3].resize(1, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_IS[0][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  0] * g_IS[3][  0];}
    }
  }

  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
