#include "header.hpp"

#include "ppwx01.phasespace.set.hpp"

void ppwx01_phasespace_set::ax_psp_210_ubx_wpbbx(int x_a){
  static Logger logger("ppwx01_phasespace_set::ax_psp_210_ubx_wpbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   1}; //   1
  needed_v_smin[x_a][  1] = {   2,    3,    0}; //   3

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   1}; //   1
  needed_v_smax[x_a][  1] = {   2,    3,    0}; //   3

  g_p[x_a].resize(2);
  needed_g_p[x_a].resize(2);
  needed_g_p[x_a][0] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");

  c_p[x_a].resize(4);
  c_f[x_a].resize(4);
  c_t[x_a].resize(4);
  c_d[x_a].resize(4);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  2}; //   1
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  3}; //   1
  c_d[x_a][2] = {  1}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 4, 8, 16;   0,   0)
// channel    1: 2v1(1, 2, 4, 8, 16;   0,   0)
// channel    2: 2v1(1, 2, 8, 16, 4;   0,   0)
// channel    3: 12v(1, 2, 4, 8, 16;   0,   0)
