#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_dxcx_wpwmuxsx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_dxcx_wpwmuxsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  needed_v_smin[x_a][  0] = {   1,    3}; //   2
  needed_v_smin[x_a][  1] = {   2,    3}; //   2
  needed_v_smin[x_a][  2] = {   0}; //   1
  needed_v_smin[x_a][  3] = {   0}; //   1
  needed_v_smin[x_a][  4] = {   1}; //   1
  needed_v_smin[x_a][  5] = {   2}; //   1

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   1}; //   1
  needed_v_smax[x_a][  1] = {   2,    3}; //   2
  needed_v_smax[x_a][  2] = {   3}; //   1
  needed_v_smax[x_a][  3] = {   0}; //   1
  needed_v_smax[x_a][  4] = {   0,    2}; //   2
  needed_v_smax[x_a][  5] = {   1}; //   1

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax2");

  g_f[x_a].resize(4);
  needed_g_f[x_a].resize(4);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax3");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax4");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax5");
  needed_g_f[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__20_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__40_16");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_40");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   1,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");

  c_p[x_a].resize(4);
  c_f[x_a].resize(4);
  c_t[x_a].resize(4);
  c_d[x_a].resize(4);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2}; //   1
  c_t[x_a][1] = {  3,   4}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  1}; //   1
  c_f[x_a][2] = {  3}; //   1
  c_t[x_a][2] = {  0,   5}; //   2
  c_d[x_a][2] = {  1}; //   1

  c_p[x_a][3] = {  1,   2}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  6}; //   1
  c_d[x_a][3] = {  0,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    1: 2v11(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel    2: 112v(1, 2, 4, 16, 8, 32;   0,   0,   0)
// channel    3: 2v2v(1, 2, 4, 16, 8, 32;   0,   0,   0)
