#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_gux_wpwmgux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_gux_wpwmgux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(10);
  needed_v_smin[x_a].resize(10);
  needed_v_smin[x_a][  0] = {   4,    5,   10,   11,   15,   16,   21,   24,    2}; //   9
  needed_v_smin[x_a][  1] = {   6,    9,   14,   17,   18,   29,   30}; //   7
  needed_v_smin[x_a][  2] = {   7,    8,   12,   13,   17,   18,   19,   20,   22,   23,   25,   26,   27,   28,   29,   30,    0}; //  17
  needed_v_smin[x_a][  3] = {   7,    8,   12,   13,   22,   23,   25,   26}; //   8
  needed_v_smin[x_a][  4] = {   9,   14,    6}; //   3
  needed_v_smin[x_a][  5] = {  10,   15,    5}; //   3
  needed_v_smin[x_a][  6] = {  11,   16,   24,    2,    4,   21}; //   6
  needed_v_smin[x_a][  7] = {   0,   19,   20,   27,   28}; //   5
  needed_v_smin[x_a][  8] = {   1,    3}; //   2
  needed_v_smin[x_a][  9] = {   1,    3}; //   2

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   4,    5,   10,   11,   15,   16,   21,   24,    2}; //   9
  needed_v_smax[x_a][  1] = {   6,    9,   14,   17,   18}; //   5
  needed_v_smax[x_a][  2] = {   7,    8,   12,   13,   19,   20,   22,   23,   25,   26,   27,   28,   29,   30,    0}; //  15
  needed_v_smax[x_a][  3] = {   7,    8,   11,   12,   13,   16,   22,   23,   24,    2,    4,   21,   25,   26}; //  14
  needed_v_smax[x_a][  4] = {   9,   10,   14,   15,    5,    6}; //   6
  needed_v_smax[x_a][  5] = {  17,   18}; //   2
  needed_v_smax[x_a][  6] = {  29,   30}; //   2
  needed_v_smax[x_a][  7] = {   0,    1,    3,   19,   20,   27,   28}; //   7
  needed_v_smax[x_a][  8] = {   1,    3}; //   2

  g_p[x_a].resize(11);
  needed_g_p[x_a].resize(11);
  needed_g_p[x_a][0] = {   4,    5,   10,   11,   15,   16,   21,   24}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   6,    9,   14,   17,   18}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   12,   19,   22,   25,   27,   29}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   7,    8,   12,   13,   22,   23}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,   13,   20,   23,   26,   28,   30}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   9,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  11,   16,   24}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][8] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax5");
  needed_g_p[x_a][9] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax5");
  needed_g_p[x_a][10] = {  29,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax6");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,   19,   20,   27,   28}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax7");
  needed_g_f[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   2,    4,   21}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][8] = {  25,   26}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    3,   19,   20,   27,   28}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,   19,   20}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][5] = {   2,   21,   22,   23,   24,   25,   26}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][9] = {   4,    7,    8,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__36_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__36_8");
  needed_g_t[x_a][11] = {   5,    6,    9,   10}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_16");
  needed_g_t[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][14] = {  25,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][15] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][16] = {  29,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   4,    5,   10,   11,   15,   16,   21,   24}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   6,    9,   14,   17,   18,   29,   30}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   7,    8,   12,   13,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   7,    8,   12,   13,   17,   18,   19,   20,   22,   23,   25,   26,   27,   28,   29,   30}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][4] = {   9,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][5] = {  10,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  11,   16,   24}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][7] = {  12,   13,   16}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {  17,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(31);
  c_f[x_a].resize(31);
  c_t[x_a].resize(31);
  c_d[x_a].resize(31);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  0,   3,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  9,  10}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  1}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 11,  13}; //   2
  c_d[x_a][6] = {  1}; //   1

  c_p[x_a][7] = {  2,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  9}; //   1
  c_d[x_a][7] = {  2,   3}; //   2

  c_p[x_a][8] = {  4,   3}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  9}; //   1
  c_d[x_a][8] = {  2,   3}; //   2

  c_p[x_a][9] = {  1,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 11}; //   1
  c_d[x_a][9] = {  4,   1}; //   2

  c_p[x_a][10] = {  0,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 11}; //   1
  c_d[x_a][10] = {  5,   0}; //   2

  c_p[x_a][11] = {  0,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  9}; //   1
  c_d[x_a][11] = {  6,   0}; //   2

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  7,   2,   3}; //   3

  c_p[x_a][13] = {  4,   3}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  7,   2,   3}; //   3

  c_p[x_a][14] = {  1,   5}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  8,   4,   1}; //   3

  c_p[x_a][15] = {  0,   6}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  8,   5,   0}; //   3

  c_p[x_a][16] = {  0,   7}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  7,   6,   0}; //   3

  c_p[x_a][17] = {  1,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,   3,   1}; //   3

  c_p[x_a][18] = {  1,   9}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  9,   3,   1}; //   3

  c_p[x_a][19] = {  2}; //   1
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  0,   1}; //   2
  c_d[x_a][19] = {  3}; //   1

  c_p[x_a][20] = {  4}; //   1
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  0,   1}; //   2
  c_d[x_a][20] = {  3}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {  5}; //   1
  c_t[x_a][21] = {  5,   6}; //   2
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  2,   3}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  5}; //   1
  c_d[x_a][22] = {  2,   3}; //   2

  c_p[x_a][23] = {  4,   3}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  5}; //   1
  c_d[x_a][23] = {  2,   3}; //   2

  c_p[x_a][24] = {  0,   7}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  5}; //   1
  c_d[x_a][24] = {  6,   0}; //   2

  c_p[x_a][25] = {  2}; //   1
  c_f[x_a][25] = {  8}; //   1
  c_t[x_a][25] = {  5,  14}; //   2
  c_d[x_a][25] = {  3}; //   1

  c_p[x_a][26] = {  4}; //   1
  c_f[x_a][26] = {  8}; //   1
  c_t[x_a][26] = {  5,  14}; //   2
  c_d[x_a][26] = {  3}; //   1

  c_p[x_a][27] = {  2}; //   1
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  0,  15}; //   2
  c_d[x_a][27] = {  3}; //   1

  c_p[x_a][28] = {  4}; //   1
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = {  0,  15}; //   2
  c_d[x_a][28] = {  3}; //   1

  c_p[x_a][29] = {  2,  10}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 16}; //   1
  c_d[x_a][29] = {  1,   3}; //   2

  c_p[x_a][30] = {  4,  10}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 16}; //   1
  c_d[x_a][30] = {  1,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    1: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    3: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel    4: 2v11(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel    5: 2v11(1, 2, 4, 32, 16, 8;   0,   0,   0)
// channel    6: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel    7: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel    8: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel    9: 3yv1(1, 2, 4, 16, 32, 8;   0,   0,   0)
// channel   10: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   11: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
// channel   12: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   13: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   14: 4yyv(1, 2, 8, 4, 16, 32;   0,   0,   0)
// channel   15: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
// channel   16: 4yyv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   17: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   18: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
// channel   19: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   20: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel   21: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
// channel   22: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   23: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   24: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
// channel   25: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   26: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   27: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   28: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel   29: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   30: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
