#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_udx_wpwmcsx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_udx_wpwmcsx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  needed_v_smin[x_a][  0] = {   0,    2}; //   2
  needed_v_smin[x_a][  1] = {   0,    2}; //   2
  needed_v_smin[x_a][  2] = {   1,    3}; //   2
  needed_v_smin[x_a][  3] = {   1,    3}; //   2

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   0,    2}; //   2
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  2] = {   1,    3}; //   2

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][1] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   0,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");

  c_p[x_a].resize(4);
  c_f[x_a].resize(4);
  c_t[x_a].resize(4);
  c_d[x_a].resize(4);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  2,   3}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  2,   3}; //   2

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  0,   1}; //   2

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  2,   3}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 3yv1(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel    1: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel    2: 13yv(1, 2, 4, 32, 8, 16;   0,   0,   0)
// channel    3: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
