#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_uu_wpwmuu(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_uu_wpwmuu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(9);
  needed_v_smin[x_a].resize(9);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27}; //  16
  needed_v_smin[x_a][  1] = {   8,   14,   16,   18,    0,    3}; //   6
  needed_v_smin[x_a][  2] = {   8,   18,    3,   16}; //   4
  needed_v_smin[x_a][  3] = {   9,   15,   17,   19,    1,    2}; //   6
  needed_v_smin[x_a][  4] = {   9,   19,    2,   17}; //   4
  needed_v_smin[x_a][  5] = {  10,   11,   20,   21,    6,    7,   24,   25}; //   8
  needed_v_smin[x_a][  6] = {  12,   13,   22,   23,    4,    5,   26,   27}; //   8
  needed_v_smin[x_a][  7] = {   0,   14}; //   2
  needed_v_smin[x_a][  8] = {   1,   15}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27}; //  16
  needed_v_smax[x_a][  1] = {   8,   14,   16,   18,    0,    3}; //   6
  needed_v_smax[x_a][  2] = {   8,   12,   13,   18,   22,   23,    3,    4,    5,   16,   26,   27}; //  12
  needed_v_smax[x_a][  3] = {   9,   15,   17,   19,    1,    2}; //   6
  needed_v_smax[x_a][  4] = {   9,   10,   11,   19,   20,   21,    2,    6,    7,   17,   24,   25}; //  12
  needed_v_smax[x_a][  5] = {   0,    1,   14,   15}; //   4

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   4,    6,   10,   12,   20,   22,   24,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,    7,   11,   13,   21,   23,   25,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   8,   14,   16,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   8,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   9,   15,   17,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   9,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {  10,   11,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  12,   13,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax2");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][4] = {   2,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][5] = {   3,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][6] = {   4,    5,   26,   27}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax2");
  needed_g_f[x_a][7] = {   6,    7,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,   14,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2,   17,   19,   20,   21,   24,   25}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][8] = {   3,   16,   18,   22,   23,   26,   27}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][9] = {   3,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][11] = {   4,    5,    8,   12,   13}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][12] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][13] = {   6,    7,    9,   10,   11}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][14] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][15] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][16] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   26,   27}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   8,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   8,   14,   16,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   9,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {   9,   15,   17,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {  10,   11,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  12,   13,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   4}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5}; //   2
  c_t[x_a][3] = {  8,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = { 11,  12}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 13,  14}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = { 13,  14}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  2,   3}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 11}; //   1
  c_d[x_a][8] = {  1,   2}; //   2

  c_p[x_a][9] = {  4,   5}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 13}; //   1
  c_d[x_a][9] = {  3,   4}; //   2

  c_p[x_a][10] = {  0,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 13}; //   1
  c_d[x_a][10] = {  5,   0}; //   2

  c_p[x_a][11] = {  1,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 13}; //   1
  c_d[x_a][11] = {  5,   0}; //   2

  c_p[x_a][12] = {  0,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 11}; //   1
  c_d[x_a][12] = {  6,   0}; //   2

  c_p[x_a][13] = {  1,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 11}; //   1
  c_d[x_a][13] = {  6,   0}; //   2

  c_p[x_a][14] = {  2}; //   1
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  0,   1}; //   2
  c_d[x_a][14] = {  2}; //   1

  c_p[x_a][15] = {  4}; //   1
  c_f[x_a][15] = {  3}; //   1
  c_t[x_a][15] = {  0,   3}; //   2
  c_d[x_a][15] = {  4}; //   1

  c_p[x_a][16] = {  2}; //   1
  c_f[x_a][16] = {  5}; //   1
  c_t[x_a][16] = {  8,   9}; //   2
  c_d[x_a][16] = {  2}; //   1

  c_p[x_a][17] = {  4}; //   1
  c_f[x_a][17] = {  4}; //   1
  c_t[x_a][17] = {  5,   6}; //   2
  c_d[x_a][17] = {  4}; //   1

  c_p[x_a][18] = {  2,   3}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  8}; //   1
  c_d[x_a][18] = {  1,   2}; //   2

  c_p[x_a][19] = {  4,   5}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  5}; //   1
  c_d[x_a][19] = {  3,   4}; //   2

  c_p[x_a][20] = {  0,   6}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  5}; //   1
  c_d[x_a][20] = {  5,   0}; //   2

  c_p[x_a][21] = {  1,   6}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  5}; //   1
  c_d[x_a][21] = {  5,   0}; //   2

  c_p[x_a][22] = {  0,   7}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  8}; //   1
  c_d[x_a][22] = {  6,   0}; //   2

  c_p[x_a][23] = {  1,   7}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  8}; //   1
  c_d[x_a][23] = {  6,   0}; //   2

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  7}; //   1
  c_t[x_a][24] = {  5,  15}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = {  7}; //   1
  c_t[x_a][25] = {  5,  15}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  6}; //   1
  c_t[x_a][26] = {  8,  16}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = {  6}; //   1
  c_t[x_a][27] = {  8,  16}; //   2
  c_d[x_a][27] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    1: 1111(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    2: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
// channel    3: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
// channel    4: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    5: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
// channel    6: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel    7: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
// channel    8: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel    9: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   10: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   11: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
// channel   12: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   13: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
// channel   14: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
// channel   15: 12v1(1, 2, 4, 8, 32, 16;   0,   0,   0)
// channel   16: 12v1(1, 2, 32, 8, 16, 4;   0,   0,   0)
// channel   17: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
// channel   18: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
// channel   19: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
// channel   20: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   21: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   22: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   23: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
// channel   24: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
// channel   25: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
// channel   26: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
// channel   27: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
