#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_030_aa_wpwma(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_030_aa_wpwma");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   2,    5,    1}; //   3
  needed_v_smin[x_a][  1] = {   3,    4,    0}; //   3

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   2,    5,    1}; //   3
  needed_v_smax[x_a][  1] = {   3,    4,    0}; //   3

  g_p[x_a].resize(2);
  needed_g_p[x_a].resize(2);
  needed_g_p[x_a][0] = {   2,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__4_24");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_5__8_16");
  needed_g_t[x_a][2] = {   1,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__8_20");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_9__4_16");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__8_20");
  needed_g_t[x_a][5] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__4_24");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   2,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][1] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");

  c_p[x_a].resize(6);
  c_f[x_a].resize(6);
  c_t[x_a].resize(6);
  c_d[x_a].resize(6);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  4}; //   1
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  5}; //   1
  c_d[x_a][3] = {  1}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  1}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 4, 16, 8;  24,  24)
// channel    1: 111(1, 2, 8, 16, 4;  24,  24)
// channel    2: 2v1(1, 2, 4, 16, 8;  24,  24)
// channel    3: 2v1(1, 2, 8, 16, 4;  24,  24)
// channel    4: 12v(1, 2, 4, 8, 16;  24,  24)
// channel    5: 12v(1, 2, 8, 4, 16;  24,  24)
