#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_030_bbx_wpwma(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_030_bbx_wpwma");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   3,    4,    5,   13,   14,   15,    2}; //   7
  needed_v_smin[x_a][  1] = {   6,    7,    8,    9}; //   4
  needed_v_smin[x_a][  2] = {  10,   11,   12,   16,    0,    1}; //   6

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   3,    4,    5,   13,   14,   15,    2}; //   7
  needed_v_smax[x_a][  1] = {   6,    7,    8,    9}; //   4
  needed_v_smax[x_a][  2] = {  10,   11,   12,   16,    0,    1}; //   6

  g_p[x_a].resize(5);
  needed_g_p[x_a].resize(5);
  needed_g_p[x_a][0] = {   3,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   4,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   5,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][4] = {  10,   11,   12,   16}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1,   16}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_20");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_9__16_4");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_16");
  needed_g_t[x_a][3] = {   2,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__16_12");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_8");
  needed_g_t[x_a][5] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_12");
  needed_g_t[x_a][6] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_24");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   3,    4,    5,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {   7,    8,    9}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {  10,   11,   12}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {  10,   11,   12,   16}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(17);
  c_f[x_a].resize(17);
  c_t[x_a].resize(17);
  c_d[x_a].resize(17);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  3,   4}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  5}; //   1
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  5}; //   1
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  2}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  5}; //   1
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  3}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  6}; //   1
  c_d[x_a][6] = {  1}; //   1

  c_p[x_a][7] = {  3}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  2,   1}; //   2

  c_p[x_a][8] = {  3}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  2,   1}; //   2

  c_p[x_a][9] = {  3}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  2,   1}; //   2

  c_p[x_a][10] = {  4}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  3,   4}; //   2

  c_p[x_a][11] = {  4}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  3,   4}; //   2

  c_p[x_a][12] = {  4}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  3,   4}; //   2

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  1}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  2}; //   1
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  3}; //   1
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  4}; //   1
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  4}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 8, 4, 16;   6,   5)
// channel    1: 111(1, 2, 8, 16, 4;   6,   6)
// channel    2: 111(1, 2, 16, 8, 4;   5,   6)
// channel    3: 2v1(1, 2, 4, 8, 16;   0,   5)
// channel    4: 2v1(1, 2, 4, 8, 16;  23,   5)
// channel    5: 2v1(1, 2, 4, 8, 16;  25,   5)
// channel    6: 2v1(1, 2, 8, 16, 4;  24,   6)
// channel    7: 3yv(1, 2, 4, 8, 16;  24,   0)
// channel    8: 3yv(1, 2, 4, 8, 16;  24,  23)
// channel    9: 3yv(1, 2, 4, 8, 16;  24,  25)
// channel   10: 3yv(1, 2, 8, 4, 16;  24,   0)
// channel   11: 3yv(1, 2, 8, 4, 16;  24,  23)
// channel   12: 3yv(1, 2, 8, 4, 16;  24,  25)
// channel   13: 12v(1, 2, 16, 4, 8;   0,   5)
// channel   14: 12v(1, 2, 16, 4, 8;  23,   5)
// channel   15: 12v(1, 2, 16, 4, 8;  25,   5)
// channel   16: 12v(1, 2, 8, 4, 16;  24,   6)
