#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_120_gu_wpwmu(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_120_gu_wpwmu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   1,    2}; //   2
  needed_v_smin[x_a][  1] = {   3,    4,    5,    6,    0}; //   5

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   1,    2}; //   2
  needed_v_smax[x_a][  1] = {   3,    4,    5,    6,    0}; //   5

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin1_smax1");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(3);
  needed_g_t[x_a].resize(3);
  needed_g_t[x_a][0] = {   0,    5,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");

  g_d[x_a].resize(4);
  needed_g_d[x_a].resize(4);
  needed_g_d[x_a][0] = {   1,    2}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][1] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   3,    4,    5,    6}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");

  c_p[x_a].resize(7);
  c_f[x_a].resize(7);
  c_t[x_a].resize(7);
  c_d[x_a].resize(7);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  2}; //   1
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  2,   3}; //   2

  c_p[x_a][4] = {  2}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  2,   3}; //   2

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  3}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  3}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 111(1, 2, 16, 8, 4;   0,   0)
// channel    1: 2v1(1, 2, 8, 16, 4;   0,   0)
// channel    2: 3yv(1, 2, 4, 8, 16;   0,   0)
// channel    3: 3yv(1, 2, 16, 4, 8;   0,   0)
// channel    4: 3yv(1, 2, 16, 4, 8;  23,   0)
// channel    5: 12v(1, 2, 16, 4, 8;   0,   0)
// channel    6: 12v(1, 2, 16, 4, 8;  23,   0)
void ppwxw02_phasespace_set::ax_psp_320_gu_wpwmu(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_320_gu_wpwmu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  int needed_v_smin_0[] = {   6,    7,    8,    9,   10,   11}; //   6
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 6);
  int needed_v_smin_1[] = {   0,    1,    2}; //   3
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 3);
  int needed_v_smin_2[] = {   3,    4,    5}; //   3
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 3);

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  int needed_v_smax_0[] = {   6,    7,    8,    9,   10,   11}; //   6
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 6);
  int needed_v_smax_1[] = {   0,    1,    2}; //   3
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 3);
  int needed_v_smax_2[] = {   3,    4,    5}; //   3
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 3);

  g_p[x_a].resize(5);
  needed_g_p[x_a].resize(5);
  needed_g_p[x_a][0] = {   6,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin0_smax0");
  needed_g_p[x_a][4] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax0");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__4_24");
  needed_g_t[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_24");
  needed_g_t[x_a][4] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][5] = {   3,    4,    5}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_20");
  needed_g_t[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__8_20");
  needed_g_t[x_a][8] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");

  c_p[x_a].resize(12);
  c_f[x_a].resize(12);
  c_t[x_a].resize(12);
  c_d[x_a].resize(12);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  2,   1}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  3,   1}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  4,   5}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  6,   5}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  7,   5}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  8}; //   1
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  8}; //   1
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  2}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  8}; //   1
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  8}; //   1
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  3}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  8}; //   1
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  4}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  8}; //   1
  c_d[x_a][11] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
